// FIX FOR DECALS CLIPPING// FIX FOR DECALS CLIPPING
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 20, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _792
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1310
{
    int _m0;
    int _m1;
};

struct _1313
{
    int _m0;
    int _m1;
};

struct _1490
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _2829
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _814_816
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _816;

layout(set = 2, binding = 0, std140) uniform _965_967
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _967;

layout(set = 1, binding = 0, std140) uniform _1128_1130
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
} _1130;

layout(set = 0, binding = 5, std430) restrict readonly buffer _1315_1317
{
    _1313 _m0[];
} _1317;

layout(set = 0, binding = 6, std430) restrict readonly buffer _1466_1468
{
    uint _m0[];
} _1468;

layout(set = 0, binding = 7, std140) uniform _1495_1497
{
    vec4 _m0[4096];
} _1497;

layout(set = 0, binding = 8, std140) uniform _1534_1536
{
    vec4 _m0[4096];
} _1536;

layout(set = 0, binding = 9, std140) uniform _1603_1605
{
    vec4 _m0[3072];
} _1605;

layout(set = 0, binding = 12, std140) uniform _2833_2835
{
    vec4 _m0[4095];
} _2835;

layout(set = 0, binding = 1, std430) restrict readonly buffer _3636_3638
{
    vec4 _m0[];
} _3638;

layout(push_constant, std430) uniform _3632_3634
{
    int _m0;
    int _m1;
} _3634;

layout(set = 2, binding = 1) uniform SAMPLER_2D _945;
layout(set = 2, binding = 2) uniform SAMPLER_2D _1081;
layout(set = 1, binding = 1) uniform SAMPLER_2D _1137;
layout(set = 1, binding = 2) uniform SAMPLER_2D _1142;
layout(set = 0, binding = 10) uniform samplerCubeArray _2003;
layout(set = 0, binding = 11) uniform SAMPLER_2D _2390;
layout(set = 0, binding = 13) uniform sampler2DShadow _3156;
layout(set = 3, binding = 0) uniform TEXTURE_2D _3624[8];
layout(set = 3, binding = 1) uniform TEXTURE_2D _3625[8];
layout(set = 3, binding = 2) uniform TEXTURE_2D _3626[8];
layout(set = 3, binding = 3) uniform TEXTURE_2D _3627[8];
layout(set = 3, binding = 4) uniform TEXTURE_2D _3628[8];
layout(set = 3, binding = 5) uniform TEXTURE_2D _3629[8];
layout(set = 3, binding = 6) uniform TEXTURE_2D _3630[8];
layout(set = 3, binding = 7) uniform TEXTURE_2D _3631[8];
layout(set = 0, binding = 3) uniform sampler3D _3642;
layout(set = 0, binding = 4) uniform sampler3D _3643;

layout(location = 2) in vec4 _807;
layout(location = 6) in vec4 _821;
layout(location = 3) in vec4 _833;
layout(location = 4) in vec4 _836;
layout(location = 5) in vec4 _839;
layout(location = 10) in vec4 _857;
layout(location = 11) in vec4 _861;
layout(location = 12) in vec4 _865;
layout(location = 8) in vec4 _1147;
layout(location = 0) out vec4 _3578;
layout(location = 1) out vec4 _3586;
layout(location = 2) out vec4 _3594;

float _264;

float _62(float _61)
{
    return _61 * _61;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _47(float _46)
{
    return _46 * ((_46 * ((_46 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec3 _50(vec3 _49)
{
    float _301 = _49.x;
    vec3 _300;
    _300.x = _47(_301);
    float _306 = _49.y;
    _300.y = _47(_306);
    float _311 = _49.z;
    _300.z = _47(_311);
    return _300;
}

vec4 _56(vec4 _55)
{
    vec3 _320 = _55.xyz;
    vec4 _319 = vec4(_50(_320), 1.0);
    float _328 = _55.w;
    _319.w = _47(_328);
    return _319;
}

vec4 _104(SAMPLER_2D _102, vec2 _103)
{
    vec4 _440 = SAMPLE_TEXTURE(_102, _103);
    vec4 _444 = _440;
    _440 = _56(_444);
    return _440;
}

float _108(vec3 _107)
{
    return dot(_107, vec3(0.2125999927520751953125, 0.715200006961822509765625, 0.072200000286102294921875));
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _144(vec3 _142, bool _143)
{
    vec3 _646 = (_142 * 2.0) - vec3(1.0);
    float _663 = (1.0 - (_646.x * _646.x)) - (_646.y * _646.y);
    _646.z = sqrt(_10(_663));
    if (_143 == false)
    {
        _646.z = -_646.z;
    }
    return _646;
}

vec3 _151(vec3 _149, mat3 _150)
{
    return normalize(vec3(dot(_149, _150[0]), dot(_149, _150[1]), dot(_149, _150[2])));
}

vec3 _157(vec3 _154, mat3 _155, bool _156)
{
    vec3 _696 = _154;
    bool _698 = _156;
    vec3 _695 = _144(_696, _698);
    vec3 _701 = _695;
    mat3 _703 = _155;
    return _151(_701, _703);
}

float _41(float _40)
{
    if (_40 <= 0.040449999272823333740234375)
    {
        return _40 / 12.9200000762939453125;
    }
    else
    {
        return pow((_40 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _44(vec3 _43)
{
    float _266 = _43.x;
    vec3 _265;
    _265.x = _41(_266);
    float _272 = _43.y;
    _265.y = _41(_272);
    float _278 = _43.z;
    _265.z = _41(_278);
    return _265;
}

vec3 _59(vec3 _58)
{
    vec3 _337 = _58;
    return _44(_337);
}

float _139(float _135, vec4 _136, float _137, bool _138)
{
    float _633 = _136.w / (_135 + _136.z);
    return _633 * _137;
}

uint _21(float _20)
{
    return floatBitsToUint(_20);
}

float _32(float _29, float _30, float _31)
{
    return min(_29, min(_30, _31));
}

float _27(float _24, float _25, float _26)
{
    return max(_24, max(_25, _26));
}

vec4 _81(uint _80)
{
    return unpackUnorm4x8(_80).wzyx;
}

float _65(float _64)
{
    return exp2(_64);
}

vec3 _111(uint _110)
{
    uint _459 = _110;
    vec4 _458 = _81(_459);
    float _470 = (_458.w * 255.0) - 128.0;
    return _458.xyz * _65(_470);
}

vec4 _84(uint _83)
{
    return vec4(float((_83 >> uint(24)) & 255u), float((_83 >> uint(16)) & 255u), float((_83 >> uint(8)) & 255u), float(_83 & 255u));
}

vec3 _130(float _127, float _128, vec3 _129)
{
    float _585 = 0.0949999988079071044921875 + (_128 * (0.60000002384185791015625 + (4.190000057220458984375 * _128)));
    float _595 = _127 + 0.02500000037252902984619140625;
    float _599 = (9.5 * _128) * _127;
    float _613 = 1.0 - (14.0 * _127);
    float _605 = (_585 * _595) * _65(_613);
    float _620 = -_599;
    float _616 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _65(_620)));
    return mix(vec3(_605), vec3(_616), _129);
}

vec4 _94(uvec2 _93)
{
    return vec4(float((_93.x >> uint(16)) & 65535u), float(_93.x & 65535u), float((_93.y >> uint(16)) & 65535u), float(_93.y & 65535u)) * 3.0518509447574615478515625e-05;
}

float _73(float _72)
{
    return (step(0.0, _72) * 2.0) - 1.0;
}

vec3 _88(uint _87)
{
    return vec3(float((_87 >> uint(21)) & 2047u), float((_87 >> uint(10)) & 2047u), float(_87 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _38(float _35, float _36, float _37)
{
    bool _205 = abs(_37) >= abs(_35);
    bool _213;
    if (_205)
    {
        _213 = abs(_37) >= abs(_36);
    }
    else
    {
        _213 = _205;
    }
    if (_213)
    {
        return uint((_37 < 0.0) ? 5 : 4);
    }
    if (abs(_36) >= abs(_35))
    {
        return uint((_36 < 0.0) ? 3 : 2);
    }
    return uint(int(_35 < 0.0));
}

float _70(float _68, float _69)
{
    return pow(_68, _69);
}

vec3 _116(vec3 _114, float _115)
{
    float _482 = 50.0 * dot(_114, vec3(0.33329999446868896484375));
    float _475 = _10(_482);
    float _491 = 1.0 - _115;
    float _494 = _10(_491);
    float _495 = 5.0;
    vec3 _499 = _114 + ((vec3(_475) - _114) * _70(_494, _495));
    return _16(_499);
}

vec3 _124(vec3 _119, vec3 _120, vec3 _121, vec3 _122, float _123)
{
    vec3 _503 = normalize(_120 + _121);
    float _508 = 1.0 - (_123 * 0.800000011920928955078125);
    _508 *= _508;
    _508 *= _508;
    float _519 = _508 * _508;
    float _527 = dot(_119, _503);
    float _523 = _10(_527);
    float _529 = ((_523 * _523) * (_519 - 1.0)) + 1.0;
    _529 = _519 / ((_529 * _529) + 9.9999999392252902907785028219223e-09);
    float _548 = dot(_119, _120);
    float _544 = (_10(_548) * (1.0 - _508)) + _508;
    float _559 = dot(_119, _121);
    float _555 = (_10(_559) * (1.0 - _508)) + _508;
    _529 /= (((4.0 * _544) * _555) + 9.9999999392252902907785028219223e-09);
    vec3 _577 = _122;
    float _579 = dot(_121, _503);
    return _116(_577, _579) * _529;
}

vec2 _161(vec2 _160)
{
    return (vec2(1.0) - abs(_160.yx)) * vec2((_160.x >= 0.0) ? 1.0 : (-1.0), (_160.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _166(inout vec3 _164, bool _165)
{
    _164 /= vec3((abs(_164.x) + abs(_164.y)) + abs(_164.z));
    vec2 _743;
    if (_164.z >= 0.0)
    {
        _743 = _164.xy;
    }
    else
    {
        vec2 _749 = _164.xy;
        _743 = _161(_749);
    }
    _164 = vec3(_743.x, _743.y, _164.z);
    if (_165)
    {
        vec2 _764 = (_164.xy * 0.5) + vec2(0.5);
        _164 = vec3(_764.x, _764.y, _164.z);
    }
    return _164.xy;
}

float _76(float _75)
{
    return sqrt(_75);
}

float _169(float _168)
{
    float _774 = abs(_168);
    float _771 = _76(_774);
    float _778;
    if (_168 > 0.0)
    {
        _778 = _771;
    }
    else
    {
        _778 = -_771;
    }
    return (_778 * 0.5) + 0.5;
}

void main()
{
    _792 _794 = _792(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _792 _804 = _792(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _804._m15 = _807;
    _804._m16 = gl_FragCoord;
    _804._m14 = _816._m0.xyz + _821.xyz;
    _804._m13 = normalize(-_821.xyz);
    _804._m17 = mat3(vec3(_833.xyz), vec3(_836.xyz), vec3(_839.xyz));
    _804._m34 = _857;
    _804._m35 = _861;
    _804._m36 = _865;
    uint _868 = 0u;
    vec4 _869 = vec4(0.0);
    vec4 _870 = vec4(0.0);
    vec4 _871 = vec4(0.0);
    vec4 _872 = vec4(0.0);
    vec4 _873 = vec4(0.0);
    _804._m0 = _871.xyz;
    _804._m2 = _872.xyz;
    _804._m1 = _870.xyz;
    _804._m9 = _869.xyz;
    _804._m3 = _869.w;
    _804._m6 = _873.wyz;
    _804._m12 = 0.0;
    mat3 _896 = transpose(_804._m17);
    vec3 _900 = normalize(vec3(dot(_804._m13, _896[0]), dot(_804._m13, _896[1]), dot(_804._m13, _896[2])));
    vec2 _918 = _807.xy;
    int _922 = 8;
    vec3 _923 = vec3(-_900.xy, 1.0);
    vec3 _930 = _923 / vec3(float(_922));
    vec3 _936 = vec3(_918, 0.0);
    vec2 _941 = _936.xy;
    float _960 = TEXTURE_LOD(_945, vec4(_936.xy, 0.0, 0.0).xy, vec4(_936.xy, 0.0, 0.0).w).w;
    float _944 = _62(_960);
    float _963 = _944 * _967._m2.x;
    float _972 = _963;
    int _974 = 0;
    for (;;)
    {
        bool _982 = _974 < _922;
        bool _989;
        if (_982)
        {
            _989 = _936.z < _963;
        }
        else
        {
            _989 = _982;
        }
        if (_989)
        {
            _941 = _936.xy;
            _972 = _963;
            _936 += _930;
            float _1010 = TEXTURE_LOD(_945, vec4(_936.xy, 0.0, 0.0).xy, vec4(_936.xy, 0.0, 0.0).w).w;
            _963 = _62(_1010) * _967._m2.x;
            _974++;
            continue;
        }
        else
        {
            break;
        }
    }
    float _1018 = _963 - _936.z;
    float _1023 = (_972 - _936.z) + _930.z;
    float _1037 = _1018 / (_1018 - _1023);
    float _1031 = _10(_1037);
    vec2 _1039 = mix(_936.xy, _941, vec2(_1031));
    vec2 _1047 = _1039;
    vec4 _1046 = _104(_945, _1047);
    _794._m0 = _1046.xyz;
    vec3 _1055 = _1046.xyz;
    vec3 _1070 = (_1046.www * _967._m3.w) * 8.0;
    _804._m0 = mix(_1046.xyz, _967._m3.xyz * _108(_1055), _16(_1070));
    _804._m2 = _967._m4.xxx;
    _804._m3 = _967._m4.y;
    _804._m6 = SAMPLE_TEXTURE(_1081, _918).xyz;
    vec3 _1090 = _794._m0;
    _794._m2 = _967._m4.zzz * _108(_1090);
    _794._m3 = _967._m4.w;
    _794._m6 = vec3(1.0) - SAMPLE_TEXTURE1(_1081, vec4(_1039, 0.0, 0.0).xy, vec4(_1039, 0.0, 0.0).w).xyz;
    vec3 _1116 = _794._m6;
    mat3 _1119 = _804._m17;
    bool _1122 = true;
    _794._m6 = _157(_1116, _1119, _1122);
    vec2 _1125 = _807.xy * _1130._m25.xy;
    vec4 _1136 = SAMPLE_TEXTURE(_1137, _1125);
    vec4 _1141 = SAMPLE_TEXTURE(_1142, _1125);
    float _1152 = _1147.x * 0.5;
    float _1146 = 1.0 - _10(_1152);
    float _1158 = _1146 * 2.0;
    float _1165 = (_10(_1158) - (1.0 - _1136.w)) * 1.0;
    float _1155 = _10(_1165);
    float _1174 = (_1146 - (1.0 - _1141.w)) * 1.0;
    float _1167 = _10(_1174);
    vec3 _1178 = _1136.xyz;
    _804._m0 = mix(_804._m0, _59(_1178), vec3(_1155));
    _804._m2 = mix(_804._m2, vec3(0.0199999995529651641845703125), vec3(_1155));
    _804._m3 = mix(_804._m3, 0.64999997615814208984375, _1155);
    _804._m6 = mix(_804._m6, _1141.xyz, vec3(_1167));
    uint _1208 = uint((_1130._m26.x > 0.0) ? 8 : 0);
    float _1215 = 16.0;
    float _1217 = 8.0;
    float _1218 = 24.0;
    vec2 _1227 = _804._m16.xy * _816._m2.xy;
    vec3 _1220;
    _1220 = vec3(_1227.x, _1227.y, _1220.z);
    _1220.y = 1.0 - _1220.y;
    
         // FIX FOR DECALS CLIPPING
    //clusterCoordinate.x -= vk3d_params[VIEW].stereo.x * 0.5;
   _1220.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    
    
    
    vec2 _1240 = floor(_1220.xy * vec2(_1215, _1217));
    _1220 = vec3(_1240.x, _1240.y, _1220.z);
    float _1244 = _804._m16.z;
    vec4 _1247 = _816._m3;
    float _1250 = 1.0;
    bool _1251 = false;
    float _1243 = _139(_1244, _1247, _1250, _1251);
    float _1253 = log2(max(1.0, _1243 / _816._m4.z)) * _816._m4.w;
    _1220.z = min(_1218 - 1.0, floor(_1253));
    uint _1269 = uint((_1220.x + (_1220.y * _1215)) + ((_1220.z * _1215) * _1217));
    bool _1285 = true;
    vec3 _1287 = _804._m6;
    bool _1290 = _1285;
    _804._m7 = _144(_1287, _1290);
    vec3 _1294 = _804._m7;
    mat3 _1297 = _804._m17;
    _804._m6 = _151(_1294, _1297);
    uint _1302 = 0u;
    uint _1303 = 0u;
    uint _1304 = 0u;
    uint _1305 = 0u;
    uint _1306 = 0u;
    uint _1307 = 0u;
    int _1308 = 256;
    _1310 _1312;
    _1312._m0 = _1317._m0[_1269]._m0;
    _1312._m1 = _1317._m0[_1269]._m1;
    int _1326 = _1312._m0 & (~(_1312._m0 >> 31));
    int _1335 = _1312._m1 & (~(_1312._m1 >> 31));
    _1302 = uint((_1326 >> 16) * _1308);
    _1303 = _1302 + uint(_1335 & 255);
    _1304 = _1302;
    _1305 = _1304 + uint((_1335 >> 8) & 255);
    _1306 = _1302;
    _1307 = _1306 + uint((_1335 >> 16) & 255);
    vec3 _1368 = vec3(0.0);
    vec3 _1369 = vec3(_804._m34.x, _804._m34.y, _804._m34.z);
    vec3 _1377 = vec3(_804._m34.w, _804._m35.x, _804._m35.y);
    vec3 _1385 = vec3(_804._m35.z, _804._m35.w, _804._m36.x);
    vec3 _1393 = vec3(_804._m36.y, _804._m36.z, _804._m36.w);
    vec3 _1401 = ((_1369 - (_1377 * _804._m6.y)) + (_1385 * _804._m6.z)) - (_1393 * _804._m6.x);
    float _1425 = _1130._m27.x * _816._m5.x;
    _1368 += max(_1401 * _10(_1425), vec3(0.0));
    float _1436;
    if (dot(_804._m10, vec3(1.0)) > 0.0)
    {
        _1436 = -_804._m3;
    }
    else
    {
        _1436 = _804._m3;
    }
    _804._m3 = _1436;
    _804._m18 = _1368;
    _804._m19 = _1368;
    float _1453 = 1.0;
    uint _1454 = _1306;
    _1490 _1492;
    while (_1454 < _1307)
    {
        uint _1464 = _1468._m0[_1454];
        uint _1473 = (_1464 >> uint(24)) & 4095u;
        uint _1478 = _1473;
        if (_1478 >= _1473)
        {
            _1454++;
        }
        int _1487 = 4;
        int _1488 = 4;
        int _1489 = 3;
        _1492._m0 = _1497._m0[(uint(_1487) * _1478) + 0u].xyz;
        float _1512 = _1497._m0[(uint(_1487) * _1478) + 0u].w;
        _1492._m1 = _21(_1512);
        _1492._m2 = _1497._m0[(uint(_1487) * _1478) + 1u];
        _1492._m3 = _1497._m0[(uint(_1487) * _1478) + 2u];
        _1492._m4 = _1536._m0[(uint(_1488) * _1478) + 0u];
        _1492._m5 = _1536._m0[(uint(_1488) * _1478) + 1u];
        _1492._m6 = _1536._m0[(uint(_1488) * _1478) + 2u];
        float _1566 = _1497._m0[(uint(_1487) * _1478) + 3u].x;
        _1492._m7.x = _21(_1566);
        float _1576 = _1497._m0[(uint(_1487) * _1478) + 3u].y;
        _1492._m7.y = _21(_1576);
        float _1586 = _1497._m0[(uint(_1487) * _1478) + 3u].z;
        _1492._m7.z = _21(_1586);
        float _1596 = _1497._m0[(uint(_1487) * _1478) + 3u].w;
        _1492._m7.w = _21(_1596);
        _1492._m8 = _1605._m0[(uint(_1489) * _1478) + 0u];
        _1492._m9 = _1605._m0[(uint(_1489) * _1478) + 1u];
        _1492._m10 = _1605._m0[(uint(_1489) * _1478) + 2u];
        float _1636 = _1536._m0[(uint(_1488) * _1478) + 3u].x;
        _1492._m11 = _21(_1636);
        float _1646 = _1536._m0[(uint(_1488) * _1478) + 3u].y;
        _1492._m12 = _21(_1646);
        _1492._m13 = _1536._m0[(uint(_1488) * _1478) + 3u].z;
        float _1664 = _1536._m0[(uint(_1488) * _1478) + 3u].w;
        _1492._m14 = _21(_1664);
        vec3 _1669 = vec3((_804._m14.x * _1492._m4.x) + ((_804._m14.y * _1492._m4.y) + ((_804._m14.z * _1492._m4.z) + _1492._m4.w)), (_804._m14.x * _1492._m5.x) + ((_804._m14.y * _1492._m5.y) + ((_804._m14.z * _1492._m5.z) + _1492._m5.w)), (_804._m14.x * _1492._m6.x) + ((_804._m14.y * _1492._m6.y) + ((_804._m14.z * _1492._m6.z) + _1492._m6.w)));
        vec2 _1736 = _1669.xy / vec2(_1669.z);
        _1669 = vec3(_1736.x, _1736.y, _1669.z);
        _1669.z = (_804._m14.x * _1492._m3.x) + ((_804._m14.y * _1492._m3.y) + ((_804._m14.z * _1492._m3.z) + _1492._m3.w));
        float _1760 = 0.0039215688593685626983642578125;
        float _1762 = _1669.x;
        float _1765 = _1669.y;
        float _1768 = _1669.z;
        bool _1773 = _32(_1762, _1765, _1768) < _1760;
        bool _1790;
        if (!_1773)
        {
            float _1777 = _1669.x;
            float _1780 = _1669.y;
            float _1783 = _1669.z;
            _1790 = _27(_1777, _1780, _1783) >= (1.0 - _1760);
        }
        else
        {
            _1790 = _1773;
        }
        if (_1790)
        {
            continue;
        }
        uint _1794 = _1492._m1;
        uint _1798 = _1492._m12;
        vec3 _1797 = _111(_1798);
        float _1802 = _1492._m13;
        vec3 _1805 = _1492._m0;
        uint _1809 = _1794;
        float _1808 = _81(_1809).y;
        vec3 _1813 = (_1669 * 2.0) - vec3(1.0);
        vec3 _1817 = _1813 * sqrt(((vec3(1.0) - ((_1813.yzx * _1813.yzx) * 0.5)) - ((_1813.zxy * _1813.zxy) * 0.5)) + ((((_1813.yzx * _1813.yzx) * _1813.zxy) * _1813.zxy) / vec3(3.0)));
        float _1861 = 1.0 - ((length(_1817) - _1808) / ((1.0 - _1808) + 9.9999999747524270787835121154785e-07));
        float _1850 = _10(_1861);
        _1850 *= _1850;
        _1850 *= (_1492._m8.w * _1453);
        _1453 *= (1.0 - _1850);
        if (_1850 <= (_1760 * 4.0))
        {
            continue;
        }
        vec3 _1883 = _1797;
        uint _1886 = _1794;
        float _1885 = _84(_1886).z;
        vec3 _1890 = vec3(0.0);
        vec3 _1891 = vec3(0.0);
        vec3 _1892 = _804._m6;
        _1892.x = dot(_1492._m2.xy, _804._m6.xy);
        _1892.y = dot(_1492._m2.zw, _804._m6.xy);
        vec3 _1911 = reflect(-_804._m13, _804._m6);
        vec3 _1918 = (_1492._m9.xyz - _804._m14) / _1911;
        vec3 _1927 = (_1492._m8.xyz - _804._m14) / _1911;
        vec3 _1936 = max(_1918, _1927);
        float _1941 = _1936.x;
        float _1944 = _1936.y;
        float _1947 = _1936.z;
        float _1940 = _32(_1941, _1944, _1947);
        vec3 _1951 = _804._m14 + (_1911 * _1940);
        vec3 _1958 = normalize(_1951 - _1805);
        vec3 _1963 = _1958;
        _1963.x = dot(_1492._m2.xy, _1958.xy);
        _1963.y = dot(_1492._m2.zw, _1958.xy);
        float _1985 = dot(_804._m13, _804._m6);
        float _1979 = _10(_1985);
        float _1987 = 0.0;
        float _1988 = 6.0;
        float _1990 = max(_1987, _1988 - (_1988 * abs(_804._m3)));
        _1891 = textureLod(_2003, vec4(_1963, _1885), _1990).xyz * _1802;
        float _2020 = _1979;
        float _2022 = abs(_804._m3);
        vec3 _2023 = _804._m2;
        vec3 _2016 = _130(_2020, _2022, _2023);
        _1891 *= _2016;
        float _2034 = _1850;
        _804._m20 += ((_1891 * _1883) * _10(_2034));
        if (_1453 <= (_1760 * 4.0))
        {
            break;
        }
    }
    uint _2049 = _1302;
    _1490 _2078;
    vec3 _2363;
    float _2440;
    float _2458;
    _2829 _2831;
    uint _2952;
    _2829 _2976;
    while (_2049 < _1303)
    {
        uint _2059 = _1468._m0[_2049];
        uint _2063 = _2059 & 4095u;
        uint _2066 = _2063;
        if (_2066 >= _2063)
        {
            _2049++;
        }
        int _2075 = 4;
        int _2076 = 4;
        int _2077 = 3;
        _2078._m0 = _1497._m0[(uint(_2075) * _2066) + 0u].xyz;
        float _2093 = _1497._m0[(uint(_2075) * _2066) + 0u].w;
        _2078._m1 = _21(_2093);
        _2078._m2 = _1497._m0[(uint(_2075) * _2066) + 1u];
        _2078._m3 = _1497._m0[(uint(_2075) * _2066) + 2u];
        _2078._m4 = _1536._m0[(uint(_2076) * _2066) + 0u];
        _2078._m5 = _1536._m0[(uint(_2076) * _2066) + 1u];
        _2078._m6 = _1536._m0[(uint(_2076) * _2066) + 2u];
        float _2143 = _1497._m0[(uint(_2075) * _2066) + 3u].x;
        _2078._m7.x = _21(_2143);
        float _2153 = _1497._m0[(uint(_2075) * _2066) + 3u].y;
        _2078._m7.y = _21(_2153);
        float _2163 = _1497._m0[(uint(_2075) * _2066) + 3u].z;
        _2078._m7.z = _21(_2163);
        float _2173 = _1497._m0[(uint(_2075) * _2066) + 3u].w;
        _2078._m7.w = _21(_2173);
        _2078._m8 = _1605._m0[(uint(_2077) * _2066) + 0u];
        _2078._m9 = _1605._m0[(uint(_2077) * _2066) + 1u];
        _2078._m10 = _1605._m0[(uint(_2077) * _2066) + 2u];
        float _2207 = _1536._m0[(uint(_2076) * _2066) + 3u].x;
        _2078._m11 = _21(_2207);
        float _2217 = _1536._m0[(uint(_2076) * _2066) + 3u].y;
        _2078._m12 = _21(_2217);
        _2078._m13 = _1536._m0[(uint(_2076) * _2066) + 3u].z;
        float _2235 = _1536._m0[(uint(_2076) * _2066) + 3u].w;
        _2078._m14 = _21(_2235);
        float _2240 = 0.0039215688593685626983642578125;
        vec4 _2241 = vec4(_804._m14, 1.0);
        float _2248 = 1.0 / dot(_2241, _2078._m6);
        vec3 _2254 = vec3(dot(_2241, _2078._m4) * _2248, dot(_2241, _2078._m5) * _2248, dot(_2241, _2078._m3));
        uint _2272 = _2078._m1;
        uint _2275 = _1208;
        _2275 |= 64u;
        float _2280 = _2254.x;
        float _2283 = _2254.y;
        float _2286 = _2254.z;
        bool _2291 = _32(_2280, _2283, _2286) <= _2240;
        bool _2308;
        if (!_2291)
        {
            float _2295 = _2254.x;
            float _2298 = _2254.y;
            float _2301 = _2254.z;
            _2308 = _27(_2295, _2298, _2301) >= (1.0 - _2240);
        }
        else
        {
            _2308 = _2291;
        }
        bool _2316;
        if (!_2308)
        {
            _2316 = (_2272 & _2275) != 0u;
        }
        else
        {
            _2316 = _2308;
        }
        if (_2316)
        {
            continue;
        }
        if ((_2272 & 3u) == 2u)
        {
            vec2 _2335 = fract((_2254.xy * _816._m6.xy) + _816._m6.zw);
            _2254 = vec3(_2335.x, _2335.y, _2254.z);
        }
        vec3 _2338 = _2078._m0;
        float _2341 = 1.0;
        float _2342 = 1.0;
        vec3 _2343 = vec3(0.0, 0.0, 1.0);
        vec3 _2344 = vec3(0.0, 0.0, 1.0);
        uint _2345 = _2078._m1;
        vec3 _2348 = (_2254 * 2.0) - vec3(1.0);
        vec2 _2353 = _2254.xy;
        vec3 _2356 = _2078._m10.xyz;
        if ((_2345 & 3u) == 2u)
        {
            _2363 = _2356;
        }
        else
        {
            _2363 = normalize(_2338 - _804._m14);
        }
        _2343 = _2363;
        _2343 = _2343;
        float _2380 = dot(_804._m6, _2343);
        float _2375 = _10(_2380);
        uvec2 _2383 = _2078._m7.zw;
        vec4 _2382 = _94(_2383);
        float _2389 = TEXTURE_LOD(_2390, vec4((_2353 * _2382.xy) + _2382.zw, 0.0, 0.0).xy, vec4((_2353 * _2382.xy) + _2382.zw, 0.0, 0.0).w).x;
        float _2416 = _2389 * _2389;
        uint _2420 = _2345 & 3u;
        bool _2425 = _2420 == 1u;
        bool _2437;
        if (!_2425)
        {
            bool _2430 = _2420 == 0u;
            bool _2436;
            if (_2430)
            {
                _2436 = _2078._m8.z != 0.0;
            }
            else
            {
                _2436 = _2430;
            }
            _2437 = _2436;
        }
        else
        {
            _2437 = _2425;
        }
        bool _2423 = _2437;
        if (_2423)
        {
            float _2443 = _2078._m8.w;
            _2440 = _10(_2443);
        }
        else
        {
            _2440 = 0.5;
        }
        float _2438 = _2440;
        bool _2451 = _2420 == 0u;
        bool _2457;
        if (_2451)
        {
            _2457 = _2078._m8.z != 0.0;
        }
        else
        {
            _2457 = _2451;
        }
        if (_2457)
        {
            float _2466 = sqrt(dot(_2348, _2348));
            _2458 = min(0.9921875, _10(_2466));
        }
        else
        {
            _2458 = _2254.z;
        }
        float _2449 = _2458;
        uvec2 _2474 = _2078._m7.xy;
        vec4 _2473 = _94(_2474);
        vec2 _2479 = vec2(_2449, _2438);
        float _2483 = TEXTURE_LOD(_2390, vec4((_2479 * _2473.xy) + _2473.zw, 0.0, 0.0).xy, vec4((_2479 * _2473.xy) + _2473.zw, 0.0, 0.0).w).x;
        _2483 *= _2483;
        _2341 = _2483 * _2416;
        if ((_2345 & 48u) != 0u)
        {
            vec4 _2521 = _2078._m10;
            vec4 _2524 = _2078._m8;
            vec4 _2527 = _2078._m9;
            float _2530 = dot(_804._m14, _2521.xyz) + _2521.w;
            if (_2530 < 0.0)
            {
                continue;
            }
            float _2544 = length(_2521.xyz);
            float _2551 = _2530 * 50.0;
            float _2548 = _10(_2551);
            _2341 *= (_2548 * _2548);
            _2530 /= _2544;
            _2521 /= vec4(_2544);
            vec3 _2565 = reflect(-_804._m13, _804._m6);
            if (dot(_2565, _2521.xyz) > 0.0)
            {
                _2565 = reflect(_2565, _2521.xyz);
            }
            float _2583 = dot(_2565, _2521.xyz);
            float _2588 = _2530 / _2583;
            vec3 _2592 = _804._m14 - (_2565 * _2588);
            vec3 _2599 = _2592 - _2338;
            float _2603 = dot(_2599, _2524.xyz) / _2524.w;
            float _2611 = dot(_2599, _2527.xyz) / _2527.w;
            if ((_2345 & 48u) == 32u)
            {
                vec2 _2625 = vec2(_2603, _2611);
                float _2629 = 1.0 / max(1.0, length(vec2(_2603, _2611)));
                _2603 *= (_2629 * _2524.w);
                _2611 *= (_2629 * _2527.w);
            }
            else
            {
                float _2651 = abs(_2603);
                float _2653 = _2603;
                _2603 = (_10(_2651) * _73(_2653)) * _2524.w;
                float _2662 = abs(_2611);
                float _2664 = _2611;
                _2611 = (_10(_2662) * _73(_2664)) * _2527.w;
            }
            vec3 _2671 = (_2524.xyz * _2603) + (_2527.xyz * _2611);
            _2338 += _2671;
            _2343 = normalize(_2338 - _804._m14);
            _2343 = _2343;
        }
        else
        {
            uint _2691 = (_2078._m14 >> uint(16)) & 255u;
            if (_2691 == 0u)
            {
                vec4 _2700 = _2078._m9;
                if (dot(_2700.xyz, _804._m14) < (_2700.w - _2240))
                {
                    continue;
                }
            }
            else
            {
                if (_2691 == 1u)
                {
                    vec3 _2721 = _2078._m9.xyz;
                    float _2726 = _2078._m9.w;
                    uint _2730 = _21(_2726);
                    vec3 _2725 = (((_88(_2730) * 2.0) - vec3(1.0)) * _2721) + _2338;
                    vec3 _2739 = abs((_804._m14 - _2725) / _2721);
                    float _2747 = _2739.x;
                    float _2750 = _2739.y;
                    float _2753 = _2739.z;
                    if (_27(_2747, _2750, _2753) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_2341 <= (_2240 / 256.0))
        {
            continue;
        }
        float _2769 = 1.0;
        if ((_2272 & 4u) != 0u)
        {
            float _2776 = float(_2078._m14 & 255u) / 255.0;
            float _2782 = 0.001000000047497451305389404296875;
            vec3 _2784 = _804._m14 + (_804._m6 * _2782);
            uint _2792 = 0u;
            if ((_2272 & 3u) == 0u)
            {
                vec3 _2798 = _2784 - _2078._m2.xyz;
                float _2804 = _2798.x;
                float _2807 = _2798.y;
                float _2810 = _2798.z;
                _2792 = _38(_2804, _2807, _2810);
            }
            else
            {
                if ((_2272 & 3u) == 2u)
                {
                    float _2820 = 0.0;
                    for (; _2792 < 3u; _2792++)
                    {
                        int _2828 = 5;
                        _2831._m0 = _2835._m0[(uint(_2828) * ((_2272 >> uint(22)) + _2792)) + 0u];
                        _2831._m1 = _2835._m0[(uint(_2828) * ((_2272 >> uint(22)) + _2792)) + 1u];
                        _2831._m2 = _2835._m0[(uint(_2828) * ((_2272 >> uint(22)) + _2792)) + 2u];
                        _2831._m3 = _2835._m0[(uint(_2828) * ((_2272 >> uint(22)) + _2792)) + 3u];
                        _2831._m4 = _2835._m0[(uint(_2828) * ((_2272 >> uint(22)) + _2792)) + 4u];
                        vec2 _2892 = vec2(dot(_2784, _2831._m0.xyz) + _2831._m0.w, dot(_2784, _2831._m1.xyz) + _2831._m1.w);
                        _2892 = abs((_2892 * 2.0) - vec2(1.0));
                        bool _2917 = _2892.x < 1.0;
                        bool _2923;
                        if (_2917)
                        {
                            _2923 = _2892.y < 1.0;
                        }
                        else
                        {
                            _2923 = _2917;
                        }
                        if (_2923)
                        {
                            _2820 = (1.0 - max(_2892.x, _2892.y)) * _816._m7.w;
                            break;
                        }
                    }
                    _2792 = min(2u, _2792);
                    uint _2940 = uint(_804._m16.x) ^ (uint(_804._m16.y) << uint(1));
                    if (_816._m8.w > 0.0)
                    {
                        _2952 = uint(_816._m9.x);
                    }
                    else
                    {
                        _2952 = 0u;
                    }
                    _2940 ^= _2952;
                    _2792 += uint(int(((float(_2940 & 3u) * 0.25) + 0.125) > _2820));
                }
            }
            int _2975 = 5;
            _2976._m0 = _2835._m0[(uint(_2975) * ((_2272 >> uint(22)) + _2792)) + 0u];
            _2976._m1 = _2835._m0[(uint(_2975) * ((_2272 >> uint(22)) + _2792)) + 1u];
            _2976._m2 = _2835._m0[(uint(_2975) * ((_2272 >> uint(22)) + _2792)) + 2u];
            _2976._m3 = _2835._m0[(uint(_2975) * ((_2272 >> uint(22)) + _2792)) + 3u];
            _2976._m4 = _2835._m0[(uint(_2975) * ((_2272 >> uint(22)) + _2792)) + 4u];
            vec4 _3032 = vec4((_2784.x * _2976._m0.x) + ((_2784.y * _2976._m0.y) + ((_2784.z * _2976._m0.z) + _2976._m0.w)), (_2784.x * _2976._m1.x) + ((_2784.y * _2976._m1.y) + ((_2784.z * _2976._m1.z) + _2976._m1.w)), (_2784.x * _2976._m2.x) + ((_2784.y * _2976._m2.y) + ((_2784.z * _2976._m2.z) + _2976._m2.w)), (_2784.x * _2976._m3.x) + ((_2784.y * _2976._m3.y) + ((_2784.z * _2976._m3.z) + _2976._m3.w)));
            vec3 _3119 = _3032.xyz / vec3(_3032.w);
            _3032 = vec4(_3119.x, _3119.y, _3119.z, _3032.w);
            bool _3127 = min(_3032.x, _3032.y) > 0.0;
            bool _3136;
            if (_3127)
            {
                _3136 = max(_3032.x, _3032.y) < 1.0;
            }
            else
            {
                _3136 = _3127;
            }
            if (_3136)
            {
                vec2 _3148 = (_3032.xy * _2976._m4.xy) + _2976._m4.zw;
                _3032 = vec4(_3148.x, _3148.y, _3032.z, _3032.w);
                if (false)
                {
                    _2769 = textureLod(_3156, vec3(_3032.xyz.xy, _3032.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3163 = (_3032.xy * _816._m10.xy) + vec2(0.5);
                    vec2 _3172 = floor(_3163);
                    vec2 _3175 = _3163 - _3172;
                    _3172 -= vec2(0.5);
                    vec2 _3182 = vec2(4.0) - (_3175 * 3.0);
                    vec2 _3187 = vec2(7.0);
                    vec2 _3190 = vec2(1.0) + (_3175 * 3.0);
                    vec2 _3195 = (_3172 + (((vec2(3.0) - (_3175 * 2.0)) / _3182) - vec2(2.0))) * _816._m10.zw;
                    vec2 _3210 = (_3172 + ((vec2(3.0) + _3175) / _3187)) * _816._m10.zw;
                    vec2 _3222 = (_3172 + ((_3175 / _3190) + vec2(2.0))) * _816._m10.zw;
                    vec3 _3246 = vec3(_3195.x, _3195.y, _3032.z);
                    _2769 = (_3182.x * _3182.y) * textureLod(_3156, vec3(_3246.xy, _3246.z), 0.0);
                    vec3 _3262 = vec3(_3210.x, _3195.y, _3032.z);
                    _2769 += ((_3187.x * _3182.y) * textureLod(_3156, vec3(_3262.xy, _3262.z), 0.0));
                    vec3 _3280 = vec3(_3222.x, _3195.y, _3032.z);
                    _2769 += ((_3190.x * _3182.y) * textureLod(_3156, vec3(_3280.xy, _3280.z), 0.0));
                    vec3 _3298 = vec3(_3195.x, _3210.y, _3032.z);
                    _2769 += ((_3182.x * _3187.y) * textureLod(_3156, vec3(_3298.xy, _3298.z), 0.0));
                    vec3 _3316 = vec3(_3210.x, _3210.y, _3032.z);
                    _2769 += ((_3187.x * _3187.y) * textureLod(_3156, vec3(_3316.xy, _3316.z), 0.0));
                    vec3 _3334 = vec3(_3222.x, _3210.y, _3032.z);
                    _2769 += ((_3190.x * _3187.y) * textureLod(_3156, vec3(_3334.xy, _3334.z), 0.0));
                    vec3 _3352 = vec3(_3195.x, _3222.y, _3032.z);
                    _2769 += ((_3182.x * _3190.y) * textureLod(_3156, vec3(_3352.xy, _3352.z), 0.0));
                    vec3 _3370 = vec3(_3210.x, _3222.y, _3032.z);
                    _2769 += ((_3187.x * _3190.y) * textureLod(_3156, vec3(_3370.xy, _3370.z), 0.0));
                    vec3 _3388 = vec3(_3222.x, _3222.y, _3032.z);
                    _2769 += ((_3190.x * _3190.y) * textureLod(_3156, vec3(_3388.xy, _3388.z), 0.0));
                    _2769 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _2769 = float((_2272 & 3u) == 2u);
            }
            float _3402 = float((_2272 >> uint(16)) & 63u) / 63.0;
            float _3416 = ((_2769 * _3402) + 1.0) - _3402;
            _2769 = _10(_3416);
        }
        uint _3419 = _2078._m12;
        vec3 _3418 = (_111(_3419) * _2769) * _2341;
        _2342 *= _2078._m13;
        vec3 _3431 = _3418;
        vec3 _3433 = normalize(_2338 - _804._m14);
        float _3444 = dot(_804._m6, _3433);
        float _3439 = _10(_3444);
        vec3 _3447 = _804._m6;
        vec3 _3450 = _804._m13;
        vec3 _3453 = _3433;
        vec3 _3455 = _804._m2;
        float _3458 = _804._m3;
        vec3 _3446 = _124(_3447, _3450, _3453, _3455, _3458);
        _804._m20 += (((_3446 * _2342) * _3431) * _3439);
        float _3480 = 1.25;
        float _3483 = (dot(_794._m6, _3433) + 0.25) / _62(_3480);
        float _3473 = _10(_3483);
        _804._m19 += (_3431 * _3473);
        vec3 _3493 = _794._m6;
        vec3 _3496 = _804._m13;
        vec3 _3499 = _3433;
        vec3 _3501 = _794._m2;
        float _3504 = _794._m3;
        vec3 _3492 = _124(_3493, _3496, _3499, _3501, _3504);
        _804._m20 += (((_3492 * _2342) * _3431) * _3439);
    }
    _804._m19 = _804._m19;
    _804._m20 += _804._m10;
    _804._m19 *= _804._m0;
    _804._m21 = _804._m19 + _804._m20;
    float _3546 = dot(_804._m6, _804._m13);
    float _3540 = _10(_3546);
    vec3 _3549 = _804._m19;
    vec3 _3555 = _804._m6;
    vec3 _3558 = _804._m13;
    vec3 _3561 = _804._m13;
    vec3 _3564 = _804._m2;
    float _3567 = _804._m3;
    vec3 _3548 = (_16(_3549) * _3540) * _124(_3555, _3558, _3561, _3564, _3567);
    _804._m19 += _3548;
    vec3 _3583 = _804._m19 + _804._m20;
    _3578 = vec4(_3583.x, _3583.y, _3583.z, _3578.w);
    vec3 _3587 = _804._m6;
    bool _3590 = false;
    vec2 _3591 = _166(_3587, _3590);
    _3586 = vec4(_3591.x, _3591.y, _3586.z, _3586.w);
    float _3595 = _804._m2.x;
    float _3599 = _804._m2.y;
    float _3603 = _804._m2.z;
    float _3607 = _804._m3;
    _3594 = vec4(_76(_3595), _76(_3599), _76(_3603), _169(_3607));
    vec3 _3618 = _3578.xyz + _1130._m28.xyz;
    _3578 = vec4(_3618.x, _3618.y, _3618.z, _3578.w);
}


