// FIX FOR DECALS CLIPPING
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _799
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1075
{
    int _m0;
    int _m1;
};

struct _1078
{
    int _m0;
    int _m1;
};

struct _1189
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2056
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _3402
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _820_822
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
} _822;

layout(set = 2, binding = 0, std140) uniform _903_905
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _905;

layout(set = 1, binding = 0, std140) uniform _949_951
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _951;

layout(set = 0, binding = 4, std430) restrict readonly buffer _1080_1082
{
    _1078 _m0[];
} _1082;

layout(set = 0, binding = 5, std430) restrict readonly buffer _1164_1166
{
    uint _m0[];
} _1166;

layout(set = 0, binding = 6, std140) uniform _1194_1196
{
    vec4 _m0[4096];
} _1196;

layout(set = 0, binding = 7, std140) uniform _1214_1216
{
    vec4 _m0[4096];
} _1216;

layout(set = 0, binding = 8, std140) uniform _1266_1268
{
    vec4 _m0[4096];
} _1268;

layout(set = 0, binding = 10, std140) uniform _2060_2062
{
    vec4 _m0[4096];
} _2062;

layout(set = 0, binding = 11, std140) uniform _2099_2101
{
    vec4 _m0[4096];
} _2101;

layout(set = 0, binding = 12, std140) uniform _2168_2170
{
    vec4 _m0[3072];
} _2170;

layout(set = 0, binding = 15, std140) uniform _3406_3408
{
    vec4 _m0[4095];
} _3408;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4448_4450
{
    vec4 _m0[];
} _4450;

layout(push_constant, std430) uniform _4444_4446
{
    int _m0;
    int _m1;
} _4446;

layout(set = 2, binding = 1) uniform SAMPLER_2D _911;
layout(set = 2, binding = 2) uniform SAMPLER_2D _916;
layout(set = 2, binding = 3) uniform SAMPLER_2D _921;
layout(set = 2, binding = 4) uniform SAMPLER_2D _926;
layout(set = 2, binding = 5) uniform SAMPLER_2D _944;
layout(set = 0, binding = 9) uniform SAMPLER_2D _1488;
layout(set = 0, binding = 13) uniform samplerCubeArray _2566;
layout(set = 0, binding = 14) uniform SAMPLER_2D _2965;
layout(set = 0, binding = 16) uniform sampler2DShadow _3729;
layout(set = 0, binding = 17) uniform sampler3D _4204;
layout(set = 0, binding = 18) uniform sampler3D _4225;
layout(set = 0, binding = 19) uniform sampler3D _4342;
layout(set = 0, binding = 20) uniform SAMPLER_2D _4415;
layout(set = 0, binding = 2) uniform sampler3D _4451;
layout(set = 0, binding = 3) uniform sampler3D _4452;

layout(location = 2) in vec4 _813;
layout(location = 6) in vec4 _827;
layout(location = 3) in vec4 _839;
layout(location = 4) in vec4 _842;
layout(location = 5) in vec4 _845;
layout(location = 10) in vec4 _863;
layout(location = 11) in vec4 _867;
layout(location = 12) in vec4 _871;
layout(location = 0) out vec4 _4122;
layout(location = 1) out vec4 _4397;
layout(location = 2) out vec4 _4398;

float _274;

float _57(float _56)
{
    return _56 * ((_56 * ((_56 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec3 _60(vec3 _59)
{
    float _311 = _59.x;
    vec3 _310;
    _310.x = _57(_311);
    float _316 = _59.y;
    _310.y = _57(_316);
    float _321 = _59.z;
    _310.z = _57(_321);
    return _310;
}

vec4 _63(vec4 _62)
{
    vec3 _330 = _62.xyz;
    vec4 _329 = vec4(_60(_330), 1.0);
    float _338 = _62.w;
    _329.w = _57(_338);
    return _329;
}

vec4 _118(SAMPLER_2D _116, vec2 _117)
{
    vec4 _543 = SAMPLE_TEXTURE(_116, _117);
    vec4 _547 = _543;
    _543 = _63(_547);
    return _543;
}

vec3 _20(vec3 _19)
{
    return clamp(_19, vec3(0.0), vec3(1.0));
}

float _14(float _13)
{
    return clamp(_13, 0.0, 1.0);
}

float _156(float _152, vec4 _153, float _154, bool _155)
{
    float _735 = _153.w / (_152 + _153.z);
    return _735 * _154;
}

vec3 _161(vec3 _159, bool _160)
{
    vec3 _748 = (_159 * 2.0) - vec3(1.0);
    float _765 = (1.0 - (_748.x * _748.x)) - (_748.y * _748.y);
    _748.z = sqrt(_14(_765));
    if (_160 == false)
    {
        _748.z = -_748.z;
    }
    return _748;
}

vec3 _168(vec3 _166, mat3 _167)
{
    return normalize(vec3(dot(_166, _167[0]), dot(_166, _167[1]), dot(_166, _167[2])));
}

uint _31(float _30)
{
    return floatBitsToUint(_30);
}

float _42(float _39, float _40, float _41)
{
    return min(_39, min(_40, _41));
}

float _37(float _34, float _35, float _36)
{
    return max(_34, max(_35, _36));
}

vec4 _95(uint _94)
{
    return unpackUnorm4x8(_94).wzyx;
}

vec4 _108(uvec2 _107)
{
    return vec4(float((_107.x >> uint(16)) & 65535u), float(_107.x & 65535u), float((_107.y >> uint(16)) & 65535u), float(_107.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _125(SAMPLER_2D _121, vec2 _122, vec2 _123, vec2 _124)
{
    return TEXTURE_GRAD(_121, _122, _123, _124);
}

void _10(float _9)
{
    if (_9 < 0.0)
    {
        discard;
    }
}

vec4 _98(uint _97)
{
    return vec4(float((_97 >> uint(24)) & 255u), float((_97 >> uint(16)) & 255u), float((_97 >> uint(8)) & 255u), float(_97 & 255u));
}

float _77(float _76)
{
    return (step(0.0, _76) * 2.0) - 1.0;
}

vec4 _26(vec4 _25)
{
    return clamp(_25, vec4(0.0), vec4(1.0));
}

float _69(float _68)
{
    return exp2(_68);
}

vec3 _128(uint _127)
{
    uint _561 = _127;
    vec4 _560 = _95(_561);
    float _572 = (_560.w * 255.0) - 128.0;
    return _560.xyz * _69(_572);
}

vec3 _147(float _144, float _145, vec3 _146)
{
    float _687 = 0.0949999988079071044921875 + (_145 * (0.60000002384185791015625 + (4.190000057220458984375 * _145)));
    float _697 = _144 + 0.02500000037252902984619140625;
    float _701 = (9.5 * _145) * _144;
    float _715 = 1.0 - (14.0 * _144);
    float _707 = (_687 * _697) * _69(_715);
    float _722 = -_701;
    float _718 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _69(_722)));
    return mix(vec3(_707), vec3(_718), _146);
}

vec3 _102(uint _101)
{
    return vec3(float((_101 >> uint(21)) & 2047u), float((_101 >> uint(10)) & 2047u), float(_101 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _48(float _45, float _46, float _47)
{
    bool _215 = abs(_47) >= abs(_45);
    bool _223;
    if (_215)
    {
        _223 = abs(_47) >= abs(_46);
    }
    else
    {
        _223 = _215;
    }
    if (_223)
    {
        return uint((_47 < 0.0) ? 5 : 4);
    }
    if (abs(_46) >= abs(_45))
    {
        return uint((_46 < 0.0) ? 3 : 2);
    }
    return uint(int(_45 < 0.0));
}

float _74(float _72, float _73)
{
    return pow(_72, _73);
}

vec3 _133(vec3 _131, float _132)
{
    float _584 = 50.0 * dot(_131, vec3(0.33329999446868896484375));
    float _577 = _14(_584);
    float _593 = 1.0 - _132;
    float _596 = _14(_593);
    float _597 = 5.0;
    vec3 _601 = _131 + ((vec3(_577) - _131) * _74(_596, _597));
    return _20(_601);
}

vec3 _141(vec3 _136, vec3 _137, vec3 _138, vec3 _139, float _140)
{
    vec3 _605 = normalize(_137 + _138);
    float _610 = 1.0 - (_140 * 0.800000011920928955078125);
    _610 *= _610;
    _610 *= _610;
    float _621 = _610 * _610;
    float _629 = dot(_136, _605);
    float _625 = _14(_629);
    float _631 = ((_625 * _625) * (_621 - 1.0)) + 1.0;
    _631 = _621 / ((_631 * _631) + 9.9999999392252902907785028219223e-09);
    float _650 = dot(_136, _137);
    float _646 = (_14(_650) * (1.0 - _610)) + _610;
    float _661 = dot(_136, _138);
    float _657 = (_14(_661) * (1.0 - _610)) + _610;
    _631 /= (((4.0 * _646) * _657) + 9.9999999392252902907785028219223e-09);
    vec3 _679 = _139;
    float _681 = dot(_138, _605);
    return _133(_679, _681) * _631;
}

float _51(float _50)
{
    if (_50 <= 0.040449999272823333740234375)
    {
        return _50 / 12.9200000762939453125;
    }
    else
    {
        return pow((_50 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _54(vec3 _53)
{
    float _276 = _53.x;
    vec3 _275;
    _275.x = _51(_276);
    float _282 = _53.y;
    _275.y = _51(_282);
    float _288 = _53.z;
    _275.z = _51(_288);
    return _275;
}

vec3 _66(vec3 _65)
{
    vec3 _347 = _65;
    return _54(_347);
}

float _80(float _79)
{
    float _368 = (((-0.15658299624919891357421875) * abs(_79)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_79));
    float _380;
    if (_79 >= 0.0)
    {
        _380 = _368;
    }
    else
    {
        _380 = 3.1415927410125732421875 - _368;
    }
    return _380;
}

float _83(float _82)
{
    float _394;
    if (_82 < 1.0)
    {
        _394 = _82;
    }
    else
    {
        _394 = 1.0 / _82;
    }
    float _393 = _394;
    float _404 = _393 * _393;
    float _408 = 0.087292902171611785888671875;
    _408 = (-0.3018949925899505615234375) + (_408 * _404);
    _408 = 1.0 + (_408 * _404);
    _408 *= _393;
    float _422;
    if (_82 < 1.0)
    {
        _422 = _408;
    }
    else
    {
        _422 = 1.57079637050628662109375 - _408;
    }
    return _422;
}

float _86(float _85)
{
    float _437 = abs(_85);
    float _434 = _83(_437);
    float _439;
    if (_85 < 0.0)
    {
        _439 = -_434;
    }
    else
    {
        _439 = _434;
    }
    return _439;
}

float _90(float _88, float _89)
{
    float _455 = _88 / _89;
    float _451 = _86(_455);
    if (_89 < 0.0)
    {
        _451 += ((_88 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _451;
}

void main()
{
    _799 _801 = _799(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _801._m15 = _813;
    _801._m16 = gl_FragCoord;
    _801._m14 = _822._m4.xyz + _827.xyz;
    _801._m13 = normalize(-_827.xyz);
    _801._m17 = mat3(vec3(_839.xyz), vec3(_842.xyz), vec3(_845.xyz));
    _801._m34 = _863;
    _801._m35 = _867;
    _801._m36 = _871;
    uint _874 = 0u;
    vec4 _875 = vec4(0.0);
    vec4 _876 = vec4(0.0);
    vec4 _877 = vec4(0.0);
    vec4 _878 = vec4(0.0);
    vec4 _879 = vec4(0.0);
    _801._m0 = _877.xyz;
    _801._m2 = _878.xyz;
    _801._m1 = _876.xyz;
    _801._m9 = _875.xyz;
    _801._m3 = _875.w;
    _801._m6 = _879.wyz;
    vec2 _900 = _813.xy * _905._m2.xy;
    vec4 _910 = SAMPLE_TEXTURE(_911, _900);
    vec2 _917 = _900;
    vec4 _915 = _118(_916, _917);
    vec4 _920 = SAMPLE_TEXTURE(_921, _900);
    float _925 = SAMPLE_TEXTURE(_926, _900).x;
    _801._m0 = _915.xyz;
    vec3 _934 = _920.xyz;
    _801._m2 = _20(_934);
    _801._m3 = _925;
    _801._m6 = _910.xyz;
    _801._m10 = (SAMPLE_TEXTURE(_944, _900).xyz * _951._m6.xyz) * vec3(_951._m7.x);
    float _969 = _905._m3.x + _915.w;
    _801._m11 = _14(_969);
    uint _972 = uint((_951._m8.x > 0.0) ? 8 : 0);
    float _978 = 16.0;
    float _980 = 8.0;
    float _982 = 24.0;
    vec2 _991 = _801._m16.xy * _822._m6.xy;
    vec3 _984;
    _984 = vec3(_991.x, _991.y, _984.z);
    _984.y = 1.0 - _984.y;
         // FIX FOR DECALS CLIPPING
    //clusterCoordinate.x -= vk3d_params[VIEW].stereo.x * 0.5;
   _984.x -= vk3d_params[VIEW].stereo.x * 0.5;
    vec2 _1004 = floor(_984.xy * vec2(_978, _980));
    _984 = vec3(_1004.x, _1004.y, _984.z);
    float _1008 = _801._m16.z;
    vec4 _1011 = _822._m7;
    float _1014 = 1.0;
    bool _1015 = false;
    float _1007 = _156(_1008, _1011, _1014, _1015);
    float _1017 = log2(max(1.0, _1007 / _822._m8.z)) * _822._m8.w;
    _984.z = min(_982 - 1.0, floor(_1017));
    uint _1033 = uint((_984.x + (_984.y * _978)) + ((_984.z * _978) * _980));
    bool _1049 = true;
    vec3 _1051 = _801._m6;
    bool _1054 = _1049;
    _801._m7 = _161(_1051, _1054);
    vec3 _1058 = _801._m7;
    mat3 _1061 = _801._m17;
    _801._m6 = _168(_1058, _1061);
    uint _1066 = 0u;
    uint _1067 = 0u;
    uint _1068 = 0u;
    uint _1069 = 0u;
    uint _1070 = 0u;
    uint _1071 = 0u;
    int _1073 = 256;
    _1075 _1077;
    _1077._m0 = _1082._m0[_1033]._m0;
    _1077._m1 = _1082._m0[_1033]._m1;
    int _1091 = _1077._m0 & (~(_1077._m0 >> 31));
    int _1100 = _1077._m1 & (~(_1077._m1 >> 31));
    _1066 = uint((_1091 >> 16) * _1073);
    _1067 = _1066 + uint(_1100 & 255);
    _1068 = _1066;
    _1069 = _1068 + uint((_1100 >> 8) & 255);
    _1070 = _1066;
    _1071 = _1070 + uint((_1100 >> 16) & 255);
    vec3 _1133 = dFdx(_801._m14);
    vec3 _1137 = dFdy(_801._m14);
    bool _1142 = _972 == 0u;
    bool _1148;
    if (_1142)
    {
        _1148 = _951._m8.y == 0.0;
    }
    else
    {
        _1148 = _1142;
    }
    _1068 = _1148 ? _1069 : _1068;
    uint _1152 = _1068;
    _1189 _1191;
    vec3 _1552;
    float _1685;
    while (_1152 < _1069)
    {
        uint _1162 = _1166._m0[_1152];
        uint _1171 = (_1162 >> uint(12)) & 4095u;
        uint _1177 = _1171;
        if (_1177 >= _1171)
        {
            _1152++;
        }
        int _1186 = 2;
        int _1187 = 2;
        int _1188 = 2;
        _1191._m0 = _1196._m0[(uint(_1186) * _1177) + 0u];
        _1191._m1 = _1196._m0[(uint(_1186) * _1177) + 1u];
        _1191._m2 = _1216._m0[(uint(_1187) * _1177) + 0u];
        float _1230 = _1216._m0[(uint(_1187) * _1177) + 1u].x;
        _1191._m3.x = _31(_1230);
        float _1240 = _1216._m0[(uint(_1187) * _1177) + 1u].y;
        _1191._m3.y = _31(_1240);
        float _1250 = _1216._m0[(uint(_1187) * _1177) + 1u].z;
        _1191._m4.x = _31(_1250);
        float _1260 = _1216._m0[(uint(_1187) * _1177) + 1u].w;
        _1191._m4.y = _31(_1260);
        float _1274 = _1268._m0[(uint(_1188) * _1177) + 0u].x;
        _1191._m5.x = _31(_1274);
        float _1284 = _1268._m0[(uint(_1188) * _1177) + 0u].y;
        _1191._m5.y = _31(_1284);
        float _1294 = _1268._m0[(uint(_1188) * _1177) + 0u].z;
        _1191._m6 = _31(_1294);
        float _1304 = _1268._m0[(uint(_1188) * _1177) + 0u].w;
        _1191._m7 = _31(_1304);
        float _1314 = _1268._m0[(uint(_1188) * _1177) + 1u].x;
        _1191._m8 = _31(_1314);
        float _1324 = _1268._m0[(uint(_1188) * _1177) + 1u].y;
        _1191._m9 = _31(_1324);
        float _1334 = _1268._m0[(uint(_1188) * _1177) + 1u].z;
        _1191._m10 = _31(_1334);
        float _1344 = _1268._m0[(uint(_1188) * _1177) + 1u].w;
        _1191._m11 = _31(_1344);
        vec4 _1349 = _1191._m0;
        vec4 _1352 = _1191._m2;
        vec4 _1355 = _1191._m1;
        vec4 _1358 = vec4(_801._m14, 1.0);
        vec3 _1365 = vec3(dot(_1358, _1349), dot(_1358, _1355), dot(_1358, _1352));
        float _1376 = 0.0039215688593685626983642578125;
        float _1378 = _1365.x;
        float _1381 = _1365.y;
        float _1384 = _1365.z;
        bool _1389 = _42(_1378, _1381, _1384) <= _1376;
        bool _1406;
        if (!_1389)
        {
            float _1393 = _1365.x;
            float _1396 = _1365.y;
            float _1399 = _1365.z;
            _1406 = _37(_1393, _1396, _1399) >= (1.0 - _1376);
        }
        else
        {
            _1406 = _1389;
        }
        if (_1406)
        {
            continue;
        }
        uint _1410 = _1191._m11;
        bool _1414 = _972 != 0u;
        bool _1421;
        if (_1414)
        {
            _1421 = (_1410 & 512u) != 0u;
        }
        else
        {
            _1421 = _1414;
        }
        bool _1434;
        if (!_1421)
        {
            bool _1426 = _972 == 0u;
            bool _1433;
            if (_1426)
            {
                _1433 = (_1410 & 1024u) != 0u;
            }
            else
            {
                _1433 = _1426;
            }
            _1434 = _1433;
        }
        else
        {
            _1434 = _1421;
        }
        if (_1434)
        {
            continue;
        }
        vec2 _1438 = vec2(dot(_1133, _1349.xyz), dot(_1133, _1355.xyz));
        vec2 _1448 = vec2(dot(_1137, _1349.xyz), dot(_1137, _1355.xyz));
        float _1458 = 1.0;
        float _1459 = 1.0;
        vec3 _1460 = vec3(0.5, 0.5, 1.0);
        vec3 _1463 = vec3(0.0, 0.0, 1.0);
        uint _1464 = _1191._m7;
        uint _1468 = _1191._m9;
        vec4 _1467 = _95(_1468);
        uvec2 _1473 = _1191._m5;
        vec4 _1472 = _108(_1473);
        vec2 _1477 = _1438 * _1472.xy;
        vec2 _1482 = _1448 * _1472.xy;
        vec2 _1497 = (_1365.xy * _1472.xy) + _1472.zw;
        vec2 _1498 = _1477;
        vec2 _1500 = _1482;
        vec4 _1487 = _125(_1488, _1497, _1498, _1500);
        vec2 _1503 = (_1487.xy * 2.0) - vec2(1.0);
        float _1514 = 1.0 - dot(_1503, _1503);
        _1460 = vec3(_1503, sqrt(_14(_1514)));
        _1463 = _1460;
        _1458 = _1487.z;
        if ((_1464 & 32u) == 0u)
        {
            float _1531 = _1458 - 0.5;
            _10(_1531);
        }
        float _1533 = _1487.w;
        _1459 = _57(_1533);
        bool _1540 = _1459 <= (4.0 * _1376);
        bool _1547;
        if (_1540)
        {
            _1547 = _1467.w <= _1376;
        }
        else
        {
            _1547 = _1540;
        }
        if (_1547)
        {
            continue;
        }
        _1460 = _1463;
        if ((_1410 & 128u) != 0u)
        {
            _1552 = vec3(-_1460.x, -_1460.y, _1460.z);
        }
        else
        {
            _1552 = _1460;
        }
        _1460 = _1552;
        uint _1571 = _1191._m8;
        uint _1575 = _1571;
        float _1574 = 1.0 + (_98(_1575).w * 0.062745101749897003173828125);
        uint _1583 = _1464;
        float _1582 = _95(_1583).z;
        uint _1588 = _1571;
        vec3 _1587 = _95(_1588).xyz;
        float _1601 = _1574 - (_1574 * abs((_1365.z * 2.0) - 1.0));
        _1459 *= _14(_1601);
        float _1605 = _1459;
        if ((_1464 & 1u) != 0u)
        {
            vec3 _1612 = _1587;
            _1587 = vec3(0.0);
            uvec2 _1615 = _1191._m3;
            vec4 _1614 = _108(_1615);
            vec2 _1619 = _1438 * _1614.xy;
            vec2 _1624 = _1448 * _1614.xy;
            vec2 _1638 = (_1365.xy * _1614.xy) + _1614.zw;
            vec2 _1639 = _1619;
            vec2 _1641 = _1624;
            vec4 _1629 = _125(_1488, _1638, _1639, _1641);
            vec4 _1644 = _1629;
            _1629 = _63(_1644);
            _1587 = _1629.xyz;
            float _1656 = (_1629.w - _1376) / (1.0 - _1376);
            _1605 = _14(_1656);
            _1587 *= _1612;
        }
        vec3 _1661 = normalize(vec3(_801._m17[0].z, _801._m17[1].z, _801._m17[2].z));
        float _1670 = dot(_1661, normalize(_1352.xyz));
        float _1676 = _1670;
        vec2 _1681 = _1460.xy * _77(_1676);
        _1460 = vec3(_1681.x, _1681.y, _1460.z);
        if ((_1410 & 16384u) != 0u)
        {
            float _1694 = abs(_1670);
            _1685 = _14(_1694);
        }
        else
        {
            float _1697 = _1670;
            _1685 = _14(_1697);
        }
        float _1684 = _1685;
        float _1701 = ((_1684 * _1605) * _1467.w) * _1582;
        _801._m10 += (_1467.xyz * (_1701 * 64.0));
        uint _1720 = _1191._m10;
        uint _1724 = _1720;
        vec4 _1723 = _95(_1724);
        if ((_1464 & 2u) != 0u)
        {
            uvec2 _1733 = _1191._m4;
            vec4 _1732 = _108(_1733);
            vec2 _1737 = _1438 * _1732.xy;
            vec2 _1742 = _1448 * _1732.xy;
            vec2 _1755 = (_1365.xy * _1732.xy) + _1732.zw;
            vec2 _1756 = _1737;
            vec2 _1758 = _1742;
            _1723 = _125(_1488, _1755, _1756, _1758);
            _1723 *= _1723;
        }
        if ((_1464 & 32u) != 0u)
        {
            uint _1770 = _1464;
            float _1769 = _95(_1770).x;
            uint _1775 = _1464;
            float _1774 = _98(_1775).y;
            float _1781 = _1769;
            float _1779 = mix(_1774, 0.0, _14(_1781));
            float _1790 = _1458 - (_1779 / 255.0);
            float _1785 = float(_14(_1790) > 0.0);
            _1459 *= _1785;
        }
        float _1797 = _1459 * _1684;
        uint _1801 = _1191._m6;
        uint _1805 = _1801;
        vec4 _1810 = _95(_1805) * _1797;
        vec4 _1804 = _26(_1810);
        _801._m11 = max(_801._m11, _1804.x);
        _801._m0 = mix(_801._m0, _1587, _1804.xxx);
        _801._m2 = mix(_801._m2, _1723.xyz, _1804.yyy);
        vec3 _1833 = _1661;
        vec3 _1843 = _1349.xyz + (_1833 * dot(_1349.xyz, _1833));
        _1349 = vec4(_1843.x, _1843.y, _1843.z, _1349.w);
        vec3 _1854 = _1355.xyz + (_1833 * dot(_1355.xyz, _1833));
        _1355 = vec4(_1854.x, _1854.y, _1854.z, _1355.w);
        _1460 = ((normalize(_1349.xyz) * _1460.x) + (normalize(_1355.xyz) * _1460.y)) + (_1833 * _1460.z);
        if ((_1410 & 256u) != 0u)
        {
            vec3 _1881 = mix(_1661, _1460, _1804.www);
            float _1887 = dot(_1881, _1661);
            _1460 = (_801._m6 * _1887) + ((_1881 - (_1661 * _1887)) * dot(_801._m6, _1661));
        }
        else
        {
            if ((_1410 & 64u) != 0u)
            {
                _1460 = mix(mix(_801._m6, _1661, vec3(_1797)), _1460, _1804.www);
            }
            else
            {
                _1460 = mix(_801._m6, _1460, _1804.www);
            }
        }
        _801._m6 = normalize(_1460);
        _801._m3 = mix(_801._m3, _1723.w, _1804.z);
    }
    vec3 _1941 = vec3(0.0);
    vec3 _1942 = vec3(_801._m34.x, _801._m34.y, _801._m34.z);
    vec3 _1950 = vec3(_801._m34.w, _801._m35.x, _801._m35.y);
    vec3 _1958 = vec3(_801._m35.z, _801._m35.w, _801._m36.x);
    vec3 _1966 = vec3(_801._m36.y, _801._m36.z, _801._m36.w);
    vec3 _1974 = ((_1942 - (_1950 * _801._m6.y)) + (_1958 * _801._m6.z)) - (_1966 * _801._m6.x);
    float _1997 = _951._m9.x * _822._m9.x;
    _1941 += max(_1974 * _14(_1997), vec3(0.0));
    float _2003;
    if (dot(_801._m10, vec3(1.0)) > 0.0)
    {
        _2003 = -_801._m3;
    }
    else
    {
        _2003 = _801._m3;
    }
    _801._m3 = _2003;
    _801._m18 = _1941;
    _801._m19 = _1941;
    float _2025 = 1.0;
    uint _2026 = _1070;
    _2056 _2058;
    while (_2026 < _1071)
    {
        uint _2036 = _1166._m0[_2026];
        uint _2040 = (_2036 >> uint(24)) & 4095u;
        uint _2044 = _2040;
        if (_2044 >= _2040)
        {
            _2026++;
        }
        int _2053 = 4;
        int _2054 = 4;
        int _2055 = 3;
        _2058._m0 = _2062._m0[(uint(_2053) * _2044) + 0u].xyz;
        float _2077 = _2062._m0[(uint(_2053) * _2044) + 0u].w;
        _2058._m1 = _31(_2077);
        _2058._m2 = _2062._m0[(uint(_2053) * _2044) + 1u];
        _2058._m3 = _2062._m0[(uint(_2053) * _2044) + 2u];
        _2058._m4 = _2101._m0[(uint(_2054) * _2044) + 0u];
        _2058._m5 = _2101._m0[(uint(_2054) * _2044) + 1u];
        _2058._m6 = _2101._m0[(uint(_2054) * _2044) + 2u];
        float _2131 = _2062._m0[(uint(_2053) * _2044) + 3u].x;
        _2058._m7.x = _31(_2131);
        float _2141 = _2062._m0[(uint(_2053) * _2044) + 3u].y;
        _2058._m7.y = _31(_2141);
        float _2151 = _2062._m0[(uint(_2053) * _2044) + 3u].z;
        _2058._m7.z = _31(_2151);
        float _2161 = _2062._m0[(uint(_2053) * _2044) + 3u].w;
        _2058._m7.w = _31(_2161);
        _2058._m8 = _2170._m0[(uint(_2055) * _2044) + 0u];
        _2058._m9 = _2170._m0[(uint(_2055) * _2044) + 1u];
        _2058._m10 = _2170._m0[(uint(_2055) * _2044) + 2u];
        float _2200 = _2101._m0[(uint(_2054) * _2044) + 3u].x;
        _2058._m11 = _31(_2200);
        float _2210 = _2101._m0[(uint(_2054) * _2044) + 3u].y;
        _2058._m12 = _31(_2210);
        _2058._m13 = _2101._m0[(uint(_2054) * _2044) + 3u].z;
        float _2228 = _2101._m0[(uint(_2054) * _2044) + 3u].w;
        _2058._m14 = _31(_2228);
        vec3 _2233 = vec3((_801._m14.x * _2058._m4.x) + ((_801._m14.y * _2058._m4.y) + ((_801._m14.z * _2058._m4.z) + _2058._m4.w)), (_801._m14.x * _2058._m5.x) + ((_801._m14.y * _2058._m5.y) + ((_801._m14.z * _2058._m5.z) + _2058._m5.w)), (_801._m14.x * _2058._m6.x) + ((_801._m14.y * _2058._m6.y) + ((_801._m14.z * _2058._m6.z) + _2058._m6.w)));
        vec2 _2300 = _2233.xy / vec2(_2233.z);
        _2233 = vec3(_2300.x, _2300.y, _2233.z);
        _2233.z = (_801._m14.x * _2058._m3.x) + ((_801._m14.y * _2058._m3.y) + ((_801._m14.z * _2058._m3.z) + _2058._m3.w));
        float _2324 = 0.0039215688593685626983642578125;
        float _2325 = _2233.x;
        float _2328 = _2233.y;
        float _2331 = _2233.z;
        bool _2336 = _42(_2325, _2328, _2331) < _2324;
        bool _2353;
        if (!_2336)
        {
            float _2340 = _2233.x;
            float _2343 = _2233.y;
            float _2346 = _2233.z;
            _2353 = _37(_2340, _2343, _2346) >= (1.0 - _2324);
        }
        else
        {
            _2353 = _2336;
        }
        if (_2353)
        {
            continue;
        }
        uint _2357 = _2058._m1;
        uint _2361 = _2058._m12;
        vec3 _2360 = _128(_2361);
        float _2365 = _2058._m13;
        vec3 _2368 = _2058._m0;
        uint _2372 = _2357;
        float _2371 = _95(_2372).y;
        vec3 _2376 = (_2233 * 2.0) - vec3(1.0);
        vec3 _2380 = _2376 * sqrt(((vec3(1.0) - ((_2376.yzx * _2376.yzx) * 0.5)) - ((_2376.zxy * _2376.zxy) * 0.5)) + ((((_2376.yzx * _2376.yzx) * _2376.zxy) * _2376.zxy) / vec3(3.0)));
        float _2424 = 1.0 - ((length(_2380) - _2371) / ((1.0 - _2371) + 9.9999999747524270787835121154785e-07));
        float _2413 = _14(_2424);
        _2413 *= _2413;
        _2413 *= (_2058._m8.w * _2025);
        _2025 *= (1.0 - _2413);
        if (_2413 <= (_2324 * 4.0))
        {
            continue;
        }
        vec3 _2446 = _2360;
        uint _2449 = _2357;
        float _2448 = _98(_2449).z;
        vec3 _2453 = vec3(0.0);
        vec3 _2454 = vec3(0.0);
        vec3 _2455 = _801._m6;
        _2455.x = dot(_2058._m2.xy, _801._m6.xy);
        _2455.y = dot(_2058._m2.zw, _801._m6.xy);
        vec3 _2474 = reflect(-_801._m13, _801._m6);
        vec3 _2481 = (_2058._m9.xyz - _801._m14) / _2474;
        vec3 _2490 = (_2058._m8.xyz - _801._m14) / _2474;
        vec3 _2499 = max(_2481, _2490);
        float _2504 = _2499.x;
        float _2507 = _2499.y;
        float _2510 = _2499.z;
        float _2503 = _42(_2504, _2507, _2510);
        vec3 _2514 = _801._m14 + (_2474 * _2503);
        vec3 _2521 = normalize(_2514 - _2368);
        vec3 _2526 = _2521;
        _2526.x = dot(_2058._m2.xy, _2521.xy);
        _2526.y = dot(_2058._m2.zw, _2521.xy);
        float _2548 = dot(_801._m13, _801._m6);
        float _2542 = _14(_2548);
        float _2550 = 0.0;
        float _2551 = 6.0;
        float _2553 = max(_2550, _2551 - (_2551 * abs(_801._m3)));
        _2454 = textureLod(_2566, vec4(_2526, _2448), _2553).xyz * _2365;
        float _2583 = _2542;
        float _2585 = abs(_801._m3);
        vec3 _2586 = _801._m2;
        vec3 _2579 = _147(_2583, _2585, _2586);
        _2454 *= _2579;
        float _2597 = _2413;
        _801._m20 += ((_2454 * _2446) * _14(_2597));
        if (_2025 <= (_2324 * 4.0))
        {
            break;
        }
    }
    uint _2612 = _1066;
    _2056 _2641;
    vec3 _2922;
    float _3014;
    float _3025;
    _3402 _3404;
    uint _3522;
    _3402 _3549;
    while (_2612 < _1067)
    {
        uint _2622 = _1166._m0[_2612];
        uint _2626 = _2622 & 4095u;
        uint _2629 = _2626;
        if (_2629 >= _2626)
        {
            _2612++;
        }
        int _2638 = 4;
        int _2639 = 4;
        int _2640 = 3;
        _2641._m0 = _2062._m0[(uint(_2638) * _2629) + 0u].xyz;
        float _2656 = _2062._m0[(uint(_2638) * _2629) + 0u].w;
        _2641._m1 = _31(_2656);
        _2641._m2 = _2062._m0[(uint(_2638) * _2629) + 1u];
        _2641._m3 = _2062._m0[(uint(_2638) * _2629) + 2u];
        _2641._m4 = _2101._m0[(uint(_2639) * _2629) + 0u];
        _2641._m5 = _2101._m0[(uint(_2639) * _2629) + 1u];
        _2641._m6 = _2101._m0[(uint(_2639) * _2629) + 2u];
        float _2706 = _2062._m0[(uint(_2638) * _2629) + 3u].x;
        _2641._m7.x = _31(_2706);
        float _2716 = _2062._m0[(uint(_2638) * _2629) + 3u].y;
        _2641._m7.y = _31(_2716);
        float _2726 = _2062._m0[(uint(_2638) * _2629) + 3u].z;
        _2641._m7.z = _31(_2726);
        float _2736 = _2062._m0[(uint(_2638) * _2629) + 3u].w;
        _2641._m7.w = _31(_2736);
        _2641._m8 = _2170._m0[(uint(_2640) * _2629) + 0u];
        _2641._m9 = _2170._m0[(uint(_2640) * _2629) + 1u];
        _2641._m10 = _2170._m0[(uint(_2640) * _2629) + 2u];
        float _2770 = _2101._m0[(uint(_2639) * _2629) + 3u].x;
        _2641._m11 = _31(_2770);
        float _2780 = _2101._m0[(uint(_2639) * _2629) + 3u].y;
        _2641._m12 = _31(_2780);
        _2641._m13 = _2101._m0[(uint(_2639) * _2629) + 3u].z;
        float _2798 = _2101._m0[(uint(_2639) * _2629) + 3u].w;
        _2641._m14 = _31(_2798);
        float _2803 = 0.0039215688593685626983642578125;
        vec4 _2804 = vec4(_801._m14, 1.0);
        float _2811 = 1.0 / dot(_2804, _2641._m6);
        vec3 _2817 = vec3(dot(_2804, _2641._m4) * _2811, dot(_2804, _2641._m5) * _2811, dot(_2804, _2641._m3));
        uint _2835 = _2641._m1;
        uint _2838 = _972;
        _2838 |= 64u;
        float _2842 = _2817.x;
        float _2845 = _2817.y;
        float _2848 = _2817.z;
        bool _2853 = _42(_2842, _2845, _2848) <= _2803;
        bool _2870;
        if (!_2853)
        {
            float _2857 = _2817.x;
            float _2860 = _2817.y;
            float _2863 = _2817.z;
            _2870 = _37(_2857, _2860, _2863) >= (1.0 - _2803);
        }
        else
        {
            _2870 = _2853;
        }
        bool _2878;
        if (!_2870)
        {
            _2878 = (_2835 & _2838) != 0u;
        }
        else
        {
            _2878 = _2870;
        }
        if (_2878)
        {
            continue;
        }
        if ((_2835 & 3u) == 2u)
        {
            vec2 _2897 = fract((_2817.xy * _822._m10.xy) + _822._m10.zw);
            _2817 = vec3(_2897.x, _2897.y, _2817.z);
        }
        vec3 _2900 = _2641._m0;
        float _2903 = 1.0;
        float _2904 = 1.0;
        vec3 _2905 = vec3(0.0, 0.0, 1.0);
        vec3 _2906 = vec3(0.0, 0.0, 1.0);
        uint _2907 = _2641._m1;
        vec3 _2910 = (_2817 * 2.0) - vec3(1.0);
        vec2 _2915 = _2817.xy;
        vec3 _2918 = _2641._m10.xyz;
        if ((_2907 & 3u) == 2u)
        {
            _2922 = _2918;
        }
        else
        {
            _2922 = normalize(_2900 - _801._m14);
        }
        _2905 = _2922;
        _2905 = _2905;
        float _2942 = dot(_801._m6, _2905);
        float _2937 = _14(_2942);
        bool _2946 = _2937 <= _2803;
        bool _2953;
        if (_2946)
        {
            _2953 = (_2907 & 48u) == 0u;
        }
        else
        {
            _2953 = _2946;
        }
        if (_2953)
        {
            continue;
        }
        uvec2 _2958 = _2641._m7.zw;
        vec4 _2957 = _108(_2958);
        float _2964 = TEXTURE_LOD(_2965, vec4((_2915 * _2957.xy) + _2957.zw, 0.0, 0.0).xy, vec4((_2915 * _2957.xy) + _2957.zw, 0.0, 0.0).w).x;
        float _2991 = _2964 * _2964;
        uint _2995 = _2907 & 3u;
        bool _3000 = _2995 == 1u;
        bool _3012;
        if (!_3000)
        {
            bool _3005 = _2995 == 0u;
            bool _3011;
            if (_3005)
            {
                _3011 = _2641._m8.z != 0.0;
            }
            else
            {
                _3011 = _3005;
            }
            _3012 = _3011;
        }
        else
        {
            _3012 = _3000;
        }
        bool _2998 = _3012;
        if (_2998)
        {
            float _3018 = _2641._m8.w;
            _3014 = _14(_3018);
        }
        else
        {
            _3014 = 0.5;
        }
        float _3013 = _3014;
        bool _3027 = _2995 == 0u;
        bool _3033;
        if (_3027)
        {
            _3033 = _2641._m8.z != 0.0;
        }
        else
        {
            _3033 = _3027;
        }
        if (_3033)
        {
            float _3041 = sqrt(dot(_2910, _2910));
            _3025 = min(0.9921875, _14(_3041));
        }
        else
        {
            _3025 = _2817.z;
        }
        float _3024 = _3025;
        uvec2 _3049 = _2641._m7.xy;
        vec4 _3048 = _108(_3049);
        vec2 _3054 = vec2(_3024, _3013);
        float _3058 = TEXTURE_LOD(_2965, vec4((_3054 * _3048.xy) + _3048.zw, 0.0, 0.0).xy, vec4((_3054 * _3048.xy) + _3048.zw, 0.0, 0.0).w).x;
        _3058 *= _3058;
        _2903 = _3058 * _2991;
        if ((_2907 & 48u) != 0u)
        {
            vec4 _3095 = _2641._m10;
            vec4 _3098 = _2641._m8;
            vec4 _3101 = _2641._m9;
            float _3104 = dot(_801._m14, _3095.xyz) + _3095.w;
            if (_3104 < 0.0)
            {
                continue;
            }
            float _3118 = length(_3095.xyz);
            float _3125 = _3104 * 50.0;
            float _3122 = _14(_3125);
            _2903 *= (_3122 * _3122);
            _3104 /= _3118;
            _3095 /= vec4(_3118);
            vec3 _3139 = reflect(-_801._m13, _801._m6);
            if (dot(_3139, _3095.xyz) > 0.0)
            {
                _3139 = reflect(_3139, _3095.xyz);
            }
            float _3157 = dot(_3139, _3095.xyz);
            float _3162 = _3104 / _3157;
            vec3 _3166 = _801._m14 - (_3139 * _3162);
            vec3 _3173 = _3166 - _2900;
            float _3177 = dot(_3173, _3098.xyz) / _3098.w;
            float _3185 = dot(_3173, _3101.xyz) / _3101.w;
            if ((_2907 & 48u) == 32u)
            {
                vec2 _3198 = vec2(_3177, _3185);
                float _3202 = 1.0 / max(1.0, length(vec2(_3177, _3185)));
                _3177 *= (_3202 * _3098.w);
                _3185 *= (_3202 * _3101.w);
            }
            else
            {
                float _3224 = abs(_3177);
                float _3226 = _3177;
                _3177 = (_14(_3224) * _77(_3226)) * _3098.w;
                float _3235 = abs(_3185);
                float _3237 = _3185;
                _3185 = (_14(_3235) * _77(_3237)) * _3101.w;
            }
            vec3 _3244 = (_3098.xyz * _3177) + (_3101.xyz * _3185);
            _2900 += _3244;
            _2905 = normalize(_2900 - _801._m14);
            _2905 = _2905;
        }
        else
        {
            uint _3264 = (_2641._m14 >> uint(16)) & 255u;
            if (_3264 == 0u)
            {
                vec4 _3273 = _2641._m9;
                if (dot(_3273.xyz, _801._m14) < (_3273.w - _2803))
                {
                    continue;
                }
            }
            else
            {
                if (_3264 == 1u)
                {
                    vec3 _3294 = _2641._m9.xyz;
                    float _3299 = _2641._m9.w;
                    uint _3303 = _31(_3299);
                    vec3 _3298 = (((_102(_3303) * 2.0) - vec3(1.0)) * _3294) + _2900;
                    vec3 _3312 = abs((_801._m14 - _3298) / _3294);
                    float _3320 = _3312.x;
                    float _3323 = _3312.y;
                    float _3326 = _3312.z;
                    if (_37(_3320, _3323, _3326) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_2903 <= (_2803 / 256.0))
        {
            continue;
        }
        float _3342 = 1.0;
        if ((_2835 & 4u) != 0u)
        {
            float _3349 = float(_2641._m14 & 255u) / 255.0;
            float _3355 = 0.00999999977648258209228515625;
            vec3 _3357 = _801._m14 + (_801._m6 * _3355);
            uint _3365 = 0u;
            if ((_2835 & 3u) == 0u)
            {
                vec3 _3371 = _3357 - _2641._m2.xyz;
                float _3377 = _3371.x;
                float _3380 = _3371.y;
                float _3383 = _3371.z;
                _3365 = _48(_3377, _3380, _3383);
            }
            else
            {
                if ((_2835 & 3u) == 2u)
                {
                    float _3393 = 0.0;
                    for (; _3365 < 3u; _3365++)
                    {
                        int _3401 = 5;
                        _3404._m0 = _3408._m0[(uint(_3401) * ((_2835 >> uint(22)) + _3365)) + 0u];
                        _3404._m1 = _3408._m0[(uint(_3401) * ((_2835 >> uint(22)) + _3365)) + 1u];
                        _3404._m2 = _3408._m0[(uint(_3401) * ((_2835 >> uint(22)) + _3365)) + 2u];
                        _3404._m3 = _3408._m0[(uint(_3401) * ((_2835 >> uint(22)) + _3365)) + 3u];
                        _3404._m4 = _3408._m0[(uint(_3401) * ((_2835 >> uint(22)) + _3365)) + 4u];
                        vec2 _3465 = vec2(dot(_3357, _3404._m0.xyz) + _3404._m0.w, dot(_3357, _3404._m1.xyz) + _3404._m1.w);
                        _3465 = abs((_3465 * 2.0) - vec2(1.0));
                        bool _3490 = _3465.x < 1.0;
                        bool _3496;
                        if (_3490)
                        {
                            _3496 = _3465.y < 1.0;
                        }
                        else
                        {
                            _3496 = _3490;
                        }
                        if (_3496)
                        {
                            _3393 = (1.0 - max(_3465.x, _3465.y)) * _822._m11.w;
                            break;
                        }
                    }
                    _3365 = min(2u, _3365);
                    uint _3513 = uint(_801._m16.x) ^ (uint(_801._m16.y) << uint(1));
                    if (_822._m12.w > 0.0)
                    {
                        _3522 = uint(_822._m13.x);
                    }
                    else
                    {
                        _3522 = 0u;
                    }
                    _3513 ^= _3522;
                    _3365 += uint(int(((float(_3513 & 3u) * 0.25) + 0.125) > _3393));
                }
            }
            int _3548 = 5;
            _3549._m0 = _3408._m0[(uint(_3548) * ((_2835 >> uint(22)) + _3365)) + 0u];
            _3549._m1 = _3408._m0[(uint(_3548) * ((_2835 >> uint(22)) + _3365)) + 1u];
            _3549._m2 = _3408._m0[(uint(_3548) * ((_2835 >> uint(22)) + _3365)) + 2u];
            _3549._m3 = _3408._m0[(uint(_3548) * ((_2835 >> uint(22)) + _3365)) + 3u];
            _3549._m4 = _3408._m0[(uint(_3548) * ((_2835 >> uint(22)) + _3365)) + 4u];
            vec4 _3605 = vec4((_3357.x * _3549._m0.x) + ((_3357.y * _3549._m0.y) + ((_3357.z * _3549._m0.z) + _3549._m0.w)), (_3357.x * _3549._m1.x) + ((_3357.y * _3549._m1.y) + ((_3357.z * _3549._m1.z) + _3549._m1.w)), (_3357.x * _3549._m2.x) + ((_3357.y * _3549._m2.y) + ((_3357.z * _3549._m2.z) + _3549._m2.w)), (_3357.x * _3549._m3.x) + ((_3357.y * _3549._m3.y) + ((_3357.z * _3549._m3.z) + _3549._m3.w)));
            vec3 _3692 = _3605.xyz / vec3(_3605.w);
            _3605 = vec4(_3692.x, _3692.y, _3692.z, _3605.w);
            bool _3700 = min(_3605.x, _3605.y) > 0.0;
            bool _3709;
            if (_3700)
            {
                _3709 = max(_3605.x, _3605.y) < 1.0;
            }
            else
            {
                _3709 = _3700;
            }
            if (_3709)
            {
                vec2 _3721 = (_3605.xy * _3549._m4.xy) + _3549._m4.zw;
                _3605 = vec4(_3721.x, _3721.y, _3605.z, _3605.w);
                if (false)
                {
                    _3342 = textureLod(_3729, vec3(_3605.xyz.xy, _3605.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3736 = (_3605.xy * _822._m14.xy) + vec2(0.5);
                    vec2 _3745 = floor(_3736);
                    vec2 _3748 = _3736 - _3745;
                    _3745 -= vec2(0.5);
                    vec2 _3755 = vec2(4.0) - (_3748 * 3.0);
                    vec2 _3760 = vec2(7.0);
                    vec2 _3763 = vec2(1.0) + (_3748 * 3.0);
                    vec2 _3768 = (_3745 + (((vec2(3.0) - (_3748 * 2.0)) / _3755) - vec2(2.0))) * _822._m14.zw;
                    vec2 _3783 = (_3745 + ((vec2(3.0) + _3748) / _3760)) * _822._m14.zw;
                    vec2 _3795 = (_3745 + ((_3748 / _3763) + vec2(2.0))) * _822._m14.zw;
                    vec3 _3819 = vec3(_3768.x, _3768.y, _3605.z);
                    _3342 = (_3755.x * _3755.y) * textureLod(_3729, vec3(_3819.xy, _3819.z), 0.0);
                    vec3 _3835 = vec3(_3783.x, _3768.y, _3605.z);
                    _3342 += ((_3760.x * _3755.y) * textureLod(_3729, vec3(_3835.xy, _3835.z), 0.0));
                    vec3 _3853 = vec3(_3795.x, _3768.y, _3605.z);
                    _3342 += ((_3763.x * _3755.y) * textureLod(_3729, vec3(_3853.xy, _3853.z), 0.0));
                    vec3 _3871 = vec3(_3768.x, _3783.y, _3605.z);
                    _3342 += ((_3755.x * _3760.y) * textureLod(_3729, vec3(_3871.xy, _3871.z), 0.0));
                    vec3 _3889 = vec3(_3783.x, _3783.y, _3605.z);
                    _3342 += ((_3760.x * _3760.y) * textureLod(_3729, vec3(_3889.xy, _3889.z), 0.0));
                    vec3 _3907 = vec3(_3795.x, _3783.y, _3605.z);
                    _3342 += ((_3763.x * _3760.y) * textureLod(_3729, vec3(_3907.xy, _3907.z), 0.0));
                    vec3 _3925 = vec3(_3768.x, _3795.y, _3605.z);
                    _3342 += ((_3755.x * _3763.y) * textureLod(_3729, vec3(_3925.xy, _3925.z), 0.0));
                    vec3 _3943 = vec3(_3783.x, _3795.y, _3605.z);
                    _3342 += ((_3760.x * _3763.y) * textureLod(_3729, vec3(_3943.xy, _3943.z), 0.0));
                    vec3 _3961 = vec3(_3795.x, _3795.y, _3605.z);
                    _3342 += ((_3763.x * _3763.y) * textureLod(_3729, vec3(_3961.xy, _3961.z), 0.0));
                    _3342 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3342 = float((_2835 & 3u) == 2u);
            }
            float _3975 = float((_2835 >> uint(16)) & 63u) / 63.0;
            float _3989 = ((_3342 * _3975) + 1.0) - _3975;
            _3342 = _14(_3989);
        }
        uint _3992 = _2641._m12;
        vec3 _3991 = (_128(_3992) * _3342) * _2903;
        _2904 *= _2641._m13;
        vec3 _4004 = _3991;
        vec3 _4006 = _2905;
        float _4013 = dot(_801._m6, _4006);
        float _4008 = _14(_4013);
        vec3 _4019 = _801._m6;
        vec3 _4022 = _801._m13;
        vec3 _4025 = _2905;
        vec3 _4027 = _801._m2;
        float _4030 = abs(_801._m3);
        vec3 _4015 = _141(_4019, _4022, _4025, _4027, _4030);
        _801._m20 += (((_4015 * _2904) * _4004) * _4008);
        vec3 _4043 = mix(_4004, vec3(0.0), bvec3((_2835 & 256u) > 0u));
        _801._m19 += (_4043 * _4008);
    }
    _801._m19 = _801._m19;
    _801._m20 += _801._m10;
    _801._m19 *= _801._m0;
    _801._m21 = _801._m19 + _801._m20;
    vec3 _4079 = _801._m19;
    vec3 _4082 = _801._m20;
    float _4091 = dot(_801._m20, vec3(0.3300000131130218505859375));
    float _4085 = _14(_4091);
    float _4098 = max(_801._m11, _4085);
    float _4093 = _14(_4098);
    vec3 _4101 = _905._m4.xyz;
    _801._m21 = _4079 * (_66(_4101) * _801._m11);
    _801._m21 += min(_4082, vec3(10.0));
    _801._m11 = _4093;
    _4122 = vec4(_801._m21, _801._m11);
    vec2 _4131 = _801._m16.xy * _822._m6.zw;
    float _4139 = _801._m16.z;
    vec4 _4142 = vec4(0.0);
    float _4143 = 1.0;
    float _4145 = _822._m15.w;
    uint _4144 = _31(_4145);
    if ((_4144 & 6u) != 0u)
    {
        vec2 _4155 = _4131 + vec2(0.0);
        vec3 _4159 = _822._m16.xyz;
        float _4163 = 0.100000001490116119384765625;
        float _4165 = _822._m17.y;
        float _4168 = _822._m16.z;
        float _4171 = 0.0;
        float _4173 = _4139;
        vec4 _4175 = _822._m7;
        float _4178 = 1.0;
        bool _4179 = false;
        float _4172 = _156(_4173, _4175, _4178, _4179);
        _4171 = pow((_4172 - _4163) / (_4165 - _4163), 0.5);
        _4171 = (_4171 * (_4168 - 1.0)) / _4168;
        vec4 _4195 = vec4(_4155, _4171, 0.0);
        vec3 _4221 = textureLod(_4204, vec4(_4195.xyz, 0.0).xyz, vec4(_4195.xyz, 0.0).w).xyz;
        _4142 = vec4(_4221.x, _4221.y, _4221.z, _4142.w);
        vec2 _4224 = textureLod(_4225, vec4(_4195.xyz, 0.0).xyz, vec4(_4195.xyz, 0.0).w).xy;
        _4142.w = _4224.x;
        _4143 = _4224.y;
    }
    if ((_4144 & 2u) != 0u)
    {
        vec4 _4253 = vec4(0.0);
        vec3 _4254 = _822._m4.xyz;
        float _4259 = _4139;
        vec4 _4261 = _822._m7;
        float _4264 = 1.0;
        bool _4265 = false;
        float _4258 = _156(_4259, _4261, _4264, _4265);
        vec3 _4267 = mix(_822._m18.xyz, _822._m19.xyz, vec3(_4131.x * _822._m20.z));
        vec3 _4281 = mix(_822._m21.xyz, _822._m22.xyz, vec3(_4131.x * _822._m20.z));
        vec3 _4295 = mix(_4281, _4267, vec3(1.0 - (_4131.y * _822._m20.w)));
        vec4 _4306 = vec4(0.0);
        vec3 _4307 = normalize(_4295);
        float _4310 = _4307.z;
        _4306.x = clamp(_80(_4310) / 3.1415927410125732421875, 0.00390625, 0.99609375);
        float _4319 = _4307.y;
        float _4322 = _4307.x;
        _4306.y = _90(_4319, _4322) / 6.283185482025146484375;
        _4306.z = sqrt(_4258 * _822._m23.w);
        _4306.z = clamp(_4306.z, 0.015625, 0.984375);
        vec3 _4349 = textureLod(_4342, _4306.xyz, _4306.w).xyz;
        _4253 = vec4(_4349.x, _4349.y, _4349.z, _4253.w);
        vec3 _4358 = _4122.xyz + (_4253.xyz * _4143);
        _4122 = vec4(_4358.x, _4358.y, _4358.z, _4122.w);
    }
    if ((_4144 & 4u) != 0u)
    {
        vec3 _4373 = (_4122.xyz * _4142.w) + _4142.xyz;
        _4122 = vec4(_4373.x, _4373.y, _4373.z, _4122.w);
    }
    vec3 _4381 = _4122.xyz + _951._m10.xyz;
    _4122 = vec4(_4381.x, _4381.y, _4381.z, _4122.w);
    float _4384 = _4122.w;
    _4122.w = _14(_4384);
    vec3 _4394 = _4122.xyz * _4122.w;
    _4122 = vec4(_4394.x, _4394.y, _4394.z, _4122.w);
    _4397 = vec4(0.0);
    _4398 = vec4(0.0);
    if (_822._m24.w > 0.0)
    {
        vec2 _4404 = gl_FragCoord.xy * _822._m6.xy;
        bool _4411 = (gl_FragCoord.z < TEXTURE_LOD(_4415, vec4(_4404, 0.0, 0.0).xy, vec4(_4404, 0.0, 0.0).w).x) ? true : false;
        if (_4411 == false)
        {
            _4397 = _4122;
        }
        _4122 *= float(_4411 == true);
        _4398.x = _4122.w;
    }
}

