// FIX FOR DECALS CLIPPING
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
layout(early_fragment_tests) in;
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _721
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1007
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _2313
{
    int _m0;
    int _m1;
};

struct _2316
{
    int _m0;
    int _m1;
};

struct _2416
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _3213
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _3988
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _4682
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 0, binding = 0, std140) uniform _753_755
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _755;

layout(set = 2, binding = 0, std140) uniform _863_865
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _865;

layout(set = 1, binding = 0, std140) uniform _1694_1696
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
} _1696;

layout(set = 0, binding = 14, std430) restrict readonly buffer _2318_2320
{
    _2316 _m0[];
} _2320;

layout(set = 0, binding = 15, std430) restrict readonly buffer _2391_2393
{
    uint _m0[];
} _2393;

layout(set = 0, binding = 16, std140) uniform _2421_2423
{
    vec4 _m0[4096];
} _2423;

layout(set = 0, binding = 17, std140) uniform _2441_2443
{
    vec4 _m0[4096];
} _2443;

layout(set = 0, binding = 18, std140) uniform _2493_2495
{
    vec4 _m0[4096];
} _2495;

layout(set = 0, binding = 20, std140) uniform _3217_3219
{
    vec4 _m0[4096];
} _3219;

layout(set = 0, binding = 21, std140) uniform _3256_3258
{
    vec4 _m0[4096];
} _3258;

layout(set = 0, binding = 22, std140) uniform _3325_3327
{
    vec4 _m0[3072];
} _3327;

layout(set = 0, binding = 24, std140) uniform _3992_3994
{
    vec4 _m0[4095];
} _3994;

layout(set = 0, binding = 26, std140) uniform _4686_4688
{
    vec4 _m0[4096];
} _4688;

layout(set = 0, binding = 1, std430) restrict readonly buffer _5027_5029
{
    uint _m0[];
} _5029;

layout(push_constant, std430) uniform _5023_5025
{
    int _m0;
    int _m1;
} _5025;

layout(set = 3, binding = 3) uniform TEXTURE_2D _890[8];
layout(set = 0, binding = 3) uniform sampler _897;
layout(set = 3, binding = 2) uniform TEXTURE_2D _905[8];
layout(set = 0, binding = 4) uniform sampler _909;
layout(set = 3, binding = 0) uniform TEXTURE_2D _917[8];
layout(set = 0, binding = 5) uniform sampler _921;
layout(set = 3, binding = 1) uniform TEXTURE_2D _931[8];
layout(set = 0, binding = 6) uniform sampler _935;
layout(set = 3, binding = 7) uniform TEXTURE_2D _944[8];
layout(set = 0, binding = 7) uniform sampler _948;
layout(set = 3, binding = 4) uniform TEXTURE_2D _956[8];
layout(set = 0, binding = 8) uniform sampler _960;
layout(set = 3, binding = 6) uniform TEXTURE_2D _968[8];
layout(set = 0, binding = 9) uniform sampler _972;
layout(set = 0, binding = 10) uniform SAMPLER_2D _1897;
layout(set = 0, binding = 11) uniform SAMPLER_2D _1906;
layout(set = 0, binding = 12) uniform SAMPLER_2D _1952;
layout(set = 0, binding = 13, r32f) uniform writeonly image2D _2187;
layout(set = 0, binding = 19) uniform SAMPLER_2D _2714;
layout(set = 0, binding = 23) uniform SAMPLER_2D _3551;
layout(set = 0, binding = 25) uniform sampler2DShadow _4314;
layout(set = 0, binding = 27) uniform SAMPLER_2D _4827;
layout(set = 3, binding = 5) uniform TEXTURE_2D _5022[8];

layout(location = 2) in vec4 _735;
layout(location = 5) in vec4 _742;
layout(location = 3) in vec4 _745;
layout(location = 4) in vec4 _768;
layout(location = 14) flat in uvec3 _820;
layout(location = 0) out vec4 _4980;
layout(location = 1) out vec4 _4988;
layout(location = 2) out vec4 _4996;

float _285;

uvec4 _44(vec4 _43)
{
    return floatBitsToUint(_43);
}

float _64(float _63)
{
    if (_63 <= 0.040449999272823333740234375)
    {
        return _63 / 12.9200000762939453125;
    }
    else
    {
        return pow((_63 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

float _76(float _75)
{
    float _339 = _75;
    return _64(_339);
}

float _67(float _66)
{
    return _66 * ((_66 * ((_66 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _29(vec2 _27, vec2 _28)
{
    return dot(_27, _28);
}

vec4 _122(SAMPLER_2D _118, vec2 _119, vec2 _120, vec2 _121)
{
    return TEXTURE_GRAD(_118, _119, _120, _121);
}

vec4 _115(SAMPLER_2D _113, vec2 _114)
{
    return SAMPLE_TEXTURE(_113, _114);
}

float _35(uint _34)
{
    return uintBitsToFloat(_34);
}

float _147(float _143, vec4 _144, float _145, bool _146)
{
    float _576 = _144.w / (_143 + _144.z);
    return _576 * _145;
}

vec3 _152(vec3 _150, bool _151)
{
    vec3 _589 = (_150 * 2.0) - vec3(1.0);
    float _606 = (1.0 - (_589.x * _589.x)) - (_589.y * _589.y);
    _589.z = sqrt(_10(_606));
    if (_151 == false)
    {
        _589.z = -_589.z;
    }
    return _589;
}

vec3 _159(vec3 _157, mat3 _158)
{
    return normalize(vec3(dot(_157, _158[0]), dot(_157, _158[1]), dot(_157, _158[2])));
}

uint _39(float _38)
{
    return floatBitsToUint(_38);
}

float _55(float _52, float _53, float _54)
{
    return min(_52, min(_53, _54));
}

float _50(float _47, float _48, float _49)
{
    return max(_47, max(_48, _49));
}

vec4 _94(uint _93)
{
    return unpackUnorm4x8(_93).wzyx;
}

vec4 _107(uvec2 _106)
{
    return vec4(float((_106.x >> uint(16)) & 65535u), float(_106.x & 65535u), float((_106.y >> uint(16)) & 65535u), float(_106.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _97(uint _96)
{
    return vec4(float((_96 >> uint(24)) & 255u), float((_96 >> uint(16)) & 255u), float((_96 >> uint(8)) & 255u), float(_96 & 255u));
}

vec3 _70(vec3 _69)
{
    float _300 = _69.x;
    vec3 _299;
    _299.x = _67(_300);
    float _306 = _69.y;
    _299.y = _67(_306);
    float _312 = _69.z;
    _299.z = _67(_312);
    return _299;
}

vec4 _73(vec4 _72)
{
    vec3 _322 = _72.xyz;
    vec4 _321 = vec4(_70(_322), 1.0);
    float _330 = _72.w;
    _321.w = _67(_330);
    return _321;
}

float _87(float _86)
{
    return (step(0.0, _86) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _101(uint _100)
{
    return vec3(float((_100 >> uint(21)) & 2047u), float((_100 >> uint(10)) & 2047u), float(_100 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _61(float _58, float _59, float _60)
{
    bool _226 = abs(_60) >= abs(_58);
    bool _234;
    if (_226)
    {
        _234 = abs(_60) >= abs(_59);
    }
    else
    {
        _234 = _226;
    }
    if (_234)
    {
        return uint((_60 < 0.0) ? 5 : 4);
    }
    if (abs(_59) >= abs(_58))
    {
        return uint((_59 < 0.0) ? 3 : 2);
    }
    return uint(int(_58 < 0.0));
}

float _79(float _78)
{
    return exp2(_78);
}

vec3 _125(uint _124)
{
    uint _450 = _124;
    vec4 _449 = _94(_450);
    float _461 = (_449.w * 255.0) - 128.0;
    return _449.xyz * _79(_461);
}

float _84(float _82, float _83)
{
    return pow(_82, _83);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _130(vec3 _128, float _129)
{
    float _473 = 50.0 * dot(_128, vec3(0.33329999446868896484375));
    float _466 = _10(_473);
    float _482 = 1.0 - _129;
    float _485 = _10(_482);
    float _486 = 5.0;
    vec3 _490 = _128 + ((vec3(_466) - _128) * _84(_485, _486));
    return _16(_490);
}

vec3 _138(vec3 _133, vec3 _134, vec3 _135, vec3 _136, float _137)
{
    vec3 _494 = normalize(_134 + _135);
    float _499 = 1.0 - (_137 * 0.800000011920928955078125);
    _499 *= _499;
    _499 *= _499;
    float _510 = _499 * _499;
    float _518 = dot(_133, _494);
    float _514 = _10(_518);
    float _520 = ((_514 * _514) * (_510 - 1.0)) + 1.0;
    _520 = _510 / ((_520 * _520) + 9.9999999392252902907785028219223e-09);
    float _539 = dot(_133, _134);
    float _535 = (_10(_539) * (1.0 - _499)) + _499;
    float _550 = dot(_133, _135);
    float _546 = (_10(_550) * (1.0 - _499)) + _499;
    _520 /= (((4.0 * _535) * _546) + 9.9999999392252902907785028219223e-09);
    vec3 _568 = _136;
    float _570 = dot(_135, _494);
    return _130(_568, _570) * _520;
}

vec2 _163(vec2 _162)
{
    return (vec2(1.0) - abs(_162.yx)) * vec2((_162.x >= 0.0) ? 1.0 : (-1.0), (_162.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _168(inout vec3 _166, bool _167)
{
    _166 /= vec3((abs(_166.x) + abs(_166.y)) + abs(_166.z));
    vec2 _670;
    if (_166.z >= 0.0)
    {
        _670 = _166.xy;
    }
    else
    {
        vec2 _679 = _166.xy;
        _670 = _163(_679);
    }
    _166 = vec3(_670.x, _670.y, _166.z);
    if (_167)
    {
        vec2 _694 = (_166.xy * 0.5) + vec2(0.5);
        _166 = vec3(_694.x, _694.y, _166.z);
    }
    return _166.xy;
}

float _90(float _89)
{
    return sqrt(_89);
}

float _171(float _170)
{
    float _704 = abs(_170);
    float _701 = _90(_704);
    float _706;
    if (_170 > 0.0)
    {
        _706 = _701;
    }
    else
    {
        _706 = -_701;
    }
    return (_706 * 0.5) + 0.5;
}

void main()
{
    _721 _723 = _721(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _723._m15 = _735;
    _723._m16 = gl_FragCoord;
    vec3 _741 = vec3(_742.zw, _745.w);
    _723._m14 = _755._m0.xyz + _741;
    vec3 _763 = normalize(_745.xyz);
    vec3 _767 = normalize(_768.xyz);
    vec3 _772 = normalize(cross(_763, _767) * sign(_768.w));
    _723._m17 = mat3(vec3(_767.x, _772.x, _763.x), vec3(_767.y, _772.y, _763.y), vec3(_767.z, _772.z, _763.z));
    _723._m13 = normalize(-_741);
    uint _810 = 0u;
    vec4 _811 = vec4(0.0);
    vec4 _812 = vec4(0.0);
    vec4 _813 = vec4(0.0);
    vec4 _814 = vec4(0.0);
    vec4 _815 = vec4(0.0);
    uvec3 _818 = _820;
    vec3 _822 = vec3(abs(_768.w) - 1.0, 0.0, _742.x);
    bool _833 = _818.y == 65535u;
    bool _839;
    if (_833)
    {
        _839 = _818.z == 65535u;
    }
    else
    {
        _839 = _833;
    }
    bool _830 = _839;
    bool _840 = !_830;
    bool _843 = _818.z != 65535u;
    uint _847 = _818.x & 7u;
    uint _858;
    if (_755._m1.x == 0.0)
    {
        _858 = _847;
    }
    else
    {
        vec4 _866 = _865._m3;
        uvec4 _862 = _44(_866);
        uint _870 = _862[_847 / 2u];
        uint _875 = 16u * (_847 & 1u);
        _858 = (_870 >> _875) & 65535u;
    }
    uint _884 = _858;
    float _886 = texture(SAMPLER_2D(_890[_884], _897), _735.zw).x;
    vec2 _904 = texture(SAMPLER_2D(_905[_884], _909), _735.zw).yx;
    vec3 _916 = texture(SAMPLER_2D(_917[_884], _921), _735.zw).xyz;
    vec3 _928 = vec3(0.039999999105930328369140625);
    _928 = texture(SAMPLER_2D(_931[_884], _935), _735.zw).xyz;
    float _942 = 1.0;
    float _943 = texture(SAMPLER_2D(_944[_884], _948), _735.zw).x;
    float _955 = texture(SAMPLER_2D(_956[_884], _960), _735.zw).x;
    vec3 _967 = texture(SAMPLER_2D(_968[_884], _972), _735.zw).xyz;
    _813 = vec4(_916.x, _916.y, _916.z, _813.w);
    _813.w = _904.y;
    _814 = vec4(_928.x, _928.y, _928.z, _814.w);
    _814.w = _955;
    _815 = vec4(_815.x, _904.x, _815.z, _904.y);
    _811.x = _943;
    _811.y = _942;
    _811.z = _955;
    _811.w = _886;
    _812 = vec4(_967.x, _967.y, _967.z, _812.w);
    vec2 _1004 = _735.zw;
    _1007 _1009;
    _1009._m0 = _813;
    _1009._m1 = _814;
    float _1014 = _811.x;
    _1009._m2.x = _76(_1014);
    _1009._m2 = vec4(_1009._m2.x, _811.yzw.x, _811.yzw.y, _811.yzw.z);
    _1009._m3 = _815;
    _1009._m4 = _812;
    _1007 _1028 = _1009;
    vec3 _1030 = vec3(0.0);
    bool _1038;
    if (_840)
    {
        _1038 = _822.x < 65534.0;
    }
    else
    {
        _1038 = _840;
    }
    bool _1044;
    if (_1038)
    {
        _1044 = _822.x > 0.0;
    }
    else
    {
        _1044 = _1038;
    }
    if (_1044)
    {
        uint _1047 = 0u;
        _1007 _1048 = _1007(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1050 = _818.y & 7u;
        uint _1059;
        if (_755._m1.x == 0.0)
        {
            _1059 = _1050;
        }
        else
        {
            vec4 _1063 = _865._m3;
            uvec4 _1062 = _44(_1063);
            uint _1067 = _1062[_1050 / 2u];
            uint _1072 = 16u * (_1050 & 1u);
            _1059 = (_1067 >> _1072) & 65535u;
        }
        uint _1080 = _1059;
        float _1082 = texture(SAMPLER_2D(_890[_1080], _897), _1004).x;
        vec2 _1091 = texture(SAMPLER_2D(_905[_1080], _909), _1004).yx;
        vec3 _1100 = texture(SAMPLER_2D(_917[_1080], _921), _1004).xyz;
        vec3 _1109 = vec3(0.039999999105930328369140625);
        _1109 = texture(SAMPLER_2D(_931[_1080], _935), _1004).xyz;
        float _1118 = 1.0;
        float _1119 = texture(SAMPLER_2D(_944[_1080], _948), _1004).x;
        float _1128 = texture(SAMPLER_2D(_956[_1080], _960), _1004).x;
        vec3 _1137 = texture(SAMPLER_2D(_968[_1080], _972), _1004).xyz;
        _1048._m0 = vec4(_1100.x, _1100.y, _1100.z, _1048._m0.w);
        _1048._m0.w = _1091.y;
        _1048._m1 = vec4(_1109.x, _1109.y, _1109.z, _1048._m1.w);
        _1048._m1.w = _1128;
        _1048._m3 = vec4(_1048._m3.x, _1091.x, _1048._m3.z, _1091.y);
        _1048._m2.x = _1119;
        _1048._m2.y = _1118;
        _1048._m2.z = _1128;
        _1048._m2.w = _1082;
        _1048._m4 = vec4(_1137.x, _1137.y, _1137.z, _1048._m4.w);
        float _1175 = _1048._m2.x;
        _1048._m2.x = _67(_1175);
        float _1180 = _1048._m1.w;
        float _1183 = _822.x * _1180;
        float _1188 = _1009._m2.x;
        float _1191 = 0.0;
        float _1192 = 0.0;
        float _1193 = (_1183 * 1.5) - 0.5;
        float _1201 = 1.0 - _1188;
        float _1198 = _10(_1201);
        float _1210 = ((_1198 + _1193) - 0.5) * 10.0;
        float _1203 = _10(_1210);
        _1191 = _1203;
        float _1213 = (_822.x * 1.5) - 0.5;
        float _1221 = 1.0 - _1188;
        float _1218 = _10(_1221);
        float _1229 = ((_1218 + _1213) - 0.5) * 10.0;
        float _1223 = _10(_1229);
        _1192 = _1223;
        _1028._m0 = mix(_1028._m0, _1048._m0, vec4(_1191));
        _1028._m1 = mix(_1028._m1, _1048._m1, vec4(_1191));
        _1028._m2 = mix(_1028._m2, _1048._m2, vec4(_1191));
        _1028._m3 = mix(_1028._m3, _1048._m3, vec4(_1191));
        _1028._m4 = mix(_1028._m4, _1048._m4, vec4(_1191));
        _810 = (_1191 > 0.5) ? _1047 : _810;
        _1030.x = _1191;
    }
    bool _1285;
    if (_843)
    {
        _1285 = _822.y < 65534.0;
    }
    else
    {
        _1285 = _843;
    }
    bool _1291;
    if (_1285)
    {
        _1291 = _822.y > 0.0;
    }
    else
    {
        _1291 = _1285;
    }
    if (_1291)
    {
        uint _1294 = 0u;
        _1007 _1295 = _1007(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1296 = _818.z & 7u;
        uint _1305;
        if (_755._m1.x == 0.0)
        {
            _1305 = _1296;
        }
        else
        {
            vec4 _1309 = _865._m3;
            uvec4 _1308 = _44(_1309);
            uint _1313 = _1308[_1296 / 2u];
            uint _1318 = 16u * (_1296 & 1u);
            _1305 = (_1313 >> _1318) & 65535u;
        }
        uint _1326 = _1305;
        float _1328 = texture(SAMPLER_2D(_890[_1326], _897), _1004).x;
        vec2 _1337 = texture(SAMPLER_2D(_905[_1326], _909), _1004).yx;
        vec3 _1346 = texture(SAMPLER_2D(_917[_1326], _921), _1004).xyz;
        vec3 _1355 = vec3(0.039999999105930328369140625);
        _1355 = texture(SAMPLER_2D(_931[_1326], _935), _1004).xyz;
        float _1364 = 1.0;
        float _1365 = texture(SAMPLER_2D(_944[_1326], _948), _1004).x;
        float _1374 = texture(SAMPLER_2D(_956[_1326], _960), _1004).x;
        vec3 _1383 = texture(SAMPLER_2D(_968[_1326], _972), _1004).xyz;
        _1295._m0 = vec4(_1346.x, _1346.y, _1346.z, _1295._m0.w);
        _1295._m0.w = _1337.y;
        _1295._m1 = vec4(_1355.x, _1355.y, _1355.z, _1295._m1.w);
        _1295._m1.w = _1374;
        _1295._m3 = vec4(_1295._m3.x, _1337.x, _1295._m3.z, _1337.y);
        _1295._m2.x = _1365;
        _1295._m2.y = _1364;
        _1295._m2.z = _1374;
        _1295._m2.w = _1328;
        _1295._m4 = vec4(_1383.x, _1383.y, _1383.z, _1295._m4.w);
        float _1421 = _1295._m2.x;
        _1295._m2.x = _67(_1421);
        float _1426 = _1295._m1.w;
        float _1429 = _822.y * _1426;
        float _1434 = _1028._m2.x;
        float _1437 = 0.0;
        float _1438 = 0.0;
        float _1439 = (_1429 * 1.5) - 0.5;
        float _1446 = 1.0 - _1434;
        float _1443 = _10(_1446);
        float _1454 = ((_1443 + _1439) - 0.5) * 10.0;
        float _1448 = _10(_1454);
        _1437 = _1448;
        float _1457 = (_822.y * 1.5) - 0.5;
        float _1465 = 1.0 - _1434;
        float _1462 = _10(_1465);
        float _1473 = ((_1462 + _1457) - 0.5) * 10.0;
        float _1467 = _10(_1473);
        _1438 = _1467;
        _1028._m0 = mix(_1028._m0, _1295._m0, vec4(_1437));
        _1028._m1 = mix(_1028._m1, _1295._m1, vec4(_1437));
        _1028._m2 = mix(_1028._m2, _1295._m2, vec4(_1437));
        _1028._m3 = mix(_1028._m3, _1295._m3, vec4(_1437));
        _1028._m4 = mix(_1028._m4, _1295._m4, vec4(_1437));
        _810 = (_1437 > 0.5) ? _1294 : _810;
        _1030.y = _1437;
    }
    bool _1529;
    if (_840)
    {
        _1529 = _822.z > 0.0;
    }
    else
    {
        _1529 = _840;
    }
    if (_1529)
    {
        float _1532 = _822.z;
        float _1539 = 1.0 - _1028._m2.x;
        float _1535 = _10(_1539);
        float _1548 = ((_1535 - 0.5) * _1532) + _1532;
        float _1541 = _10(_1548);
        _1030.z = _1541;
        vec3 _1552 = _1028._m0.xyz * _1028._m0.xyz;
        float _1560 = 1.0 - _1028._m2.w;
        float _1572 = (_1541 - 0.0) / 0.3499999940395355224609375;
        vec3 _1577 = mix(_1028._m0.xyz, _1552, vec3(_10(_1572) * _1560));
        _1028._m0 = vec4(_1577.x, _1577.y, _1577.z, _1028._m0.w);
        float _1588 = (_1541 - 0.25) / 0.25;
        vec3 _1591 = mix(_1028._m1.xyz, vec3(0.039999999105930328369140625), vec3(_10(_1588)));
        _1028._m1 = vec4(_1591.x, _1591.y, _1591.z, _1028._m1.w);
        vec3 _1595 = vec3(_723._m17[0].z, _723._m17[1].z, _723._m17[2].z);
        float _1609 = _1595.z + 0.0625;
        float _1603 = _1541 * _10(_1609);
        float _1619 = (_1603 - 0.20000000298023223876953125) / 0.800000011920928955078125;
        _1028._m2.w = mix(_1028._m2.w, 0.89999997615814208984375, _10(_1619));
        float _1632 = (_1603 - 0.449999988079071044921875) / 0.5299999713897705078125;
        vec3 _1635 = mix(_1028._m3.wyz, vec3(0.5, 0.5, 1.0), vec3(_10(_1632)));
        _1028._m3 = vec4(_1028._m3.x, _1635.y, _1635.z, _1635.x);
        if (_1603 > 0.980000019073486328125)
        {
            float _1649 = (_1603 - 0.980000019073486328125) / 0.0199999995529651641845703125;
            _1595 = normalize(mix(_1595, vec3(0.0, 0.0, 1.0), vec3(_10(_1649))));
            _723._m17[0].z = _1595.x;
            _723._m17[1].z = _1595.y;
            _723._m17[2].z = _1595.z;
        }
    }
    _813 = _1028._m0;
    _814 = _1028._m1;
    vec3 _1667;
    if (_840)
    {
        _1667 = vec3(0.0);
    }
    else
    {
        _1667 = _811.xyz;
    }
    _811 = vec4(_1667.x, _1667.y, _1667.z, _811.w);
    _811.w = _1028._m2.w;
    _815 = _1028._m3;
    _812 = _1028._m4;
    vec3 _1684 = vec3(1.0);
    _723._m10 = (((vec3(_811.x * _811.x) * _1684) * _1696._m0.xyz) * _1696._m1.xxx) * mix(_813.xyz, vec3(1.0), vec3(_1696._m0.w));
    _723._m10 *= _822;
    _723._m10 *= vec3(_755._m2.x);
    uint _1725 = 0u;
    _723._m15.x = (_723._m15.x * _1696._m3.x) + _1696._m3.z;
    _723._m15.y = (_723._m15.y * _1696._m3.y) + _1696._m3.w;
    float _1744 = _755._m3.z;
    float _1747 = _755._m4.z;
    vec2 _1750 = _723._m15.xy * _1744;
    vec2 _1756 = dFdx(_1750);
    vec2 _1759 = dFdy(_1750);
    vec2 _1763 = _1756;
    vec2 _1765 = _1756;
    float _1762 = _29(_1763, _1765);
    vec2 _1769 = _1759;
    vec2 _1771 = _1759;
    float _1768 = _29(_1769, _1771);
    float _1774 = 0.5 * log2(max(_1762, _1768));
    float _1780 = 0.5 * log2(min(_1762, _1768));
    float _1786 = _1774 - min(_1747, _1774 - _1780);
    float _1794 = _1786;
    float _1796 = _755._m3.y;
    float _1799 = _755._m4.y;
    uvec2 _1802 = uvec2(_723._m15.xy * _1796);
    uint _1809 = uint(min(_755._m4.w, max(0.0, _1786) + _1799));
    uint _1818 = uint(_755._m3.x);
    _1725 = _1802.x & 255u;
    _1725 |= ((_1802.y & 255u) << uint(8));
    _1725 |= ((_1802.x >> uint(8)) << uint(16));
    _1725 |= ((_1802.y >> uint(8)) << uint(24));
    _1725 |= (_1809 << uint(19));
    _1725 |= (_1818 << uint(27));
    vec3 _1910;
    if (_755._m5.y != 0.0)
    {
        float _1858 = fract(_1794);
        float _1861 = 0.375;
        float _1863 = 0.625;
        bool _1870;
        float _1871;
        float _1874;
        if (_1858 <= _1861)
        {
            _1870 = false;
            _1871 = _1794 - 0.5;
            _1874 = 0.0;
        }
        else
        {
            if (_1858 >= _1863)
            {
                _1870 = false;
                _1871 = _1794 + 0.5;
                _1874 = 0.0;
            }
            else
            {
                _1870 = true;
                _1871 = _1794 - 0.5;
                _1874 = _1794 + 0.5;
            }
        }
        vec4 _1889 = vec4(_723._m15.x, _723._m15.y, 0.0, _1871);
        vec2 _1896 = TEXTURE_LOD(_1897, _1889.xy, _1889.w).xy;
        vec4 _1905 = SAMPLE_TEXTURE(_1906, _1896);
        _1910.x = (_723._m15.x * _1905.x) + _1905.z;
        _1910.y = (_723._m15.y * (_1905.x * _755._m6.x)) + _1905.w;
        _1910.z = _1905.y;
        vec2 _1936 = dFdx(_723._m15.xy) * _1910.z;
        vec2 _1944 = dFdy(_723._m15.xy) * _1910.z;
        vec2 _1953 = _1910.xy;
        vec2 _1956 = _1936;
        vec2 _1958 = _1944;
        vec3 _1961 = _122(_1952, _1953, _1956, _1958).xyz;
        _811 = vec4(_1961.x, _1961.y, _1961.z, _811.w);
        vec2 _1964 = _1910.xy;
        vec3 _1968 = _115(_1952, _1964).xyz;
        _811 = vec4(_1968.x, _1968.y, _1968.z, _811.w);
        if (_1870)
        {
            vec4 _1974 = vec4(_723._m15.x, _723._m15.y, 0.0, _1874);
            vec2 _1981 = TEXTURE_LOD(_1897, _1974.xy, _1974.w).xy;
            vec4 _1989 = SAMPLE_TEXTURE(_1906, _1981);
            _1910.x = (_723._m15.x * _1989.x) + _1989.z;
            _1910.y = (_723._m15.y * (_1989.x * _755._m6.x)) + _1989.w;
            _1910.z = _1989.y;
            vec2 _2017 = dFdx(_723._m15.xy) * _1910.z;
            vec2 _2025 = dFdy(_723._m15.xy) * _1910.z;
            vec2 _2034 = _1910.xy;
            vec2 _2037 = _2017;
            vec2 _2039 = _2025;
            vec3 _2042 = _122(_1952, _2034, _2037, _2039).xyz;
            vec4 _2033;
            _2033 = vec4(_2042.x, _2042.y, _2042.z, _2033.w);
            vec2 _2045 = _1910.xy;
            vec3 _2049 = _115(_1952, _2045).xyz;
            _2033 = vec4(_2049.x, _2049.y, _2049.z, _2033.w);
            float _2052 = 0.0;
            float _2053 = 0.375;
            float _2058 = (_1858 - _2053) * 4.0;
            _2052 = _10(_2058);
            vec3 _2066 = mix(_811.xyz, _2033.xyz, vec3(_2052));
            _2033 = vec4(_2066.x, _2066.y, _2066.z, _2033.w);
        }
    }
    else
    {
        vec4 _2070 = vec4(_723._m15.x, _723._m15.y, 0.0, _1794 - 0.5);
        vec2 _2078 = TEXTURE_LOD(_1897, _2070.xy, _2070.w).xy;
        vec4 _2086 = SAMPLE_TEXTURE(_1906, _2078);
        _1910.x = (_723._m15.x * _2086.x) + _2086.z;
        _1910.y = (_723._m15.y * (_2086.x * _755._m6.x)) + _2086.w;
        _1910.z = _2086.y;
        vec2 _2114 = dFdx(_723._m15.xy) * _1910.z;
        vec2 _2122 = dFdy(_723._m15.xy) * _1910.z;
        vec2 _2130 = _1910.xy;
        vec2 _2133 = _2114;
        vec2 _2135 = _2122;
        vec3 _2138 = _122(_1952, _2130, _2133, _2135).xyz;
        _811 = vec4(_2138.x, _2138.y, _2138.z, _811.w);
        vec2 _2141 = _1910.xy;
        vec3 _2145 = _115(_1952, _2141).xyz;
        _811 = vec4(_2145.x, _2145.y, _2145.z, _811.w);
    }
    vec2 _2148 = vec2(160.0, 90.0);
    vec2 _2152 = _2148 * _755._m7.zw;
    vec2 _2159 = (gl_FragCoord.xy * _755._m7.zw) * _2148;
    bool _2173 = fract(_2159.x) < _2152.x;
    bool _2182;
    if (_2173)
    {
        _2182 = fract(_2159.y) < _2152.y;
    }
    else
    {
        _2182 = _2173;
    }
    if (_2182)
    {
        uint _2192 = _1725;
        imageStore(_2187, ivec2(_2159), vec4(_35(_2192), 0.0, 0.0, 0.0));
    }
    _810 = _1725;
    _723._m0 = _813.xyz;
    _723._m2 = _814.xyz;
    _723._m1 = _812.xyz;
    _723._m9 = _811.xyz;
    _723._m3 = _811.w;
    _723._m6 = _815.wyz;
    uint _2216 = 8u;
    float _2217 = 16.0;
    float _2219 = 8.0;
    float _2221 = 24.0;
    vec2 _2230 = _723._m16.xy * _755._m7.xy;
    vec3 _2223;
    _2223 = vec3(_2230.x, _2230.y, _2223.z);
    _2223.y = 1.0 - _2223.y;
    // FIX FOR DECALS CLIPPING
    //clusterCoordinate.x -= vk3d_params[VIEW].stereo.x * 0.5;
    _2223.x -= vk3d_params[VIEW].stereo.x * 0.5;
    vec2 _2243 = floor(_2223.xy * vec2(_2217, _2219));
    _2223 = vec3(_2243.x, _2243.y, _2223.z);
    float _2247 = _723._m16.z;
    vec4 _2250 = _755._m8;
    float _2253 = 1.0;
    bool _2254 = false;
    float _2246 = _147(_2247, _2250, _2253, _2254);
    float _2256 = log2(max(1.0, _2246 / _755._m9.z)) * _755._m9.w;
    _2223.z = min(_2221 - 1.0, floor(_2256));
    uint _2272 = uint((_2223.x + (_2223.y * _2217)) + ((_2223.z * _2217) * _2219));
    bool _2288 = true;
    vec3 _2289 = _723._m6;
    bool _2292 = _2288;
    _723._m7 = _152(_2289, _2292);
    vec3 _2296 = _723._m7;
    mat3 _2299 = _723._m17;
    _723._m6 = _159(_2296, _2299);
    uint _2304 = 0u;
    uint _2305 = 0u;
    uint _2306 = 0u;
    uint _2307 = 0u;
    uint _2308 = 0u;
    uint _2309 = 0u;
    int _2311 = 256;
    _2313 _2315;
    _2315._m0 = _2320._m0[_2272]._m0;
    _2315._m1 = _2320._m0[_2272]._m1;
    int _2329 = _2315._m0 & (~(_2315._m0 >> 31));
    int _2338 = _2315._m1 & (~(_2315._m1 >> 31));
    _2304 = uint((_2329 >> 16) * _2311);
    _2305 = _2304 + uint(_2338 & 255);
    _2306 = _2304;
    _2307 = _2306 + uint((_2338 >> 8) & 255);
    _2308 = _2304;
    _2309 = _2308 + uint((_2338 >> 16) & 255);
    vec3 _2371 = dFdx(_723._m14);
    vec3 _2375 = dFdy(_723._m14);
    uint _2379 = _2306;
    _2416 _2418;
    vec3 _2768;
    float _2901;
    while (_2379 < _2307)
    {
        uint _2389 = _2393._m0[_2379];
        uint _2398 = (_2389 >> uint(12)) & 4095u;
        uint _2404 = _2398;
        if (_2404 >= _2398)
        {
            _2379++;
        }
        int _2413 = 2;
        int _2414 = 2;
        int _2415 = 2;
        _2418._m0 = _2423._m0[(uint(_2413) * _2404) + 0u];
        _2418._m1 = _2423._m0[(uint(_2413) * _2404) + 1u];
        _2418._m2 = _2443._m0[(uint(_2414) * _2404) + 0u];
        float _2457 = _2443._m0[(uint(_2414) * _2404) + 1u].x;
        _2418._m3.x = _39(_2457);
        float _2467 = _2443._m0[(uint(_2414) * _2404) + 1u].y;
        _2418._m3.y = _39(_2467);
        float _2477 = _2443._m0[(uint(_2414) * _2404) + 1u].z;
        _2418._m4.x = _39(_2477);
        float _2487 = _2443._m0[(uint(_2414) * _2404) + 1u].w;
        _2418._m4.y = _39(_2487);
        float _2501 = _2495._m0[(uint(_2415) * _2404) + 0u].x;
        _2418._m5.x = _39(_2501);
        float _2511 = _2495._m0[(uint(_2415) * _2404) + 0u].y;
        _2418._m5.y = _39(_2511);
        float _2521 = _2495._m0[(uint(_2415) * _2404) + 0u].z;
        _2418._m6 = _39(_2521);
        float _2531 = _2495._m0[(uint(_2415) * _2404) + 0u].w;
        _2418._m7 = _39(_2531);
        float _2541 = _2495._m0[(uint(_2415) * _2404) + 1u].x;
        _2418._m8 = _39(_2541);
        float _2551 = _2495._m0[(uint(_2415) * _2404) + 1u].y;
        _2418._m9 = _39(_2551);
        float _2561 = _2495._m0[(uint(_2415) * _2404) + 1u].z;
        _2418._m10 = _39(_2561);
        float _2572 = _2495._m0[(uint(_2415) * _2404) + 1u].w;
        _2418._m11 = _39(_2572);
        vec4 _2577 = _2418._m0;
        vec4 _2580 = _2418._m2;
        vec4 _2583 = _2418._m1;
        vec4 _2586 = vec4(_723._m14, 1.0);
        vec3 _2593 = vec3(dot(_2586, _2577), dot(_2586, _2583), dot(_2586, _2580));
        float _2604 = 0.0039215688593685626983642578125;
        float _2606 = _2593.x;
        float _2609 = _2593.y;
        float _2612 = _2593.z;
        bool _2617 = _55(_2606, _2609, _2612) <= _2604;
        bool _2634;
        if (!_2617)
        {
            float _2621 = _2593.x;
            float _2624 = _2593.y;
            float _2627 = _2593.z;
            _2634 = _50(_2621, _2624, _2627) >= (1.0 - _2604);
        }
        else
        {
            _2634 = _2617;
        }
        if (_2634)
        {
            continue;
        }
        uint _2638 = _2418._m11;
        bool _2642 = _2216 != 0u;
        bool _2649;
        if (_2642)
        {
            _2649 = (_2638 & 512u) != 0u;
        }
        else
        {
            _2649 = _2642;
        }
        bool _2662;
        if (!_2649)
        {
            bool _2654 = _2216 == 0u;
            bool _2661;
            if (_2654)
            {
                _2661 = (_2638 & 1024u) != 0u;
            }
            else
            {
                _2661 = _2654;
            }
            _2662 = _2661;
        }
        else
        {
            _2662 = _2649;
        }
        if (_2662)
        {
            continue;
        }
        vec2 _2666 = vec2(dot(_2371, _2577.xyz), dot(_2371, _2583.xyz));
        vec2 _2676 = vec2(dot(_2375, _2577.xyz), dot(_2375, _2583.xyz));
        float _2686 = 1.0;
        float _2687 = 1.0;
        vec3 _2688 = vec3(0.5, 0.5, 1.0);
        vec3 _2689 = vec3(0.0, 0.0, 1.0);
        uint _2690 = _2418._m7;
        uint _2694 = _2418._m9;
        vec4 _2693 = _94(_2694);
        uvec2 _2699 = _2418._m5;
        vec4 _2698 = _107(_2699);
        vec2 _2703 = _2666 * _2698.xy;
        vec2 _2708 = _2676 * _2698.xy;
        vec2 _2723 = (_2593.xy * _2698.xy) + _2698.zw;
        vec2 _2724 = _2703;
        vec2 _2726 = _2708;
        vec4 _2713 = _122(_2714, _2723, _2724, _2726);
        vec2 _2729 = (_2713.xy * 2.0) - vec2(1.0);
        float _2740 = 1.0 - dot(_2729, _2729);
        _2688 = vec3(_2729, sqrt(_10(_2740)));
        _2689 = _2688;
        _2686 = _2713.z;
        float _2749 = _2713.w;
        _2687 = _67(_2749);
        bool _2756 = _2687 <= (4.0 * _2604);
        bool _2763;
        if (_2756)
        {
            _2763 = _2693.w <= _2604;
        }
        else
        {
            _2763 = _2756;
        }
        if (_2763)
        {
            continue;
        }
        _2688 = _2689;
        if ((_2638 & 128u) != 0u)
        {
            _2768 = vec3(-_2688.x, -_2688.y, _2688.z);
        }
        else
        {
            _2768 = _2688;
        }
        _2688 = _2768;
        uint _2787 = _2418._m8;
        uint _2791 = _2787;
        float _2790 = 1.0 + (_97(_2791).w * 0.062745101749897003173828125);
        uint _2799 = _2690;
        float _2798 = _94(_2799).z;
        uint _2804 = _2787;
        vec3 _2803 = _94(_2804).xyz;
        float _2817 = _2790 - (_2790 * abs((_2593.z * 2.0) - 1.0));
        _2687 *= _10(_2817);
        float _2821 = _2687;
        if ((_2690 & 1u) != 0u)
        {
            vec3 _2828 = _2803;
            _2803 = vec3(0.0);
            uvec2 _2831 = _2418._m3;
            vec4 _2830 = _107(_2831);
            vec2 _2835 = _2666 * _2830.xy;
            vec2 _2840 = _2676 * _2830.xy;
            vec2 _2854 = (_2593.xy * _2830.xy) + _2830.zw;
            vec2 _2855 = _2835;
            vec2 _2857 = _2840;
            vec4 _2845 = _122(_2714, _2854, _2855, _2857);
            vec4 _2860 = _2845;
            _2845 = _73(_2860);
            _2803 = _2845.xyz;
            float _2872 = (_2845.w - _2604) / (1.0 - _2604);
            _2821 = _10(_2872);
            _2803 *= _2828;
        }
        vec3 _2877 = normalize(vec3(_723._m17[0].z, _723._m17[1].z, _723._m17[2].z));
        float _2886 = dot(_2877, normalize(_2580.xyz));
        float _2892 = _2886;
        vec2 _2897 = _2688.xy * _87(_2892);
        _2688 = vec3(_2897.x, _2897.y, _2688.z);
        if ((_2638 & 16384u) != 0u)
        {
            float _2910 = abs(_2886);
            _2901 = _10(_2910);
        }
        else
        {
            float _2913 = _2886;
            _2901 = _10(_2913);
        }
        float _2900 = _2901;
        float _2917 = ((_2900 * _2821) * _2693.w) * _2798;
        _723._m10 += (_2693.xyz * (_2917 * 64.0));
        uint _2936 = _2418._m10;
        uint _2940 = _2936;
        vec4 _2939 = _94(_2940);
        if ((_2690 & 2u) != 0u)
        {
            uvec2 _2949 = _2418._m4;
            vec4 _2948 = _107(_2949);
            vec2 _2953 = _2666 * _2948.xy;
            vec2 _2958 = _2676 * _2948.xy;
            vec2 _2971 = (_2593.xy * _2948.xy) + _2948.zw;
            vec2 _2972 = _2953;
            vec2 _2974 = _2958;
            _2939 = _122(_2714, _2971, _2972, _2974);
            _2939 *= _2939;
        }
        if ((_2690 & 32u) != 0u)
        {
            uint _2987 = _2690;
            float _2986 = _94(_2987).x;
            uint _2992 = _2690;
            float _2991 = _97(_2992).y;
            float _2998 = _2986;
            float _2996 = mix(_2991, 0.0, _10(_2998));
            float _3007 = _2686 - (_2996 / 255.0);
            float _3002 = float(_10(_3007) > 0.0);
            _2687 *= _3002;
        }
        float _3014 = _2687 * _2900;
        uint _3018 = _2418._m6;
        uint _3022 = _3018;
        vec4 _3027 = _94(_3022) * _3014;
        vec4 _3021 = _22(_3027);
        _723._m11 = max(_723._m11, _3021.x);
        _723._m0 = mix(_723._m0, _2803, _3021.xxx);
        _723._m2 = mix(_723._m2, _2939.xyz, _3021.yyy);
        vec3 _3050 = _2877;
        vec3 _3060 = _2577.xyz + (_3050 * dot(_2577.xyz, _3050));
        _2577 = vec4(_3060.x, _3060.y, _3060.z, _2577.w);
        vec3 _3071 = _2583.xyz + (_3050 * dot(_2583.xyz, _3050));
        _2583 = vec4(_3071.x, _3071.y, _3071.z, _2583.w);
        _2688 = ((normalize(_2577.xyz) * _2688.x) + (normalize(_2583.xyz) * _2688.y)) + (_3050 * _2688.z);
        if ((_2638 & 256u) != 0u)
        {
            vec3 _3098 = mix(_2877, _2688, _3021.www);
            float _3104 = dot(_3098, _2877);
            _2688 = (_723._m6 * _3104) + ((_3098 - (_2877 * _3104)) * dot(_723._m6, _2877));
        }
        else
        {
            if ((_2638 & 64u) != 0u)
            {
                _2688 = mix(mix(_723._m6, _2877, vec3(_3014)), _2688, _3021.www);
            }
            else
            {
                _2688 = mix(_723._m6, _2688, _3021.www);
            }
        }
        _723._m6 = normalize(_2688);
        _723._m3 = mix(_723._m3, _2939.w, _3021.z);
    }
    vec3 _3158 = vec3(0.0);
    _3158 = _723._m9 * _755._m10.x;
    float _3164;
    if (dot(_723._m10, vec3(1.0)) > 0.0)
    {
        _3164 = -_723._m3;
    }
    else
    {
        _3164 = _723._m3;
    }
    _723._m3 = _3164;
    _723._m18 = _3158;
    _723._m19 = _3158;
    uint _3184 = _2304;
    _3213 _3215;
    vec3 _3509;
    float _3600;
    float _3611;
    _3988 _3990;
    uint _4108;
    _3988 _4134;
    while (_3184 < _2305)
    {
        uint _3194 = _2393._m0[_3184];
        uint _3198 = _3194 & 4095u;
        uint _3201 = _3198;
        if (_3201 >= _3198)
        {
            _3184++;
        }
        int _3210 = 4;
        int _3211 = 4;
        int _3212 = 3;
        _3215._m0 = _3219._m0[(uint(_3210) * _3201) + 0u].xyz;
        float _3234 = _3219._m0[(uint(_3210) * _3201) + 0u].w;
        _3215._m1 = _39(_3234);
        _3215._m2 = _3219._m0[(uint(_3210) * _3201) + 1u];
        _3215._m3 = _3219._m0[(uint(_3210) * _3201) + 2u];
        _3215._m4 = _3258._m0[(uint(_3211) * _3201) + 0u];
        _3215._m5 = _3258._m0[(uint(_3211) * _3201) + 1u];
        _3215._m6 = _3258._m0[(uint(_3211) * _3201) + 2u];
        float _3288 = _3219._m0[(uint(_3210) * _3201) + 3u].x;
        _3215._m7.x = _39(_3288);
        float _3298 = _3219._m0[(uint(_3210) * _3201) + 3u].y;
        _3215._m7.y = _39(_3298);
        float _3308 = _3219._m0[(uint(_3210) * _3201) + 3u].z;
        _3215._m7.z = _39(_3308);
        float _3318 = _3219._m0[(uint(_3210) * _3201) + 3u].w;
        _3215._m7.w = _39(_3318);
        _3215._m8 = _3327._m0[(uint(_3212) * _3201) + 0u];
        _3215._m9 = _3327._m0[(uint(_3212) * _3201) + 1u];
        _3215._m10 = _3327._m0[(uint(_3212) * _3201) + 2u];
        float _3357 = _3258._m0[(uint(_3211) * _3201) + 3u].x;
        _3215._m11 = _39(_3357);
        float _3367 = _3258._m0[(uint(_3211) * _3201) + 3u].y;
        _3215._m12 = _39(_3367);
        _3215._m13 = _3258._m0[(uint(_3211) * _3201) + 3u].z;
        float _3385 = _3258._m0[(uint(_3211) * _3201) + 3u].w;
        _3215._m14 = _39(_3385);
        float _3390 = 0.0039215688593685626983642578125;
        vec4 _3391 = vec4(_723._m14, 1.0);
        float _3398 = 1.0 / dot(_3391, _3215._m6);
        vec3 _3404 = vec3(dot(_3391, _3215._m4) * _3398, dot(_3391, _3215._m5) * _3398, dot(_3391, _3215._m3));
        uint _3422 = _3215._m1;
        uint _3425 = _2216;
        _3425 |= 64u;
        float _3429 = _3404.x;
        float _3432 = _3404.y;
        float _3435 = _3404.z;
        bool _3440 = _55(_3429, _3432, _3435) <= _3390;
        bool _3457;
        if (!_3440)
        {
            float _3444 = _3404.x;
            float _3447 = _3404.y;
            float _3450 = _3404.z;
            _3457 = _50(_3444, _3447, _3450) >= (1.0 - _3390);
        }
        else
        {
            _3457 = _3440;
        }
        bool _3465;
        if (!_3457)
        {
            _3465 = (_3422 & _3425) != 0u;
        }
        else
        {
            _3465 = _3457;
        }
        if (_3465)
        {
            continue;
        }
        if ((_3422 & 3u) == 2u)
        {
            vec2 _3484 = fract((_3404.xy * _755._m11.xy) + _755._m11.zw);
            _3404 = vec3(_3484.x, _3484.y, _3404.z);
        }
        vec3 _3487 = _3215._m0;
        float _3490 = 1.0;
        float _3491 = 1.0;
        vec3 _3492 = vec3(0.0, 0.0, 1.0);
        vec3 _3493 = vec3(0.0, 0.0, 1.0);
        uint _3494 = _3215._m1;
        vec3 _3497 = (_3404 * 2.0) - vec3(1.0);
        vec2 _3502 = _3404.xy;
        vec3 _3505 = _3215._m10.xyz;
        if ((_3494 & 3u) == 2u)
        {
            _3509 = _3505;
        }
        else
        {
            _3509 = normalize(_3487 - _723._m14);
        }
        _3492 = _3509;
        _3492 = _3492;
        float _3529 = dot(_723._m6, _3492);
        float _3524 = _10(_3529);
        bool _3533 = _3524 <= _3390;
        bool _3540;
        if (_3533)
        {
            _3540 = (_3494 & 48u) == 0u;
        }
        else
        {
            _3540 = _3533;
        }
        if (_3540)
        {
            continue;
        }
        uvec2 _3545 = _3215._m7.zw;
        vec4 _3544 = _107(_3545);
        float _3550 = TEXTURE_LOD(_3551, vec4((_3502 * _3544.xy) + _3544.zw, 0.0, 0.0).xy, vec4((_3502 * _3544.xy) + _3544.zw, 0.0, 0.0).w).x;
        float _3577 = _3550 * _3550;
        uint _3581 = _3494 & 3u;
        bool _3586 = _3581 == 1u;
        bool _3598;
        if (!_3586)
        {
            bool _3591 = _3581 == 0u;
            bool _3597;
            if (_3591)
            {
                _3597 = _3215._m8.z != 0.0;
            }
            else
            {
                _3597 = _3591;
            }
            _3598 = _3597;
        }
        else
        {
            _3598 = _3586;
        }
        bool _3584 = _3598;
        if (_3584)
        {
            float _3604 = _3215._m8.w;
            _3600 = _10(_3604);
        }
        else
        {
            _3600 = 0.5;
        }
        float _3599 = _3600;
        bool _3613 = _3581 == 0u;
        bool _3619;
        if (_3613)
        {
            _3619 = _3215._m8.z != 0.0;
        }
        else
        {
            _3619 = _3613;
        }
        if (_3619)
        {
            float _3627 = sqrt(dot(_3497, _3497));
            _3611 = min(0.9921875, _10(_3627));
        }
        else
        {
            _3611 = _3404.z;
        }
        float _3610 = _3611;
        uvec2 _3635 = _3215._m7.xy;
        vec4 _3634 = _107(_3635);
        vec2 _3640 = vec2(_3610, _3599);
        float _3644 = TEXTURE_LOD(_3551, vec4((_3640 * _3634.xy) + _3634.zw, 0.0, 0.0).xy, vec4((_3640 * _3634.xy) + _3634.zw, 0.0, 0.0).w).x;
        _3644 *= _3644;
        _3490 = _3644 * _3577;
        if ((_3494 & 48u) != 0u)
        {
            vec4 _3681 = _3215._m10;
            vec4 _3684 = _3215._m8;
            vec4 _3687 = _3215._m9;
            float _3690 = dot(_723._m14, _3681.xyz) + _3681.w;
            if (_3690 < 0.0)
            {
                continue;
            }
            float _3704 = length(_3681.xyz);
            float _3711 = _3690 * 50.0;
            float _3708 = _10(_3711);
            _3490 *= (_3708 * _3708);
            _3690 /= _3704;
            _3681 /= vec4(_3704);
            vec3 _3725 = reflect(-_723._m13, _723._m6);
            if (dot(_3725, _3681.xyz) > 0.0)
            {
                _3725 = reflect(_3725, _3681.xyz);
            }
            float _3743 = dot(_3725, _3681.xyz);
            float _3748 = _3690 / _3743;
            vec3 _3752 = _723._m14 - (_3725 * _3748);
            vec3 _3759 = _3752 - _3487;
            float _3763 = dot(_3759, _3684.xyz) / _3684.w;
            float _3771 = dot(_3759, _3687.xyz) / _3687.w;
            if ((_3494 & 48u) == 32u)
            {
                vec2 _3784 = vec2(_3763, _3771);
                float _3788 = 1.0 / max(1.0, length(vec2(_3763, _3771)));
                _3763 *= (_3788 * _3684.w);
                _3771 *= (_3788 * _3687.w);
            }
            else
            {
                float _3810 = abs(_3763);
                float _3812 = _3763;
                _3763 = (_10(_3810) * _87(_3812)) * _3684.w;
                float _3821 = abs(_3771);
                float _3823 = _3771;
                _3771 = (_10(_3821) * _87(_3823)) * _3687.w;
            }
            vec3 _3830 = (_3684.xyz * _3763) + (_3687.xyz * _3771);
            _3487 += _3830;
            _3492 = normalize(_3487 - _723._m14);
            _3492 = _3492;
        }
        else
        {
            uint _3850 = (_3215._m14 >> uint(16)) & 255u;
            if (_3850 == 0u)
            {
                vec4 _3859 = _3215._m9;
                if (dot(_3859.xyz, _723._m14) < (_3859.w - _3390))
                {
                    continue;
                }
            }
            else
            {
                if (_3850 == 1u)
                {
                    vec3 _3880 = _3215._m9.xyz;
                    float _3885 = _3215._m9.w;
                    uint _3889 = _39(_3885);
                    vec3 _3884 = (((_101(_3889) * 2.0) - vec3(1.0)) * _3880) + _3487;
                    vec3 _3898 = abs((_723._m14 - _3884) / _3880);
                    float _3906 = _3898.x;
                    float _3909 = _3898.y;
                    float _3912 = _3898.z;
                    if (_50(_3906, _3909, _3912) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_3490 <= (_3390 / 256.0))
        {
            continue;
        }
        float _3928 = 1.0;
        if ((_3422 & 4u) != 0u)
        {
            float _3935 = float(_3215._m14 & 255u) / 255.0;
            float _3941 = 0.00999999977648258209228515625;
            vec3 _3943 = _723._m14 + (_723._m6 * _3941);
            uint _3951 = 0u;
            if ((_3422 & 3u) == 0u)
            {
                vec3 _3957 = _3943 - _3215._m2.xyz;
                float _3963 = _3957.x;
                float _3966 = _3957.y;
                float _3969 = _3957.z;
                _3951 = _61(_3963, _3966, _3969);
            }
            else
            {
                if ((_3422 & 3u) == 2u)
                {
                    float _3979 = 0.0;
                    for (; _3951 < 3u; _3951++)
                    {
                        int _3987 = 5;
                        _3990._m0 = _3994._m0[(uint(_3987) * ((_3422 >> uint(22)) + _3951)) + 0u];
                        _3990._m1 = _3994._m0[(uint(_3987) * ((_3422 >> uint(22)) + _3951)) + 1u];
                        _3990._m2 = _3994._m0[(uint(_3987) * ((_3422 >> uint(22)) + _3951)) + 2u];
                        _3990._m3 = _3994._m0[(uint(_3987) * ((_3422 >> uint(22)) + _3951)) + 3u];
                        _3990._m4 = _3994._m0[(uint(_3987) * ((_3422 >> uint(22)) + _3951)) + 4u];
                        vec2 _4051 = vec2(dot(_3943, _3990._m0.xyz) + _3990._m0.w, dot(_3943, _3990._m1.xyz) + _3990._m1.w);
                        _4051 = abs((_4051 * 2.0) - vec2(1.0));
                        bool _4076 = _4051.x < 1.0;
                        bool _4082;
                        if (_4076)
                        {
                            _4082 = _4051.y < 1.0;
                        }
                        else
                        {
                            _4082 = _4076;
                        }
                        if (_4082)
                        {
                            _3979 = (1.0 - max(_4051.x, _4051.y)) * _755._m12.w;
                            break;
                        }
                    }
                    _3951 = min(2u, _3951);
                    uint _4099 = uint(_723._m16.x) ^ (uint(_723._m16.y) << uint(1));
                    if (_755._m13.w > 0.0)
                    {
                        _4108 = uint(_755._m14.x);
                    }
                    else
                    {
                        _4108 = 0u;
                    }
                    _4099 ^= _4108;
                    _3951 += uint(int(((float(_4099 & 3u) * 0.25) + 0.125) > _3979));
                }
            }
            int _4133 = 5;
            _4134._m0 = _3994._m0[(uint(_4133) * ((_3422 >> uint(22)) + _3951)) + 0u];
            _4134._m1 = _3994._m0[(uint(_4133) * ((_3422 >> uint(22)) + _3951)) + 1u];
            _4134._m2 = _3994._m0[(uint(_4133) * ((_3422 >> uint(22)) + _3951)) + 2u];
            _4134._m3 = _3994._m0[(uint(_4133) * ((_3422 >> uint(22)) + _3951)) + 3u];
            _4134._m4 = _3994._m0[(uint(_4133) * ((_3422 >> uint(22)) + _3951)) + 4u];
            vec4 _4190 = vec4((_3943.x * _4134._m0.x) + ((_3943.y * _4134._m0.y) + ((_3943.z * _4134._m0.z) + _4134._m0.w)), (_3943.x * _4134._m1.x) + ((_3943.y * _4134._m1.y) + ((_3943.z * _4134._m1.z) + _4134._m1.w)), (_3943.x * _4134._m2.x) + ((_3943.y * _4134._m2.y) + ((_3943.z * _4134._m2.z) + _4134._m2.w)), (_3943.x * _4134._m3.x) + ((_3943.y * _4134._m3.y) + ((_3943.z * _4134._m3.z) + _4134._m3.w)));
            vec3 _4277 = _4190.xyz / vec3(_4190.w);
            _4190 = vec4(_4277.x, _4277.y, _4277.z, _4190.w);
            bool _4285 = min(_4190.x, _4190.y) > 0.0;
            bool _4294;
            if (_4285)
            {
                _4294 = max(_4190.x, _4190.y) < 1.0;
            }
            else
            {
                _4294 = _4285;
            }
            if (_4294)
            {
                vec2 _4306 = (_4190.xy * _4134._m4.xy) + _4134._m4.zw;
                _4190 = vec4(_4306.x, _4306.y, _4190.z, _4190.w);
                if (false)
                {
                    _3928 = textureLod(_4314, vec3(_4190.xyz.xy, _4190.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4321 = (_4190.xy * _755._m15.xy) + vec2(0.5);
                    vec2 _4330 = floor(_4321);
                    vec2 _4333 = _4321 - _4330;
                    _4330 -= vec2(0.5);
                    vec2 _4340 = vec2(4.0) - (_4333 * 3.0);
                    vec2 _4346 = vec2(7.0);
                    vec2 _4349 = vec2(1.0) + (_4333 * 3.0);
                    vec2 _4354 = (_4330 + (((vec2(3.0) - (_4333 * 2.0)) / _4340) - vec2(2.0))) * _755._m15.zw;
                    vec2 _4369 = (_4330 + ((vec2(3.0) + _4333) / _4346)) * _755._m15.zw;
                    vec2 _4381 = (_4330 + ((_4333 / _4349) + vec2(2.0))) * _755._m15.zw;
                    vec3 _4405 = vec3(_4354.x, _4354.y, _4190.z);
                    _3928 = (_4340.x * _4340.y) * textureLod(_4314, vec3(_4405.xy, _4405.z), 0.0);
                    vec3 _4421 = vec3(_4369.x, _4354.y, _4190.z);
                    _3928 += ((_4346.x * _4340.y) * textureLod(_4314, vec3(_4421.xy, _4421.z), 0.0));
                    vec3 _4439 = vec3(_4381.x, _4354.y, _4190.z);
                    _3928 += ((_4349.x * _4340.y) * textureLod(_4314, vec3(_4439.xy, _4439.z), 0.0));
                    vec3 _4457 = vec3(_4354.x, _4369.y, _4190.z);
                    _3928 += ((_4340.x * _4346.y) * textureLod(_4314, vec3(_4457.xy, _4457.z), 0.0));
                    vec3 _4475 = vec3(_4369.x, _4369.y, _4190.z);
                    _3928 += ((_4346.x * _4346.y) * textureLod(_4314, vec3(_4475.xy, _4475.z), 0.0));
                    vec3 _4493 = vec3(_4381.x, _4369.y, _4190.z);
                    _3928 += ((_4349.x * _4346.y) * textureLod(_4314, vec3(_4493.xy, _4493.z), 0.0));
                    vec3 _4511 = vec3(_4354.x, _4381.y, _4190.z);
                    _3928 += ((_4340.x * _4349.y) * textureLod(_4314, vec3(_4511.xy, _4511.z), 0.0));
                    vec3 _4529 = vec3(_4369.x, _4381.y, _4190.z);
                    _3928 += ((_4346.x * _4349.y) * textureLod(_4314, vec3(_4529.xy, _4529.z), 0.0));
                    vec3 _4547 = vec3(_4381.x, _4381.y, _4190.z);
                    _3928 += ((_4349.x * _4349.y) * textureLod(_4314, vec3(_4547.xy, _4547.z), 0.0));
                    _3928 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3928 = float((_3422 & 3u) == 2u);
            }
            float _4561 = float((_3422 >> uint(16)) & 63u) / 63.0;
            float _4575 = ((_3928 * _4561) + 1.0) - _4561;
            _3928 = _10(_4575);
        }
        uint _4578 = _3215._m12;
        vec3 _4577 = (_125(_4578) * _3928) * _3490;
        _3491 *= _3215._m13;
        vec3 _4590 = _4577;
        vec3 _4592 = _3492;
        float _4599 = dot(_723._m6, _4592);
        float _4594 = _10(_4599);
        vec3 _4605 = _723._m6;
        vec3 _4608 = _723._m13;
        vec3 _4611 = _3492;
        vec3 _4613 = _723._m2;
        float _4616 = abs(_723._m3);
        vec3 _4601 = _138(_4605, _4608, _4611, _4613, _4616);
        _723._m20 += (((_4601 * _3491) * _4590) * _4594);
        vec3 _4630 = mix(_4590, vec3(0.0), bvec3((_3422 & 256u) > 0u));
        _723._m19 += (_4630 * _4594);
    }
    _723._m19 = _723._m19;
    _723._m20 += _723._m10;
    float _4654 = 0.064999997615814208984375;
    float _4656 = 1.0 + _4654;
    bool _4659 = false;
    uint _4661;
    if (_755._m16.w > 0.00999999977648258209228515625)
    {
        _4661 = uint(_755._m16.x);
    }
    else
    {
        _4661 = 0u;
    }
    uint _4660 = _4661;
    _4682 _4684;
    for (uint _4672 = 0u; _4672 < _4660; _4672++)
    {
        int _4681 = 4;
        _4684._m0 = _4688._m0[(uint(_4681) * _4672) + 0u];
        _4684._m1 = _4688._m0[(uint(_4681) * _4672) + 1u];
        _4684._m2 = _4688._m0[(uint(_4681) * _4672) + 2u];
        float _4718 = _4688._m0[(uint(_4681) * _4672) + 3u].x;
        _4684._m3 = _39(_4718);
        float _4728 = _4688._m0[(uint(_4681) * _4672) + 3u].y;
        _4684._m4 = _39(_4728);
        float _4738 = _4688._m0[(uint(_4681) * _4672) + 3u].z;
        _4684._m5 = _39(_4738);
        vec4 _4743 = vec4(_723._m14, 1.0);
        vec3 _4750 = vec3(dot(_4743, _4684._m1), dot(_4743, _4684._m2), dot(_4743, _4684._m0));
        float _4764 = _4750.x;
        float _4767 = _4750.y;
        float _4770 = _4750.z;
        bool _4774 = _55(_4764, _4767, _4770) >= 0.0;
        bool _4783;
        if (_4774)
        {
            _4783 = max(_4750.x, _4750.y) < 1.0;
        }
        else
        {
            _4783 = _4774;
        }
        bool _4790;
        if (_4783)
        {
            _4790 = _4750.z < _4656;
        }
        else
        {
            _4790 = _4783;
        }
        if (_4790)
        {
            float _4793 = _4750.z;
            vec4 _4796 = vec4(_723._m14, 1.0);
            vec2 _4803 = vec2(0.0);
            _4803 = (((_4796.xy - _755._m17.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _4816 = 0.000244140625;
            float _4822 = abs(_723._m6.z) * 2.0;
            _4816 *= _10(_4822);
            vec3 _4826 = vec3(TEXTURE_LOD(_4827, vec4(_4803 + vec2(_4816), 0.0, 0.0).xy, vec4(_4803 + vec2(_4816), 0.0, 0.0).w).x, TEXTURE_LOD(_4827, vec4(_4803, 0.0, 0.0).xy, vec4(_4803, 0.0, 0.0).w).x, TEXTURE_LOD(_4827, vec4(_4803 - vec2(_4816), 0.0, 0.0).xy, vec4(_4803 - vec2(_4816), 0.0, 0.0).w).x);
            float _4890 = 2.0 - (2.0 * (length(_4796.xy - _755._m17.zw) / 16.0));
            _4826 *= _10(_4890);
            float _4897 = 1.0 - _4793;
            float _4894 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_4897));
            float _4908 = (_723._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _4900 = (_4826 * _4894) * _10(_4908);
            float _4917 = _4656 - _4793;
            float _4911 = (1.0 - _4894) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_4917));
            float _4931 = ((-_723._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _4921 = (_4826 * _4911) * _10(_4931);
            _4826 = _4900 + _4921;
            float _4942 = 1.02499997615814208984375 - _4793;
            float _4937 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_4942));
            float _4945 = _755._m16.w;
            _723._m19 = mix(_723._m19, (_723._m19 * _4826) + (_723._m19 * mix(1.0, 0.5, _4937)), vec3(_4945));
            break;
        }
    }
    _723._m19 *= _723._m0;
    _723._m21 = _723._m19 + _723._m20;
    vec3 _4985 = _723._m19 + _723._m20;
    _4980 = vec4(_4985.x, _4985.y, _4985.z, _4980.w);
    vec3 _4989 = _723._m6;
    bool _4992 = false;
    vec2 _4993 = _168(_4989, _4992);
    _4988 = vec4(_4993.x, _4993.y, _4988.z, _4988.w);
    float _4997 = _723._m2.x;
    float _5001 = _723._m2.y;
    float _5005 = _723._m2.z;
    float _5009 = _723._m3;
    _4996 = vec4(_90(_4997), _90(_5001), _90(_5005), _171(_5009));
    vec3 _5019 = _4980.xyz + _1696._m2.xyz;
    _4980 = vec4(_5019.x, _5019.y, _5019.z, _4980.w);
}

