// MORE SKY
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 2, binding = 0, std140) uniform _188_190
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _190;

layout(set = 0, binding = 0, std140) uniform _211_213
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    vec4 _m33;
} _213;

layout(set = 0, binding = 1, std430) restrict readonly buffer _1016_1018
{
    vec4 _m0[];
} _1018;

layout(push_constant, std430) uniform _1012_1014
{
    int _m0;
    int _m1;
} _1014;

layout(set = 2, binding = 1) uniform SAMPLER_2D _256;
layout(set = 0, binding = 2) uniform SAMPLER_2D _633;
layout(set = 0, binding = 3) uniform SAMPLER_2D _656;
layout(set = 0, binding = 4) uniform sampler3D _776;
layout(set = 0, binding = 5) uniform sampler3D _797;
layout(set = 0, binding = 6) uniform sampler3D _918;

layout(location = 2) in vec4 _258;
layout(location = 7) in vec4 _285;
layout(location = 8) in vec4 _294;
layout(location = 3) in vec4 _475;
layout(location = 4) in vec4 _516;
layout(location = 5) in vec4 _571;
layout(location = 6) in vec4 _575;
layout(location = 0) out vec4 _591;
layout(location = 1) out vec4 _965;
layout(location = 2) out vec4 _966;

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _35(vec4 _34)
{
    return _34.z;
}

uint _15(float _14)
{
    return floatBitsToUint(_14);
}

float _44(float _40, vec4 _41, float _42, bool _43)
{
    float _163 = _41.w / (_40 + _41.z);
    return _163 * _42;
}

float _18(float _17)
{
    float _56 = (((-0.15658299624919891357421875) * abs(_17)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_17));
    float _68;
    if (_17 >= 0.0)
    {
        _68 = _56;
    }
    else
    {
        _68 = 3.1415927410125732421875 - _56;
    }
    return _68;
}

float _21(float _20)
{
    float _82;
    if (_20 < 1.0)
    {
        _82 = _20;
    }
    else
    {
        _82 = 1.0 / _20;
    }
    float _81 = _82;
    float _92 = _81 * _81;
    float _96 = 0.087292902171611785888671875;
    _96 = (-0.3018949925899505615234375) + (_96 * _92);
    _96 = 1.0 + (_96 * _92);
    _96 *= _81;
    float _110;
    if (_20 < 1.0)
    {
        _110 = _96;
    }
    else
    {
        _110 = 1.57079637050628662109375 - _96;
    }
    return _110;
}

float _24(float _23)
{
    float _125 = abs(_23);
    float _122 = _21(_125);
    float _127;
    if (_23 < 0.0)
    {
        _127 = -_122;
    }
    else
    {
        _127 = _122;
    }
    return _127;
}

float _29(float _27, float _28)
{
    float _143 = _27 / _28;
    float _139 = _24(_143);
    if (_28 < 0.0)
    {
        _139 += ((_27 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _139;
}

void main()
{
    int _179 = 6;
    float _181 = 1.0 / float(_179);
    float _185 = 100.0;
    float _187 = _190._m2.x * _185;
    float _198 = 1.0;
    vec2 _201 = fract(gl_FragCoord.xy * 0.5);
    int _210;
    if (dot(_213._m20.zw, vec2(1.0)) > 0.0)
    {
        _210 = int(_213._m21.x) & 3;
    }
    else
    {
        _210 = 0;
    }
    int _209 = _210;
    float _233 = fract(((_201.x * 0.5) + _201.y) + (float(_209) * 0.125));
    float _247 = 0.100000001490116119384765625 * _190._m3.w;
    vec4 _252 = SAMPLE_TEXTURE(_256, (_258.xy * _190._m4.xy) + (_190._m4.zw * _213._m22.xx));
    if (_252.w < 0.0039215688593685626983642578125)
    {
        _252.w = 0.0;
    }
    else
    {
        vec2 _284 = normalize(_285.xyz).xy * _247;
        vec2 _293 = normalize(_294.xyz).xy * _247;
        if (_294.z < 0.0)
        {
            _293 *= (-1.0);
        }
        float _310 = 1.0;
        for (int _311 = 0; _311 < _179; _311++)
        {
            float _320 = _181 * (float(_311) + _233);
            vec2 _327 = _258.xy + (_284 * (1.0 - _320));
            vec4 _335 = SAMPLE_TEXTURE(_256, (clamp(_327, vec2(0.0), vec2(1.0)) * _190._m4.xy) + (_190._m4.zw * _213._m22.xx));
            float _353 = max(0.001000000047497451305389404296875, _335.x - _320);
            _310 *= exp(((-_353) * _187) * _181);
            float _369 = 1.0;
            for (int _370 = 0; _370 < _179; _370++)
            {
                float _379 = _181 * float(_370);
                vec4 _384 = SAMPLE_TEXTURE(_256, (clamp(_327 - (_293 * (1.0 - _379)), vec2(0.0), vec2(1.0)) * _190._m4.xy) + (_190._m4.zw * _213._m22.xx));
                float _406 = max(0.001000000047497451305389404296875, (_384.x - _379) - _320);
                _369 *= exp(((-_406) * _187) * _181);
            }
            float _436 = (_294.z * _190._m5.z) + 0.5;
            _369 = mix(_369, 1.0 - _369, _10(_436));
            _198 = mix(_198, _369, _353);
        }
        _252.w *= (1.0 - _310);
    }
    _252.w *= SAMPLE_TEXTURE(_256, (_258.xy * _190._m6.xy) + _190._m6.zw).z;
    float _468 = 1.0;
    float _469 = 0.0;
    _198 *= _468;
    vec3 _474 = normalize(_475.xyz);
    float _479 = _213._m5.x * 1.57079637050628662109375;
    float _483 = _213._m6.x * 3.1415927410125732421875;
    vec3 _487 = vec3(sin(_479) * cos(_483), sin(_479) * sin(_483), cos(_479));
    float _501 = dot(normalize(_487), _474);
    float _506 = max((_501 * 0.5) + 0.5, (_501 * (-0.5)) + 0.5);
    vec3 _515 = normalize(_516.xyz);
    float _520 = 0.079577468335628509521484375;
    vec2 _522 = vec2(_190._m7.x, -_190._m8.x);
    float _531 = dot(_515, _487);
    vec2 _535 = _522 * _522;
    vec2 _539 = vec2(1.0) - _535;
    vec2 _542 = (vec2(1.0) + _535) - ((vec2(2.0) * _522) * _531);
    vec2 _552 = (_539 * _520) / (_542 * sqrt(_542));
    float _561 = mix(_552.y, _552.x, (_531 * 0.5) + 0.5);
    vec3 _570 = _571.xyz;
    vec3 _574 = _575.xyz * _198;
    float _580 = (1.0 - _252.y) * (_190._m9.w * 10.0);
    vec3 _611 = (_570 * _190._m10.xyz) + (_574 * ((vec3(_506) + (_190._m9.xyz * _580)) + vec3(_561)));
    _591 = vec4(_611.x, _611.y, _611.z, _591.w);
    float _620 = (_252.w * _468) - _469;
    _591.w = _10(_620);
    vec2 _624 = gl_FragCoord.xy * _213._m23.zw;
    float _632 = 1.0 / (1.0 - min(TEXTURE_LOD(_633, vec4(_624 * _213._m24.zw, 0.0, 0.0).xy, vec4(_624 * _213._m24.zw, 0.0, 0.0).w).x, TEXTURE_LOD(_656, vec4(_624, 0.0, 0.0).xy, vec4(_624, 0.0, 0.0).w).x));
    vec4 _674 = gl_FragCoord;
    float _673 = 1.0 / (1.0 - _35(_674));
    float _679 = abs(_632 - _673);
    float _693 = ((_679 * _190._m5.x) * _190._m5.x) * 10.0;
    float _684 = _10(_693);
    _591.w *= _684;
    vec2 _700 = gl_FragCoord.xy * _213._m23.zw;
        // FIX for SKY
    _700.x -= vk3d_params[VIEW].stereo.x*0.5;
    float _707 = gl_FragCoord.z;
    vec4 _710 = vec4(0.0);
    float _712 = 1.0;
    float _716 = _213._m25.w;
    uint _714 = _15(_716);
    if ((_714 & 6u) != 0u)
    {
        vec2 _726 = _700 + vec2(0.0);
        vec3 _729 = _213._m26.xyz;
        float _734 = 0.100000001490116119384765625;
        float _735 = _213._m27.y;
        float _739 = _213._m26.z;
        float _742 = 0.0;
        float _745 = _707;
        vec4 _747 = _213._m7;
        float _750 = 1.0;
        bool _751 = false;
        float _743 = _44(_745, _747, _750, _751);
        _742 = pow((_743 - _734) / (_735 - _734), 0.5);
        _742 = (_742 * (_739 - 1.0)) / _739;
        vec4 _767 = vec4(_726, _742, 0.0);
        vec3 _793 = textureLod(_776, vec4(_767.xyz, 0.0).xyz, vec4(_767.xyz, 0.0).w).xyz;
        _710 = vec4(_793.x, _793.y, _793.z, _710.w);
        vec2 _796 = textureLod(_797, vec4(_767.xyz, 0.0).xyz, vec4(_767.xyz, 0.0).w).xy;
        _710.w = _796.x;
        _712 = _796.y;
    }
    if ((_714 & 2u) != 0u)
    {
        vec4 _825 = vec4(0.0);
        vec3 _826 = _213._m4.xyz;
        float _831 = _707;
        vec4 _833 = _213._m7;
        float _836 = 1.0;
        bool _837 = false;
        float _830 = _44(_831, _833, _836, _837);
        vec3 _839 = mix(_213._m28.xyz, _213._m29.xyz, vec3(_700.x * _213._m24.z));
        vec3 _855 = mix(_213._m30.xyz, _213._m31.xyz, vec3(_700.x * _213._m24.z));
        vec3 _871 = mix(_855, _839, vec3(1.0 - (_700.y * _213._m24.w)));
        vec4 _882 = vec4(0.0);
        vec3 _883 = normalize(_871);
        float _886 = _883.z;
        _882.x = clamp(_18(_886) / 3.1415927410125732421875, 0.00390625, 0.99609375);
        float _895 = _883.y;
        float _898 = _883.x;
        _882.y = _29(_895, _898) / 6.283185482025146484375;
        _882.z = sqrt(_830 * _213._m32.w);
        _882.z = clamp(_882.z, 0.015625, 0.984375);
        vec3 _925 = textureLod(_918, _882.xyz, _882.w).xyz;
        _825 = vec4(_925.x, _925.y, _925.z, _825.w);
        vec3 _934 = _591.xyz + (_825.xyz * _712);
        _591 = vec4(_934.x, _934.y, _934.z, _591.w);
    }
    if ((_714 & 4u) != 0u)
    {
        vec3 _950 = (_591.xyz * _710.w) + _710.xyz;
        _591 = vec4(_950.x, _950.y, _950.z, _591.w);
    }
    float _953 = _591.w;
    _591.w = _10(_953);
    vec3 _962 = _591.xyz * _591.w;
    _591 = vec4(_962.x, _962.y, _962.z, _591.w);
    _965 = vec4(0.0);
    _966 = vec4(0.0);
    if (_213._m33.w > 0.0)
    {
        vec2 _973 = gl_FragCoord.xy * _213._m23.xy;
        bool _980 = (gl_FragCoord.z < TEXTURE_LOD(_633, vec4(_973, 0.0, 0.0).xy, vec4(_973, 0.0, 0.0).w).x) ? true : false;
        if (_980 == false)
        {
            _965 = _591;
        }
        _591 *= float(_980 == true);
        _966.x = _591.w;
    }
}

