// FIX FOR DECALS CLIPPING
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_NV_shading_rate_image : require


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _693
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1005
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _1875
{
    int _m0;
    int _m1;
};

struct _1878
{
    int _m0;
    int _m1;
};

struct _1989
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2843
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _3618
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _4311
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 0, binding = 0, std140) uniform _714_716
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _716;

layout(set = 2, binding = 0, std140) uniform _817_819
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _819;

layout(set = 1, binding = 0, std140) uniform _1769_1771
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
} _1771;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1880_1882
{
    _1878 _m0[];
} _1882;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1964_1966
{
    uint _m0[];
} _1966;

layout(set = 0, binding = 15, std140) uniform _1994_1996
{
    vec4 _m0[4096];
} _1996;

layout(set = 0, binding = 16, std140) uniform _2014_2016
{
    vec4 _m0[4096];
} _2016;

layout(set = 0, binding = 17, std140) uniform _2066_2068
{
    vec4 _m0[4096];
} _2068;

layout(set = 0, binding = 19, std140) uniform _2847_2849
{
    vec4 _m0[4096];
} _2849;

layout(set = 0, binding = 20, std140) uniform _2886_2888
{
    vec4 _m0[4096];
} _2888;

layout(set = 0, binding = 21, std140) uniform _2955_2957
{
    vec4 _m0[3072];
} _2957;

layout(set = 0, binding = 23, std140) uniform _3622_3624
{
    vec4 _m0[4095];
} _3624;

layout(set = 0, binding = 25, std140) uniform _4315_4317
{
    vec4 _m0[4096];
} _4317;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4836_4838
{
    uint _m0[];
} _4838;

layout(set = 0, binding = 2, std430) restrict readonly buffer _4840_4842
{
    vec4 _m0[];
} _4842;

layout(push_constant, std430) uniform _4832_4834
{
    int _m0;
    int _m1;
} _4834;

layout(set = 3, binding = 3) uniform TEXTURE_2D _844[8];
layout(set = 0, binding = 6) uniform sampler _851;
layout(set = 3, binding = 2) uniform TEXTURE_2D _895[8];
layout(set = 0, binding = 7) uniform sampler _899;
layout(set = 3, binding = 0) uniform TEXTURE_2D _910[8];
layout(set = 0, binding = 8) uniform sampler _914;
layout(set = 3, binding = 1) uniform TEXTURE_2D _925[8];
layout(set = 0, binding = 9) uniform sampler _929;
layout(set = 3, binding = 7) uniform TEXTURE_2D _939[8];
layout(set = 0, binding = 10) uniform sampler _943;
layout(set = 3, binding = 4) uniform TEXTURE_2D _952[8];
layout(set = 0, binding = 11) uniform sampler _956;
layout(set = 3, binding = 6) uniform TEXTURE_2D _965[8];
layout(set = 0, binding = 12) uniform sampler _969;
layout(set = 0, binding = 18) uniform SAMPLER_2D _2287;
layout(set = 0, binding = 22) uniform SAMPLER_2D _3181;
layout(set = 0, binding = 24) uniform sampler2DShadow _3943;
layout(set = 0, binding = 26) uniform SAMPLER_2D _4456;
layout(set = 0, binding = 27) uniform SAMPLER_2D _4639;
layout(set = 3, binding = 5) uniform TEXTURE_2D _4831[8];
layout(set = 0, binding = 4) uniform sampler3D _4846;
layout(set = 0, binding = 5) uniform sampler3D _4847;

layout(location = 2) in vec4 _707;
layout(location = 6) in vec4 _721;
layout(location = 3) in vec4 _733;
layout(location = 4) in vec4 _736;
layout(location = 5) in vec4 _739;
layout(location = 10) in vec4 _757;
layout(location = 11) in vec4 _761;
layout(location = 12) in vec4 _765;
layout(location = 14) flat in uvec3 _778;
layout(location = 15) in vec4 _781;
layout(location = 0) out vec4 _4789;
layout(location = 1) out vec4 _4797;
layout(location = 2) out vec4 _4805;

float _262;

uvec4 _32(vec4 _31)
{
    return floatBitsToUint(_31);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _52(float _51)
{
    if (_51 <= 0.040449999272823333740234375)
    {
        return _51 / 12.9200000762939453125;
    }
    else
    {
        return pow((_51 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

float _64(float _63)
{
    float _316 = _63;
    return _52(_316);
}

float _55(float _54)
{
    return _54 * ((_54 * ((_54 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

float _133(float _129, vec4 _130, float _131, bool _132)
{
    float _548 = _130.w / (_129 + _130.z);
    return _548 * _131;
}

vec3 _138(vec3 _136, bool _137)
{
    vec3 _561 = (_136 * 2.0) - vec3(1.0);
    float _578 = (1.0 - (_561.x * _561.x)) - (_561.y * _561.y);
    _561.z = sqrt(_10(_578));
    if (_137 == false)
    {
        _561.z = -_561.z;
    }
    return _561;
}

vec3 _145(vec3 _143, mat3 _144)
{
    return normalize(vec3(dot(_143, _144[0]), dot(_143, _144[1]), dot(_143, _144[2])));
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

float _43(float _40, float _41, float _42)
{
    return min(_40, min(_41, _42));
}

float _38(float _35, float _36, float _37)
{
    return max(_35, max(_36, _37));
}

vec4 _83(uint _82)
{
    return unpackUnorm4x8(_82).wzyx;
}

vec4 _96(uvec2 _95)
{
    return vec4(float((_95.x >> uint(16)) & 65535u), float(_95.x & 65535u), float((_95.y >> uint(16)) & 65535u), float(_95.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _108(SAMPLER_2D _104, vec2 _105, vec2 _106, vec2 _107)
{
    return TEXTURE_GRAD(_104, _105, _106, _107);
}

vec4 _86(uint _85)
{
    return vec4(float((_85 >> uint(24)) & 255u), float((_85 >> uint(16)) & 255u), float((_85 >> uint(8)) & 255u), float(_85 & 255u));
}

vec3 _58(vec3 _57)
{
    float _277 = _57.x;
    vec3 _276;
    _276.x = _55(_277);
    float _283 = _57.y;
    _276.y = _55(_283);
    float _289 = _57.z;
    _276.z = _55(_289);
    return _276;
}

vec4 _61(vec4 _60)
{
    vec3 _299 = _60.xyz;
    vec4 _298 = vec4(_58(_299), 1.0);
    float _307 = _60.w;
    _298.w = _55(_307);
    return _298;
}

float _75(float _74)
{
    return (step(0.0, _74) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _90(uint _89)
{
    return vec3(float((_89 >> uint(21)) & 2047u), float((_89 >> uint(10)) & 2047u), float(_89 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _49(float _46, float _47, float _48)
{
    bool _203 = abs(_48) >= abs(_46);
    bool _211;
    if (_203)
    {
        _211 = abs(_48) >= abs(_47);
    }
    else
    {
        _211 = _203;
    }
    if (_211)
    {
        return uint((_48 < 0.0) ? 5 : 4);
    }
    if (abs(_47) >= abs(_46))
    {
        return uint((_47 < 0.0) ? 3 : 2);
    }
    return uint(int(_46 < 0.0));
}

float _67(float _66)
{
    return exp2(_66);
}

vec3 _111(uint _110)
{
    uint _422 = _110;
    vec4 _421 = _83(_422);
    float _433 = (_421.w * 255.0) - 128.0;
    return _421.xyz * _67(_433);
}

float _72(float _70, float _71)
{
    return pow(_70, _71);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _116(vec3 _114, float _115)
{
    float _445 = 50.0 * dot(_114, vec3(0.33329999446868896484375));
    float _438 = _10(_445);
    float _454 = 1.0 - _115;
    float _457 = _10(_454);
    float _458 = 5.0;
    vec3 _462 = _114 + ((vec3(_438) - _114) * _72(_457, _458));
    return _16(_462);
}

vec3 _124(vec3 _119, vec3 _120, vec3 _121, vec3 _122, float _123)
{
    vec3 _466 = normalize(_120 + _121);
    float _471 = 1.0 - (_123 * 0.800000011920928955078125);
    _471 *= _471;
    _471 *= _471;
    float _482 = _471 * _471;
    float _490 = dot(_119, _466);
    float _486 = _10(_490);
    float _492 = ((_486 * _486) * (_482 - 1.0)) + 1.0;
    _492 = _482 / ((_492 * _492) + 9.9999999392252902907785028219223e-09);
    float _511 = dot(_119, _120);
    float _507 = (_10(_511) * (1.0 - _471)) + _471;
    float _522 = dot(_119, _121);
    float _518 = (_10(_522) * (1.0 - _471)) + _471;
    _492 /= (((4.0 * _507) * _518) + 9.9999999392252902907785028219223e-09);
    vec3 _540 = _122;
    float _542 = dot(_121, _466);
    return _116(_540, _542) * _492;
}

vec2 _149(vec2 _148)
{
    return (vec2(1.0) - abs(_148.yx)) * vec2((_148.x >= 0.0) ? 1.0 : (-1.0), (_148.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _154(inout vec3 _152, bool _153)
{
    _152 /= vec3((abs(_152.x) + abs(_152.y)) + abs(_152.z));
    vec2 _645;
    if (_152.z >= 0.0)
    {
        _645 = _152.xy;
    }
    else
    {
        vec2 _651 = _152.xy;
        _645 = _149(_651);
    }
    _152 = vec3(_645.x, _645.y, _152.z);
    if (_153)
    {
        vec2 _666 = (_152.xy * 0.5) + vec2(0.5);
        _152 = vec3(_666.x, _666.y, _152.z);
    }
    return _152.xy;
}

float _78(float _77)
{
    return sqrt(_77);
}

float _157(float _156)
{
    float _676 = abs(_156);
    float _673 = _78(_676);
    float _680;
    if (_156 > 0.0)
    {
        _680 = _673;
    }
    else
    {
        _680 = -_673;
    }
    return (_680 * 0.5) + 0.5;
}

void main()
{
    _693 _695 = _693(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _695._m15 = _707;
    _695._m16 = gl_FragCoord;
    _695._m14 = _716._m2.xyz + _721.xyz;
    _695._m13 = normalize(-_721.xyz);
    _695._m17 = mat3(vec3(_733.xyz), vec3(_736.xyz), vec3(_739.xyz));
    _695._m34 = _757;
    _695._m35 = _761;
    _695._m36 = _765;
    uint _768 = 0u;
    vec4 _769 = vec4(0.0);
    vec4 _770 = vec4(0.0);
    vec4 _771 = vec4(0.0);
    vec4 _772 = vec4(0.0);
    vec4 _773 = vec4(0.0);
    uvec3 _776 = _778;
    vec3 _780 = _781.xyz;
    bool _787 = _776.y == 65535u;
    bool _793;
    if (_787)
    {
        _793 = _776.z == 65535u;
    }
    else
    {
        _793 = _787;
    }
    bool _784 = _793;
    bool _794 = !_784;
    bool _797 = _776.z != 65535u;
    uint _801 = _776.x & 7u;
    uint _812;
    if (_716._m4.x == 0.0)
    {
        _812 = _801;
    }
    else
    {
        vec4 _820 = _819._m3;
        uvec4 _816 = _32(_820);
        uint _824 = _816[_801 / 2u];
        uint _829 = 16u * (_801 & 1u);
        _812 = (_824 >> _829) & 65535u;
    }
    uint _838 = _812;
    float _840 = SAMPLE_TEXTURE(SAMPLER_2D(_844[_838], _851), _695._m15.zw).x;
    float _870 = pow(_840, 0.125) - 0.800000011920928955078125;
    vec2 _859 = vec2(1.0) / mix(vec2(1.0), vec2(gl_FragmentSizeNV), vec2(_10(_870) / 0.20000000298023223876953125));
    vec2 _878 = dFdx(_695._m15.zw) * _859.x;
    vec2 _886 = dFdy(_695._m15.zw) * _859.y;
    vec2 _894 = TEXTURE_GRAD(SAMPLER_2D(_895[_838], _899), _695._m15.zw, _878, _886).yx;
    vec3 _909 = SAMPLE_TEXTURE(SAMPLER_2D(_910[_838], _914), _695._m15.zw).xyz;
    vec3 _922 = vec3(0.039999999105930328369140625);
    _922 = SAMPLE_TEXTURE(SAMPLER_2D(_925[_838], _929), _695._m15.zw).xyz;
    float _937 = 1.0;
    float _938 = SAMPLE_TEXTURE(SAMPLER_2D(_939[_838], _943), _695._m15.zw).x;
    float _951 = SAMPLE_TEXTURE(SAMPLER_2D(_952[_838], _956), _695._m15.zw).x;
    vec3 _964 = SAMPLE_TEXTURE(SAMPLER_2D(_965[_838], _969), _695._m15.zw).xyz;
    _771 = vec4(_909.x, _909.y, _909.z, _771.w);
    _771.w = _894.y;
    _772 = vec4(_922.x, _922.y, _922.z, _772.w);
    _772.w = _951;
    _773 = vec4(_773.x, _894.x, _773.z, _894.y);
    _769.x = _938;
    _769.y = _937;
    _769.z = _951;
    _769.w = _840;
    _770 = vec4(_964.x, _964.y, _964.z, _770.w);
    vec2 _1002 = _707.zw;
    _1005 _1007;
    _1007._m0 = _771;
    _1007._m1 = _772;
    float _1012 = _769.x;
    _1007._m2.x = _64(_1012);
    _1007._m2 = vec4(_1007._m2.x, _769.yzw.x, _769.yzw.y, _769.yzw.z);
    _1007._m3 = _773;
    _1007._m4 = _770;
    _1005 _1026 = _1007;
    vec3 _1028 = vec3(0.0);
    bool _1036;
    if (_794)
    {
        _1036 = _780.x < 65534.0;
    }
    else
    {
        _1036 = _794;
    }
    bool _1042;
    if (_1036)
    {
        _1042 = _780.x > 0.0;
    }
    else
    {
        _1042 = _1036;
    }
    if (_1042)
    {
        uint _1045 = 0u;
        _1005 _1046 = _1005(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1048 = _776.y & 7u;
        uint _1057;
        if (_716._m4.x == 0.0)
        {
            _1057 = _1048;
        }
        else
        {
            vec4 _1061 = _819._m3;
            uvec4 _1060 = _32(_1061);
            uint _1065 = _1060[_1048 / 2u];
            uint _1070 = 16u * (_1048 & 1u);
            _1057 = (_1065 >> _1070) & 65535u;
        }
        uint _1078 = _1057;
        float _1080 = SAMPLE_TEXTURE(SAMPLER_2D(_844[_1078], _851), _1002).x;
        float _1095 = pow(_1080, 0.125) - 0.800000011920928955078125;
        vec2 _1089 = vec2(1.0) / mix(vec2(1.0), vec2(gl_FragmentSizeNV), vec2(_10(_1095) / 0.20000000298023223876953125));
        vec2 _1102 = dFdx(_1002) * _1089.x;
        vec2 _1108 = dFdy(_1002) * _1089.y;
        vec2 _1114 = TEXTURE_GRAD(SAMPLER_2D(_895[_1078], _899), _1002, _1102, _1108).yx;
        vec3 _1125 = SAMPLE_TEXTURE(SAMPLER_2D(_910[_1078], _914), _1002).xyz;
        vec3 _1134 = vec3(0.039999999105930328369140625);
        _1134 = SAMPLE_TEXTURE(SAMPLER_2D(_925[_1078], _929), _1002).xyz;
        float _1143 = 1.0;
        float _1144 = SAMPLE_TEXTURE(SAMPLER_2D(_939[_1078], _943), _1002).x;
        float _1153 = SAMPLE_TEXTURE(SAMPLER_2D(_952[_1078], _956), _1002).x;
        vec3 _1162 = SAMPLE_TEXTURE(SAMPLER_2D(_965[_1078], _969), _1002).xyz;
        _1046._m0 = vec4(_1125.x, _1125.y, _1125.z, _1046._m0.w);
        _1046._m0.w = _1114.y;
        _1046._m1 = vec4(_1134.x, _1134.y, _1134.z, _1046._m1.w);
        _1046._m1.w = _1153;
        _1046._m3 = vec4(_1046._m3.x, _1114.x, _1046._m3.z, _1114.y);
        _1046._m2.x = _1144;
        _1046._m2.y = _1143;
        _1046._m2.z = _1153;
        _1046._m2.w = _1080;
        _1046._m4 = vec4(_1162.x, _1162.y, _1162.z, _1046._m4.w);
        float _1200 = _1046._m2.x;
        _1046._m2.x = _55(_1200);
        float _1205 = _1046._m1.w;
        float _1208 = _780.x * _1205;
        float _1213 = _1007._m2.x;
        float _1216 = 0.0;
        float _1217 = 0.0;
        float _1218 = (_1208 * 1.5) - 0.5;
        float _1226 = 1.0 - _1213;
        float _1223 = _10(_1226);
        float _1235 = ((_1223 + _1218) - 0.5) * 10.0;
        float _1228 = _10(_1235);
        _1216 = _1228;
        float _1238 = (_780.x * 1.5) - 0.5;
        float _1246 = 1.0 - _1213;
        float _1243 = _10(_1246);
        float _1254 = ((_1243 + _1238) - 0.5) * 10.0;
        float _1248 = _10(_1254);
        _1217 = _1248;
        _1026._m0 = mix(_1026._m0, _1046._m0, vec4(_1216));
        _1026._m1 = mix(_1026._m1, _1046._m1, vec4(_1216));
        _1026._m2 = mix(_1026._m2, _1046._m2, vec4(_1216));
        _1026._m3 = mix(_1026._m3, _1046._m3, vec4(_1216));
        _1026._m4 = mix(_1026._m4, _1046._m4, vec4(_1216));
        _768 = (_1216 > 0.5) ? _1045 : _768;
        _1028.x = _1216;
    }
    bool _1310;
    if (_797)
    {
        _1310 = _780.y < 65534.0;
    }
    else
    {
        _1310 = _797;
    }
    bool _1316;
    if (_1310)
    {
        _1316 = _780.y > 0.0;
    }
    else
    {
        _1316 = _1310;
    }
    if (_1316)
    {
        uint _1319 = 0u;
        _1005 _1320 = _1005(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1321 = _776.z & 7u;
        uint _1330;
        if (_716._m4.x == 0.0)
        {
            _1330 = _1321;
        }
        else
        {
            vec4 _1334 = _819._m3;
            uvec4 _1333 = _32(_1334);
            uint _1338 = _1333[_1321 / 2u];
            uint _1343 = 16u * (_1321 & 1u);
            _1330 = (_1338 >> _1343) & 65535u;
        }
        uint _1351 = _1330;
        float _1353 = SAMPLE_TEXTURE(SAMPLER_2D(_844[_1351], _851), _1002).x;
        float _1368 = pow(_1353, 0.125) - 0.800000011920928955078125;
        vec2 _1362 = vec2(1.0) / mix(vec2(1.0), vec2(gl_FragmentSizeNV), vec2(_10(_1368) / 0.20000000298023223876953125));
        vec2 _1375 = dFdx(_1002) * _1362.x;
        vec2 _1381 = dFdy(_1002) * _1362.y;
        vec2 _1387 = TEXTURE_GRAD(SAMPLER_2D(_895[_1351], _899), _1002, _1375, _1381).yx;
        vec3 _1398 = SAMPLE_TEXTURE(SAMPLER_2D(_910[_1351], _914), _1002).xyz;
        vec3 _1407 = vec3(0.039999999105930328369140625);
        _1407 = SAMPLE_TEXTURE(SAMPLER_2D(_925[_1351], _929), _1002).xyz;
        float _1416 = 1.0;
        float _1417 = SAMPLE_TEXTURE(SAMPLER_2D(_939[_1351], _943), _1002).x;
        float _1426 = SAMPLE_TEXTURE(SAMPLER_2D(_952[_1351], _956), _1002).x;
        vec3 _1435 = SAMPLE_TEXTURE(SAMPLER_2D(_965[_1351], _969), _1002).xyz;
        _1320._m0 = vec4(_1398.x, _1398.y, _1398.z, _1320._m0.w);
        _1320._m0.w = _1387.y;
        _1320._m1 = vec4(_1407.x, _1407.y, _1407.z, _1320._m1.w);
        _1320._m1.w = _1426;
        _1320._m3 = vec4(_1320._m3.x, _1387.x, _1320._m3.z, _1387.y);
        _1320._m2.x = _1417;
        _1320._m2.y = _1416;
        _1320._m2.z = _1426;
        _1320._m2.w = _1353;
        _1320._m4 = vec4(_1435.x, _1435.y, _1435.z, _1320._m4.w);
        float _1473 = _1320._m2.x;
        _1320._m2.x = _55(_1473);
        float _1478 = _1320._m1.w;
        float _1481 = _780.y * _1478;
        float _1486 = _1026._m2.x;
        float _1489 = 0.0;
        float _1490 = 0.0;
        float _1491 = (_1481 * 1.5) - 0.5;
        float _1498 = 1.0 - _1486;
        float _1495 = _10(_1498);
        float _1506 = ((_1495 + _1491) - 0.5) * 10.0;
        float _1500 = _10(_1506);
        _1489 = _1500;
        float _1509 = (_780.y * 1.5) - 0.5;
        float _1517 = 1.0 - _1486;
        float _1514 = _10(_1517);
        float _1525 = ((_1514 + _1509) - 0.5) * 10.0;
        float _1519 = _10(_1525);
        _1490 = _1519;
        _1026._m0 = mix(_1026._m0, _1320._m0, vec4(_1489));
        _1026._m1 = mix(_1026._m1, _1320._m1, vec4(_1489));
        _1026._m2 = mix(_1026._m2, _1320._m2, vec4(_1489));
        _1026._m3 = mix(_1026._m3, _1320._m3, vec4(_1489));
        _1026._m4 = mix(_1026._m4, _1320._m4, vec4(_1489));
        _768 = (_1489 > 0.5) ? _1319 : _768;
        _1028.y = _1489;
    }
    bool _1581;
    if (_794)
    {
        _1581 = _780.z > 0.0;
    }
    else
    {
        _1581 = _794;
    }
    if (_1581)
    {
        float _1584 = _780.z;
        float _1591 = 1.0 - _1026._m2.x;
        float _1587 = _10(_1591);
        float _1600 = ((_1587 - 0.5) * _1584) + _1584;
        float _1593 = _10(_1600);
        _1028.z = _1593;
        vec3 _1604 = _1026._m0.xyz * _1026._m0.xyz;
        float _1612 = 1.0 - _1026._m2.w;
        float _1624 = (_1593 - 0.0) / 0.3499999940395355224609375;
        vec3 _1629 = mix(_1026._m0.xyz, _1604, vec3(_10(_1624) * _1612));
        _1026._m0 = vec4(_1629.x, _1629.y, _1629.z, _1026._m0.w);
        float _1640 = (_1593 - 0.25) / 0.25;
        vec3 _1643 = mix(_1026._m1.xyz, vec3(0.039999999105930328369140625), vec3(_10(_1640)));
        _1026._m1 = vec4(_1643.x, _1643.y, _1643.z, _1026._m1.w);
        vec3 _1647 = vec3(_695._m17[0].z, _695._m17[1].z, _695._m17[2].z);
        float _1661 = _1647.z + 0.0625;
        float _1655 = _1593 * _10(_1661);
        float _1670 = (_1655 - 0.20000000298023223876953125) / 0.800000011920928955078125;
        _1026._m2.w = mix(_1026._m2.w, 0.89999997615814208984375, _10(_1670));
        float _1683 = (_1655 - 0.449999988079071044921875) / 0.5299999713897705078125;
        vec3 _1686 = mix(_1026._m3.wyz, vec3(0.5, 0.5, 1.0), vec3(_10(_1683)));
        _1026._m3 = vec4(_1026._m3.x, _1686.y, _1686.z, _1686.x);
        if (_1655 > 0.980000019073486328125)
        {
            float _1700 = (_1655 - 0.980000019073486328125) / 0.0199999995529651641845703125;
            _1647 = normalize(mix(_1647, vec3(0.0, 0.0, 1.0), vec3(_10(_1700))));
            _695._m17[0].z = _1647.x;
            _695._m17[1].z = _1647.y;
            _695._m17[2].z = _1647.z;
        }
    }
    _771 = _1026._m0;
    _772 = _1026._m1;
    vec3 _1719;
    if (_794)
    {
        _1719 = vec3(0.0);
    }
    else
    {
        _1719 = _769.xyz;
    }
    _769 = vec4(_1719.x, _1719.y, _1719.z, _769.w);
    _769.w = _1026._m2.w;
    _773 = _1026._m3;
    _770 = _1026._m4;
    _695._m10 = vec3(_769.x) * _780;
    _695._m10 *= vec3(_716._m5.x);
    _695._m0 = _771.xyz;
    _695._m2 = _772.xyz;
    _695._m1 = _770.xyz;
    _695._m9 = _769.xyz;
    _695._m3 = _769.w;
    _695._m6 = _773.wyz;
    uint _1768 = uint((_1771._m17.x > 0.0) ? 8 : 0);
    float _1777 = 16.0;
    float _1779 = 8.0;
    float _1781 = 24.0;
    vec2 _1790 = _695._m16.xy * _716._m6.xy;
    vec3 _1783;
    _1783 = vec3(_1790.x, _1790.y, _1783.z);
    _1783.y = 1.0 - _1783.y;
    
     // FIX FOR DECALS CLIPPING
    //clusterCoordinate.x -= vk3d_params[VIEW].stereo.x * 0.5;
   _1783.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec2 _1803 = floor(_1783.xy * vec2(_1777, _1779));
    _1783 = vec3(_1803.x, _1803.y, _1783.z);
    float _1808 = _695._m16.z;
    vec4 _1811 = _716._m7;
    float _1814 = 1.0;
    bool _1815 = false;
    float _1806 = _133(_1808, _1811, _1814, _1815);
    float _1817 = log2(max(1.0, _1806 / _716._m8.z)) * _716._m8.w;
    _1783.z = min(_1781 - 1.0, floor(_1817));
    uint _1833 = uint((_1783.x + (_1783.y * _1777)) + ((_1783.z * _1777) * _1779));
    bool _1849 = true;
    vec3 _1851 = _695._m6;
    bool _1854 = _1849;
    _695._m7 = _138(_1851, _1854);
    vec3 _1858 = _695._m7;
    mat3 _1861 = _695._m17;
    _695._m6 = _145(_1858, _1861);
    uint _1866 = 0u;
    uint _1867 = 0u;
    uint _1868 = 0u;
    uint _1869 = 0u;
    uint _1870 = 0u;
    uint _1871 = 0u;
    int _1873 = 256;
    _1875 _1877;
    _1877._m0 = _1882._m0[_1833]._m0;
    _1877._m1 = _1882._m0[_1833]._m1;
    int _1891 = _1877._m0 & (~(_1877._m0 >> 31));
    int _1900 = _1877._m1 & (~(_1877._m1 >> 31));
    _1866 = uint((_1891 >> 16) * _1873);
    _1867 = _1866 + uint(_1900 & 255);
    _1868 = _1866;
    _1869 = _1868 + uint((_1900 >> 8) & 255);
    _1870 = _1866;
    _1871 = _1870 + uint((_1900 >> 16) & 255);
    vec3 _1933 = dFdx(_695._m14);
    vec3 _1937 = dFdy(_695._m14);
    bool _1942 = _1768 == 0u;
    bool _1948;
    if (_1942)
    {
        _1948 = _1771._m17.y == 0.0;
    }
    else
    {
        _1948 = _1942;
    }
    _1868 = _1948 ? _1869 : _1868;
    uint _1952 = _1868;
    _1989 _1991;
    vec3 _2344;
    float _2477;
    while (_1952 < _1869)
    {
        uint _1962 = _1966._m0[_1952];
        uint _1971 = (_1962 >> uint(12)) & 4095u;
        uint _1977 = _1971;
        if (_1977 >= _1971)
        {
            _1952++;
        }
        int _1986 = 2;
        int _1987 = 2;
        int _1988 = 2;
        _1991._m0 = _1996._m0[(uint(_1986) * _1977) + 0u];
        _1991._m1 = _1996._m0[(uint(_1986) * _1977) + 1u];
        _1991._m2 = _2016._m0[(uint(_1987) * _1977) + 0u];
        float _2030 = _2016._m0[(uint(_1987) * _1977) + 1u].x;
        _1991._m3.x = _27(_2030);
        float _2040 = _2016._m0[(uint(_1987) * _1977) + 1u].y;
        _1991._m3.y = _27(_2040);
        float _2050 = _2016._m0[(uint(_1987) * _1977) + 1u].z;
        _1991._m4.x = _27(_2050);
        float _2060 = _2016._m0[(uint(_1987) * _1977) + 1u].w;
        _1991._m4.y = _27(_2060);
        float _2074 = _2068._m0[(uint(_1988) * _1977) + 0u].x;
        _1991._m5.x = _27(_2074);
        float _2084 = _2068._m0[(uint(_1988) * _1977) + 0u].y;
        _1991._m5.y = _27(_2084);
        float _2094 = _2068._m0[(uint(_1988) * _1977) + 0u].z;
        _1991._m6 = _27(_2094);
        float _2104 = _2068._m0[(uint(_1988) * _1977) + 0u].w;
        _1991._m7 = _27(_2104);
        float _2114 = _2068._m0[(uint(_1988) * _1977) + 1u].x;
        _1991._m8 = _27(_2114);
        float _2124 = _2068._m0[(uint(_1988) * _1977) + 1u].y;
        _1991._m9 = _27(_2124);
        float _2134 = _2068._m0[(uint(_1988) * _1977) + 1u].z;
        _1991._m10 = _27(_2134);
        float _2145 = _2068._m0[(uint(_1988) * _1977) + 1u].w;
        _1991._m11 = _27(_2145);
        vec4 _2150 = _1991._m0;
        vec4 _2153 = _1991._m2;
        vec4 _2156 = _1991._m1;
        vec4 _2159 = vec4(_695._m14, 1.0);
        vec3 _2166 = vec3(dot(_2159, _2150), dot(_2159, _2156), dot(_2159, _2153));
        float _2177 = 0.0039215688593685626983642578125;
        float _2179 = _2166.x;
        float _2182 = _2166.y;
        float _2185 = _2166.z;
        bool _2190 = _43(_2179, _2182, _2185) <= _2177;
        bool _2207;
        if (!_2190)
        {
            float _2194 = _2166.x;
            float _2197 = _2166.y;
            float _2200 = _2166.z;
            _2207 = _38(_2194, _2197, _2200) >= (1.0 - _2177);
        }
        else
        {
            _2207 = _2190;
        }
        if (_2207)
        {
            continue;
        }
        uint _2211 = _1991._m11;
        bool _2215 = _1768 != 0u;
        bool _2222;
        if (_2215)
        {
            _2222 = (_2211 & 512u) != 0u;
        }
        else
        {
            _2222 = _2215;
        }
        bool _2235;
        if (!_2222)
        {
            bool _2227 = _1768 == 0u;
            bool _2234;
            if (_2227)
            {
                _2234 = (_2211 & 1024u) != 0u;
            }
            else
            {
                _2234 = _2227;
            }
            _2235 = _2234;
        }
        else
        {
            _2235 = _2222;
        }
        if (_2235)
        {
            continue;
        }
        vec2 _2239 = vec2(dot(_1933, _2150.xyz), dot(_1933, _2156.xyz));
        vec2 _2249 = vec2(dot(_1937, _2150.xyz), dot(_1937, _2156.xyz));
        float _2259 = 1.0;
        float _2260 = 1.0;
        vec3 _2261 = vec3(0.5, 0.5, 1.0);
        vec3 _2262 = vec3(0.0, 0.0, 1.0);
        uint _2263 = _1991._m7;
        uint _2267 = _1991._m9;
        vec4 _2266 = _83(_2267);
        uvec2 _2272 = _1991._m5;
        vec4 _2271 = _96(_2272);
        vec2 _2276 = _2239 * _2271.xy;
        vec2 _2281 = _2249 * _2271.xy;
        vec2 _2296 = (_2166.xy * _2271.xy) + _2271.zw;
        vec2 _2297 = _2276;
        vec2 _2299 = _2281;
        vec4 _2286 = _108(_2287, _2296, _2297, _2299);
        vec2 _2302 = (_2286.xy * 2.0) - vec2(1.0);
        float _2312 = 1.0 - dot(_2302, _2302);
        _2261 = vec3(_2302, sqrt(_10(_2312)));
        _2262 = _2261;
        _2259 = _2286.z;
        float _2321 = _2286.w;
        _2260 = _55(_2321);
        bool _2328 = _2260 <= (4.0 * _2177);
        bool _2335;
        if (_2328)
        {
            _2335 = _2266.w <= _2177;
        }
        else
        {
            _2335 = _2328;
        }
        if (_2335)
        {
            continue;
        }
        _2261 = _2262;
        if ((_2211 & 128u) != 0u)
        {
            _2344 = vec3(-_2261.x, -_2261.y, _2261.z);
        }
        else
        {
            _2344 = _2261;
        }
        _2261 = _2344;
        uint _2359 = _1991._m8;
        uint _2363 = _2359;
        float _2362 = 1.0 + (_86(_2363).w * 0.062745101749897003173828125);
        uint _2371 = _2263;
        float _2370 = _83(_2371).z;
        uint _2376 = _2359;
        vec3 _2375 = _83(_2376).xyz;
        float _2389 = _2362 - (_2362 * abs((_2166.z * 2.0) - 1.0));
        _2260 *= _10(_2389);
        float _2393 = _2260;
        if ((_2263 & 1u) != 0u)
        {
            vec3 _2400 = _2375;
            _2375 = vec3(0.0);
            uvec2 _2403 = _1991._m3;
            vec4 _2402 = _96(_2403);
            vec2 _2407 = _2239 * _2402.xy;
            vec2 _2412 = _2249 * _2402.xy;
            vec2 _2426 = (_2166.xy * _2402.xy) + _2402.zw;
            vec2 _2427 = _2407;
            vec2 _2429 = _2412;
            vec4 _2417 = _108(_2287, _2426, _2427, _2429);
            vec4 _2432 = _2417;
            _2417 = _61(_2432);
            _2375 = _2417.xyz;
            float _2444 = (_2417.w - _2177) / (1.0 - _2177);
            _2393 = _10(_2444);
            _2375 *= _2400;
        }
        vec3 _2449 = normalize(vec3(_695._m17[0].z, _695._m17[1].z, _695._m17[2].z));
        float _2458 = dot(_2449, normalize(_2153.xyz));
        float _2464 = _2458;
        vec2 _2469 = _2261.xy * _75(_2464);
        _2261 = vec3(_2469.x, _2469.y, _2261.z);
        if ((_2211 & 16384u) != 0u)
        {
            float _2482 = abs(_2458);
            _2477 = _10(_2482);
        }
        else
        {
            float _2485 = _2458;
            _2477 = _10(_2485);
        }
        float _2472 = _2477;
        float _2489 = ((_2472 * _2393) * _2266.w) * _2370;
        _695._m10 += (_2266.xyz * (_2489 * 64.0));
        uint _2508 = _1991._m10;
        uint _2512 = _2508;
        vec4 _2511 = _83(_2512);
        if ((_2263 & 2u) != 0u)
        {
            uvec2 _2521 = _1991._m4;
            vec4 _2520 = _96(_2521);
            vec2 _2525 = _2239 * _2520.xy;
            vec2 _2530 = _2249 * _2520.xy;
            vec2 _2543 = (_2166.xy * _2520.xy) + _2520.zw;
            vec2 _2544 = _2525;
            vec2 _2546 = _2530;
            _2511 = _108(_2287, _2543, _2544, _2546);
            _2511 *= _2511;
        }
        if ((_2263 & 32u) != 0u)
        {
            uint _2559 = _2263;
            float _2558 = _83(_2559).x;
            uint _2564 = _2263;
            float _2563 = _86(_2564).y;
            float _2570 = _2558;
            float _2568 = mix(_2563, 0.0, _10(_2570));
            float _2579 = _2259 - (_2568 / 255.0);
            float _2574 = float(_10(_2579) > 0.0);
            _2260 *= _2574;
        }
        float _2586 = _2260 * _2472;
        uint _2590 = _1991._m6;
        uint _2594 = _2590;
        vec4 _2599 = _83(_2594) * _2586;
        vec4 _2593 = _22(_2599);
        _695._m11 = max(_695._m11, _2593.x);
        _695._m0 = mix(_695._m0, _2375, _2593.xxx);
        _695._m2 = mix(_695._m2, _2511.xyz, _2593.yyy);
        vec3 _2622 = _2449;
        vec3 _2632 = _2150.xyz + (_2622 * dot(_2150.xyz, _2622));
        _2150 = vec4(_2632.x, _2632.y, _2632.z, _2150.w);
        vec3 _2643 = _2156.xyz + (_2622 * dot(_2156.xyz, _2622));
        _2156 = vec4(_2643.x, _2643.y, _2643.z, _2156.w);
        _2261 = ((normalize(_2150.xyz) * _2261.x) + (normalize(_2156.xyz) * _2261.y)) + (_2622 * _2261.z);
        if ((_2211 & 256u) != 0u)
        {
            vec3 _2670 = mix(_2449, _2261, _2593.www);
            float _2676 = dot(_2670, _2449);
            _2261 = (_695._m6 * _2676) + ((_2670 - (_2449 * _2676)) * dot(_695._m6, _2449));
        }
        else
        {
            if ((_2211 & 64u) != 0u)
            {
                _2261 = mix(mix(_695._m6, _2449, vec3(_2586)), _2261, _2593.www);
            }
            else
            {
                _2261 = mix(_695._m6, _2261, _2593.www);
            }
        }
        _695._m6 = normalize(_2261);
        _695._m3 = mix(_695._m3, _2511.w, _2593.z);
    }
    vec3 _2730 = vec3(0.0);
    vec3 _2731 = vec3(_695._m34.x, _695._m34.y, _695._m34.z);
    vec3 _2739 = vec3(_695._m34.w, _695._m35.x, _695._m35.y);
    vec3 _2747 = vec3(_695._m35.z, _695._m35.w, _695._m36.x);
    vec3 _2755 = vec3(_695._m36.y, _695._m36.z, _695._m36.w);
    vec3 _2763 = ((_2731 - (_2739 * _695._m6.y)) + (_2747 * _695._m6.z)) - (_2755 * _695._m6.x);
    float _2787 = _1771._m18.x * _716._m9.x;
    _2730 += max(_2763 * _10(_2787), vec3(0.0));
    float _2798;
    if (dot(_695._m10, vec3(1.0)) > 0.0)
    {
        _2798 = -_695._m3;
    }
    else
    {
        _2798 = _695._m3;
    }
    _695._m3 = _2798;
    _695._m18 = _2730;
    _695._m19 = _2730;
    uint _2814 = _1866;
    _2843 _2845;
    vec3 _3142;
    float _3231;
    float _3249;
    _3618 _3620;
    uint _3741;
    _3618 _3763;
    while (_2814 < _1867)
    {
        uint _2824 = _1966._m0[_2814];
        uint _2828 = _2824 & 4095u;
        uint _2831 = _2828;
        if (_2831 >= _2828)
        {
            _2814++;
        }
        int _2840 = 4;
        int _2841 = 4;
        int _2842 = 3;
        _2845._m0 = _2849._m0[(uint(_2840) * _2831) + 0u].xyz;
        float _2864 = _2849._m0[(uint(_2840) * _2831) + 0u].w;
        _2845._m1 = _27(_2864);
        _2845._m2 = _2849._m0[(uint(_2840) * _2831) + 1u];
        _2845._m3 = _2849._m0[(uint(_2840) * _2831) + 2u];
        _2845._m4 = _2888._m0[(uint(_2841) * _2831) + 0u];
        _2845._m5 = _2888._m0[(uint(_2841) * _2831) + 1u];
        _2845._m6 = _2888._m0[(uint(_2841) * _2831) + 2u];
        float _2918 = _2849._m0[(uint(_2840) * _2831) + 3u].x;
        _2845._m7.x = _27(_2918);
        float _2928 = _2849._m0[(uint(_2840) * _2831) + 3u].y;
        _2845._m7.y = _27(_2928);
        float _2938 = _2849._m0[(uint(_2840) * _2831) + 3u].z;
        _2845._m7.z = _27(_2938);
        float _2948 = _2849._m0[(uint(_2840) * _2831) + 3u].w;
        _2845._m7.w = _27(_2948);
        _2845._m8 = _2957._m0[(uint(_2842) * _2831) + 0u];
        _2845._m9 = _2957._m0[(uint(_2842) * _2831) + 1u];
        _2845._m10 = _2957._m0[(uint(_2842) * _2831) + 2u];
        float _2987 = _2888._m0[(uint(_2841) * _2831) + 3u].x;
        _2845._m11 = _27(_2987);
        float _2997 = _2888._m0[(uint(_2841) * _2831) + 3u].y;
        _2845._m12 = _27(_2997);
        _2845._m13 = _2888._m0[(uint(_2841) * _2831) + 3u].z;
        float _3015 = _2888._m0[(uint(_2841) * _2831) + 3u].w;
        _2845._m14 = _27(_3015);
        float _3020 = 0.0039215688593685626983642578125;
        vec4 _3021 = vec4(_695._m14, 1.0);
        float _3028 = 1.0 / dot(_3021, _2845._m6);
        vec3 _3034 = vec3(dot(_3021, _2845._m4) * _3028, dot(_3021, _2845._m5) * _3028, dot(_3021, _2845._m3));
        uint _3052 = _2845._m1;
        uint _3055 = _1768;
        _3055 |= 64u;
        float _3059 = _3034.x;
        float _3062 = _3034.y;
        float _3065 = _3034.z;
        bool _3070 = _43(_3059, _3062, _3065) <= _3020;
        bool _3087;
        if (!_3070)
        {
            float _3074 = _3034.x;
            float _3077 = _3034.y;
            float _3080 = _3034.z;
            _3087 = _38(_3074, _3077, _3080) >= (1.0 - _3020);
        }
        else
        {
            _3087 = _3070;
        }
        bool _3095;
        if (!_3087)
        {
            _3095 = (_3052 & _3055) != 0u;
        }
        else
        {
            _3095 = _3087;
        }
        if (_3095)
        {
            continue;
        }
        if ((_3052 & 3u) == 2u)
        {
            vec2 _3114 = fract((_3034.xy * _716._m10.xy) + _716._m10.zw);
            _3034 = vec3(_3114.x, _3114.y, _3034.z);
        }
        vec3 _3117 = _2845._m0;
        float _3120 = 1.0;
        float _3121 = 1.0;
        vec3 _3122 = vec3(0.0, 0.0, 1.0);
        vec3 _3123 = vec3(0.0, 0.0, 1.0);
        uint _3124 = _2845._m1;
        vec3 _3127 = (_3034 * 2.0) - vec3(1.0);
        vec2 _3132 = _3034.xy;
        vec3 _3135 = _2845._m10.xyz;
        if ((_3124 & 3u) == 2u)
        {
            _3142 = _3135;
        }
        else
        {
            _3142 = normalize(_3117 - _695._m14);
        }
        _3122 = _3142;
        _3122 = _3122;
        float _3159 = dot(_695._m6, _3122);
        float _3154 = _10(_3159);
        bool _3163 = _3154 <= _3020;
        bool _3170;
        if (_3163)
        {
            _3170 = (_3124 & 48u) == 0u;
        }
        else
        {
            _3170 = _3163;
        }
        if (_3170)
        {
            continue;
        }
        uvec2 _3175 = _2845._m7.zw;
        vec4 _3174 = _96(_3175);
        float _3180 = TEXTURE_LOD(_3181, vec4((_3132 * _3174.xy) + _3174.zw, 0.0, 0.0).xy, vec4((_3132 * _3174.xy) + _3174.zw, 0.0, 0.0).w).x;
        float _3207 = _3180 * _3180;
        uint _3211 = _3124 & 3u;
        bool _3216 = _3211 == 1u;
        bool _3228;
        if (!_3216)
        {
            bool _3221 = _3211 == 0u;
            bool _3227;
            if (_3221)
            {
                _3227 = _2845._m8.z != 0.0;
            }
            else
            {
                _3227 = _3221;
            }
            _3228 = _3227;
        }
        else
        {
            _3228 = _3216;
        }
        bool _3214 = _3228;
        if (_3214)
        {
            float _3234 = _2845._m8.w;
            _3231 = _10(_3234);
        }
        else
        {
            _3231 = 0.5;
        }
        float _3229 = _3231;
        bool _3242 = _3211 == 0u;
        bool _3248;
        if (_3242)
        {
            _3248 = _2845._m8.z != 0.0;
        }
        else
        {
            _3248 = _3242;
        }
        if (_3248)
        {
            float _3257 = sqrt(dot(_3127, _3127));
            _3249 = min(0.9921875, _10(_3257));
        }
        else
        {
            _3249 = _3034.z;
        }
        float _3240 = _3249;
        uvec2 _3265 = _2845._m7.xy;
        vec4 _3264 = _96(_3265);
        vec2 _3270 = vec2(_3240, _3229);
        float _3274 = TEXTURE_LOD(_3181, vec4((_3270 * _3264.xy) + _3264.zw, 0.0, 0.0).xy, vec4((_3270 * _3264.xy) + _3264.zw, 0.0, 0.0).w).x;
        _3274 *= _3274;
        _3120 = _3274 * _3207;
        if ((_3124 & 48u) != 0u)
        {
            vec4 _3311 = _2845._m10;
            vec4 _3314 = _2845._m8;
            vec4 _3317 = _2845._m9;
            float _3320 = dot(_695._m14, _3311.xyz) + _3311.w;
            if (_3320 < 0.0)
            {
                continue;
            }
            float _3334 = length(_3311.xyz);
            float _3341 = _3320 * 50.0;
            float _3338 = _10(_3341);
            _3120 *= (_3338 * _3338);
            _3320 /= _3334;
            _3311 /= vec4(_3334);
            vec3 _3355 = reflect(-_695._m13, _695._m6);
            if (dot(_3355, _3311.xyz) > 0.0)
            {
                _3355 = reflect(_3355, _3311.xyz);
            }
            float _3373 = dot(_3355, _3311.xyz);
            float _3378 = _3320 / _3373;
            vec3 _3382 = _695._m14 - (_3355 * _3378);
            vec3 _3389 = _3382 - _3117;
            float _3393 = dot(_3389, _3314.xyz) / _3314.w;
            float _3401 = dot(_3389, _3317.xyz) / _3317.w;
            if ((_3124 & 48u) == 32u)
            {
                vec2 _3414 = vec2(_3393, _3401);
                float _3418 = 1.0 / max(1.0, length(vec2(_3393, _3401)));
                _3393 *= (_3418 * _3314.w);
                _3401 *= (_3418 * _3317.w);
            }
            else
            {
                float _3440 = abs(_3393);
                float _3442 = _3393;
                _3393 = (_10(_3440) * _75(_3442)) * _3314.w;
                float _3451 = abs(_3401);
                float _3453 = _3401;
                _3401 = (_10(_3451) * _75(_3453)) * _3317.w;
            }
            vec3 _3460 = (_3314.xyz * _3393) + (_3317.xyz * _3401);
            _3117 += _3460;
            _3122 = normalize(_3117 - _695._m14);
            _3122 = _3122;
        }
        else
        {
            uint _3480 = (_2845._m14 >> uint(16)) & 255u;
            if (_3480 == 0u)
            {
                vec4 _3489 = _2845._m9;
                if (dot(_3489.xyz, _695._m14) < (_3489.w - _3020))
                {
                    continue;
                }
            }
            else
            {
                if (_3480 == 1u)
                {
                    vec3 _3510 = _2845._m9.xyz;
                    float _3515 = _2845._m9.w;
                    uint _3519 = _27(_3515);
                    vec3 _3514 = (((_90(_3519) * 2.0) - vec3(1.0)) * _3510) + _3117;
                    vec3 _3528 = abs((_695._m14 - _3514) / _3510);
                    float _3536 = _3528.x;
                    float _3539 = _3528.y;
                    float _3542 = _3528.z;
                    if (_38(_3536, _3539, _3542) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_3120 <= (_3020 / 256.0))
        {
            continue;
        }
        float _3558 = 1.0;
        if ((_3052 & 4u) != 0u)
        {
            float _3565 = float(_2845._m14 & 255u) / 255.0;
            float _3571 = 0.00999999977648258209228515625;
            vec3 _3573 = _695._m14 + (_695._m6 * _3571);
            uint _3581 = 0u;
            if ((_3052 & 3u) == 0u)
            {
                vec3 _3587 = _3573 - _2845._m2.xyz;
                float _3593 = _3587.x;
                float _3596 = _3587.y;
                float _3599 = _3587.z;
                _3581 = _49(_3593, _3596, _3599);
            }
            else
            {
                if ((_3052 & 3u) == 2u)
                {
                    float _3609 = 0.0;
                    for (; _3581 < 3u; _3581++)
                    {
                        int _3617 = 5;
                        _3620._m0 = _3624._m0[(uint(_3617) * ((_3052 >> uint(22)) + _3581)) + 0u];
                        _3620._m1 = _3624._m0[(uint(_3617) * ((_3052 >> uint(22)) + _3581)) + 1u];
                        _3620._m2 = _3624._m0[(uint(_3617) * ((_3052 >> uint(22)) + _3581)) + 2u];
                        _3620._m3 = _3624._m0[(uint(_3617) * ((_3052 >> uint(22)) + _3581)) + 3u];
                        _3620._m4 = _3624._m0[(uint(_3617) * ((_3052 >> uint(22)) + _3581)) + 4u];
                        vec2 _3681 = vec2(dot(_3573, _3620._m0.xyz) + _3620._m0.w, dot(_3573, _3620._m1.xyz) + _3620._m1.w);
                        _3681 = abs((_3681 * 2.0) - vec2(1.0));
                        bool _3706 = _3681.x < 1.0;
                        bool _3712;
                        if (_3706)
                        {
                            _3712 = _3681.y < 1.0;
                        }
                        else
                        {
                            _3712 = _3706;
                        }
                        if (_3712)
                        {
                            _3609 = (1.0 - max(_3681.x, _3681.y)) * _716._m11.w;
                            break;
                        }
                    }
                    _3581 = min(2u, _3581);
                    uint _3729 = uint(_695._m16.x) ^ (uint(_695._m16.y) << uint(1));
                    if (_716._m12.w > 0.0)
                    {
                        _3741 = uint(_716._m13.x);
                    }
                    else
                    {
                        _3741 = 0u;
                    }
                    _3729 ^= _3741;
                    _3581 += uint(int(((float(_3729 & 3u) * 0.25) + 0.125) > _3609));
                }
            }
            int _3762 = 5;
            _3763._m0 = _3624._m0[(uint(_3762) * ((_3052 >> uint(22)) + _3581)) + 0u];
            _3763._m1 = _3624._m0[(uint(_3762) * ((_3052 >> uint(22)) + _3581)) + 1u];
            _3763._m2 = _3624._m0[(uint(_3762) * ((_3052 >> uint(22)) + _3581)) + 2u];
            _3763._m3 = _3624._m0[(uint(_3762) * ((_3052 >> uint(22)) + _3581)) + 3u];
            _3763._m4 = _3624._m0[(uint(_3762) * ((_3052 >> uint(22)) + _3581)) + 4u];
            vec4 _3819 = vec4((_3573.x * _3763._m0.x) + ((_3573.y * _3763._m0.y) + ((_3573.z * _3763._m0.z) + _3763._m0.w)), (_3573.x * _3763._m1.x) + ((_3573.y * _3763._m1.y) + ((_3573.z * _3763._m1.z) + _3763._m1.w)), (_3573.x * _3763._m2.x) + ((_3573.y * _3763._m2.y) + ((_3573.z * _3763._m2.z) + _3763._m2.w)), (_3573.x * _3763._m3.x) + ((_3573.y * _3763._m3.y) + ((_3573.z * _3763._m3.z) + _3763._m3.w)));
            vec3 _3906 = _3819.xyz / vec3(_3819.w);
            _3819 = vec4(_3906.x, _3906.y, _3906.z, _3819.w);
            bool _3914 = min(_3819.x, _3819.y) > 0.0;
            bool _3923;
            if (_3914)
            {
                _3923 = max(_3819.x, _3819.y) < 1.0;
            }
            else
            {
                _3923 = _3914;
            }
            if (_3923)
            {
                vec2 _3935 = (_3819.xy * _3763._m4.xy) + _3763._m4.zw;
                _3819 = vec4(_3935.x, _3935.y, _3819.z, _3819.w);
                if (false)
                {
                    _3558 = textureLod(_3943, vec3(_3819.xyz.xy, _3819.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3950 = (_3819.xy * _716._m14.xy) + vec2(0.5);
                    vec2 _3959 = floor(_3950);
                    vec2 _3962 = _3950 - _3959;
                    _3959 -= vec2(0.5);
                    vec2 _3969 = vec2(4.0) - (_3962 * 3.0);
                    vec2 _3975 = vec2(7.0);
                    vec2 _3978 = vec2(1.0) + (_3962 * 3.0);
                    vec2 _3983 = (_3959 + (((vec2(3.0) - (_3962 * 2.0)) / _3969) - vec2(2.0))) * _716._m14.zw;
                    vec2 _3998 = (_3959 + ((vec2(3.0) + _3962) / _3975)) * _716._m14.zw;
                    vec2 _4010 = (_3959 + ((_3962 / _3978) + vec2(2.0))) * _716._m14.zw;
                    vec3 _4034 = vec3(_3983.x, _3983.y, _3819.z);
                    _3558 = (_3969.x * _3969.y) * textureLod(_3943, vec3(_4034.xy, _4034.z), 0.0);
                    vec3 _4050 = vec3(_3998.x, _3983.y, _3819.z);
                    _3558 += ((_3975.x * _3969.y) * textureLod(_3943, vec3(_4050.xy, _4050.z), 0.0));
                    vec3 _4068 = vec3(_4010.x, _3983.y, _3819.z);
                    _3558 += ((_3978.x * _3969.y) * textureLod(_3943, vec3(_4068.xy, _4068.z), 0.0));
                    vec3 _4086 = vec3(_3983.x, _3998.y, _3819.z);
                    _3558 += ((_3969.x * _3975.y) * textureLod(_3943, vec3(_4086.xy, _4086.z), 0.0));
                    vec3 _4104 = vec3(_3998.x, _3998.y, _3819.z);
                    _3558 += ((_3975.x * _3975.y) * textureLod(_3943, vec3(_4104.xy, _4104.z), 0.0));
                    vec3 _4122 = vec3(_4010.x, _3998.y, _3819.z);
                    _3558 += ((_3978.x * _3975.y) * textureLod(_3943, vec3(_4122.xy, _4122.z), 0.0));
                    vec3 _4140 = vec3(_3983.x, _4010.y, _3819.z);
                    _3558 += ((_3969.x * _3978.y) * textureLod(_3943, vec3(_4140.xy, _4140.z), 0.0));
                    vec3 _4158 = vec3(_3998.x, _4010.y, _3819.z);
                    _3558 += ((_3975.x * _3978.y) * textureLod(_3943, vec3(_4158.xy, _4158.z), 0.0));
                    vec3 _4176 = vec3(_4010.x, _4010.y, _3819.z);
                    _3558 += ((_3978.x * _3978.y) * textureLod(_3943, vec3(_4176.xy, _4176.z), 0.0));
                    _3558 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3558 = float((_3052 & 3u) == 2u);
            }
            float _4190 = float((_3052 >> uint(16)) & 63u) / 63.0;
            float _4204 = ((_3558 * _4190) + 1.0) - _4190;
            _3558 = _10(_4204);
        }
        uint _4207 = _2845._m12;
        vec3 _4206 = (_111(_4207) * _3558) * _3120;
        _3121 *= _2845._m13;
        vec3 _4219 = _4206;
        vec3 _4221 = _3122;
        float _4228 = dot(_695._m6, _4221);
        float _4223 = _10(_4228);
        vec3 _4234 = _695._m6;
        vec3 _4237 = _695._m13;
        vec3 _4240 = _3122;
        vec3 _4242 = _695._m2;
        float _4245 = abs(_695._m3);
        vec3 _4230 = _124(_4234, _4237, _4240, _4242, _4245);
        _695._m20 += (((_4230 * _3121) * _4219) * _4223);
        vec3 _4259 = mix(_4219, vec3(0.0), bvec3((_3052 & 256u) > 0u));
        _695._m19 += (_4259 * _4223);
    }
    _695._m19 = _695._m19;
    _695._m20 += _695._m10;
    float _4283 = 0.064999997615814208984375;
    float _4285 = 1.0 + _4283;
    bool _4288 = false;
    uint _4293;
    if (_716._m15.w > 0.00999999977648258209228515625)
    {
        _4293 = uint(_716._m15.x);
    }
    else
    {
        _4293 = 0u;
    }
    uint _4289 = _4293;
    _4311 _4313;
    for (uint _4301 = 0u; _4301 < _4289; _4301++)
    {
        int _4310 = 4;
        _4313._m0 = _4317._m0[(uint(_4310) * _4301) + 0u];
        _4313._m1 = _4317._m0[(uint(_4310) * _4301) + 1u];
        _4313._m2 = _4317._m0[(uint(_4310) * _4301) + 2u];
        float _4347 = _4317._m0[(uint(_4310) * _4301) + 3u].x;
        _4313._m3 = _27(_4347);
        float _4357 = _4317._m0[(uint(_4310) * _4301) + 3u].y;
        _4313._m4 = _27(_4357);
        float _4367 = _4317._m0[(uint(_4310) * _4301) + 3u].z;
        _4313._m5 = _27(_4367);
        vec4 _4372 = vec4(_695._m14, 1.0);
        vec3 _4379 = vec3(dot(_4372, _4313._m1), dot(_4372, _4313._m2), dot(_4372, _4313._m0));
        float _4393 = _4379.x;
        float _4396 = _4379.y;
        float _4399 = _4379.z;
        bool _4403 = _43(_4393, _4396, _4399) >= 0.0;
        bool _4412;
        if (_4403)
        {
            _4412 = max(_4379.x, _4379.y) < 1.0;
        }
        else
        {
            _4412 = _4403;
        }
        bool _4419;
        if (_4412)
        {
            _4419 = _4379.z < _4285;
        }
        else
        {
            _4419 = _4412;
        }
        if (_4419)
        {
            float _4422 = _4379.z;
            vec4 _4425 = vec4(_695._m14, 1.0);
            vec2 _4432 = vec2(0.0);
            _4432 = (((_4425.xy - _716._m16.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _4445 = 0.000244140625;
            float _4451 = abs(_695._m6.z) * 2.0;
            _4445 *= _10(_4451);
            vec3 _4455 = vec3(TEXTURE_LOD(_4456, vec4(_4432 + vec2(_4445), 0.0, 0.0).xy, vec4(_4432 + vec2(_4445), 0.0, 0.0).w).x, TEXTURE_LOD(_4456, vec4(_4432, 0.0, 0.0).xy, vec4(_4432, 0.0, 0.0).w).x, TEXTURE_LOD(_4456, vec4(_4432 - vec2(_4445), 0.0, 0.0).xy, vec4(_4432 - vec2(_4445), 0.0, 0.0).w).x);
            float _4519 = 2.0 - (2.0 * (length(_4425.xy - _716._m16.zw) / 16.0));
            _4455 *= _10(_4519);
            float _4526 = 1.0 - _4422;
            float _4523 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_4526));
            float _4537 = (_695._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _4529 = (_4455 * _4523) * _10(_4537);
            float _4546 = _4285 - _4422;
            float _4540 = (1.0 - _4523) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_4546));
            float _4560 = ((-_695._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _4550 = (_4455 * _4540) * _10(_4560);
            _4455 = _4529 + _4550;
            float _4571 = 1.02499997615814208984375 - _4422;
            float _4566 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_4571));
            float _4574 = _716._m15.w;
            _695._m19 = mix(_695._m19, (_695._m19 * _4455) + (_695._m19 * mix(1.0, 0.5, _4566)), vec3(_4574));
            break;
        }
    }
    _695._m19 *= _695._m0;
    _695._m21 = _695._m19 + _695._m20;
    vec3 _4608 = vec3(0.0);
    if (_1771._m19.w > 0.0)
    {
        vec4 _4614 = vec4(0.0030000000260770320892333984375, 0.00999999977648258209228515625, 0.0500000007450580596923828125, 0.300000011920928955078125);
        vec2 _4619 = abs(vec2(1.0) / _716._m6.zw);
        vec2 _4625 = ((gl_FragCoord.xy * 1.5) * _716._m6.zw) * (_4619 / vec2(32.0));
        vec4 _4638 = TEXTURE_LOD(_4639, vec4((_4625 * _4614.xy) + (vec2(_716._m1.x * 0.75) * _4614.zw), 0.0, 0.0).xy, vec4((_4625 * _4614.xy) + (vec2(_716._m1.x * 0.75) * _4614.zw), 0.0, 0.0).w);
        float _4681 = (length(_721.xyz) - 10.0) * 2.0;
        float _4675 = 1.0 - _10(_4681);
        float _4684 = 1.0 - dot(_695._m6, normalize(-_721.xyz));
        float _4693 = 2.0;
        _4693 *= ((sin((_716._m1.x * 5.0) * 0.75) * 0.5) + 0.699999988079071044921875);
        _4693 *= _4693;
        _4693 *= _4684;
        _4684 *= _4684;
        float _4713 = (_4684 * _4684) * 9.9999997473787516355514526367188e-05;
        vec3 _4723 = _4638.xyz * _4638.xyz;
        _4638 = vec4(_4723.x, _4723.y, _4723.z, _4638.w);
        vec3 _4726 = _4638.xyz;
        float _4736 = (_4726.x * _4684) + _4713;
        vec3 _4729 = _1771._m19.xyz * _10(_4736);
        float _4743 = _4726.x;
        vec3 _4742 = _1771._m19.xyz * _10(_4743);
        vec3 _4751 = mix(_4729, _4742, vec3(0.0500000007450580596923828125));
        float _4761 = (0.5 * _4684) + _4713;
        vec3 _4756 = _1771._m19.xyz * _10(_4761);
        _4751 /= _716._m17.xyz;
        vec3 _4772 = (_4751 * _1771._m19.w) * 0.5;
        _4608 += (_4772 * _4675);
    }
    _695._m19 += _4608;
    vec3 _4794 = _695._m19 + _695._m20;
    _4789 = vec4(_4794.x, _4794.y, _4794.z, _4789.w);
    vec3 _4798 = _695._m6;
    bool _4801 = false;
    vec2 _4802 = _154(_4798, _4801);
    _4797 = vec4(_4802.x, _4802.y, _4797.z, _4797.w);
    float _4806 = _695._m2.x;
    float _4810 = _695._m2.y;
    float _4814 = _695._m2.z;
    float _4818 = _695._m3;
    _4805 = vec4(_78(_4806), _78(_4810), _78(_4814), _157(_4818));
    vec3 _4828 = _4789.xyz + _1771._m2.xyz;
    _4789 = vec4(_4828.x, _4828.y, _4828.z, _4789.w);
}


