// Water Reflect
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

layout(set = 1, binding = 0, std140) uniform _147_149
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
} _149;

layout(set = 0, binding = 0, std140) uniform _157_159
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
} _159;

layout(push_constant, std430) uniform _635_637
{
    int _m0;
    int _m1;
} _637;

layout(set = 0, binding = 3) uniform SAMPLER_2D _169;
layout(set = 0, binding = 4) uniform SAMPLER_2D _213;
layout(set = 0, binding = 5) uniform SAMPLER_2D _466;
layout(set = 0, binding = 1) uniform sampler3D _641;
layout(set = 0, binding = 2) uniform sampler3D _642;
layout(set = 1, binding = 1) uniform SAMPLER_2D _643;
layout(set = 1, binding = 2) uniform SAMPLER_2D _644;

layout(location = 2) in vec4 _203;
layout(location = 3) in vec4 _208;
layout(location = 0) out vec4 _400;
layout(location = 1) out vec4 _419;
layout(location = 4) in vec4 _420;

void _10(float _9)
{
    if (_9 < 0.0)
    {
        discard;
    }
}

float _31(float _27, vec4 _28, float _29, bool _30)
{
    float _61 = _28.w / (_27 + _28.z);
    return _61 * _29;
}

float _14(float _13)
{
    return clamp(_13, 0.0, 1.0);
}

vec3 _20(vec3 _19)
{
    return clamp(_19, vec3(0.0), vec3(1.0));
}

vec2 _37(vec2 _36)
{
    return (vec2(1.0) - abs(_36.yx)) * vec2((_36.x >= 0.0) ? 1.0 : (-1.0), (_36.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _42(inout vec3 _40, bool _41)
{
    _40 /= vec3((abs(_40.x) + abs(_40.y)) + abs(_40.z));
    vec2 _114;
    if (_40.z >= 0.0)
    {
        _114 = _40.xy;
    }
    else
    {
        vec2 _120 = _40.xy;
        _114 = _37(_120);
    }
    _40 = vec3(_114.x, _114.y, _40.z);
    if (_41)
    {
        vec2 _135 = (_40.xy * 0.5) + vec2(0.5);
        _40 = vec3(_135.x, _135.y, _40.z);
    }
    return _40.xy;
}

void main()
{
    vec2 _142 = (gl_FragCoord.xy * _149._m3.zw) * _159._m7.xy;
    float _165 = TEXTURE_LOD(_169, vec4(_142, 0.0, 0.0).xy, vec4(_142, 0.0, 0.0).w).x;
    float _188 = _165 - gl_FragCoord.z;
    _10(_188);
    float _193 = gl_FragCoord.z;
    vec4 _196 = _159._m8;
    float _199 = 1.0;
    bool _200 = false;
    float _190 = _31(_193, _196, _199, _200);
    vec3 _202 = _203.xyz;
    vec3 _206 = vec3(0.0);
    _206 = normalize(_208.xyz);
    vec2 _231 = (SAMPLE_TEXTURE(_213, (_202.xy * (_159._m9.x / 100.0)) * 4.0).xy * 2.0) - vec2(1.0);
    vec3 _212;
    _212 = vec3(_231.x, _231.y, _212.z);
    float _246 = (1.0 - (_212.x * _212.x)) - (_212.y * _212.y);
    _212.z = sqrt(_14(_246));
    _212 = mix(vec3(0.0, 0.0, 1.0), _212, _159._m10.xxx);
    vec3 _264 = vec3(_190) / vec3(1024.0);
    _206 = mix(_206, _212, _20(_264));
    vec3 _267 = vec3(0.0);
    vec2 _268 = _202.xy * _159._m11.x;
    vec2 _298 = (SAMPLE_TEXTURE(_213, ((_268 / vec2(2.0)) + ((_159._m12.xx * 0.0500000007450580596923828125) * _159._m11.x)) + (_206.xy * 0.02500000037252902984619140625)).xy * 2.0) - vec2(1.0);
    _267 = vec3(_298.x, _298.y, _267.z);
    vec2 _324 = _267.xy + ((SAMPLE_TEXTURE(_213, ((_268 / vec2(4.0)) + ((_159._m12.xx * 0.0500000007450580596923828125) * _159._m11.x)) + (_206.xy * 0.02500000037252902984619140625)).xy * 2.0) - vec2(1.0));
    _267 = vec3(_324.x, _324.y, _267.z);
    vec2 _343 = _267.xy + ((SAMPLE_TEXTURE(_213, (_268 / vec2(8.0)) + (_206.xy * 0.02500000037252902984619140625)).xy * 2.0) - vec2(1.0));
    _267 = vec3(_343.x, _343.y, _267.z);
    vec2 _352 = _267.xy * (0.333000004291534423828125 * _159._m10.x);
    _267 = vec3(_352.x, _352.y, _267.z);
    float _367 = (1.0 - (_267.x * _267.x)) - (_267.y * _267.y);
    _267.z = sqrt(_14(_367));
    vec2 _375 = _206.xy + _267.xy;
    _206 = vec3(_375.x, _375.y, _206.z);
    bool _378 = (_149._m0.x > 0.0) ? true : false;
    bool _385 = (gl_FrontFacing == true) ? false : true;
    bool _398;
    if (!_385)
    {
        _398 = (_378 == true) ? true : false;
    }
    else
    {
        _398 = _385;
    }
    _385 = _398;
    vec3 _403;
    if (_385 == true)
    {
        _403 = -_206;
    }
    else
    {
        _403 = _206;
    }
    vec3 _410 = _403;
    bool _412 = false;
    vec2 _413 = _42(_410, _412);
    _400 = vec4(_413.x, _413.y, _400.z, _400.w);
    _400 = vec4(_400.x, _400.y, vec2(0.0).x, vec2(0.0).y);
    _419 = vec4(_420.xyz.x, _420.xyz.y, _420.xyz.z, _419.w);
    vec3 _430 = _419.xyz / vec3(16.0);
    vec3 _432 = sqrt(_20(_430));
    _419 = vec4(_432.x, _432.y, _432.z, _419.w);
    float _435 = 0.0;
    float _437 = _203.w;
    float _436 = _14(_437);
    float _441 = _159._m12.x * 0.039999999105930328369140625;
    vec2 _446 = vec2(1.0, 0.0);
    vec2 _448 = ((_446 * _441) * 0.25) + ((_203.xy * _159._m13.x) * 0.100000001490116119384765625);
    float _484 = ((2.0 + _436) * SAMPLE_TEXTURE1(_466, vec4(_448, 0.0, 0.0).xy, vec4(_448, 0.0, 0.0).w).y) + (_436 * 0.25);
    float _463 = _14(_484);
    float _493 = (_159._m14.x - 1.0) / 10.0;
    float _486 = mix(4.0, 2.0, _14(_493));
    float _496 = _486 * pow(_436, 8.0);
    vec2 _501 = (((vec2(_463) * 0.02500000037252902984619140625) + (_206.xy * 0.004999999888241291046142578125)) + (_446 * _441)) + (_203.xy * _159._m13.x);
    float _520 = SAMPLE_TEXTURE(_466, _501.yx).y;
    _501 += vec2(_520 * 0.00999999977648258209228515625);
    _435 = (_520 * 0.20000000298023223876953125) + (0.800000011920928955078125 * SAMPLE_TEXTURE1(_466, vec4(_501, 0.0, _496).xy, vec4(_501, 0.0, _496).w).y);
    _435 = max(_435, SAMPLE_TEXTURE1(_466, vec4(_501 * 0.5, 0.0, _496).xy, vec4(_501 * 0.5, 0.0, _496).w).y);
    float _582 = (_206.x * 0.5) + (0.449999988079071044921875 * _463);
    float _589 = 0.100000001490116119384765625 + (0.4000000059604644775390625 * _463);
    float _601 = _435 * _463;
    _435 = smoothstep(max(0.2199999988079071044921875, ((1.0 - _436) * _14(_582)) * _14(_589)), 0.60000002384185791015625 + ((1.0 - _463) * 0.4000000059604644775390625), _14(_601));
    float _608 = (_463 * 0.20000000298023223876953125) + _436;
    _435 *= (_14(_608) * _159._m15.x);
    float _616 = _435;
    _435 = _14(_616);
    _435 = max(_435, 0.00196078442968428134918212890625);
    float _623;
    if (_385)
    {
        _623 = -_435;
    }
    else
    {
        _623 = _435;
    }
    _419.w = (_623 * 0.5) + 0.5;
}


