// FIX FOR DECALS CLIPPING
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_NV_shading_rate_image : require
layout(early_fragment_tests) in;
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _721
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1042
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _2441
{
    int _m0;
    int _m1;
};

struct _2444
{
    int _m0;
    int _m1;
};

struct _2544
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _3340
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _4115
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _4808
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 0, binding = 0, std140) uniform _753_755
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _755;

layout(set = 2, binding = 0, std140) uniform _863_865
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _865;

layout(set = 1, binding = 0, std140) uniform _1782_1784
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
} _1784;

layout(set = 0, binding = 14, std430) restrict readonly buffer _2446_2448
{
    _2444 _m0[];
} _2448;

layout(set = 0, binding = 15, std430) restrict readonly buffer _2519_2521
{
    uint _m0[];
} _2521;

layout(set = 0, binding = 16, std140) uniform _2549_2551
{
    vec4 _m0[4096];
} _2551;

layout(set = 0, binding = 17, std140) uniform _2569_2571
{
    vec4 _m0[4096];
} _2571;

layout(set = 0, binding = 18, std140) uniform _2621_2623
{
    vec4 _m0[4096];
} _2623;

layout(set = 0, binding = 20, std140) uniform _3344_3346
{
    vec4 _m0[4096];
} _3346;

layout(set = 0, binding = 21, std140) uniform _3383_3385
{
    vec4 _m0[4096];
} _3385;

layout(set = 0, binding = 22, std140) uniform _3452_3454
{
    vec4 _m0[3072];
} _3454;

layout(set = 0, binding = 24, std140) uniform _4119_4121
{
    vec4 _m0[4095];
} _4121;

layout(set = 0, binding = 26, std140) uniform _4812_4814
{
    vec4 _m0[4096];
} _4814;

layout(set = 0, binding = 1, std430) restrict readonly buffer _5153_5155
{
    uint _m0[];
} _5155;

layout(push_constant, std430) uniform _5149_5151
{
    int _m0;
    int _m1;
} _5151;

layout(set = 3, binding = 3) uniform TEXTURE_2D _890[8];
layout(set = 0, binding = 3) uniform sampler _897;
layout(set = 3, binding = 2) uniform TEXTURE_2D _938[8];
layout(set = 0, binding = 4) uniform sampler _942;
layout(set = 3, binding = 0) uniform TEXTURE_2D _952[8];
layout(set = 0, binding = 5) uniform sampler _956;
layout(set = 3, binding = 1) uniform TEXTURE_2D _966[8];
layout(set = 0, binding = 6) uniform sampler _970;
layout(set = 3, binding = 7) uniform TEXTURE_2D _979[8];
layout(set = 0, binding = 7) uniform sampler _983;
layout(set = 3, binding = 4) uniform TEXTURE_2D _991[8];
layout(set = 0, binding = 8) uniform sampler _995;
layout(set = 3, binding = 6) uniform TEXTURE_2D _1003[8];
layout(set = 0, binding = 9) uniform sampler _1007;
layout(set = 0, binding = 10) uniform SAMPLER_2D _1996;
layout(set = 0, binding = 11) uniform SAMPLER_2D _2005;
layout(set = 0, binding = 12) uniform SAMPLER_2D _2061;
layout(set = 0, binding = 13, r32f) uniform writeonly image2D _2316;
layout(set = 0, binding = 19) uniform SAMPLER_2D _2842;
layout(set = 0, binding = 23) uniform SAMPLER_2D _3678;
layout(set = 0, binding = 25) uniform sampler2DShadow _4440;
layout(set = 0, binding = 27) uniform SAMPLER_2D _4953;
layout(set = 3, binding = 5) uniform TEXTURE_2D _5148[8];

layout(location = 2) in vec4 _735;
layout(location = 5) in vec4 _742;
layout(location = 3) in vec4 _745;
layout(location = 4) in vec4 _768;
layout(location = 14) flat in uvec3 _820;
layout(location = 0) out vec4 _5106;
layout(location = 1) out vec4 _5114;
layout(location = 2) out vec4 _5122;

float _285;

uvec4 _44(vec4 _43)
{
    return floatBitsToUint(_43);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _64(float _63)
{
    if (_63 <= 0.040449999272823333740234375)
    {
        return _63 / 12.9200000762939453125;
    }
    else
    {
        return pow((_63 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

float _76(float _75)
{
    float _339 = _75;
    return _64(_339);
}

float _67(float _66)
{
    return _66 * ((_66 * ((_66 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

float _29(vec2 _27, vec2 _28)
{
    return dot(_27, _28);
}

vec4 _122(SAMPLER_2D _118, vec2 _119, vec2 _120, vec2 _121)
{
    return TEXTURE_GRAD(_118, _119, _120, _121);
}

vec4 _115(SAMPLER_2D _113, vec2 _114)
{
    return SAMPLE_TEXTURE(_113, _114);
}

float _35(uint _34)
{
    return uintBitsToFloat(_34);
}

float _147(float _143, vec4 _144, float _145, bool _146)
{
    float _576 = _144.w / (_143 + _144.z);
    return _576 * _145;
}

vec3 _152(vec3 _150, bool _151)
{
    vec3 _589 = (_150 * 2.0) - vec3(1.0);
    float _606 = (1.0 - (_589.x * _589.x)) - (_589.y * _589.y);
    _589.z = sqrt(_10(_606));
    if (_151 == false)
    {
        _589.z = -_589.z;
    }
    return _589;
}

vec3 _159(vec3 _157, mat3 _158)
{
    return normalize(vec3(dot(_157, _158[0]), dot(_157, _158[1]), dot(_157, _158[2])));
}

uint _39(float _38)
{
    return floatBitsToUint(_38);
}

float _55(float _52, float _53, float _54)
{
    return min(_52, min(_53, _54));
}

float _50(float _47, float _48, float _49)
{
    return max(_47, max(_48, _49));
}

vec4 _94(uint _93)
{
    return unpackUnorm4x8(_93).wzyx;
}

vec4 _107(uvec2 _106)
{
    return vec4(float((_106.x >> uint(16)) & 65535u), float(_106.x & 65535u), float((_106.y >> uint(16)) & 65535u), float(_106.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _97(uint _96)
{
    return vec4(float((_96 >> uint(24)) & 255u), float((_96 >> uint(16)) & 255u), float((_96 >> uint(8)) & 255u), float(_96 & 255u));
}

vec3 _70(vec3 _69)
{
    float _300 = _69.x;
    vec3 _299;
    _299.x = _67(_300);
    float _306 = _69.y;
    _299.y = _67(_306);
    float _312 = _69.z;
    _299.z = _67(_312);
    return _299;
}

vec4 _73(vec4 _72)
{
    vec3 _322 = _72.xyz;
    vec4 _321 = vec4(_70(_322), 1.0);
    float _330 = _72.w;
    _321.w = _67(_330);
    return _321;
}

float _87(float _86)
{
    return (step(0.0, _86) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _101(uint _100)
{
    return vec3(float((_100 >> uint(21)) & 2047u), float((_100 >> uint(10)) & 2047u), float(_100 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _61(float _58, float _59, float _60)
{
    bool _226 = abs(_60) >= abs(_58);
    bool _234;
    if (_226)
    {
        _234 = abs(_60) >= abs(_59);
    }
    else
    {
        _234 = _226;
    }
    if (_234)
    {
        return uint((_60 < 0.0) ? 5 : 4);
    }
    if (abs(_59) >= abs(_58))
    {
        return uint((_59 < 0.0) ? 3 : 2);
    }
    return uint(int(_58 < 0.0));
}

float _79(float _78)
{
    return exp2(_78);
}

vec3 _125(uint _124)
{
    uint _450 = _124;
    vec4 _449 = _94(_450);
    float _461 = (_449.w * 255.0) - 128.0;
    return _449.xyz * _79(_461);
}

float _84(float _82, float _83)
{
    return pow(_82, _83);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _130(vec3 _128, float _129)
{
    float _473 = 50.0 * dot(_128, vec3(0.33329999446868896484375));
    float _466 = _10(_473);
    float _482 = 1.0 - _129;
    float _485 = _10(_482);
    float _486 = 5.0;
    vec3 _490 = _128 + ((vec3(_466) - _128) * _84(_485, _486));
    return _16(_490);
}

vec3 _138(vec3 _133, vec3 _134, vec3 _135, vec3 _136, float _137)
{
    vec3 _494 = normalize(_134 + _135);
    float _499 = 1.0 - (_137 * 0.800000011920928955078125);
    _499 *= _499;
    _499 *= _499;
    float _510 = _499 * _499;
    float _518 = dot(_133, _494);
    float _514 = _10(_518);
    float _520 = ((_514 * _514) * (_510 - 1.0)) + 1.0;
    _520 = _510 / ((_520 * _520) + 9.9999999392252902907785028219223e-09);
    float _539 = dot(_133, _134);
    float _535 = (_10(_539) * (1.0 - _499)) + _499;
    float _550 = dot(_133, _135);
    float _546 = (_10(_550) * (1.0 - _499)) + _499;
    _520 /= (((4.0 * _535) * _546) + 9.9999999392252902907785028219223e-09);
    vec3 _568 = _136;
    float _570 = dot(_135, _494);
    return _130(_568, _570) * _520;
}

vec2 _163(vec2 _162)
{
    return (vec2(1.0) - abs(_162.yx)) * vec2((_162.x >= 0.0) ? 1.0 : (-1.0), (_162.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _168(inout vec3 _166, bool _167)
{
    _166 /= vec3((abs(_166.x) + abs(_166.y)) + abs(_166.z));
    vec2 _673;
    if (_166.z >= 0.0)
    {
        _673 = _166.xy;
    }
    else
    {
        vec2 _679 = _166.xy;
        _673 = _163(_679);
    }
    _166 = vec3(_673.x, _673.y, _166.z);
    if (_167)
    {
        vec2 _694 = (_166.xy * 0.5) + vec2(0.5);
        _166 = vec3(_694.x, _694.y, _166.z);
    }
    return _166.xy;
}

float _90(float _89)
{
    return sqrt(_89);
}

float _171(float _170)
{
    float _704 = abs(_170);
    float _701 = _90(_704);
    float _708;
    if (_170 > 0.0)
    {
        _708 = _701;
    }
    else
    {
        _708 = -_701;
    }
    return (_708 * 0.5) + 0.5;
}

void main()
{
    _721 _723 = _721(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _723._m15 = _735;
    _723._m16 = gl_FragCoord;
    vec3 _741 = vec3(_742.zw, _745.w);
    _723._m14 = _755._m0.xyz + _741;
    vec3 _763 = normalize(_745.xyz);
    vec3 _767 = normalize(_768.xyz);
    vec3 _772 = normalize(cross(_763, _767) * sign(_768.w));
    _723._m17 = mat3(vec3(_767.x, _772.x, _763.x), vec3(_767.y, _772.y, _763.y), vec3(_767.z, _772.z, _763.z));
    _723._m13 = normalize(-_741);
    uint _810 = 0u;
    vec4 _811 = vec4(0.0);
    vec4 _812 = vec4(0.0);
    vec4 _813 = vec4(0.0);
    vec4 _814 = vec4(0.0);
    vec4 _815 = vec4(0.0);
    uvec3 _818 = _820;
    vec3 _822 = vec3(abs(_768.w) - 1.0, 0.0, _742.x);
    bool _833 = _818.y == 65535u;
    bool _839;
    if (_833)
    {
        _839 = _818.z == 65535u;
    }
    else
    {
        _839 = _833;
    }
    bool _830 = _839;
    bool _840 = !_830;
    bool _843 = _818.z != 65535u;
    uint _847 = _818.x & 7u;
    uint _858;
    if (_755._m1.x == 0.0)
    {
        _858 = _847;
    }
    else
    {
        vec4 _866 = _865._m3;
        uvec4 _862 = _44(_866);
        uint _870 = _862[_847 / 2u];
        uint _875 = 16u * (_847 & 1u);
        _858 = (_870 >> _875) & 65535u;
    }
    uint _884 = _858;
    float _886 = SAMPLE_TEXTURE(SAMPLER_2D(_890[_884], _897), _735.zw).x;
    float _915 = pow(_886, 0.125) - 0.800000011920928955078125;
    vec2 _904 = vec2(1.0) / mix(vec2(1.0), vec2(gl_FragmentSizeNV), vec2(_10(_915) / 0.20000000298023223876953125));
    vec2 _923 = dFdx(_735.zw) * _904.x;
    vec2 _930 = dFdy(_735.zw) * _904.y;
    vec2 _937 = TEXTURE_GRAD(SAMPLER_2D(_938[_884], _942), _735.zw, _923, _930).yx;
    vec3 _951 = SAMPLE_TEXTURE(SAMPLER_2D(_952[_884], _956), _735.zw).xyz;
    vec3 _963 = vec3(0.039999999105930328369140625);
    _963 = SAMPLE_TEXTURE(SAMPLER_2D(_966[_884], _970), _735.zw).xyz;
    float _977 = 1.0;
    float _978 = SAMPLE_TEXTURE(SAMPLER_2D(_979[_884], _983), _735.zw).x;
    float _990 = SAMPLE_TEXTURE(SAMPLER_2D(_991[_884], _995), _735.zw).x;
    vec3 _1002 = SAMPLE_TEXTURE(SAMPLER_2D(_1003[_884], _1007), _735.zw).xyz;
    _813 = vec4(_951.x, _951.y, _951.z, _813.w);
    _813.w = _937.y;
    _814 = vec4(_963.x, _963.y, _963.z, _814.w);
    _814.w = _990;
    _815 = vec4(_815.x, _937.x, _815.z, _937.y);
    _811.x = _978;
    _811.y = _977;
    _811.z = _990;
    _811.w = _886;
    _812 = vec4(_1002.x, _1002.y, _1002.z, _812.w);
    vec2 _1039 = _735.zw;
    _1042 _1044;
    _1044._m0 = _813;
    _1044._m1 = _814;
    float _1049 = _811.x;
    _1044._m2.x = _76(_1049);
    _1044._m2 = vec4(_1044._m2.x, _811.yzw.x, _811.yzw.y, _811.yzw.z);
    _1044._m3 = _815;
    _1044._m4 = _812;
    _1042 _1063 = _1044;
    vec3 _1065 = vec3(0.0);
    bool _1073;
    if (_840)
    {
        _1073 = _822.x < 65534.0;
    }
    else
    {
        _1073 = _840;
    }
    bool _1079;
    if (_1073)
    {
        _1079 = _822.x > 0.0;
    }
    else
    {
        _1079 = _1073;
    }
    if (_1079)
    {
        uint _1082 = 0u;
        _1042 _1083 = _1042(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1085 = _818.y & 7u;
        uint _1094;
        if (_755._m1.x == 0.0)
        {
            _1094 = _1085;
        }
        else
        {
            vec4 _1098 = _865._m3;
            uvec4 _1097 = _44(_1098);
            uint _1102 = _1097[_1085 / 2u];
            uint _1107 = 16u * (_1085 & 1u);
            _1094 = (_1102 >> _1107) & 65535u;
        }
        uint _1115 = _1094;
        float _1117 = SAMPLE_TEXTURE(SAMPLER_2D(_890[_1115], _897), _1039).x;
        float _1132 = pow(_1117, 0.125) - 0.800000011920928955078125;
        vec2 _1126 = vec2(1.0) / mix(vec2(1.0), vec2(gl_FragmentSizeNV), vec2(_10(_1132) / 0.20000000298023223876953125));
        vec2 _1139 = dFdx(_1039) * _1126.x;
        vec2 _1145 = dFdy(_1039) * _1126.y;
        vec2 _1151 = TEXTURE_GRAD(SAMPLER_2D(_938[_1115], _942), _1039, _1139, _1145).yx;
        vec3 _1162 = SAMPLE_TEXTURE(SAMPLER_2D(_952[_1115], _956), _1039).xyz;
        vec3 _1171 = vec3(0.039999999105930328369140625);
        _1171 = SAMPLE_TEXTURE(SAMPLER_2D(_966[_1115], _970), _1039).xyz;
        float _1180 = 1.0;
        float _1181 = SAMPLE_TEXTURE(SAMPLER_2D(_979[_1115], _983), _1039).x;
        float _1190 = SAMPLE_TEXTURE(SAMPLER_2D(_991[_1115], _995), _1039).x;
        vec3 _1199 = SAMPLE_TEXTURE(SAMPLER_2D(_1003[_1115], _1007), _1039).xyz;
        _1083._m0 = vec4(_1162.x, _1162.y, _1162.z, _1083._m0.w);
        _1083._m0.w = _1151.y;
        _1083._m1 = vec4(_1171.x, _1171.y, _1171.z, _1083._m1.w);
        _1083._m1.w = _1190;
        _1083._m3 = vec4(_1083._m3.x, _1151.x, _1083._m3.z, _1151.y);
        _1083._m2.x = _1181;
        _1083._m2.y = _1180;
        _1083._m2.z = _1190;
        _1083._m2.w = _1117;
        _1083._m4 = vec4(_1199.x, _1199.y, _1199.z, _1083._m4.w);
        float _1237 = _1083._m2.x;
        _1083._m2.x = _67(_1237);
        float _1242 = _1083._m1.w;
        float _1245 = _822.x * _1242;
        float _1250 = _1044._m2.x;
        float _1253 = 0.0;
        float _1254 = 0.0;
        float _1255 = (_1245 * 1.5) - 0.5;
        float _1263 = 1.0 - _1250;
        float _1260 = _10(_1263);
        float _1272 = ((_1260 + _1255) - 0.5) * 10.0;
        float _1265 = _10(_1272);
        _1253 = _1265;
        float _1275 = (_822.x * 1.5) - 0.5;
        float _1283 = 1.0 - _1250;
        float _1280 = _10(_1283);
        float _1291 = ((_1280 + _1275) - 0.5) * 10.0;
        float _1285 = _10(_1291);
        _1254 = _1285;
        _1063._m0 = mix(_1063._m0, _1083._m0, vec4(_1253));
        _1063._m1 = mix(_1063._m1, _1083._m1, vec4(_1253));
        _1063._m2 = mix(_1063._m2, _1083._m2, vec4(_1253));
        _1063._m3 = mix(_1063._m3, _1083._m3, vec4(_1253));
        _1063._m4 = mix(_1063._m4, _1083._m4, vec4(_1253));
        _810 = (_1253 > 0.5) ? _1082 : _810;
        _1065.x = _1253;
    }
    bool _1347;
    if (_843)
    {
        _1347 = _822.y < 65534.0;
    }
    else
    {
        _1347 = _843;
    }
    bool _1353;
    if (_1347)
    {
        _1353 = _822.y > 0.0;
    }
    else
    {
        _1353 = _1347;
    }
    if (_1353)
    {
        uint _1356 = 0u;
        _1042 _1357 = _1042(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1358 = _818.z & 7u;
        uint _1367;
        if (_755._m1.x == 0.0)
        {
            _1367 = _1358;
        }
        else
        {
            vec4 _1371 = _865._m3;
            uvec4 _1370 = _44(_1371);
            uint _1375 = _1370[_1358 / 2u];
            uint _1380 = 16u * (_1358 & 1u);
            _1367 = (_1375 >> _1380) & 65535u;
        }
        uint _1388 = _1367;
        float _1390 = SAMPLE_TEXTURE(SAMPLER_2D(_890[_1388], _897), _1039).x;
        float _1405 = pow(_1390, 0.125) - 0.800000011920928955078125;
        vec2 _1399 = vec2(1.0) / mix(vec2(1.0), vec2(gl_FragmentSizeNV), vec2(_10(_1405) / 0.20000000298023223876953125));
        vec2 _1412 = dFdx(_1039) * _1399.x;
        vec2 _1418 = dFdy(_1039) * _1399.y;
        vec2 _1424 = TEXTURE_GRAD(SAMPLER_2D(_938[_1388], _942), _1039, _1412, _1418).yx;
        vec3 _1435 = SAMPLE_TEXTURE(SAMPLER_2D(_952[_1388], _956), _1039).xyz;
        vec3 _1444 = vec3(0.039999999105930328369140625);
        _1444 = SAMPLE_TEXTURE(SAMPLER_2D(_966[_1388], _970), _1039).xyz;
        float _1453 = 1.0;
        float _1454 = SAMPLE_TEXTURE(SAMPLER_2D(_979[_1388], _983), _1039).x;
        float _1463 = SAMPLE_TEXTURE(SAMPLER_2D(_991[_1388], _995), _1039).x;
        vec3 _1472 = SAMPLE_TEXTURE(SAMPLER_2D(_1003[_1388], _1007), _1039).xyz;
        _1357._m0 = vec4(_1435.x, _1435.y, _1435.z, _1357._m0.w);
        _1357._m0.w = _1424.y;
        _1357._m1 = vec4(_1444.x, _1444.y, _1444.z, _1357._m1.w);
        _1357._m1.w = _1463;
        _1357._m3 = vec4(_1357._m3.x, _1424.x, _1357._m3.z, _1424.y);
        _1357._m2.x = _1454;
        _1357._m2.y = _1453;
        _1357._m2.z = _1463;
        _1357._m2.w = _1390;
        _1357._m4 = vec4(_1472.x, _1472.y, _1472.z, _1357._m4.w);
        float _1510 = _1357._m2.x;
        _1357._m2.x = _67(_1510);
        float _1515 = _1357._m1.w;
        float _1518 = _822.y * _1515;
        float _1523 = _1063._m2.x;
        float _1526 = 0.0;
        float _1527 = 0.0;
        float _1528 = (_1518 * 1.5) - 0.5;
        float _1535 = 1.0 - _1523;
        float _1532 = _10(_1535);
        float _1543 = ((_1532 + _1528) - 0.5) * 10.0;
        float _1537 = _10(_1543);
        _1526 = _1537;
        float _1546 = (_822.y * 1.5) - 0.5;
        float _1554 = 1.0 - _1523;
        float _1551 = _10(_1554);
        float _1562 = ((_1551 + _1546) - 0.5) * 10.0;
        float _1556 = _10(_1562);
        _1527 = _1556;
        _1063._m0 = mix(_1063._m0, _1357._m0, vec4(_1526));
        _1063._m1 = mix(_1063._m1, _1357._m1, vec4(_1526));
        _1063._m2 = mix(_1063._m2, _1357._m2, vec4(_1526));
        _1063._m3 = mix(_1063._m3, _1357._m3, vec4(_1526));
        _1063._m4 = mix(_1063._m4, _1357._m4, vec4(_1526));
        _810 = (_1526 > 0.5) ? _1356 : _810;
        _1065.y = _1526;
    }
    bool _1618;
    if (_840)
    {
        _1618 = _822.z > 0.0;
    }
    else
    {
        _1618 = _840;
    }
    if (_1618)
    {
        float _1621 = _822.z;
        float _1628 = 1.0 - _1063._m2.x;
        float _1624 = _10(_1628);
        float _1637 = ((_1624 - 0.5) * _1621) + _1621;
        float _1630 = _10(_1637);
        _1065.z = _1630;
        vec3 _1641 = _1063._m0.xyz * _1063._m0.xyz;
        float _1649 = 1.0 - _1063._m2.w;
        float _1661 = (_1630 - 0.0) / 0.3499999940395355224609375;
        vec3 _1666 = mix(_1063._m0.xyz, _1641, vec3(_10(_1661) * _1649));
        _1063._m0 = vec4(_1666.x, _1666.y, _1666.z, _1063._m0.w);
        float _1677 = (_1630 - 0.25) / 0.25;
        vec3 _1680 = mix(_1063._m1.xyz, vec3(0.039999999105930328369140625), vec3(_10(_1677)));
        _1063._m1 = vec4(_1680.x, _1680.y, _1680.z, _1063._m1.w);
        vec3 _1684 = vec3(_723._m17[0].z, _723._m17[1].z, _723._m17[2].z);
        float _1698 = _1684.z + 0.0625;
        float _1692 = _1630 * _10(_1698);
        float _1707 = (_1692 - 0.20000000298023223876953125) / 0.800000011920928955078125;
        _1063._m2.w = mix(_1063._m2.w, 0.89999997615814208984375, _10(_1707));
        float _1720 = (_1692 - 0.449999988079071044921875) / 0.5299999713897705078125;
        vec3 _1723 = mix(_1063._m3.wyz, vec3(0.5, 0.5, 1.0), vec3(_10(_1720)));
        _1063._m3 = vec4(_1063._m3.x, _1723.y, _1723.z, _1723.x);
        if (_1692 > 0.980000019073486328125)
        {
            float _1737 = (_1692 - 0.980000019073486328125) / 0.0199999995529651641845703125;
            _1684 = normalize(mix(_1684, vec3(0.0, 0.0, 1.0), vec3(_10(_1737))));
            _723._m17[0].z = _1684.x;
            _723._m17[1].z = _1684.y;
            _723._m17[2].z = _1684.z;
        }
    }
    _813 = _1063._m0;
    _814 = _1063._m1;
    vec3 _1756;
    if (_840)
    {
        _1756 = vec3(0.0);
    }
    else
    {
        _1756 = _811.xyz;
    }
    _811 = vec4(_1756.x, _1756.y, _1756.z, _811.w);
    _811.w = _1063._m2.w;
    _815 = _1063._m3;
    _812 = _1063._m4;
    vec3 _1772 = vec3(1.0);
    _723._m10 = (((vec3(_811.x * _811.x) * _1772) * _1784._m0.xyz) * _1784._m1.xxx) * mix(_813.xyz, vec3(1.0), vec3(_1784._m0.w));
    _723._m10 *= _822;
    _723._m10 *= vec3(_755._m2.x);
    uint _1813 = 0u;
    _723._m15.x = (_723._m15.x * _1784._m3.x) + _1784._m3.z;
    _723._m15.y = (_723._m15.y * _1784._m3.y) + _1784._m3.w;
    float _1832 = _755._m3.z;
    float _1835 = _755._m4.z;
    vec2 _1838 = _723._m15.xy * _1832;
    vec2 _1844 = dFdx(_1838) / vec2(float(gl_FragmentSizeNV.x));
    vec2 _1853 = dFdy(_1838) / vec2(float(gl_FragmentSizeNV.y));
    vec2 _1862 = _1844;
    vec2 _1864 = _1844;
    float _1861 = _29(_1862, _1864);
    vec2 _1868 = _1853;
    vec2 _1870 = _1853;
    float _1867 = _29(_1868, _1870);
    float _1873 = 0.5 * log2(max(_1861, _1867));
    float _1879 = 0.5 * log2(min(_1861, _1867));
    float _1885 = _1873 - min(_1835, _1873 - _1879);
    float _1893 = _1885;
    float _1895 = _755._m3.y;
    float _1898 = _755._m4.y;
    uvec2 _1901 = uvec2(_723._m15.xy * _1895);
    uint _1908 = uint(min(_755._m4.w, max(0.0, _1885) + _1898));
    uint _1917 = uint(_755._m3.x);
    _1813 = _1901.x & 255u;
    _1813 |= ((_1901.y & 255u) << uint(8));
    _1813 |= ((_1901.x >> uint(8)) << uint(16));
    _1813 |= ((_1901.y >> uint(8)) << uint(24));
    _1813 |= (_1908 << uint(19));
    _1813 |= (_1917 << uint(27));
    vec3 _2009;
    if (_755._m5.y != 0.0)
    {
        float _1957 = fract(_1893);
        float _1960 = 0.375;
        float _1962 = 0.625;
        bool _1969;
        float _1970;
        float _1973;
        if (_1957 <= _1960)
        {
            _1969 = false;
            _1970 = _1893 - 0.5;
            _1973 = 0.0;
        }
        else
        {
            if (_1957 >= _1962)
            {
                _1969 = false;
                _1970 = _1893 + 0.5;
                _1973 = 0.0;
            }
            else
            {
                _1969 = true;
                _1970 = _1893 - 0.5;
                _1973 = _1893 + 0.5;
            }
        }
        vec4 _1988 = vec4(_723._m15.x, _723._m15.y, 0.0, _1970);
        vec2 _1995 = TEXTURE_LOD(_1996, _1988.xy, _1988.w).xy;
        vec4 _2004 = SAMPLE_TEXTURE(_2005, _1995);
        _2009.x = (_723._m15.x * _2004.x) + _2004.z;
        _2009.y = (_723._m15.y * (_2004.x * _755._m6.x)) + _2004.w;
        _2009.z = _2004.y;
        vec2 _2035 = (dFdx(_723._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _2009.z;
        vec2 _2048 = (dFdy(_723._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _2009.z;
        vec2 _2062 = _2009.xy;
        vec2 _2065 = _2035;
        vec2 _2067 = _2048;
        vec3 _2070 = _122(_2061, _2062, _2065, _2067).xyz;
        _811 = vec4(_2070.x, _2070.y, _2070.z, _811.w);
        vec2 _2073 = _2009.xy;
        vec3 _2077 = _115(_2061, _2073).xyz;
        _811 = vec4(_2077.x, _2077.y, _2077.z, _811.w);
        if (_1969)
        {
            vec4 _2083 = vec4(_723._m15.x, _723._m15.y, 0.0, _1973);
            vec2 _2090 = TEXTURE_LOD(_1996, _2083.xy, _2083.w).xy;
            vec4 _2098 = SAMPLE_TEXTURE(_2005, _2090);
            _2009.x = (_723._m15.x * _2098.x) + _2098.z;
            _2009.y = (_723._m15.y * (_2098.x * _755._m6.x)) + _2098.w;
            _2009.z = _2098.y;
            vec2 _2126 = (dFdx(_723._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _2009.z;
            vec2 _2139 = (dFdy(_723._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _2009.z;
            vec2 _2153 = _2009.xy;
            vec2 _2156 = _2126;
            vec2 _2158 = _2139;
            vec3 _2161 = _122(_2061, _2153, _2156, _2158).xyz;
            vec4 _2152;
            _2152 = vec4(_2161.x, _2161.y, _2161.z, _2152.w);
            vec2 _2164 = _2009.xy;
            vec3 _2168 = _115(_2061, _2164).xyz;
            _2152 = vec4(_2168.x, _2168.y, _2168.z, _2152.w);
            float _2171 = 0.0;
            float _2172 = 0.375;
            float _2177 = (_1957 - _2172) * 4.0;
            _2171 = _10(_2177);
            vec3 _2185 = mix(_811.xyz, _2152.xyz, vec3(_2171));
            _2152 = vec4(_2185.x, _2185.y, _2185.z, _2152.w);
        }
    }
    else
    {
        vec4 _2189 = vec4(_723._m15.x, _723._m15.y, 0.0, _1893 - 0.5);
        vec2 _2197 = TEXTURE_LOD(_1996, _2189.xy, _2189.w).xy;
        vec4 _2205 = SAMPLE_TEXTURE(_2005, _2197);
        _2009.x = (_723._m15.x * _2205.x) + _2205.z;
        _2009.y = (_723._m15.y * (_2205.x * _755._m6.x)) + _2205.w;
        _2009.z = _2205.y;
        vec2 _2233 = (dFdx(_723._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _2009.z;
        vec2 _2246 = (dFdy(_723._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _2009.z;
        vec2 _2259 = _2009.xy;
        vec2 _2262 = _2233;
        vec2 _2264 = _2246;
        vec3 _2267 = _122(_2061, _2259, _2262, _2264).xyz;
        _811 = vec4(_2267.x, _2267.y, _2267.z, _811.w);
        vec2 _2270 = _2009.xy;
        vec3 _2274 = _115(_2061, _2270).xyz;
        _811 = vec4(_2274.x, _2274.y, _2274.z, _811.w);
    }
    vec2 _2277 = vec2(160.0, 90.0);
    vec2 _2281 = _2277 * _755._m7.zw;
    vec2 _2288 = (gl_FragCoord.xy * _755._m7.zw) * _2277;
    bool _2302 = fract(_2288.x) < _2281.x;
    bool _2311;
    if (_2302)
    {
        _2311 = fract(_2288.y) < _2281.y;
    }
    else
    {
        _2311 = _2302;
    }
    if (_2311)
    {
        uint _2320 = _1813;
        imageStore(_2316, ivec2(_2288), vec4(_35(_2320), 0.0, 0.0, 0.0));
    }
    _810 = _1813;
    _723._m0 = _813.xyz;
    _723._m2 = _814.xyz;
    _723._m1 = _812.xyz;
    _723._m9 = _811.xyz;
    _723._m3 = _811.w;
    _723._m6 = _815.wyz;
    uint _2344 = 8u;
    float _2345 = 16.0;
    float _2347 = 8.0;
    float _2349 = 24.0;
    vec2 _2358 = _723._m16.xy * _755._m7.xy;
    vec3 _2351;
    _2351 = vec3(_2358.x, _2358.y, _2351.z);
    _2351.y = 1.0 - _2351.y;
    // FIX FOR DECALS CLIPPING
    //clusterCoordinate.x -= vk3d_params[VIEW].stereo.x * 0.5;
    _2351.x -= vk3d_params[VIEW].stereo.x * 0.5;
    vec2 _2371 = floor(_2351.xy * vec2(_2345, _2347));
    _2351 = vec3(_2371.x, _2371.y, _2351.z);
    float _2375 = _723._m16.z;
    vec4 _2378 = _755._m8;
    float _2381 = 1.0;
    bool _2382 = false;
    float _2374 = _147(_2375, _2378, _2381, _2382);
    float _2384 = log2(max(1.0, _2374 / _755._m9.z)) * _755._m9.w;
    _2351.z = min(_2349 - 1.0, floor(_2384));
    uint _2400 = uint((_2351.x + (_2351.y * _2345)) + ((_2351.z * _2345) * _2347));
    bool _2416 = true;
    vec3 _2417 = _723._m6;
    bool _2420 = _2416;
    _723._m7 = _152(_2417, _2420);
    vec3 _2424 = _723._m7;
    mat3 _2427 = _723._m17;
    _723._m6 = _159(_2424, _2427);
    uint _2432 = 0u;
    uint _2433 = 0u;
    uint _2434 = 0u;
    uint _2435 = 0u;
    uint _2436 = 0u;
    uint _2437 = 0u;
    int _2439 = 256;
    _2441 _2443;
    _2443._m0 = _2448._m0[_2400]._m0;
    _2443._m1 = _2448._m0[_2400]._m1;
    int _2457 = _2443._m0 & (~(_2443._m0 >> 31));
    int _2466 = _2443._m1 & (~(_2443._m1 >> 31));
    _2432 = uint((_2457 >> 16) * _2439);
    _2433 = _2432 + uint(_2466 & 255);
    _2434 = _2432;
    _2435 = _2434 + uint((_2466 >> 8) & 255);
    _2436 = _2432;
    _2437 = _2436 + uint((_2466 >> 16) & 255);
    vec3 _2499 = dFdx(_723._m14);
    vec3 _2503 = dFdy(_723._m14);
    uint _2507 = _2434;
    _2544 _2546;
    vec3 _2899;
    float _3032;
    while (_2507 < _2435)
    {
        uint _2517 = _2521._m0[_2507];
        uint _2526 = (_2517 >> uint(12)) & 4095u;
        uint _2532 = _2526;
        if (_2532 >= _2526)
        {
            _2507++;
        }
        int _2541 = 2;
        int _2542 = 2;
        int _2543 = 2;
        _2546._m0 = _2551._m0[(uint(_2541) * _2532) + 0u];
        _2546._m1 = _2551._m0[(uint(_2541) * _2532) + 1u];
        _2546._m2 = _2571._m0[(uint(_2542) * _2532) + 0u];
        float _2585 = _2571._m0[(uint(_2542) * _2532) + 1u].x;
        _2546._m3.x = _39(_2585);
        float _2595 = _2571._m0[(uint(_2542) * _2532) + 1u].y;
        _2546._m3.y = _39(_2595);
        float _2605 = _2571._m0[(uint(_2542) * _2532) + 1u].z;
        _2546._m4.x = _39(_2605);
        float _2615 = _2571._m0[(uint(_2542) * _2532) + 1u].w;
        _2546._m4.y = _39(_2615);
        float _2629 = _2623._m0[(uint(_2543) * _2532) + 0u].x;
        _2546._m5.x = _39(_2629);
        float _2639 = _2623._m0[(uint(_2543) * _2532) + 0u].y;
        _2546._m5.y = _39(_2639);
        float _2649 = _2623._m0[(uint(_2543) * _2532) + 0u].z;
        _2546._m6 = _39(_2649);
        float _2659 = _2623._m0[(uint(_2543) * _2532) + 0u].w;
        _2546._m7 = _39(_2659);
        float _2669 = _2623._m0[(uint(_2543) * _2532) + 1u].x;
        _2546._m8 = _39(_2669);
        float _2679 = _2623._m0[(uint(_2543) * _2532) + 1u].y;
        _2546._m9 = _39(_2679);
        float _2689 = _2623._m0[(uint(_2543) * _2532) + 1u].z;
        _2546._m10 = _39(_2689);
        float _2700 = _2623._m0[(uint(_2543) * _2532) + 1u].w;
        _2546._m11 = _39(_2700);
        vec4 _2705 = _2546._m0;
        vec4 _2708 = _2546._m2;
        vec4 _2711 = _2546._m1;
        vec4 _2714 = vec4(_723._m14, 1.0);
        vec3 _2721 = vec3(dot(_2714, _2705), dot(_2714, _2711), dot(_2714, _2708));
        float _2732 = 0.0039215688593685626983642578125;
        float _2734 = _2721.x;
        float _2737 = _2721.y;
        float _2740 = _2721.z;
        bool _2745 = _55(_2734, _2737, _2740) <= _2732;
        bool _2762;
        if (!_2745)
        {
            float _2749 = _2721.x;
            float _2752 = _2721.y;
            float _2755 = _2721.z;
            _2762 = _50(_2749, _2752, _2755) >= (1.0 - _2732);
        }
        else
        {
            _2762 = _2745;
        }
        if (_2762)
        {
            continue;
        }
        uint _2766 = _2546._m11;
        bool _2770 = _2344 != 0u;
        bool _2777;
        if (_2770)
        {
            _2777 = (_2766 & 512u) != 0u;
        }
        else
        {
            _2777 = _2770;
        }
        bool _2790;
        if (!_2777)
        {
            bool _2782 = _2344 == 0u;
            bool _2789;
            if (_2782)
            {
                _2789 = (_2766 & 1024u) != 0u;
            }
            else
            {
                _2789 = _2782;
            }
            _2790 = _2789;
        }
        else
        {
            _2790 = _2777;
        }
        if (_2790)
        {
            continue;
        }
        vec2 _2794 = vec2(dot(_2499, _2705.xyz), dot(_2499, _2711.xyz));
        vec2 _2804 = vec2(dot(_2503, _2705.xyz), dot(_2503, _2711.xyz));
        float _2814 = 1.0;
        float _2815 = 1.0;
        vec3 _2816 = vec3(0.5, 0.5, 1.0);
        vec3 _2817 = vec3(0.0, 0.0, 1.0);
        uint _2818 = _2546._m7;
        uint _2822 = _2546._m9;
        vec4 _2821 = _94(_2822);
        uvec2 _2827 = _2546._m5;
        vec4 _2826 = _107(_2827);
        vec2 _2831 = _2794 * _2826.xy;
        vec2 _2836 = _2804 * _2826.xy;
        vec2 _2851 = (_2721.xy * _2826.xy) + _2826.zw;
        vec2 _2852 = _2831;
        vec2 _2854 = _2836;
        vec4 _2841 = _122(_2842, _2851, _2852, _2854);
        vec2 _2857 = (_2841.xy * 2.0) - vec2(1.0);
        float _2867 = 1.0 - dot(_2857, _2857);
        _2816 = vec3(_2857, sqrt(_10(_2867)));
        _2817 = _2816;
        _2814 = _2841.z;
        float _2876 = _2841.w;
        _2815 = _67(_2876);
        bool _2883 = _2815 <= (4.0 * _2732);
        bool _2890;
        if (_2883)
        {
            _2890 = _2821.w <= _2732;
        }
        else
        {
            _2890 = _2883;
        }
        if (_2890)
        {
            continue;
        }
        _2816 = _2817;
        if ((_2766 & 128u) != 0u)
        {
            _2899 = vec3(-_2816.x, -_2816.y, _2816.z);
        }
        else
        {
            _2899 = _2816;
        }
        _2816 = _2899;
        uint _2914 = _2546._m8;
        uint _2918 = _2914;
        float _2917 = 1.0 + (_97(_2918).w * 0.062745101749897003173828125);
        uint _2926 = _2818;
        float _2925 = _94(_2926).z;
        uint _2931 = _2914;
        vec3 _2930 = _94(_2931).xyz;
        float _2944 = _2917 - (_2917 * abs((_2721.z * 2.0) - 1.0));
        _2815 *= _10(_2944);
        float _2948 = _2815;
        if ((_2818 & 1u) != 0u)
        {
            vec3 _2955 = _2930;
            _2930 = vec3(0.0);
            uvec2 _2958 = _2546._m3;
            vec4 _2957 = _107(_2958);
            vec2 _2962 = _2794 * _2957.xy;
            vec2 _2967 = _2804 * _2957.xy;
            vec2 _2981 = (_2721.xy * _2957.xy) + _2957.zw;
            vec2 _2982 = _2962;
            vec2 _2984 = _2967;
            vec4 _2972 = _122(_2842, _2981, _2982, _2984);
            vec4 _2987 = _2972;
            _2972 = _73(_2987);
            _2930 = _2972.xyz;
            float _2999 = (_2972.w - _2732) / (1.0 - _2732);
            _2948 = _10(_2999);
            _2930 *= _2955;
        }
        vec3 _3004 = normalize(vec3(_723._m17[0].z, _723._m17[1].z, _723._m17[2].z));
        float _3013 = dot(_3004, normalize(_2708.xyz));
        float _3019 = _3013;
        vec2 _3024 = _2816.xy * _87(_3019);
        _2816 = vec3(_3024.x, _3024.y, _2816.z);
        if ((_2766 & 16384u) != 0u)
        {
            float _3037 = abs(_3013);
            _3032 = _10(_3037);
        }
        else
        {
            float _3040 = _3013;
            _3032 = _10(_3040);
        }
        float _3027 = _3032;
        float _3044 = ((_3027 * _2948) * _2821.w) * _2925;
        _723._m10 += (_2821.xyz * (_3044 * 64.0));
        uint _3063 = _2546._m10;
        uint _3067 = _3063;
        vec4 _3066 = _94(_3067);
        if ((_2818 & 2u) != 0u)
        {
            uvec2 _3076 = _2546._m4;
            vec4 _3075 = _107(_3076);
            vec2 _3080 = _2794 * _3075.xy;
            vec2 _3085 = _2804 * _3075.xy;
            vec2 _3098 = (_2721.xy * _3075.xy) + _3075.zw;
            vec2 _3099 = _3080;
            vec2 _3101 = _3085;
            _3066 = _122(_2842, _3098, _3099, _3101);
            _3066 *= _3066;
        }
        if ((_2818 & 32u) != 0u)
        {
            uint _3114 = _2818;
            float _3113 = _94(_3114).x;
            uint _3119 = _2818;
            float _3118 = _97(_3119).y;
            float _3125 = _3113;
            float _3123 = mix(_3118, 0.0, _10(_3125));
            float _3134 = _2814 - (_3123 / 255.0);
            float _3129 = float(_10(_3134) > 0.0);
            _2815 *= _3129;
        }
        float _3141 = _2815 * _3027;
        uint _3145 = _2546._m6;
        uint _3149 = _3145;
        vec4 _3154 = _94(_3149) * _3141;
        vec4 _3148 = _22(_3154);
        _723._m11 = max(_723._m11, _3148.x);
        _723._m0 = mix(_723._m0, _2930, _3148.xxx);
        _723._m2 = mix(_723._m2, _3066.xyz, _3148.yyy);
        vec3 _3177 = _3004;
        vec3 _3187 = _2705.xyz + (_3177 * dot(_2705.xyz, _3177));
        _2705 = vec4(_3187.x, _3187.y, _3187.z, _2705.w);
        vec3 _3198 = _2711.xyz + (_3177 * dot(_2711.xyz, _3177));
        _2711 = vec4(_3198.x, _3198.y, _3198.z, _2711.w);
        _2816 = ((normalize(_2705.xyz) * _2816.x) + (normalize(_2711.xyz) * _2816.y)) + (_3177 * _2816.z);
        if ((_2766 & 256u) != 0u)
        {
            vec3 _3225 = mix(_3004, _2816, _3148.www);
            float _3231 = dot(_3225, _3004);
            _2816 = (_723._m6 * _3231) + ((_3225 - (_3004 * _3231)) * dot(_723._m6, _3004));
        }
        else
        {
            if ((_2766 & 64u) != 0u)
            {
                _2816 = mix(mix(_723._m6, _3004, vec3(_3141)), _2816, _3148.www);
            }
            else
            {
                _2816 = mix(_723._m6, _2816, _3148.www);
            }
        }
        _723._m6 = normalize(_2816);
        _723._m3 = mix(_723._m3, _3066.w, _3148.z);
    }
    vec3 _3285 = vec3(0.0);
    _3285 = _723._m9 * _755._m10.x;
    float _3295;
    if (dot(_723._m10, vec3(1.0)) > 0.0)
    {
        _3295 = -_723._m3;
    }
    else
    {
        _3295 = _723._m3;
    }
    _723._m3 = _3295;
    _723._m18 = _3285;
    _723._m19 = _3285;
    uint _3311 = _2432;
    _3340 _3342;
    vec3 _3639;
    float _3728;
    float _3746;
    _4115 _4117;
    uint _4238;
    _4115 _4260;
    while (_3311 < _2433)
    {
        uint _3321 = _2521._m0[_3311];
        uint _3325 = _3321 & 4095u;
        uint _3328 = _3325;
        if (_3328 >= _3325)
        {
            _3311++;
        }
        int _3337 = 4;
        int _3338 = 4;
        int _3339 = 3;
        _3342._m0 = _3346._m0[(uint(_3337) * _3328) + 0u].xyz;
        float _3361 = _3346._m0[(uint(_3337) * _3328) + 0u].w;
        _3342._m1 = _39(_3361);
        _3342._m2 = _3346._m0[(uint(_3337) * _3328) + 1u];
        _3342._m3 = _3346._m0[(uint(_3337) * _3328) + 2u];
        _3342._m4 = _3385._m0[(uint(_3338) * _3328) + 0u];
        _3342._m5 = _3385._m0[(uint(_3338) * _3328) + 1u];
        _3342._m6 = _3385._m0[(uint(_3338) * _3328) + 2u];
        float _3415 = _3346._m0[(uint(_3337) * _3328) + 3u].x;
        _3342._m7.x = _39(_3415);
        float _3425 = _3346._m0[(uint(_3337) * _3328) + 3u].y;
        _3342._m7.y = _39(_3425);
        float _3435 = _3346._m0[(uint(_3337) * _3328) + 3u].z;
        _3342._m7.z = _39(_3435);
        float _3445 = _3346._m0[(uint(_3337) * _3328) + 3u].w;
        _3342._m7.w = _39(_3445);
        _3342._m8 = _3454._m0[(uint(_3339) * _3328) + 0u];
        _3342._m9 = _3454._m0[(uint(_3339) * _3328) + 1u];
        _3342._m10 = _3454._m0[(uint(_3339) * _3328) + 2u];
        float _3484 = _3385._m0[(uint(_3338) * _3328) + 3u].x;
        _3342._m11 = _39(_3484);
        float _3494 = _3385._m0[(uint(_3338) * _3328) + 3u].y;
        _3342._m12 = _39(_3494);
        _3342._m13 = _3385._m0[(uint(_3338) * _3328) + 3u].z;
        float _3512 = _3385._m0[(uint(_3338) * _3328) + 3u].w;
        _3342._m14 = _39(_3512);
        float _3517 = 0.0039215688593685626983642578125;
        vec4 _3518 = vec4(_723._m14, 1.0);
        float _3525 = 1.0 / dot(_3518, _3342._m6);
        vec3 _3531 = vec3(dot(_3518, _3342._m4) * _3525, dot(_3518, _3342._m5) * _3525, dot(_3518, _3342._m3));
        uint _3549 = _3342._m1;
        uint _3552 = _2344;
        _3552 |= 64u;
        float _3556 = _3531.x;
        float _3559 = _3531.y;
        float _3562 = _3531.z;
        bool _3567 = _55(_3556, _3559, _3562) <= _3517;
        bool _3584;
        if (!_3567)
        {
            float _3571 = _3531.x;
            float _3574 = _3531.y;
            float _3577 = _3531.z;
            _3584 = _50(_3571, _3574, _3577) >= (1.0 - _3517);
        }
        else
        {
            _3584 = _3567;
        }
        bool _3592;
        if (!_3584)
        {
            _3592 = (_3549 & _3552) != 0u;
        }
        else
        {
            _3592 = _3584;
        }
        if (_3592)
        {
            continue;
        }
        if ((_3549 & 3u) == 2u)
        {
            vec2 _3611 = fract((_3531.xy * _755._m11.xy) + _755._m11.zw);
            _3531 = vec3(_3611.x, _3611.y, _3531.z);
        }
        vec3 _3614 = _3342._m0;
        float _3617 = 1.0;
        float _3618 = 1.0;
        vec3 _3619 = vec3(0.0, 0.0, 1.0);
        vec3 _3620 = vec3(0.0, 0.0, 1.0);
        uint _3621 = _3342._m1;
        vec3 _3624 = (_3531 * 2.0) - vec3(1.0);
        vec2 _3629 = _3531.xy;
        vec3 _3632 = _3342._m10.xyz;
        if ((_3621 & 3u) == 2u)
        {
            _3639 = _3632;
        }
        else
        {
            _3639 = normalize(_3614 - _723._m14);
        }
        _3619 = _3639;
        _3619 = _3619;
        float _3656 = dot(_723._m6, _3619);
        float _3651 = _10(_3656);
        bool _3660 = _3651 <= _3517;
        bool _3667;
        if (_3660)
        {
            _3667 = (_3621 & 48u) == 0u;
        }
        else
        {
            _3667 = _3660;
        }
        if (_3667)
        {
            continue;
        }
        uvec2 _3672 = _3342._m7.zw;
        vec4 _3671 = _107(_3672);
        float _3677 = TEXTURE_LOD(_3678, vec4((_3629 * _3671.xy) + _3671.zw, 0.0, 0.0).xy, vec4((_3629 * _3671.xy) + _3671.zw, 0.0, 0.0).w).x;
        float _3704 = _3677 * _3677;
        uint _3708 = _3621 & 3u;
        bool _3713 = _3708 == 1u;
        bool _3725;
        if (!_3713)
        {
            bool _3718 = _3708 == 0u;
            bool _3724;
            if (_3718)
            {
                _3724 = _3342._m8.z != 0.0;
            }
            else
            {
                _3724 = _3718;
            }
            _3725 = _3724;
        }
        else
        {
            _3725 = _3713;
        }
        bool _3711 = _3725;
        if (_3711)
        {
            float _3731 = _3342._m8.w;
            _3728 = _10(_3731);
        }
        else
        {
            _3728 = 0.5;
        }
        float _3726 = _3728;
        bool _3739 = _3708 == 0u;
        bool _3745;
        if (_3739)
        {
            _3745 = _3342._m8.z != 0.0;
        }
        else
        {
            _3745 = _3739;
        }
        if (_3745)
        {
            float _3754 = sqrt(dot(_3624, _3624));
            _3746 = min(0.9921875, _10(_3754));
        }
        else
        {
            _3746 = _3531.z;
        }
        float _3737 = _3746;
        uvec2 _3762 = _3342._m7.xy;
        vec4 _3761 = _107(_3762);
        vec2 _3767 = vec2(_3737, _3726);
        float _3771 = TEXTURE_LOD(_3678, vec4((_3767 * _3761.xy) + _3761.zw, 0.0, 0.0).xy, vec4((_3767 * _3761.xy) + _3761.zw, 0.0, 0.0).w).x;
        _3771 *= _3771;
        _3617 = _3771 * _3704;
        if ((_3621 & 48u) != 0u)
        {
            vec4 _3808 = _3342._m10;
            vec4 _3811 = _3342._m8;
            vec4 _3814 = _3342._m9;
            float _3817 = dot(_723._m14, _3808.xyz) + _3808.w;
            if (_3817 < 0.0)
            {
                continue;
            }
            float _3831 = length(_3808.xyz);
            float _3838 = _3817 * 50.0;
            float _3835 = _10(_3838);
            _3617 *= (_3835 * _3835);
            _3817 /= _3831;
            _3808 /= vec4(_3831);
            vec3 _3852 = reflect(-_723._m13, _723._m6);
            if (dot(_3852, _3808.xyz) > 0.0)
            {
                _3852 = reflect(_3852, _3808.xyz);
            }
            float _3870 = dot(_3852, _3808.xyz);
            float _3875 = _3817 / _3870;
            vec3 _3879 = _723._m14 - (_3852 * _3875);
            vec3 _3886 = _3879 - _3614;
            float _3890 = dot(_3886, _3811.xyz) / _3811.w;
            float _3898 = dot(_3886, _3814.xyz) / _3814.w;
            if ((_3621 & 48u) == 32u)
            {
                vec2 _3911 = vec2(_3890, _3898);
                float _3915 = 1.0 / max(1.0, length(vec2(_3890, _3898)));
                _3890 *= (_3915 * _3811.w);
                _3898 *= (_3915 * _3814.w);
            }
            else
            {
                float _3937 = abs(_3890);
                float _3939 = _3890;
                _3890 = (_10(_3937) * _87(_3939)) * _3811.w;
                float _3948 = abs(_3898);
                float _3950 = _3898;
                _3898 = (_10(_3948) * _87(_3950)) * _3814.w;
            }
            vec3 _3957 = (_3811.xyz * _3890) + (_3814.xyz * _3898);
            _3614 += _3957;
            _3619 = normalize(_3614 - _723._m14);
            _3619 = _3619;
        }
        else
        {
            uint _3977 = (_3342._m14 >> uint(16)) & 255u;
            if (_3977 == 0u)
            {
                vec4 _3986 = _3342._m9;
                if (dot(_3986.xyz, _723._m14) < (_3986.w - _3517))
                {
                    continue;
                }
            }
            else
            {
                if (_3977 == 1u)
                {
                    vec3 _4007 = _3342._m9.xyz;
                    float _4012 = _3342._m9.w;
                    uint _4016 = _39(_4012);
                    vec3 _4011 = (((_101(_4016) * 2.0) - vec3(1.0)) * _4007) + _3614;
                    vec3 _4025 = abs((_723._m14 - _4011) / _4007);
                    float _4033 = _4025.x;
                    float _4036 = _4025.y;
                    float _4039 = _4025.z;
                    if (_50(_4033, _4036, _4039) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_3617 <= (_3517 / 256.0))
        {
            continue;
        }
        float _4055 = 1.0;
        if ((_3549 & 4u) != 0u)
        {
            float _4062 = float(_3342._m14 & 255u) / 255.0;
            float _4068 = 0.00999999977648258209228515625;
            vec3 _4070 = _723._m14 + (_723._m6 * _4068);
            uint _4078 = 0u;
            if ((_3549 & 3u) == 0u)
            {
                vec3 _4084 = _4070 - _3342._m2.xyz;
                float _4090 = _4084.x;
                float _4093 = _4084.y;
                float _4096 = _4084.z;
                _4078 = _61(_4090, _4093, _4096);
            }
            else
            {
                if ((_3549 & 3u) == 2u)
                {
                    float _4106 = 0.0;
                    for (; _4078 < 3u; _4078++)
                    {
                        int _4114 = 5;
                        _4117._m0 = _4121._m0[(uint(_4114) * ((_3549 >> uint(22)) + _4078)) + 0u];
                        _4117._m1 = _4121._m0[(uint(_4114) * ((_3549 >> uint(22)) + _4078)) + 1u];
                        _4117._m2 = _4121._m0[(uint(_4114) * ((_3549 >> uint(22)) + _4078)) + 2u];
                        _4117._m3 = _4121._m0[(uint(_4114) * ((_3549 >> uint(22)) + _4078)) + 3u];
                        _4117._m4 = _4121._m0[(uint(_4114) * ((_3549 >> uint(22)) + _4078)) + 4u];
                        vec2 _4178 = vec2(dot(_4070, _4117._m0.xyz) + _4117._m0.w, dot(_4070, _4117._m1.xyz) + _4117._m1.w);
                        _4178 = abs((_4178 * 2.0) - vec2(1.0));
                        bool _4203 = _4178.x < 1.0;
                        bool _4209;
                        if (_4203)
                        {
                            _4209 = _4178.y < 1.0;
                        }
                        else
                        {
                            _4209 = _4203;
                        }
                        if (_4209)
                        {
                            _4106 = (1.0 - max(_4178.x, _4178.y)) * _755._m12.w;
                            break;
                        }
                    }
                    _4078 = min(2u, _4078);
                    uint _4226 = uint(_723._m16.x) ^ (uint(_723._m16.y) << uint(1));
                    if (_755._m13.w > 0.0)
                    {
                        _4238 = uint(_755._m14.x);
                    }
                    else
                    {
                        _4238 = 0u;
                    }
                    _4226 ^= _4238;
                    _4078 += uint(int(((float(_4226 & 3u) * 0.25) + 0.125) > _4106));
                }
            }
            int _4259 = 5;
            _4260._m0 = _4121._m0[(uint(_4259) * ((_3549 >> uint(22)) + _4078)) + 0u];
            _4260._m1 = _4121._m0[(uint(_4259) * ((_3549 >> uint(22)) + _4078)) + 1u];
            _4260._m2 = _4121._m0[(uint(_4259) * ((_3549 >> uint(22)) + _4078)) + 2u];
            _4260._m3 = _4121._m0[(uint(_4259) * ((_3549 >> uint(22)) + _4078)) + 3u];
            _4260._m4 = _4121._m0[(uint(_4259) * ((_3549 >> uint(22)) + _4078)) + 4u];
            vec4 _4316 = vec4((_4070.x * _4260._m0.x) + ((_4070.y * _4260._m0.y) + ((_4070.z * _4260._m0.z) + _4260._m0.w)), (_4070.x * _4260._m1.x) + ((_4070.y * _4260._m1.y) + ((_4070.z * _4260._m1.z) + _4260._m1.w)), (_4070.x * _4260._m2.x) + ((_4070.y * _4260._m2.y) + ((_4070.z * _4260._m2.z) + _4260._m2.w)), (_4070.x * _4260._m3.x) + ((_4070.y * _4260._m3.y) + ((_4070.z * _4260._m3.z) + _4260._m3.w)));
            vec3 _4403 = _4316.xyz / vec3(_4316.w);
            _4316 = vec4(_4403.x, _4403.y, _4403.z, _4316.w);
            bool _4411 = min(_4316.x, _4316.y) > 0.0;
            bool _4420;
            if (_4411)
            {
                _4420 = max(_4316.x, _4316.y) < 1.0;
            }
            else
            {
                _4420 = _4411;
            }
            if (_4420)
            {
                vec2 _4432 = (_4316.xy * _4260._m4.xy) + _4260._m4.zw;
                _4316 = vec4(_4432.x, _4432.y, _4316.z, _4316.w);
                if (false)
                {
                    _4055 = textureLod(_4440, vec3(_4316.xyz.xy, _4316.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4447 = (_4316.xy * _755._m15.xy) + vec2(0.5);
                    vec2 _4456 = floor(_4447);
                    vec2 _4459 = _4447 - _4456;
                    _4456 -= vec2(0.5);
                    vec2 _4466 = vec2(4.0) - (_4459 * 3.0);
                    vec2 _4472 = vec2(7.0);
                    vec2 _4475 = vec2(1.0) + (_4459 * 3.0);
                    vec2 _4480 = (_4456 + (((vec2(3.0) - (_4459 * 2.0)) / _4466) - vec2(2.0))) * _755._m15.zw;
                    vec2 _4495 = (_4456 + ((vec2(3.0) + _4459) / _4472)) * _755._m15.zw;
                    vec2 _4507 = (_4456 + ((_4459 / _4475) + vec2(2.0))) * _755._m15.zw;
                    vec3 _4531 = vec3(_4480.x, _4480.y, _4316.z);
                    _4055 = (_4466.x * _4466.y) * textureLod(_4440, vec3(_4531.xy, _4531.z), 0.0);
                    vec3 _4547 = vec3(_4495.x, _4480.y, _4316.z);
                    _4055 += ((_4472.x * _4466.y) * textureLod(_4440, vec3(_4547.xy, _4547.z), 0.0));
                    vec3 _4565 = vec3(_4507.x, _4480.y, _4316.z);
                    _4055 += ((_4475.x * _4466.y) * textureLod(_4440, vec3(_4565.xy, _4565.z), 0.0));
                    vec3 _4583 = vec3(_4480.x, _4495.y, _4316.z);
                    _4055 += ((_4466.x * _4472.y) * textureLod(_4440, vec3(_4583.xy, _4583.z), 0.0));
                    vec3 _4601 = vec3(_4495.x, _4495.y, _4316.z);
                    _4055 += ((_4472.x * _4472.y) * textureLod(_4440, vec3(_4601.xy, _4601.z), 0.0));
                    vec3 _4619 = vec3(_4507.x, _4495.y, _4316.z);
                    _4055 += ((_4475.x * _4472.y) * textureLod(_4440, vec3(_4619.xy, _4619.z), 0.0));
                    vec3 _4637 = vec3(_4480.x, _4507.y, _4316.z);
                    _4055 += ((_4466.x * _4475.y) * textureLod(_4440, vec3(_4637.xy, _4637.z), 0.0));
                    vec3 _4655 = vec3(_4495.x, _4507.y, _4316.z);
                    _4055 += ((_4472.x * _4475.y) * textureLod(_4440, vec3(_4655.xy, _4655.z), 0.0));
                    vec3 _4673 = vec3(_4507.x, _4507.y, _4316.z);
                    _4055 += ((_4475.x * _4475.y) * textureLod(_4440, vec3(_4673.xy, _4673.z), 0.0));
                    _4055 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _4055 = float((_3549 & 3u) == 2u);
            }
            float _4687 = float((_3549 >> uint(16)) & 63u) / 63.0;
            float _4701 = ((_4055 * _4687) + 1.0) - _4687;
            _4055 = _10(_4701);
        }
        uint _4704 = _3342._m12;
        vec3 _4703 = (_125(_4704) * _4055) * _3617;
        _3618 *= _3342._m13;
        vec3 _4716 = _4703;
        vec3 _4718 = _3619;
        float _4725 = dot(_723._m6, _4718);
        float _4720 = _10(_4725);
        vec3 _4731 = _723._m6;
        vec3 _4734 = _723._m13;
        vec3 _4737 = _3619;
        vec3 _4739 = _723._m2;
        float _4742 = abs(_723._m3);
        vec3 _4727 = _138(_4731, _4734, _4737, _4739, _4742);
        _723._m20 += (((_4727 * _3618) * _4716) * _4720);
        vec3 _4756 = mix(_4716, vec3(0.0), bvec3((_3549 & 256u) > 0u));
        _723._m19 += (_4756 * _4720);
    }
    _723._m19 = _723._m19;
    _723._m20 += _723._m10;
    float _4780 = 0.064999997615814208984375;
    float _4782 = 1.0 + _4780;
    bool _4785 = false;
    uint _4790;
    if (_755._m16.w > 0.00999999977648258209228515625)
    {
        _4790 = uint(_755._m16.x);
    }
    else
    {
        _4790 = 0u;
    }
    uint _4786 = _4790;
    _4808 _4810;
    for (uint _4798 = 0u; _4798 < _4786; _4798++)
    {
        int _4807 = 4;
        _4810._m0 = _4814._m0[(uint(_4807) * _4798) + 0u];
        _4810._m1 = _4814._m0[(uint(_4807) * _4798) + 1u];
        _4810._m2 = _4814._m0[(uint(_4807) * _4798) + 2u];
        float _4844 = _4814._m0[(uint(_4807) * _4798) + 3u].x;
        _4810._m3 = _39(_4844);
        float _4854 = _4814._m0[(uint(_4807) * _4798) + 3u].y;
        _4810._m4 = _39(_4854);
        float _4864 = _4814._m0[(uint(_4807) * _4798) + 3u].z;
        _4810._m5 = _39(_4864);
        vec4 _4869 = vec4(_723._m14, 1.0);
        vec3 _4876 = vec3(dot(_4869, _4810._m1), dot(_4869, _4810._m2), dot(_4869, _4810._m0));
        float _4890 = _4876.x;
        float _4893 = _4876.y;
        float _4896 = _4876.z;
        bool _4900 = _55(_4890, _4893, _4896) >= 0.0;
        bool _4909;
        if (_4900)
        {
            _4909 = max(_4876.x, _4876.y) < 1.0;
        }
        else
        {
            _4909 = _4900;
        }
        bool _4916;
        if (_4909)
        {
            _4916 = _4876.z < _4782;
        }
        else
        {
            _4916 = _4909;
        }
        if (_4916)
        {
            float _4919 = _4876.z;
            vec4 _4922 = vec4(_723._m14, 1.0);
            vec2 _4929 = vec2(0.0);
            _4929 = (((_4922.xy - _755._m17.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _4942 = 0.000244140625;
            float _4948 = abs(_723._m6.z) * 2.0;
            _4942 *= _10(_4948);
            vec3 _4952 = vec3(TEXTURE_LOD(_4953, vec4(_4929 + vec2(_4942), 0.0, 0.0).xy, vec4(_4929 + vec2(_4942), 0.0, 0.0).w).x, TEXTURE_LOD(_4953, vec4(_4929, 0.0, 0.0).xy, vec4(_4929, 0.0, 0.0).w).x, TEXTURE_LOD(_4953, vec4(_4929 - vec2(_4942), 0.0, 0.0).xy, vec4(_4929 - vec2(_4942), 0.0, 0.0).w).x);
            float _5016 = 2.0 - (2.0 * (length(_4922.xy - _755._m17.zw) / 16.0));
            _4952 *= _10(_5016);
            float _5023 = 1.0 - _4919;
            float _5020 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_5023));
            float _5034 = (_723._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _5026 = (_4952 * _5020) * _10(_5034);
            float _5043 = _4782 - _4919;
            float _5037 = (1.0 - _5020) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_5043));
            float _5057 = ((-_723._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _5047 = (_4952 * _5037) * _10(_5057);
            _4952 = _5026 + _5047;
            float _5068 = 1.02499997615814208984375 - _4919;
            float _5063 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_5068));
            float _5071 = _755._m16.w;
            _723._m19 = mix(_723._m19, (_723._m19 * _4952) + (_723._m19 * mix(1.0, 0.5, _5063)), vec3(_5071));
            break;
        }
    }
    _723._m19 *= _723._m0;
    _723._m21 = _723._m19 + _723._m20;
    vec3 _5111 = _723._m19 + _723._m20;
    _5106 = vec4(_5111.x, _5111.y, _5111.z, _5106.w);
    vec3 _5115 = _723._m6;
    bool _5118 = false;
    vec2 _5119 = _168(_5115, _5118);
    _5114 = vec4(_5119.x, _5119.y, _5114.z, _5114.w);
    float _5123 = _723._m2.x;
    float _5127 = _723._m2.y;
    float _5131 = _723._m2.z;
    float _5135 = _723._m3;
    _5122 = vec4(_90(_5123), _90(_5127), _90(_5131), _171(_5135));
    vec3 _5145 = _5106.xyz + _1784._m2.xyz;
    _5106 = vec4(_5145.x, _5145.y, _5145.z, _5106.w);
}


