// FIX FOR DECALS CLIPPING
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   
struct _723
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _999
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _1895
{
    int _m0;
    int _m1;
};

struct _1898
{
    int _m0;
    int _m1;
};

struct _2009
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2865
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _3640
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _4334
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 0, binding = 0, std140) uniform _744_746
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _746;

layout(set = 2, binding = 0, std140) uniform _847_849
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _849;

layout(set = 1, binding = 0, std140) uniform _1711_1713
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
} _1713;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1900_1902
{
    _1898 _m0[];
} _1902;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1984_1986
{
    uint _m0[];
} _1986;

layout(set = 0, binding = 15, std140) uniform _2014_2016
{
    vec4 _m0[4096];
} _2016;

layout(set = 0, binding = 16, std140) uniform _2034_2036
{
    vec4 _m0[4096];
} _2036;

layout(set = 0, binding = 17, std140) uniform _2086_2088
{
    vec4 _m0[4096];
} _2088;

layout(set = 0, binding = 19, std140) uniform _2869_2871
{
    vec4 _m0[4096];
} _2871;

layout(set = 0, binding = 20, std140) uniform _2908_2910
{
    vec4 _m0[4096];
} _2910;

layout(set = 0, binding = 21, std140) uniform _2977_2979
{
    vec4 _m0[3072];
} _2979;

layout(set = 0, binding = 23, std140) uniform _3644_3646
{
    vec4 _m0[4095];
} _3646;

layout(set = 0, binding = 25, std140) uniform _4338_4340
{
    vec4 _m0[4096];
} _4340;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4860_4862
{
    uint _m0[];
} _4862;

layout(set = 0, binding = 2, std430) restrict readonly buffer _4864_4866
{
    vec4 _m0[];
} _4866;

layout(push_constant, std430) uniform _4856_4858
{
    int _m0;
    int _m1;
} _4858;

layout(set = 3, binding = 3) uniform TEXTURE_2D _875[8];
layout(set = 0, binding = 6) uniform sampler _882;
layout(set = 3, binding = 2) uniform TEXTURE_2D _891[8];
layout(set = 0, binding = 7) uniform sampler _895;
layout(set = 3, binding = 0) uniform TEXTURE_2D _904[8];
layout(set = 0, binding = 8) uniform sampler _908;
layout(set = 3, binding = 1) uniform TEXTURE_2D _919[8];
layout(set = 0, binding = 9) uniform sampler _923;
layout(set = 3, binding = 7) uniform TEXTURE_2D _933[8];
layout(set = 0, binding = 10) uniform sampler _937;
layout(set = 3, binding = 4) uniform TEXTURE_2D _946[8];
layout(set = 0, binding = 11) uniform sampler _950;
layout(set = 3, binding = 6) uniform TEXTURE_2D _959[8];
layout(set = 0, binding = 12) uniform sampler _963;
layout(set = 1, binding = 1) uniform SAMPLER_2D _1720;
layout(set = 1, binding = 2) uniform SAMPLER_2D _1725;
layout(set = 0, binding = 18) uniform SAMPLER_2D _2307;
layout(set = 0, binding = 22) uniform SAMPLER_2D _3203;
layout(set = 0, binding = 24) uniform sampler2DShadow _3966;
layout(set = 0, binding = 26) uniform SAMPLER_2D _4479;
layout(set = 0, binding = 27) uniform SAMPLER_2D _4662;
layout(set = 3, binding = 5) uniform TEXTURE_2D _4855[8];
layout(set = 0, binding = 4) uniform sampler3D _4870;
layout(set = 0, binding = 5) uniform sampler3D _4871;

layout(location = 2) in vec4 _737;
layout(location = 6) in vec4 _751;
layout(location = 3) in vec4 _763;
layout(location = 4) in vec4 _766;
layout(location = 5) in vec4 _769;
layout(location = 10) in vec4 _787;
layout(location = 11) in vec4 _791;
layout(location = 12) in vec4 _795;
layout(location = 14) flat in uvec3 _808;
layout(location = 15) in vec4 _811;
layout(location = 8) in vec4 _1730;
layout(location = 0) out vec4 _4812;
layout(location = 1) out vec4 _4820;
layout(location = 2) out vec4 _4828;

float _268;

uvec4 _32(vec4 _31)
{
    return floatBitsToUint(_31);
}

float _52(float _51)
{
    if (_51 <= 0.040449999272823333740234375)
    {
        return _51 / 12.9200000762939453125;
    }
    else
    {
        return pow((_51 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

float _67(float _66)
{
    float _341 = _66;
    return _52(_341);
}

float _58(float _57)
{
    return _57 * ((_57 * ((_57 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _55(vec3 _54)
{
    float _270 = _54.x;
    vec3 _269;
    _269.x = _52(_270);
    float _276 = _54.y;
    _269.y = _52(_276);
    float _282 = _54.z;
    _269.z = _52(_282);
    return _269;
}

vec3 _70(vec3 _69)
{
    vec3 _346 = _69;
    return _55(_346);
}

float _139(float _135, vec4 _136, float _137, bool _138)
{
    float _578 = _136.w / (_135 + _136.z);
    return _578 * _137;
}

vec3 _144(vec3 _142, bool _143)
{
    vec3 _591 = (_142 * 2.0) - vec3(1.0);
    float _608 = (1.0 - (_591.x * _591.x)) - (_591.y * _591.y);
    _591.z = sqrt(_10(_608));
    if (_143 == false)
    {
        _591.z = -_591.z;
    }
    return _591;
}

vec3 _151(vec3 _149, mat3 _150)
{
    return normalize(vec3(dot(_149, _150[0]), dot(_149, _150[1]), dot(_149, _150[2])));
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

float _43(float _40, float _41, float _42)
{
    return min(_40, min(_41, _42));
}

float _38(float _35, float _36, float _37)
{
    return max(_35, max(_36, _37));
}

vec4 _89(uint _88)
{
    return unpackUnorm4x8(_88).wzyx;
}

vec4 _102(uvec2 _101)
{
    return vec4(float((_101.x >> uint(16)) & 65535u), float(_101.x & 65535u), float((_101.y >> uint(16)) & 65535u), float(_101.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _114(SAMPLER_2D _110, vec2 _111, vec2 _112, vec2 _113)
{
    return TEXTURE_GRAD(_110, _111, _112, _113);
}

vec4 _92(uint _91)
{
    return vec4(float((_91 >> uint(24)) & 255u), float((_91 >> uint(16)) & 255u), float((_91 >> uint(8)) & 255u), float(_91 & 255u));
}

vec3 _61(vec3 _60)
{
    float _305 = _60.x;
    vec3 _304;
    _304.x = _58(_305);
    float _310 = _60.y;
    _304.y = _58(_310);
    float _315 = _60.z;
    _304.z = _58(_315);
    return _304;
}

vec4 _64(vec4 _63)
{
    vec3 _324 = _63.xyz;
    vec4 _323 = vec4(_61(_324), 1.0);
    float _332 = _63.w;
    _323.w = _58(_332);
    return _323;
}

float _81(float _80)
{
    return (step(0.0, _80) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _96(uint _95)
{
    return vec3(float((_95 >> uint(21)) & 2047u), float((_95 >> uint(10)) & 2047u), float(_95 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _49(float _46, float _47, float _48)
{
    bool _209 = abs(_48) >= abs(_46);
    bool _217;
    if (_209)
    {
        _217 = abs(_48) >= abs(_47);
    }
    else
    {
        _217 = _209;
    }
    if (_217)
    {
        return uint((_48 < 0.0) ? 5 : 4);
    }
    if (abs(_47) >= abs(_46))
    {
        return uint((_47 < 0.0) ? 3 : 2);
    }
    return uint(int(_46 < 0.0));
}

float _73(float _72)
{
    return exp2(_72);
}

vec3 _117(uint _116)
{
    uint _452 = _116;
    vec4 _451 = _89(_452);
    float _463 = (_451.w * 255.0) - 128.0;
    return _451.xyz * _73(_463);
}

float _78(float _76, float _77)
{
    return pow(_76, _77);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _122(vec3 _120, float _121)
{
    float _475 = 50.0 * dot(_120, vec3(0.33329999446868896484375));
    float _468 = _10(_475);
    float _484 = 1.0 - _121;
    float _487 = _10(_484);
    float _488 = 5.0;
    vec3 _492 = _120 + ((vec3(_468) - _120) * _78(_487, _488));
    return _16(_492);
}

vec3 _130(vec3 _125, vec3 _126, vec3 _127, vec3 _128, float _129)
{
    vec3 _496 = normalize(_126 + _127);
    float _501 = 1.0 - (_129 * 0.800000011920928955078125);
    _501 *= _501;
    _501 *= _501;
    float _512 = _501 * _501;
    float _520 = dot(_125, _496);
    float _516 = _10(_520);
    float _522 = ((_516 * _516) * (_512 - 1.0)) + 1.0;
    _522 = _512 / ((_522 * _522) + 9.9999999392252902907785028219223e-09);
    float _541 = dot(_125, _126);
    float _537 = (_10(_541) * (1.0 - _501)) + _501;
    float _552 = dot(_125, _127);
    float _548 = (_10(_552) * (1.0 - _501)) + _501;
    _522 /= (((4.0 * _537) * _548) + 9.9999999392252902907785028219223e-09);
    vec3 _570 = _128;
    float _572 = dot(_127, _496);
    return _122(_570, _572) * _522;
}

vec2 _155(vec2 _154)
{
    return (vec2(1.0) - abs(_154.yx)) * vec2((_154.x >= 0.0) ? 1.0 : (-1.0), (_154.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _160(inout vec3 _158, bool _159)
{
    _158 /= vec3((abs(_158.x) + abs(_158.y)) + abs(_158.z));
    vec2 _672;
    if (_158.z >= 0.0)
    {
        _672 = _158.xy;
    }
    else
    {
        vec2 _681 = _158.xy;
        _672 = _155(_681);
    }
    _158 = vec3(_672.x, _672.y, _158.z);
    if (_159)
    {
        vec2 _696 = (_158.xy * 0.5) + vec2(0.5);
        _158 = vec3(_696.x, _696.y, _158.z);
    }
    return _158.xy;
}

float _84(float _83)
{
    return sqrt(_83);
}

float _163(float _162)
{
    float _706 = abs(_162);
    float _703 = _84(_706);
    float _708;
    if (_162 > 0.0)
    {
        _708 = _703;
    }
    else
    {
        _708 = -_703;
    }
    return (_708 * 0.5) + 0.5;
}

void main()
{
    _723 _725 = _723(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _725._m15 = _737;
    _725._m16 = gl_FragCoord;
    _725._m14 = _746._m2.xyz + _751.xyz;
    _725._m13 = normalize(-_751.xyz);
    _725._m17 = mat3(vec3(_763.xyz), vec3(_766.xyz), vec3(_769.xyz));
    _725._m34 = _787;
    _725._m35 = _791;
    _725._m36 = _795;
    uint _798 = 0u;
    vec4 _799 = vec4(0.0);
    vec4 _800 = vec4(0.0);
    vec4 _801 = vec4(0.0);
    vec4 _802 = vec4(0.0);
    vec4 _803 = vec4(0.0);
    uvec3 _806 = _808;
    vec3 _810 = _811.xyz;
    bool _817 = _806.y == 65535u;
    bool _823;
    if (_817)
    {
        _823 = _806.z == 65535u;
    }
    else
    {
        _823 = _817;
    }
    bool _814 = _823;
    bool _824 = !_814;
    bool _827 = _806.z != 65535u;
    uint _831 = _806.x & 7u;
    uint _842;
    if (_746._m4.x == 0.0)
    {
        _842 = _831;
    }
    else
    {
        vec4 _851 = _849._m6;
        uvec4 _846 = _32(_851);
        uint _855 = _846[_831 / 2u];
        uint _860 = 16u * (_831 & 1u);
        _842 = (_855 >> _860) & 65535u;
    }
    uint _869 = _842;
    float _871 = texture(SAMPLER_2D(_875[_869], _882), _725._m15.zw).x;
    vec2 _890 = texture(SAMPLER_2D(_891[_869], _895), _725._m15.zw).yx;
    vec3 _903 = texture(SAMPLER_2D(_904[_869], _908), _725._m15.zw).xyz;
    vec3 _916 = vec3(0.039999999105930328369140625);
    _916 = texture(SAMPLER_2D(_919[_869], _923), _725._m15.zw).xyz;
    float _931 = 1.0;
    float _932 = texture(SAMPLER_2D(_933[_869], _937), _725._m15.zw).x;
    float _945 = texture(SAMPLER_2D(_946[_869], _950), _725._m15.zw).x;
    vec3 _958 = texture(SAMPLER_2D(_959[_869], _963), _725._m15.zw).xyz;
    _801 = vec4(_903.x, _903.y, _903.z, _801.w);
    _801.w = _890.y;
    _802 = vec4(_916.x, _916.y, _916.z, _802.w);
    _802.w = _945;
    _803 = vec4(_803.x, _890.x, _803.z, _890.y);
    _799.x = _932;
    _799.y = _931;
    _799.z = _945;
    _799.w = _871;
    _800 = vec4(_958.x, _958.y, _958.z, _800.w);
    vec2 _996 = _737.zw;
    _999 _1001;
    _1001._m0 = _801;
    _1001._m1 = _802;
    float _1006 = _799.x;
    _1001._m2.x = _67(_1006);
    _1001._m2 = vec4(_1001._m2.x, _799.yzw.x, _799.yzw.y, _799.yzw.z);
    _1001._m3 = _803;
    _1001._m4 = _800;
    _999 _1020 = _1001;
    vec3 _1022 = vec3(0.0);
    bool _1030;
    if (_824)
    {
        _1030 = _810.x < 65534.0;
    }
    else
    {
        _1030 = _824;
    }
    bool _1036;
    if (_1030)
    {
        _1036 = _810.x > 0.0;
    }
    else
    {
        _1036 = _1030;
    }
    if (_1036)
    {
        uint _1039 = 0u;
        _999 _1040 = _999(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1042 = _806.y & 7u;
        uint _1051;
        if (_746._m4.x == 0.0)
        {
            _1051 = _1042;
        }
        else
        {
            vec4 _1055 = _849._m6;
            uvec4 _1054 = _32(_1055);
            uint _1059 = _1054[_1042 / 2u];
            uint _1064 = 16u * (_1042 & 1u);
            _1051 = (_1059 >> _1064) & 65535u;
        }
        uint _1072 = _1051;
        float _1074 = texture(SAMPLER_2D(_875[_1072], _882), _996).x;
        vec2 _1083 = texture(SAMPLER_2D(_891[_1072], _895), _996).yx;
        vec3 _1092 = texture(SAMPLER_2D(_904[_1072], _908), _996).xyz;
        vec3 _1101 = vec3(0.039999999105930328369140625);
        _1101 = texture(SAMPLER_2D(_919[_1072], _923), _996).xyz;
        float _1110 = 1.0;
        float _1111 = texture(SAMPLER_2D(_933[_1072], _937), _996).x;
        float _1120 = texture(SAMPLER_2D(_946[_1072], _950), _996).x;
        vec3 _1129 = texture(SAMPLER_2D(_959[_1072], _963), _996).xyz;
        _1040._m0 = vec4(_1092.x, _1092.y, _1092.z, _1040._m0.w);
        _1040._m0.w = _1083.y;
        _1040._m1 = vec4(_1101.x, _1101.y, _1101.z, _1040._m1.w);
        _1040._m1.w = _1120;
        _1040._m3 = vec4(_1040._m3.x, _1083.x, _1040._m3.z, _1083.y);
        _1040._m2.x = _1111;
        _1040._m2.y = _1110;
        _1040._m2.z = _1120;
        _1040._m2.w = _1074;
        _1040._m4 = vec4(_1129.x, _1129.y, _1129.z, _1040._m4.w);
        float _1167 = _1040._m2.x;
        _1040._m2.x = _58(_1167);
        float _1172 = _1040._m1.w;
        float _1175 = _810.x * _1172;
        float _1180 = _1001._m2.x;
        float _1183 = 0.0;
        float _1184 = 0.0;
        float _1185 = (_1175 * 1.5) - 0.5;
        float _1193 = 1.0 - _1180;
        float _1190 = _10(_1193);
        float _1202 = ((_1190 + _1185) - 0.5) * 10.0;
        float _1195 = _10(_1202);
        _1183 = _1195;
        float _1205 = (_810.x * 1.5) - 0.5;
        float _1213 = 1.0 - _1180;
        float _1210 = _10(_1213);
        float _1221 = ((_1210 + _1205) - 0.5) * 10.0;
        float _1215 = _10(_1221);
        _1184 = _1215;
        _1020._m0 = mix(_1020._m0, _1040._m0, vec4(_1183));
        _1020._m1 = mix(_1020._m1, _1040._m1, vec4(_1183));
        _1020._m2 = mix(_1020._m2, _1040._m2, vec4(_1183));
        _1020._m3 = mix(_1020._m3, _1040._m3, vec4(_1183));
        _1020._m4 = mix(_1020._m4, _1040._m4, vec4(_1183));
        _798 = (_1183 > 0.5) ? _1039 : _798;
        _1022.x = _1183;
    }
    bool _1277;
    if (_827)
    {
        _1277 = _810.y < 65534.0;
    }
    else
    {
        _1277 = _827;
    }
    bool _1283;
    if (_1277)
    {
        _1283 = _810.y > 0.0;
    }
    else
    {
        _1283 = _1277;
    }
    if (_1283)
    {
        uint _1286 = 0u;
        _999 _1287 = _999(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1288 = _806.z & 7u;
        uint _1297;
        if (_746._m4.x == 0.0)
        {
            _1297 = _1288;
        }
        else
        {
            vec4 _1301 = _849._m6;
            uvec4 _1300 = _32(_1301);
            uint _1305 = _1300[_1288 / 2u];
            uint _1310 = 16u * (_1288 & 1u);
            _1297 = (_1305 >> _1310) & 65535u;
        }
        uint _1318 = _1297;
        float _1320 = texture(SAMPLER_2D(_875[_1318], _882), _996).x;
        vec2 _1329 = texture(SAMPLER_2D(_891[_1318], _895), _996).yx;
        vec3 _1338 = texture(SAMPLER_2D(_904[_1318], _908), _996).xyz;
        vec3 _1347 = vec3(0.039999999105930328369140625);
        _1347 = texture(SAMPLER_2D(_919[_1318], _923), _996).xyz;
        float _1356 = 1.0;
        float _1357 = texture(SAMPLER_2D(_933[_1318], _937), _996).x;
        float _1366 = texture(SAMPLER_2D(_946[_1318], _950), _996).x;
        vec3 _1375 = texture(SAMPLER_2D(_959[_1318], _963), _996).xyz;
        _1287._m0 = vec4(_1338.x, _1338.y, _1338.z, _1287._m0.w);
        _1287._m0.w = _1329.y;
        _1287._m1 = vec4(_1347.x, _1347.y, _1347.z, _1287._m1.w);
        _1287._m1.w = _1366;
        _1287._m3 = vec4(_1287._m3.x, _1329.x, _1287._m3.z, _1329.y);
        _1287._m2.x = _1357;
        _1287._m2.y = _1356;
        _1287._m2.z = _1366;
        _1287._m2.w = _1320;
        _1287._m4 = vec4(_1375.x, _1375.y, _1375.z, _1287._m4.w);
        float _1413 = _1287._m2.x;
        _1287._m2.x = _58(_1413);
        float _1418 = _1287._m1.w;
        float _1421 = _810.y * _1418;
        float _1426 = _1020._m2.x;
        float _1429 = 0.0;
        float _1430 = 0.0;
        float _1431 = (_1421 * 1.5) - 0.5;
        float _1438 = 1.0 - _1426;
        float _1435 = _10(_1438);
        float _1446 = ((_1435 + _1431) - 0.5) * 10.0;
        float _1440 = _10(_1446);
        _1429 = _1440;
        float _1449 = (_810.y * 1.5) - 0.5;
        float _1457 = 1.0 - _1426;
        float _1454 = _10(_1457);
        float _1465 = ((_1454 + _1449) - 0.5) * 10.0;
        float _1459 = _10(_1465);
        _1430 = _1459;
        _1020._m0 = mix(_1020._m0, _1287._m0, vec4(_1429));
        _1020._m1 = mix(_1020._m1, _1287._m1, vec4(_1429));
        _1020._m2 = mix(_1020._m2, _1287._m2, vec4(_1429));
        _1020._m3 = mix(_1020._m3, _1287._m3, vec4(_1429));
        _1020._m4 = mix(_1020._m4, _1287._m4, vec4(_1429));
        _798 = (_1429 > 0.5) ? _1286 : _798;
        _1022.y = _1429;
    }
    bool _1521;
    if (_824)
    {
        _1521 = _810.z > 0.0;
    }
    else
    {
        _1521 = _824;
    }
    if (_1521)
    {
        float _1524 = _810.z;
        float _1531 = 1.0 - _1020._m2.x;
        float _1527 = _10(_1531);
        float _1540 = ((_1527 - 0.5) * _1524) + _1524;
        float _1533 = _10(_1540);
        _1022.z = _1533;
        vec3 _1544 = _1020._m0.xyz * _1020._m0.xyz;
        float _1552 = 1.0 - _1020._m2.w;
        float _1564 = (_1533 - 0.0) / 0.3499999940395355224609375;
        vec3 _1569 = mix(_1020._m0.xyz, _1544, vec3(_10(_1564) * _1552));
        _1020._m0 = vec4(_1569.x, _1569.y, _1569.z, _1020._m0.w);
        float _1580 = (_1533 - 0.25) / 0.25;
        vec3 _1583 = mix(_1020._m1.xyz, vec3(0.039999999105930328369140625), vec3(_10(_1580)));
        _1020._m1 = vec4(_1583.x, _1583.y, _1583.z, _1020._m1.w);
        vec3 _1587 = vec3(_725._m17[0].z, _725._m17[1].z, _725._m17[2].z);
        float _1601 = _1587.z + 0.0625;
        float _1595 = _1533 * _10(_1601);
        float _1611 = (_1595 - 0.20000000298023223876953125) / 0.800000011920928955078125;
        _1020._m2.w = mix(_1020._m2.w, 0.89999997615814208984375, _10(_1611));
        float _1624 = (_1595 - 0.449999988079071044921875) / 0.5299999713897705078125;
        vec3 _1627 = mix(_1020._m3.wyz, vec3(0.5, 0.5, 1.0), vec3(_10(_1624)));
        _1020._m3 = vec4(_1020._m3.x, _1627.y, _1627.z, _1627.x);
        if (_1595 > 0.980000019073486328125)
        {
            float _1641 = (_1595 - 0.980000019073486328125) / 0.0199999995529651641845703125;
            _1587 = normalize(mix(_1587, vec3(0.0, 0.0, 1.0), vec3(_10(_1641))));
            _725._m17[0].z = _1587.x;
            _725._m17[1].z = _1587.y;
            _725._m17[2].z = _1587.z;
        }
    }
    _801 = _1020._m0;
    _802 = _1020._m1;
    vec3 _1659;
    if (_824)
    {
        _1659 = vec3(0.0);
    }
    else
    {
        _1659 = _799.xyz;
    }
    _799 = vec4(_1659.x, _1659.y, _1659.z, _799.w);
    _799.w = _1020._m2.w;
    _803 = _1020._m3;
    _800 = _1020._m4;
    _725._m10 = vec3(_799.x) * _810;
    _725._m10 *= vec3(_746._m5.x);
    _725._m0 = _801.xyz;
    _725._m2 = _802.xyz;
    _725._m1 = _800.xyz;
    _725._m9 = _799.xyz;
    _725._m3 = _799.w;
    _725._m6 = _803.wyz;
    vec2 _1708 = _737.xy * _1713._m28.xy;
    vec4 _1719 = SAMPLE_TEXTURE(_1720, _1708);
    vec4 _1724 = SAMPLE_TEXTURE(_1725, _1708);
    float _1735 = _1730.x * 0.5;
    float _1729 = 1.0 - _10(_1735);
    float _1741 = _1729 * 2.0;
    float _1748 = (_10(_1741) - (1.0 - _1719.w)) * 1.0;
    float _1738 = _10(_1748);
    float _1757 = (_1729 - (1.0 - _1724.w)) * 1.0;
    float _1750 = _10(_1757);
    vec3 _1761 = _1719.xyz;
    _725._m0 = mix(_725._m0, _70(_1761), vec3(_1738));
    _725._m2 = mix(_725._m2, vec3(0.0199999995529651641845703125), vec3(_1738));
    _725._m3 = mix(_725._m3, 0.64999997615814208984375, _1738);
    _725._m6 = mix(_725._m6, _1724.xyz, vec3(_1750));
    uint _1790 = uint((_1713._m29.x > 0.0) ? 8 : 0);
    float _1797 = 16.0;
    float _1799 = 8.0;
    float _1801 = 24.0;
    vec2 _1810 = _725._m16.xy * _746._m6.xy;
    vec3 _1803;
    _1803 = vec3(_1810.x, _1810.y, _1803.z);
    _1803.y = 1.0 - _1803.y;
     // FIX FOR DECALS CLIPPING
    //clusterCoordinate.x -= vk3d_params[VIEW].stereo.x * 0.5;
   _1803.x -= vk3d_params[VIEW].stereo.x * 0.5;
    vec2 _1823 = floor(_1803.xy * vec2(_1797, _1799));
    _1803 = vec3(_1823.x, _1823.y, _1803.z);
    float _1828 = _725._m16.z;
    vec4 _1831 = _746._m7;
    float _1834 = 1.0;
    bool _1835 = false;
    float _1826 = _139(_1828, _1831, _1834, _1835);
    float _1837 = log2(max(1.0, _1826 / _746._m8.z)) * _746._m8.w;
    _1803.z = min(_1801 - 1.0, floor(_1837));
    uint _1853 = uint((_1803.x + (_1803.y * _1797)) + ((_1803.z * _1797) * _1799));
    bool _1869 = true;
    vec3 _1871 = _725._m6;
    bool _1874 = _1869;
    _725._m7 = _144(_1871, _1874);
    vec3 _1878 = _725._m7;
    mat3 _1881 = _725._m17;
    _725._m6 = _151(_1878, _1881);
    uint _1886 = 0u;
    uint _1887 = 0u;
    uint _1888 = 0u;
    uint _1889 = 0u;
    uint _1890 = 0u;
    uint _1891 = 0u;
    int _1893 = 256;
    _1895 _1897;
    _1897._m0 = _1902._m0[_1853]._m0;
    _1897._m1 = _1902._m0[_1853]._m1;
    int _1911 = _1897._m0 & (~(_1897._m0 >> 31));
    int _1920 = _1897._m1 & (~(_1897._m1 >> 31));
    _1886 = uint((_1911 >> 16) * _1893);
    _1887 = _1886 + uint(_1920 & 255);
    _1888 = _1886;
    _1889 = _1888 + uint((_1920 >> 8) & 255);
    _1890 = _1886;
    _1891 = _1890 + uint((_1920 >> 16) & 255);
    vec3 _1953 = dFdx(_725._m14);
    vec3 _1957 = dFdy(_725._m14);
    bool _1962 = _1790 == 0u;
    bool _1968;
    if (_1962)
    {
        _1968 = _1713._m29.y == 0.0;
    }
    else
    {
        _1968 = _1962;
    }
    _1888 = _1968 ? _1889 : _1888;
    uint _1972 = _1888;
    _2009 _2011;
    vec3 _2361;
    float _2494;
    while (_1972 < _1889)
    {
        uint _1982 = _1986._m0[_1972];
        uint _1991 = (_1982 >> uint(12)) & 4095u;
        uint _1997 = _1991;
        if (_1997 >= _1991)
        {
            _1972++;
        }
        int _2006 = 2;
        int _2007 = 2;
        int _2008 = 2;
        _2011._m0 = _2016._m0[(uint(_2006) * _1997) + 0u];
        _2011._m1 = _2016._m0[(uint(_2006) * _1997) + 1u];
        _2011._m2 = _2036._m0[(uint(_2007) * _1997) + 0u];
        float _2050 = _2036._m0[(uint(_2007) * _1997) + 1u].x;
        _2011._m3.x = _27(_2050);
        float _2060 = _2036._m0[(uint(_2007) * _1997) + 1u].y;
        _2011._m3.y = _27(_2060);
        float _2070 = _2036._m0[(uint(_2007) * _1997) + 1u].z;
        _2011._m4.x = _27(_2070);
        float _2080 = _2036._m0[(uint(_2007) * _1997) + 1u].w;
        _2011._m4.y = _27(_2080);
        float _2094 = _2088._m0[(uint(_2008) * _1997) + 0u].x;
        _2011._m5.x = _27(_2094);
        float _2104 = _2088._m0[(uint(_2008) * _1997) + 0u].y;
        _2011._m5.y = _27(_2104);
        float _2114 = _2088._m0[(uint(_2008) * _1997) + 0u].z;
        _2011._m6 = _27(_2114);
        float _2124 = _2088._m0[(uint(_2008) * _1997) + 0u].w;
        _2011._m7 = _27(_2124);
        float _2134 = _2088._m0[(uint(_2008) * _1997) + 1u].x;
        _2011._m8 = _27(_2134);
        float _2144 = _2088._m0[(uint(_2008) * _1997) + 1u].y;
        _2011._m9 = _27(_2144);
        float _2154 = _2088._m0[(uint(_2008) * _1997) + 1u].z;
        _2011._m10 = _27(_2154);
        float _2165 = _2088._m0[(uint(_2008) * _1997) + 1u].w;
        _2011._m11 = _27(_2165);
        vec4 _2170 = _2011._m0;
        vec4 _2173 = _2011._m2;
        vec4 _2176 = _2011._m1;
        vec4 _2179 = vec4(_725._m14, 1.0);
        vec3 _2186 = vec3(dot(_2179, _2170), dot(_2179, _2176), dot(_2179, _2173));
        float _2197 = 0.0039215688593685626983642578125;
        float _2199 = _2186.x;
        float _2202 = _2186.y;
        float _2205 = _2186.z;
        bool _2210 = _43(_2199, _2202, _2205) <= _2197;
        bool _2227;
        if (!_2210)
        {
            float _2214 = _2186.x;
            float _2217 = _2186.y;
            float _2220 = _2186.z;
            _2227 = _38(_2214, _2217, _2220) >= (1.0 - _2197);
        }
        else
        {
            _2227 = _2210;
        }
        if (_2227)
        {
            continue;
        }
        uint _2231 = _2011._m11;
        bool _2235 = _1790 != 0u;
        bool _2242;
        if (_2235)
        {
            _2242 = (_2231 & 512u) != 0u;
        }
        else
        {
            _2242 = _2235;
        }
        bool _2255;
        if (!_2242)
        {
            bool _2247 = _1790 == 0u;
            bool _2254;
            if (_2247)
            {
                _2254 = (_2231 & 1024u) != 0u;
            }
            else
            {
                _2254 = _2247;
            }
            _2255 = _2254;
        }
        else
        {
            _2255 = _2242;
        }
        if (_2255)
        {
            continue;
        }
        vec2 _2259 = vec2(dot(_1953, _2170.xyz), dot(_1953, _2176.xyz));
        vec2 _2269 = vec2(dot(_1957, _2170.xyz), dot(_1957, _2176.xyz));
        float _2279 = 1.0;
        float _2280 = 1.0;
        vec3 _2281 = vec3(0.5, 0.5, 1.0);
        vec3 _2282 = vec3(0.0, 0.0, 1.0);
        uint _2283 = _2011._m7;
        uint _2287 = _2011._m9;
        vec4 _2286 = _89(_2287);
        uvec2 _2292 = _2011._m5;
        vec4 _2291 = _102(_2292);
        vec2 _2296 = _2259 * _2291.xy;
        vec2 _2301 = _2269 * _2291.xy;
        vec2 _2316 = (_2186.xy * _2291.xy) + _2291.zw;
        vec2 _2317 = _2296;
        vec2 _2319 = _2301;
        vec4 _2306 = _114(_2307, _2316, _2317, _2319);
        vec2 _2322 = (_2306.xy * 2.0) - vec2(1.0);
        float _2333 = 1.0 - dot(_2322, _2322);
        _2281 = vec3(_2322, sqrt(_10(_2333)));
        _2282 = _2281;
        _2279 = _2306.z;
        float _2342 = _2306.w;
        _2280 = _58(_2342);
        bool _2349 = _2280 <= (4.0 * _2197);
        bool _2356;
        if (_2349)
        {
            _2356 = _2286.w <= _2197;
        }
        else
        {
            _2356 = _2349;
        }
        if (_2356)
        {
            continue;
        }
        _2281 = _2282;
        if ((_2231 & 128u) != 0u)
        {
            _2361 = vec3(-_2281.x, -_2281.y, _2281.z);
        }
        else
        {
            _2361 = _2281;
        }
        _2281 = _2361;
        uint _2380 = _2011._m8;
        uint _2384 = _2380;
        float _2383 = 1.0 + (_92(_2384).w * 0.062745101749897003173828125);
        uint _2392 = _2283;
        float _2391 = _89(_2392).z;
        uint _2397 = _2380;
        vec3 _2396 = _89(_2397).xyz;
        float _2410 = _2383 - (_2383 * abs((_2186.z * 2.0) - 1.0));
        _2280 *= _10(_2410);
        float _2414 = _2280;
        if ((_2283 & 1u) != 0u)
        {
            vec3 _2421 = _2396;
            _2396 = vec3(0.0);
            uvec2 _2424 = _2011._m3;
            vec4 _2423 = _102(_2424);
            vec2 _2428 = _2259 * _2423.xy;
            vec2 _2433 = _2269 * _2423.xy;
            vec2 _2447 = (_2186.xy * _2423.xy) + _2423.zw;
            vec2 _2448 = _2428;
            vec2 _2450 = _2433;
            vec4 _2438 = _114(_2307, _2447, _2448, _2450);
            vec4 _2453 = _2438;
            _2438 = _64(_2453);
            _2396 = _2438.xyz;
            float _2465 = (_2438.w - _2197) / (1.0 - _2197);
            _2414 = _10(_2465);
            _2396 *= _2421;
        }
        vec3 _2470 = normalize(vec3(_725._m17[0].z, _725._m17[1].z, _725._m17[2].z));
        float _2479 = dot(_2470, normalize(_2173.xyz));
        float _2485 = _2479;
        vec2 _2490 = _2281.xy * _81(_2485);
        _2281 = vec3(_2490.x, _2490.y, _2281.z);
        if ((_2231 & 16384u) != 0u)
        {
            float _2503 = abs(_2479);
            _2494 = _10(_2503);
        }
        else
        {
            float _2506 = _2479;
            _2494 = _10(_2506);
        }
        float _2493 = _2494;
        float _2510 = ((_2493 * _2414) * _2286.w) * _2391;
        _725._m10 += (_2286.xyz * (_2510 * 64.0));
        uint _2529 = _2011._m10;
        uint _2533 = _2529;
        vec4 _2532 = _89(_2533);
        if ((_2283 & 2u) != 0u)
        {
            uvec2 _2542 = _2011._m4;
            vec4 _2541 = _102(_2542);
            vec2 _2546 = _2259 * _2541.xy;
            vec2 _2551 = _2269 * _2541.xy;
            vec2 _2564 = (_2186.xy * _2541.xy) + _2541.zw;
            vec2 _2565 = _2546;
            vec2 _2567 = _2551;
            _2532 = _114(_2307, _2564, _2565, _2567);
            _2532 *= _2532;
        }
        if ((_2283 & 32u) != 0u)
        {
            uint _2580 = _2283;
            float _2579 = _89(_2580).x;
            uint _2585 = _2283;
            float _2584 = _92(_2585).y;
            float _2591 = _2579;
            float _2589 = mix(_2584, 0.0, _10(_2591));
            float _2600 = _2279 - (_2589 / 255.0);
            float _2595 = float(_10(_2600) > 0.0);
            _2280 *= _2595;
        }
        float _2607 = _2280 * _2493;
        uint _2611 = _2011._m6;
        uint _2615 = _2611;
        vec4 _2620 = _89(_2615) * _2607;
        vec4 _2614 = _22(_2620);
        _725._m11 = max(_725._m11, _2614.x);
        _725._m0 = mix(_725._m0, _2396, _2614.xxx);
        _725._m2 = mix(_725._m2, _2532.xyz, _2614.yyy);
        vec3 _2643 = _2470;
        vec3 _2653 = _2170.xyz + (_2643 * dot(_2170.xyz, _2643));
        _2170 = vec4(_2653.x, _2653.y, _2653.z, _2170.w);
        vec3 _2664 = _2176.xyz + (_2643 * dot(_2176.xyz, _2643));
        _2176 = vec4(_2664.x, _2664.y, _2664.z, _2176.w);
        _2281 = ((normalize(_2170.xyz) * _2281.x) + (normalize(_2176.xyz) * _2281.y)) + (_2643 * _2281.z);
        if ((_2231 & 256u) != 0u)
        {
            vec3 _2691 = mix(_2470, _2281, _2614.www);
            float _2697 = dot(_2691, _2470);
            _2281 = (_725._m6 * _2697) + ((_2691 - (_2470 * _2697)) * dot(_725._m6, _2470));
        }
        else
        {
            if ((_2231 & 64u) != 0u)
            {
                _2281 = mix(mix(_725._m6, _2470, vec3(_2607)), _2281, _2614.www);
            }
            else
            {
                _2281 = mix(_725._m6, _2281, _2614.www);
            }
        }
        _725._m6 = normalize(_2281);
        _725._m3 = mix(_725._m3, _2532.w, _2614.z);
    }
    vec3 _2751 = vec3(0.0);
    vec3 _2752 = vec3(_725._m34.x, _725._m34.y, _725._m34.z);
    vec3 _2760 = vec3(_725._m34.w, _725._m35.x, _725._m35.y);
    vec3 _2768 = vec3(_725._m35.z, _725._m35.w, _725._m36.x);
    vec3 _2776 = vec3(_725._m36.y, _725._m36.z, _725._m36.w);
    vec3 _2784 = ((_2752 - (_2760 * _725._m6.y)) + (_2768 * _725._m6.z)) - (_2776 * _725._m6.x);
    float _2808 = _1713._m30.x * _746._m9.x;
    _2751 += max(_2784 * _10(_2808), vec3(0.0));
    float _2814;
    if (dot(_725._m10, vec3(1.0)) > 0.0)
    {
        _2814 = -_725._m3;
    }
    else
    {
        _2814 = _725._m3;
    }
    _725._m3 = _2814;
    _725._m18 = _2751;
    _725._m19 = _2751;
    uint _2836 = _1886;
    _2865 _2867;
    vec3 _3161;
    float _3252;
    float _3263;
    _3640 _3642;
    uint _3760;
    _3640 _3786;
    while (_2836 < _1887)
    {
        uint _2846 = _1986._m0[_2836];
        uint _2850 = _2846 & 4095u;
        uint _2853 = _2850;
        if (_2853 >= _2850)
        {
            _2836++;
        }
        int _2862 = 4;
        int _2863 = 4;
        int _2864 = 3;
        _2867._m0 = _2871._m0[(uint(_2862) * _2853) + 0u].xyz;
        float _2886 = _2871._m0[(uint(_2862) * _2853) + 0u].w;
        _2867._m1 = _27(_2886);
        _2867._m2 = _2871._m0[(uint(_2862) * _2853) + 1u];
        _2867._m3 = _2871._m0[(uint(_2862) * _2853) + 2u];
        _2867._m4 = _2910._m0[(uint(_2863) * _2853) + 0u];
        _2867._m5 = _2910._m0[(uint(_2863) * _2853) + 1u];
        _2867._m6 = _2910._m0[(uint(_2863) * _2853) + 2u];
        float _2940 = _2871._m0[(uint(_2862) * _2853) + 3u].x;
        _2867._m7.x = _27(_2940);
        float _2950 = _2871._m0[(uint(_2862) * _2853) + 3u].y;
        _2867._m7.y = _27(_2950);
        float _2960 = _2871._m0[(uint(_2862) * _2853) + 3u].z;
        _2867._m7.z = _27(_2960);
        float _2970 = _2871._m0[(uint(_2862) * _2853) + 3u].w;
        _2867._m7.w = _27(_2970);
        _2867._m8 = _2979._m0[(uint(_2864) * _2853) + 0u];
        _2867._m9 = _2979._m0[(uint(_2864) * _2853) + 1u];
        _2867._m10 = _2979._m0[(uint(_2864) * _2853) + 2u];
        float _3009 = _2910._m0[(uint(_2863) * _2853) + 3u].x;
        _2867._m11 = _27(_3009);
        float _3019 = _2910._m0[(uint(_2863) * _2853) + 3u].y;
        _2867._m12 = _27(_3019);
        _2867._m13 = _2910._m0[(uint(_2863) * _2853) + 3u].z;
        float _3037 = _2910._m0[(uint(_2863) * _2853) + 3u].w;
        _2867._m14 = _27(_3037);
        float _3042 = 0.0039215688593685626983642578125;
        vec4 _3043 = vec4(_725._m14, 1.0);
        float _3050 = 1.0 / dot(_3043, _2867._m6);
        vec3 _3056 = vec3(dot(_3043, _2867._m4) * _3050, dot(_3043, _2867._m5) * _3050, dot(_3043, _2867._m3));
        uint _3074 = _2867._m1;
        uint _3077 = _1790;
        _3077 |= 64u;
        float _3081 = _3056.x;
        float _3084 = _3056.y;
        float _3087 = _3056.z;
        bool _3092 = _43(_3081, _3084, _3087) <= _3042;
        bool _3109;
        if (!_3092)
        {
            float _3096 = _3056.x;
            float _3099 = _3056.y;
            float _3102 = _3056.z;
            _3109 = _38(_3096, _3099, _3102) >= (1.0 - _3042);
        }
        else
        {
            _3109 = _3092;
        }
        bool _3117;
        if (!_3109)
        {
            _3117 = (_3074 & _3077) != 0u;
        }
        else
        {
            _3117 = _3109;
        }
        if (_3117)
        {
            continue;
        }
        if ((_3074 & 3u) == 2u)
        {
            vec2 _3136 = fract((_3056.xy * _746._m10.xy) + _746._m10.zw);
            _3056 = vec3(_3136.x, _3136.y, _3056.z);
        }
        vec3 _3139 = _2867._m0;
        float _3142 = 1.0;
        float _3143 = 1.0;
        vec3 _3144 = vec3(0.0, 0.0, 1.0);
        vec3 _3145 = vec3(0.0, 0.0, 1.0);
        uint _3146 = _2867._m1;
        vec3 _3149 = (_3056 * 2.0) - vec3(1.0);
        vec2 _3154 = _3056.xy;
        vec3 _3157 = _2867._m10.xyz;
        if ((_3146 & 3u) == 2u)
        {
            _3161 = _3157;
        }
        else
        {
            _3161 = normalize(_3139 - _725._m14);
        }
        _3144 = _3161;
        _3144 = _3144;
        float _3181 = dot(_725._m6, _3144);
        float _3176 = _10(_3181);
        bool _3185 = _3176 <= _3042;
        bool _3192;
        if (_3185)
        {
            _3192 = (_3146 & 48u) == 0u;
        }
        else
        {
            _3192 = _3185;
        }
        if (_3192)
        {
            continue;
        }
        uvec2 _3197 = _2867._m7.zw;
        vec4 _3196 = _102(_3197);
        float _3202 = TEXTURE_LOD(_3203, vec4((_3154 * _3196.xy) + _3196.zw, 0.0, 0.0).xy, vec4((_3154 * _3196.xy) + _3196.zw, 0.0, 0.0).w).x;
        float _3229 = _3202 * _3202;
        uint _3233 = _3146 & 3u;
        bool _3238 = _3233 == 1u;
        bool _3250;
        if (!_3238)
        {
            bool _3243 = _3233 == 0u;
            bool _3249;
            if (_3243)
            {
                _3249 = _2867._m8.z != 0.0;
            }
            else
            {
                _3249 = _3243;
            }
            _3250 = _3249;
        }
        else
        {
            _3250 = _3238;
        }
        bool _3236 = _3250;
        if (_3236)
        {
            float _3256 = _2867._m8.w;
            _3252 = _10(_3256);
        }
        else
        {
            _3252 = 0.5;
        }
        float _3251 = _3252;
        bool _3265 = _3233 == 0u;
        bool _3271;
        if (_3265)
        {
            _3271 = _2867._m8.z != 0.0;
        }
        else
        {
            _3271 = _3265;
        }
        if (_3271)
        {
            float _3279 = sqrt(dot(_3149, _3149));
            _3263 = min(0.9921875, _10(_3279));
        }
        else
        {
            _3263 = _3056.z;
        }
        float _3262 = _3263;
        uvec2 _3287 = _2867._m7.xy;
        vec4 _3286 = _102(_3287);
        vec2 _3292 = vec2(_3262, _3251);
        float _3296 = TEXTURE_LOD(_3203, vec4((_3292 * _3286.xy) + _3286.zw, 0.0, 0.0).xy, vec4((_3292 * _3286.xy) + _3286.zw, 0.0, 0.0).w).x;
        _3296 *= _3296;
        _3142 = _3296 * _3229;
        if ((_3146 & 48u) != 0u)
        {
            vec4 _3333 = _2867._m10;
            vec4 _3336 = _2867._m8;
            vec4 _3339 = _2867._m9;
            float _3342 = dot(_725._m14, _3333.xyz) + _3333.w;
            if (_3342 < 0.0)
            {
                continue;
            }
            float _3356 = length(_3333.xyz);
            float _3363 = _3342 * 50.0;
            float _3360 = _10(_3363);
            _3142 *= (_3360 * _3360);
            _3342 /= _3356;
            _3333 /= vec4(_3356);
            vec3 _3377 = reflect(-_725._m13, _725._m6);
            if (dot(_3377, _3333.xyz) > 0.0)
            {
                _3377 = reflect(_3377, _3333.xyz);
            }
            float _3395 = dot(_3377, _3333.xyz);
            float _3400 = _3342 / _3395;
            vec3 _3404 = _725._m14 - (_3377 * _3400);
            vec3 _3411 = _3404 - _3139;
            float _3415 = dot(_3411, _3336.xyz) / _3336.w;
            float _3423 = dot(_3411, _3339.xyz) / _3339.w;
            if ((_3146 & 48u) == 32u)
            {
                vec2 _3436 = vec2(_3415, _3423);
                float _3440 = 1.0 / max(1.0, length(vec2(_3415, _3423)));
                _3415 *= (_3440 * _3336.w);
                _3423 *= (_3440 * _3339.w);
            }
            else
            {
                float _3462 = abs(_3415);
                float _3464 = _3415;
                _3415 = (_10(_3462) * _81(_3464)) * _3336.w;
                float _3473 = abs(_3423);
                float _3475 = _3423;
                _3423 = (_10(_3473) * _81(_3475)) * _3339.w;
            }
            vec3 _3482 = (_3336.xyz * _3415) + (_3339.xyz * _3423);
            _3139 += _3482;
            _3144 = normalize(_3139 - _725._m14);
            _3144 = _3144;
        }
        else
        {
            uint _3502 = (_2867._m14 >> uint(16)) & 255u;
            if (_3502 == 0u)
            {
                vec4 _3511 = _2867._m9;
                if (dot(_3511.xyz, _725._m14) < (_3511.w - _3042))
                {
                    continue;
                }
            }
            else
            {
                if (_3502 == 1u)
                {
                    vec3 _3532 = _2867._m9.xyz;
                    float _3537 = _2867._m9.w;
                    uint _3541 = _27(_3537);
                    vec3 _3536 = (((_96(_3541) * 2.0) - vec3(1.0)) * _3532) + _3139;
                    vec3 _3550 = abs((_725._m14 - _3536) / _3532);
                    float _3558 = _3550.x;
                    float _3561 = _3550.y;
                    float _3564 = _3550.z;
                    if (_38(_3558, _3561, _3564) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_3142 <= (_3042 / 256.0))
        {
            continue;
        }
        float _3580 = 1.0;
        if ((_3074 & 4u) != 0u)
        {
            float _3587 = float(_2867._m14 & 255u) / 255.0;
            float _3593 = 0.00999999977648258209228515625;
            vec3 _3595 = _725._m14 + (_725._m6 * _3593);
            uint _3603 = 0u;
            if ((_3074 & 3u) == 0u)
            {
                vec3 _3609 = _3595 - _2867._m2.xyz;
                float _3615 = _3609.x;
                float _3618 = _3609.y;
                float _3621 = _3609.z;
                _3603 = _49(_3615, _3618, _3621);
            }
            else
            {
                if ((_3074 & 3u) == 2u)
                {
                    float _3631 = 0.0;
                    for (; _3603 < 3u; _3603++)
                    {
                        int _3639 = 5;
                        _3642._m0 = _3646._m0[(uint(_3639) * ((_3074 >> uint(22)) + _3603)) + 0u];
                        _3642._m1 = _3646._m0[(uint(_3639) * ((_3074 >> uint(22)) + _3603)) + 1u];
                        _3642._m2 = _3646._m0[(uint(_3639) * ((_3074 >> uint(22)) + _3603)) + 2u];
                        _3642._m3 = _3646._m0[(uint(_3639) * ((_3074 >> uint(22)) + _3603)) + 3u];
                        _3642._m4 = _3646._m0[(uint(_3639) * ((_3074 >> uint(22)) + _3603)) + 4u];
                        vec2 _3703 = vec2(dot(_3595, _3642._m0.xyz) + _3642._m0.w, dot(_3595, _3642._m1.xyz) + _3642._m1.w);
                        _3703 = abs((_3703 * 2.0) - vec2(1.0));
                        bool _3728 = _3703.x < 1.0;
                        bool _3734;
                        if (_3728)
                        {
                            _3734 = _3703.y < 1.0;
                        }
                        else
                        {
                            _3734 = _3728;
                        }
                        if (_3734)
                        {
                            _3631 = (1.0 - max(_3703.x, _3703.y)) * _746._m11.w;
                            break;
                        }
                    }
                    _3603 = min(2u, _3603);
                    uint _3751 = uint(_725._m16.x) ^ (uint(_725._m16.y) << uint(1));
                    if (_746._m12.w > 0.0)
                    {
                        _3760 = uint(_746._m13.x);
                    }
                    else
                    {
                        _3760 = 0u;
                    }
                    _3751 ^= _3760;
                    _3603 += uint(int(((float(_3751 & 3u) * 0.25) + 0.125) > _3631));
                }
            }
            int _3785 = 5;
            _3786._m0 = _3646._m0[(uint(_3785) * ((_3074 >> uint(22)) + _3603)) + 0u];
            _3786._m1 = _3646._m0[(uint(_3785) * ((_3074 >> uint(22)) + _3603)) + 1u];
            _3786._m2 = _3646._m0[(uint(_3785) * ((_3074 >> uint(22)) + _3603)) + 2u];
            _3786._m3 = _3646._m0[(uint(_3785) * ((_3074 >> uint(22)) + _3603)) + 3u];
            _3786._m4 = _3646._m0[(uint(_3785) * ((_3074 >> uint(22)) + _3603)) + 4u];
            vec4 _3842 = vec4((_3595.x * _3786._m0.x) + ((_3595.y * _3786._m0.y) + ((_3595.z * _3786._m0.z) + _3786._m0.w)), (_3595.x * _3786._m1.x) + ((_3595.y * _3786._m1.y) + ((_3595.z * _3786._m1.z) + _3786._m1.w)), (_3595.x * _3786._m2.x) + ((_3595.y * _3786._m2.y) + ((_3595.z * _3786._m2.z) + _3786._m2.w)), (_3595.x * _3786._m3.x) + ((_3595.y * _3786._m3.y) + ((_3595.z * _3786._m3.z) + _3786._m3.w)));
            vec3 _3929 = _3842.xyz / vec3(_3842.w);
            _3842 = vec4(_3929.x, _3929.y, _3929.z, _3842.w);
            bool _3937 = min(_3842.x, _3842.y) > 0.0;
            bool _3946;
            if (_3937)
            {
                _3946 = max(_3842.x, _3842.y) < 1.0;
            }
            else
            {
                _3946 = _3937;
            }
            if (_3946)
            {
                vec2 _3958 = (_3842.xy * _3786._m4.xy) + _3786._m4.zw;
                _3842 = vec4(_3958.x, _3958.y, _3842.z, _3842.w);
                if (false)
                {
                    _3580 = textureLod(_3966, vec3(_3842.xyz.xy, _3842.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3973 = (_3842.xy * _746._m14.xy) + vec2(0.5);
                    vec2 _3982 = floor(_3973);
                    vec2 _3985 = _3973 - _3982;
                    _3982 -= vec2(0.5);
                    vec2 _3992 = vec2(4.0) - (_3985 * 3.0);
                    vec2 _3998 = vec2(7.0);
                    vec2 _4001 = vec2(1.0) + (_3985 * 3.0);
                    vec2 _4006 = (_3982 + (((vec2(3.0) - (_3985 * 2.0)) / _3992) - vec2(2.0))) * _746._m14.zw;
                    vec2 _4021 = (_3982 + ((vec2(3.0) + _3985) / _3998)) * _746._m14.zw;
                    vec2 _4033 = (_3982 + ((_3985 / _4001) + vec2(2.0))) * _746._m14.zw;
                    vec3 _4057 = vec3(_4006.x, _4006.y, _3842.z);
                    _3580 = (_3992.x * _3992.y) * textureLod(_3966, vec3(_4057.xy, _4057.z), 0.0);
                    vec3 _4073 = vec3(_4021.x, _4006.y, _3842.z);
                    _3580 += ((_3998.x * _3992.y) * textureLod(_3966, vec3(_4073.xy, _4073.z), 0.0));
                    vec3 _4091 = vec3(_4033.x, _4006.y, _3842.z);
                    _3580 += ((_4001.x * _3992.y) * textureLod(_3966, vec3(_4091.xy, _4091.z), 0.0));
                    vec3 _4109 = vec3(_4006.x, _4021.y, _3842.z);
                    _3580 += ((_3992.x * _3998.y) * textureLod(_3966, vec3(_4109.xy, _4109.z), 0.0));
                    vec3 _4127 = vec3(_4021.x, _4021.y, _3842.z);
                    _3580 += ((_3998.x * _3998.y) * textureLod(_3966, vec3(_4127.xy, _4127.z), 0.0));
                    vec3 _4145 = vec3(_4033.x, _4021.y, _3842.z);
                    _3580 += ((_4001.x * _3998.y) * textureLod(_3966, vec3(_4145.xy, _4145.z), 0.0));
                    vec3 _4163 = vec3(_4006.x, _4033.y, _3842.z);
                    _3580 += ((_3992.x * _4001.y) * textureLod(_3966, vec3(_4163.xy, _4163.z), 0.0));
                    vec3 _4181 = vec3(_4021.x, _4033.y, _3842.z);
                    _3580 += ((_3998.x * _4001.y) * textureLod(_3966, vec3(_4181.xy, _4181.z), 0.0));
                    vec3 _4199 = vec3(_4033.x, _4033.y, _3842.z);
                    _3580 += ((_4001.x * _4001.y) * textureLod(_3966, vec3(_4199.xy, _4199.z), 0.0));
                    _3580 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3580 = float((_3074 & 3u) == 2u);
            }
            float _4213 = float((_3074 >> uint(16)) & 63u) / 63.0;
            float _4227 = ((_3580 * _4213) + 1.0) - _4213;
            _3580 = _10(_4227);
        }
        uint _4230 = _2867._m12;
        vec3 _4229 = (_117(_4230) * _3580) * _3142;
        _3143 *= _2867._m13;
        vec3 _4242 = _4229;
        vec3 _4244 = _3144;
        float _4251 = dot(_725._m6, _4244);
        float _4246 = _10(_4251);
        vec3 _4257 = _725._m6;
        vec3 _4260 = _725._m13;
        vec3 _4263 = _3144;
        vec3 _4265 = _725._m2;
        float _4268 = abs(_725._m3);
        vec3 _4253 = _130(_4257, _4260, _4263, _4265, _4268);
        _725._m20 += (((_4253 * _3143) * _4242) * _4246);
        vec3 _4282 = mix(_4242, vec3(0.0), bvec3((_3074 & 256u) > 0u));
        _725._m19 += (_4282 * _4246);
    }
    _725._m19 = _725._m19;
    _725._m20 += _725._m10;
    float _4306 = 0.064999997615814208984375;
    float _4308 = 1.0 + _4306;
    bool _4311 = false;
    uint _4313;
    if (_746._m15.w > 0.00999999977648258209228515625)
    {
        _4313 = uint(_746._m15.x);
    }
    else
    {
        _4313 = 0u;
    }
    uint _4312 = _4313;
    _4334 _4336;
    for (uint _4324 = 0u; _4324 < _4312; _4324++)
    {
        int _4333 = 4;
        _4336._m0 = _4340._m0[(uint(_4333) * _4324) + 0u];
        _4336._m1 = _4340._m0[(uint(_4333) * _4324) + 1u];
        _4336._m2 = _4340._m0[(uint(_4333) * _4324) + 2u];
        float _4370 = _4340._m0[(uint(_4333) * _4324) + 3u].x;
        _4336._m3 = _27(_4370);
        float _4380 = _4340._m0[(uint(_4333) * _4324) + 3u].y;
        _4336._m4 = _27(_4380);
        float _4390 = _4340._m0[(uint(_4333) * _4324) + 3u].z;
        _4336._m5 = _27(_4390);
        vec4 _4395 = vec4(_725._m14, 1.0);
        vec3 _4402 = vec3(dot(_4395, _4336._m1), dot(_4395, _4336._m2), dot(_4395, _4336._m0));
        float _4416 = _4402.x;
        float _4419 = _4402.y;
        float _4422 = _4402.z;
        bool _4426 = _43(_4416, _4419, _4422) >= 0.0;
        bool _4435;
        if (_4426)
        {
            _4435 = max(_4402.x, _4402.y) < 1.0;
        }
        else
        {
            _4435 = _4426;
        }
        bool _4442;
        if (_4435)
        {
            _4442 = _4402.z < _4308;
        }
        else
        {
            _4442 = _4435;
        }
        if (_4442)
        {
            float _4445 = _4402.z;
            vec4 _4448 = vec4(_725._m14, 1.0);
            vec2 _4455 = vec2(0.0);
            _4455 = (((_4448.xy - _746._m16.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _4468 = 0.000244140625;
            float _4474 = abs(_725._m6.z) * 2.0;
            _4468 *= _10(_4474);
            vec3 _4478 = vec3(TEXTURE_LOD(_4479, vec4(_4455 + vec2(_4468), 0.0, 0.0).xy, vec4(_4455 + vec2(_4468), 0.0, 0.0).w).x, TEXTURE_LOD(_4479, vec4(_4455, 0.0, 0.0).xy, vec4(_4455, 0.0, 0.0).w).x, TEXTURE_LOD(_4479, vec4(_4455 - vec2(_4468), 0.0, 0.0).xy, vec4(_4455 - vec2(_4468), 0.0, 0.0).w).x);
            float _4542 = 2.0 - (2.0 * (length(_4448.xy - _746._m16.zw) / 16.0));
            _4478 *= _10(_4542);
            float _4549 = 1.0 - _4445;
            float _4546 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_4549));
            float _4560 = (_725._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _4552 = (_4478 * _4546) * _10(_4560);
            float _4569 = _4308 - _4445;
            float _4563 = (1.0 - _4546) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_4569));
            float _4583 = ((-_725._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _4573 = (_4478 * _4563) * _10(_4583);
            _4478 = _4552 + _4573;
            float _4594 = 1.02499997615814208984375 - _4445;
            float _4589 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_4594));
            float _4597 = _746._m15.w;
            _725._m19 = mix(_725._m19, (_725._m19 * _4478) + (_725._m19 * mix(1.0, 0.5, _4589)), vec3(_4597));
            break;
        }
    }
    _725._m19 *= _725._m0;
    _725._m21 = _725._m19 + _725._m20;
    vec3 _4631 = vec3(0.0);
    if (_1713._m31.w > 0.0)
    {
        vec4 _4637 = vec4(0.0030000000260770320892333984375, 0.00999999977648258209228515625, 0.0500000007450580596923828125, 0.300000011920928955078125);
        vec2 _4642 = abs(vec2(1.0) / _746._m6.zw);
        vec2 _4648 = ((gl_FragCoord.xy * 1.5) * _746._m6.zw) * (_4642 / vec2(32.0));
        vec4 _4661 = TEXTURE_LOD(_4662, vec4((_4648 * _4637.xy) + (vec2(_746._m1.x * 0.75) * _4637.zw), 0.0, 0.0).xy, vec4((_4648 * _4637.xy) + (vec2(_746._m1.x * 0.75) * _4637.zw), 0.0, 0.0).w);
        float _4704 = (length(_751.xyz) - 10.0) * 2.0;
        float _4698 = 1.0 - _10(_4704);
        float _4707 = 1.0 - dot(_725._m6, normalize(-_751.xyz));
        float _4716 = 2.0;
        _4716 *= ((sin((_746._m1.x * 5.0) * 0.75) * 0.5) + 0.699999988079071044921875);
        _4716 *= _4716;
        _4716 *= _4707;
        _4707 *= _4707;
        float _4736 = (_4707 * _4707) * 9.9999997473787516355514526367188e-05;
        vec3 _4746 = _4661.xyz * _4661.xyz;
        _4661 = vec4(_4746.x, _4746.y, _4746.z, _4661.w);
        vec3 _4749 = _4661.xyz;
        float _4759 = (_4749.x * _4707) + _4736;
        vec3 _4752 = _1713._m31.xyz * _10(_4759);
        float _4766 = _4749.x;
        vec3 _4765 = _1713._m31.xyz * _10(_4766);
        vec3 _4774 = mix(_4752, _4765, vec3(0.0500000007450580596923828125));
        float _4784 = (0.5 * _4707) + _4736;
        vec3 _4779 = _1713._m31.xyz * _10(_4784);
        _4774 /= _746._m17.xyz;
        vec3 _4795 = (_4774 * _1713._m31.w) * 0.5;
        _4631 += (_4795 * _4698);
    }
    _725._m19 += _4631;
    vec3 _4817 = _725._m19 + _725._m20;
    _4812 = vec4(_4817.x, _4817.y, _4817.z, _4812.w);
    vec3 _4821 = _725._m6;
    bool _4824 = false;
    vec2 _4825 = _160(_4821, _4824);
    _4820 = vec4(_4825.x, _4825.y, _4820.z, _4820.w);
    float _4829 = _725._m2.x;
    float _4833 = _725._m2.y;
    float _4837 = _725._m2.z;
    float _4841 = _725._m3;
    _4828 = vec4(_84(_4829), _84(_4833), _84(_4837), _163(_4841));
    vec3 _4852 = _4812.xyz + _1713._m32.xyz;
    _4812 = vec4(_4852.x, _4852.y, _4852.z, _4812.w);
}

