// FIX FOR DECALS CLIPPING
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _663
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1100
{
    int _m0;
    int _m1;
};

struct _1103
{
    int _m0;
    int _m1;
};

struct _1214
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2069
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _2844
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _3539
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 0, binding = 0, std140) uniform _684_686
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _686;

layout(set = 2, binding = 0, std140) uniform _787_789
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _789;

layout(set = 1, binding = 0, std140) uniform _936_938
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
} _938;

layout(set = 0, binding = 12, std430) restrict readonly buffer _1105_1107
{
    _1103 _m0[];
} _1107;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1189_1191
{
    uint _m0[];
} _1191;

layout(set = 0, binding = 14, std140) uniform _1219_1221
{
    vec4 _m0[4096];
} _1221;

layout(set = 0, binding = 15, std140) uniform _1239_1241
{
    vec4 _m0[4096];
} _1241;

layout(set = 0, binding = 16, std140) uniform _1291_1293
{
    vec4 _m0[4096];
} _1293;

layout(set = 0, binding = 18, std140) uniform _2073_2075
{
    vec4 _m0[4096];
} _2075;

layout(set = 0, binding = 19, std140) uniform _2112_2114
{
    vec4 _m0[4096];
} _2114;

layout(set = 0, binding = 20, std140) uniform _2181_2183
{
    vec4 _m0[3072];
} _2183;

layout(set = 0, binding = 22, std140) uniform _2848_2850
{
    vec4 _m0[4095];
} _2850;

layout(set = 0, binding = 24, std140) uniform _3543_3545
{
    vec4 _m0[4096];
} _3545;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4068_4070
{
    vec4 _m0[];
} _4070;

layout(push_constant, std430) uniform _4064_4066
{
    int _m0;
    int _m1;
} _4066;

layout(set = 3, binding = 3) uniform TEXTURE_2D _814[8];
layout(set = 0, binding = 5) uniform sampler _821;
layout(set = 3, binding = 2) uniform TEXTURE_2D _830[8];
layout(set = 0, binding = 6) uniform sampler _834;
layout(set = 3, binding = 0) uniform TEXTURE_2D _843[8];
layout(set = 0, binding = 7) uniform sampler _847;
layout(set = 3, binding = 1) uniform TEXTURE_2D _858[8];
layout(set = 0, binding = 8) uniform sampler _862;
layout(set = 3, binding = 7) uniform TEXTURE_2D _872[8];
layout(set = 0, binding = 9) uniform sampler _876;
layout(set = 3, binding = 4) uniform TEXTURE_2D _885[8];
layout(set = 0, binding = 10) uniform sampler _889;
layout(set = 3, binding = 6) uniform TEXTURE_2D _898[8];
layout(set = 0, binding = 11) uniform sampler _902;
layout(set = 0, binding = 17) uniform SAMPLER_2D _1513;
layout(set = 0, binding = 21) uniform SAMPLER_2D _2407;
layout(set = 0, binding = 23) uniform sampler2DShadow _3171;
layout(set = 0, binding = 25) uniform SAMPLER_2D _3684;
layout(set = 0, binding = 26) uniform SAMPLER_2D _3870;
layout(set = 3, binding = 5) uniform TEXTURE_2D _4063[8];
layout(set = 0, binding = 3) uniform sampler3D _4074;
layout(set = 0, binding = 4) uniform sampler3D _4075;

layout(location = 2) in vec4 _677;
layout(location = 6) in vec4 _691;
layout(location = 3) in vec4 _703;
layout(location = 4) in vec4 _706;
layout(location = 5) in vec4 _709;
layout(location = 10) in vec4 _727;
layout(location = 11) in vec4 _731;
layout(location = 12) in vec4 _735;
layout(location = 14) flat in uvec3 _748;
layout(location = 15) in vec4 _751;
layout(location = 0) out vec4 _4021;
layout(location = 1) out vec4 _4029;
layout(location = 2) out vec4 _4037;

uvec4 _32(vec4 _31)
{
    return floatBitsToUint(_31);
}

float _127(float _123, vec4 _124, float _125, bool _126)
{
    float _518 = _124.w / (_123 + _124.z);
    return _518 * _125;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _132(vec3 _130, bool _131)
{
    vec3 _531 = (_130 * 2.0) - vec3(1.0);
    float _548 = (1.0 - (_531.x * _531.x)) - (_531.y * _531.y);
    _531.z = sqrt(_10(_548));
    if (_131 == false)
    {
        _531.z = -_531.z;
    }
    return _531;
}

vec3 _139(vec3 _137, mat3 _138)
{
    return normalize(vec3(dot(_137, _138[0]), dot(_137, _138[1]), dot(_137, _138[2])));
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

float _43(float _40, float _41, float _42)
{
    return min(_40, min(_41, _42));
}

float _38(float _35, float _36, float _37)
{
    return max(_35, max(_36, _37));
}

vec4 _77(uint _76)
{
    return unpackUnorm4x8(_76).wzyx;
}

vec4 _90(uvec2 _89)
{
    return vec4(float((_89.x >> uint(16)) & 65535u), float(_89.x & 65535u), float((_89.y >> uint(16)) & 65535u), float(_89.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _102(SAMPLER_2D _98, vec2 _99, vec2 _100, vec2 _101)
{
    return TEXTURE_GRAD(_98, _99, _100, _101);
}

float _52(float _51)
{
    return _51 * ((_51 * ((_51 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec4 _80(uint _79)
{
    return vec4(float((_79 >> uint(24)) & 255u), float((_79 >> uint(16)) & 255u), float((_79 >> uint(8)) & 255u), float(_79 & 255u));
}

vec3 _55(vec3 _54)
{
    float _252 = _54.x;
    vec3 _251;
    _251.x = _52(_252);
    float _258 = _54.y;
    _251.y = _52(_258);
    float _264 = _54.z;
    _251.z = _52(_264);
    return _251;
}

vec4 _58(vec4 _57)
{
    vec3 _274 = _57.xyz;
    vec4 _273 = vec4(_55(_274), 1.0);
    float _282 = _57.w;
    _273.w = _52(_282);
    return _273;
}

float _69(float _68)
{
    return (step(0.0, _68) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _84(uint _83)
{
    return vec3(float((_83 >> uint(21)) & 2047u), float((_83 >> uint(10)) & 2047u), float(_83 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _49(float _46, float _47, float _48)
{
    bool _197 = abs(_48) >= abs(_46);
    bool _205;
    if (_197)
    {
        _205 = abs(_48) >= abs(_47);
    }
    else
    {
        _205 = _197;
    }
    if (_205)
    {
        return uint((_48 < 0.0) ? 5 : 4);
    }
    if (abs(_47) >= abs(_46))
    {
        return uint((_47 < 0.0) ? 3 : 2);
    }
    return uint(int(_46 < 0.0));
}

float _61(float _60)
{
    return exp2(_60);
}

vec3 _105(uint _104)
{
    uint _392 = _104;
    vec4 _391 = _77(_392);
    float _403 = (_391.w * 255.0) - 128.0;
    return _391.xyz * _61(_403);
}

float _66(float _64, float _65)
{
    return pow(_64, _65);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _110(vec3 _108, float _109)
{
    float _415 = 50.0 * dot(_108, vec3(0.33329999446868896484375));
    float _408 = _10(_415);
    float _424 = 1.0 - _109;
    float _427 = _10(_424);
    float _428 = 5.0;
    vec3 _432 = _108 + ((vec3(_408) - _108) * _66(_427, _428));
    return _16(_432);
}

vec3 _118(vec3 _113, vec3 _114, vec3 _115, vec3 _116, float _117)
{
    vec3 _436 = normalize(_114 + _115);
    float _441 = 1.0 - (_117 * 0.800000011920928955078125);
    _441 *= _441;
    _441 *= _441;
    float _452 = _441 * _441;
    float _460 = dot(_113, _436);
    float _456 = _10(_460);
    float _462 = ((_456 * _456) * (_452 - 1.0)) + 1.0;
    _462 = _452 / ((_462 * _462) + 9.9999999392252902907785028219223e-09);
    float _481 = dot(_113, _114);
    float _477 = (_10(_481) * (1.0 - _441)) + _441;
    float _492 = dot(_113, _115);
    float _488 = (_10(_492) * (1.0 - _441)) + _441;
    _462 /= (((4.0 * _477) * _488) + 9.9999999392252902907785028219223e-09);
    vec3 _510 = _116;
    float _512 = dot(_115, _436);
    return _110(_510, _512) * _462;
}

vec2 _143(vec2 _142)
{
    return (vec2(1.0) - abs(_142.yx)) * vec2((_142.x >= 0.0) ? 1.0 : (-1.0), (_142.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _148(inout vec3 _146, bool _147)
{
    _146 /= vec3((abs(_146.x) + abs(_146.y)) + abs(_146.z));
    vec2 _612;
    if (_146.z >= 0.0)
    {
        _612 = _146.xy;
    }
    else
    {
        vec2 _621 = _146.xy;
        _612 = _143(_621);
    }
    _146 = vec3(_612.x, _612.y, _146.z);
    if (_147)
    {
        vec2 _636 = (_146.xy * 0.5) + vec2(0.5);
        _146 = vec3(_636.x, _636.y, _146.z);
    }
    return _146.xy;
}

float _72(float _71)
{
    return sqrt(_71);
}

float _151(float _150)
{
    float _646 = abs(_150);
    float _643 = _72(_646);
    float _648;
    if (_150 > 0.0)
    {
        _648 = _643;
    }
    else
    {
        _648 = -_643;
    }
    return (_648 * 0.5) + 0.5;
}

void main()
{
    _663 _665 = _663(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _665._m15 = _677;
    _665._m16 = gl_FragCoord;
    _665._m14 = _686._m2.xyz + _691.xyz;
    _665._m13 = normalize(-_691.xyz);
    _665._m17 = mat3(vec3(_703.xyz), vec3(_706.xyz), vec3(_709.xyz));
    _665._m34 = _727;
    _665._m35 = _731;
    _665._m36 = _735;
    uint _738 = 0u;
    vec4 _739 = vec4(0.0);
    vec4 _740 = vec4(0.0);
    vec4 _741 = vec4(0.0);
    vec4 _742 = vec4(0.0);
    vec4 _743 = vec4(0.0);
    uvec3 _746 = _748;
    vec3 _750 = _751.xyz;
    bool _757 = _746.y == 65535u;
    bool _763;
    if (_757)
    {
        _763 = _746.z == 65535u;
    }
    else
    {
        _763 = _757;
    }
    bool _754 = _763;
    bool _764 = !_754;
    bool _767 = _746.z != 65535u;
    uint _771 = _746.x & 7u;
    uint _782;
    if (_686._m4.x == 0.0)
    {
        _782 = _771;
    }
    else
    {
        vec4 _790 = _789._m4;
        uvec4 _786 = _32(_790);
        uint _794 = _786[_771 / 2u];
        uint _799 = 16u * (_771 & 1u);
        _782 = (_794 >> _799) & 65535u;
    }
    uint _808 = _782;
    float _810 = texture(SAMPLER_2D(_814[_808], _821), _665._m15.zw).x;
    vec2 _829 = texture(SAMPLER_2D(_830[_808], _834), _665._m15.zw).yx;
    vec3 _842 = texture(SAMPLER_2D(_843[_808], _847), _665._m15.zw).xyz;
    vec3 _855 = vec3(0.039999999105930328369140625);
    _855 = texture(SAMPLER_2D(_858[_808], _862), _665._m15.zw).xyz;
    float _870 = 1.0;
    float _871 = texture(SAMPLER_2D(_872[_808], _876), _665._m15.zw).x;
    float _884 = texture(SAMPLER_2D(_885[_808], _889), _665._m15.zw).x;
    vec3 _897 = texture(SAMPLER_2D(_898[_808], _902), _665._m15.zw).xyz;
    _741 = vec4(_842.x, _842.y, _842.z, _741.w);
    _741.w = _829.y;
    _742 = vec4(_855.x, _855.y, _855.z, _742.w);
    _742.w = _884;
    _743 = vec4(_743.x, _829.x, _743.z, _829.y);
    _739.x = _871;
    _739.y = _870;
    _739.z = _884;
    _739.w = _810;
    _740 = vec4(_897.x, _897.y, _897.z, _740.w);
    vec3 _935 = (_938._m8.xyz * _789._m5.xyz) * mix(_741.xyz, vec3(1.0), vec3(_938._m8.w));
    _665._m10 = vec3(((_789._m6.x * _739.x) * _739.x) * _938._m9.x) * _935;
    _665._m10 *= vec3(_686._m5.x);
    _665._m0 = _741.xyz;
    _665._m2 = _742.xyz;
    _665._m1 = _740.xyz;
    _665._m9 = _739.xyz;
    _665._m3 = _739.w;
    _665._m6 = _743.wyz;
    uint _996 = uint((_938._m10.x > 0.0) ? 8 : 0);
    float _1002 = 16.0;
    float _1004 = 8.0;
    float _1006 = 24.0;
    vec2 _1015 = _665._m16.xy * _686._m6.xy;
    vec3 _1008;
    _1008 = vec3(_1015.x, _1015.y, _1008.z);
    _1008.y = 1.0 - _1008.y;
   
     // FIX FOR DECALS CLIPPING
    //clusterCoordinate.x -= vk3d_params[VIEW].stereo.x * 0.5;
   _1008.x -= vk3d_params[VIEW].stereo.x * 0.5;
   
    vec2 _1028 = floor(_1008.xy * vec2(_1002, _1004));
    _1008 = vec3(_1028.x, _1028.y, _1008.z);
    float _1033 = _665._m16.z;
    vec4 _1036 = _686._m7;
    float _1039 = 1.0;
    bool _1040 = false;
    float _1031 = _127(_1033, _1036, _1039, _1040);
    float _1042 = log2(max(1.0, _1031 / _686._m8.z)) * _686._m8.w;
    _1008.z = min(_1006 - 1.0, floor(_1042));
    uint _1058 = uint((_1008.x + (_1008.y * _1002)) + ((_1008.z * _1002) * _1004));
    bool _1074 = true;
    vec3 _1076 = _665._m6;
    bool _1079 = _1074;
    _665._m7 = _132(_1076, _1079);
    vec3 _1083 = _665._m7;
    mat3 _1086 = _665._m17;
    _665._m6 = _139(_1083, _1086);
    uint _1091 = 0u;
    uint _1092 = 0u;
    uint _1093 = 0u;
    uint _1094 = 0u;
    uint _1095 = 0u;
    uint _1096 = 0u;
    int _1098 = 256;
    _1100 _1102;
    _1102._m0 = _1107._m0[_1058]._m0;
    _1102._m1 = _1107._m0[_1058]._m1;
    int _1116 = _1102._m0 & (~(_1102._m0 >> 31));
    int _1125 = _1102._m1 & (~(_1102._m1 >> 31));
    _1091 = uint((_1116 >> 16) * _1098);
    _1092 = _1091 + uint(_1125 & 255);
    _1093 = _1091;
    _1094 = _1093 + uint((_1125 >> 8) & 255);
    _1095 = _1091;
    _1096 = _1095 + uint((_1125 >> 16) & 255);
    vec3 _1158 = dFdx(_665._m14);
    vec3 _1162 = dFdy(_665._m14);
    bool _1167 = _996 == 0u;
    bool _1173;
    if (_1167)
    {
        _1173 = _938._m10.y == 0.0;
    }
    else
    {
        _1173 = _1167;
    }
    _1093 = _1173 ? _1094 : _1093;
    uint _1177 = _1093;
    _1214 _1216;
    vec3 _1567;
    float _1700;
    while (_1177 < _1094)
    {
        uint _1187 = _1191._m0[_1177];
        uint _1196 = (_1187 >> uint(12)) & 4095u;
        uint _1202 = _1196;
        if (_1202 >= _1196)
        {
            _1177++;
        }
        int _1211 = 2;
        int _1212 = 2;
        int _1213 = 2;
        _1216._m0 = _1221._m0[(uint(_1211) * _1202) + 0u];
        _1216._m1 = _1221._m0[(uint(_1211) * _1202) + 1u];
        _1216._m2 = _1241._m0[(uint(_1212) * _1202) + 0u];
        float _1255 = _1241._m0[(uint(_1212) * _1202) + 1u].x;
        _1216._m3.x = _27(_1255);
        float _1265 = _1241._m0[(uint(_1212) * _1202) + 1u].y;
        _1216._m3.y = _27(_1265);
        float _1275 = _1241._m0[(uint(_1212) * _1202) + 1u].z;
        _1216._m4.x = _27(_1275);
        float _1285 = _1241._m0[(uint(_1212) * _1202) + 1u].w;
        _1216._m4.y = _27(_1285);
        float _1299 = _1293._m0[(uint(_1213) * _1202) + 0u].x;
        _1216._m5.x = _27(_1299);
        float _1309 = _1293._m0[(uint(_1213) * _1202) + 0u].y;
        _1216._m5.y = _27(_1309);
        float _1319 = _1293._m0[(uint(_1213) * _1202) + 0u].z;
        _1216._m6 = _27(_1319);
        float _1329 = _1293._m0[(uint(_1213) * _1202) + 0u].w;
        _1216._m7 = _27(_1329);
        float _1339 = _1293._m0[(uint(_1213) * _1202) + 1u].x;
        _1216._m8 = _27(_1339);
        float _1349 = _1293._m0[(uint(_1213) * _1202) + 1u].y;
        _1216._m9 = _27(_1349);
        float _1359 = _1293._m0[(uint(_1213) * _1202) + 1u].z;
        _1216._m10 = _27(_1359);
        float _1370 = _1293._m0[(uint(_1213) * _1202) + 1u].w;
        _1216._m11 = _27(_1370);
        vec4 _1375 = _1216._m0;
        vec4 _1378 = _1216._m2;
        vec4 _1381 = _1216._m1;
        vec4 _1384 = vec4(_665._m14, 1.0);
        vec3 _1391 = vec3(dot(_1384, _1375), dot(_1384, _1381), dot(_1384, _1378));
        float _1402 = 0.0039215688593685626983642578125;
        float _1404 = _1391.x;
        float _1407 = _1391.y;
        float _1410 = _1391.z;
        bool _1415 = _43(_1404, _1407, _1410) <= _1402;
        bool _1432;
        if (!_1415)
        {
            float _1419 = _1391.x;
            float _1422 = _1391.y;
            float _1425 = _1391.z;
            _1432 = _38(_1419, _1422, _1425) >= (1.0 - _1402);
        }
        else
        {
            _1432 = _1415;
        }
        if (_1432)
        {
            continue;
        }
        uint _1436 = _1216._m11;
        bool _1440 = _996 != 0u;
        bool _1447;
        if (_1440)
        {
            _1447 = (_1436 & 512u) != 0u;
        }
        else
        {
            _1447 = _1440;
        }
        bool _1460;
        if (!_1447)
        {
            bool _1452 = _996 == 0u;
            bool _1459;
            if (_1452)
            {
                _1459 = (_1436 & 1024u) != 0u;
            }
            else
            {
                _1459 = _1452;
            }
            _1460 = _1459;
        }
        else
        {
            _1460 = _1447;
        }
        if (_1460)
        {
            continue;
        }
        vec2 _1464 = vec2(dot(_1158, _1375.xyz), dot(_1158, _1381.xyz));
        vec2 _1474 = vec2(dot(_1162, _1375.xyz), dot(_1162, _1381.xyz));
        float _1484 = 1.0;
        float _1485 = 1.0;
        vec3 _1486 = vec3(0.5, 0.5, 1.0);
        vec3 _1488 = vec3(0.0, 0.0, 1.0);
        uint _1489 = _1216._m7;
        uint _1493 = _1216._m9;
        vec4 _1492 = _77(_1493);
        uvec2 _1498 = _1216._m5;
        vec4 _1497 = _90(_1498);
        vec2 _1502 = _1464 * _1497.xy;
        vec2 _1507 = _1474 * _1497.xy;
        vec2 _1522 = (_1391.xy * _1497.xy) + _1497.zw;
        vec2 _1523 = _1502;
        vec2 _1525 = _1507;
        vec4 _1512 = _102(_1513, _1522, _1523, _1525);
        vec2 _1528 = (_1512.xy * 2.0) - vec2(1.0);
        float _1539 = 1.0 - dot(_1528, _1528);
        _1486 = vec3(_1528, sqrt(_10(_1539)));
        _1488 = _1486;
        _1484 = _1512.z;
        float _1548 = _1512.w;
        _1485 = _52(_1548);
        bool _1555 = _1485 <= (4.0 * _1402);
        bool _1562;
        if (_1555)
        {
            _1562 = _1492.w <= _1402;
        }
        else
        {
            _1562 = _1555;
        }
        if (_1562)
        {
            continue;
        }
        _1486 = _1488;
        if ((_1436 & 128u) != 0u)
        {
            _1567 = vec3(-_1486.x, -_1486.y, _1486.z);
        }
        else
        {
            _1567 = _1486;
        }
        _1486 = _1567;
        uint _1586 = _1216._m8;
        uint _1590 = _1586;
        float _1589 = 1.0 + (_80(_1590).w * 0.062745101749897003173828125);
        uint _1598 = _1489;
        float _1597 = _77(_1598).z;
        uint _1603 = _1586;
        vec3 _1602 = _77(_1603).xyz;
        float _1616 = _1589 - (_1589 * abs((_1391.z * 2.0) - 1.0));
        _1485 *= _10(_1616);
        float _1620 = _1485;
        if ((_1489 & 1u) != 0u)
        {
            vec3 _1627 = _1602;
            _1602 = vec3(0.0);
            uvec2 _1630 = _1216._m3;
            vec4 _1629 = _90(_1630);
            vec2 _1634 = _1464 * _1629.xy;
            vec2 _1639 = _1474 * _1629.xy;
            vec2 _1653 = (_1391.xy * _1629.xy) + _1629.zw;
            vec2 _1654 = _1634;
            vec2 _1656 = _1639;
            vec4 _1644 = _102(_1513, _1653, _1654, _1656);
            vec4 _1659 = _1644;
            _1644 = _58(_1659);
            _1602 = _1644.xyz;
            float _1671 = (_1644.w - _1402) / (1.0 - _1402);
            _1620 = _10(_1671);
            _1602 *= _1627;
        }
        vec3 _1676 = normalize(vec3(_665._m17[0].z, _665._m17[1].z, _665._m17[2].z));
        float _1685 = dot(_1676, normalize(_1378.xyz));
        float _1691 = _1685;
        vec2 _1696 = _1486.xy * _69(_1691);
        _1486 = vec3(_1696.x, _1696.y, _1486.z);
        if ((_1436 & 16384u) != 0u)
        {
            float _1709 = abs(_1685);
            _1700 = _10(_1709);
        }
        else
        {
            float _1712 = _1685;
            _1700 = _10(_1712);
        }
        float _1699 = _1700;
        float _1716 = ((_1699 * _1620) * _1492.w) * _1597;
        _665._m10 += (_1492.xyz * (_1716 * 64.0));
        uint _1735 = _1216._m10;
        uint _1739 = _1735;
        vec4 _1738 = _77(_1739);
        if ((_1489 & 2u) != 0u)
        {
            uvec2 _1748 = _1216._m4;
            vec4 _1747 = _90(_1748);
            vec2 _1752 = _1464 * _1747.xy;
            vec2 _1757 = _1474 * _1747.xy;
            vec2 _1770 = (_1391.xy * _1747.xy) + _1747.zw;
            vec2 _1771 = _1752;
            vec2 _1773 = _1757;
            _1738 = _102(_1513, _1770, _1771, _1773);
            _1738 *= _1738;
        }
        if ((_1489 & 32u) != 0u)
        {
            uint _1786 = _1489;
            float _1785 = _77(_1786).x;
            uint _1791 = _1489;
            float _1790 = _80(_1791).y;
            float _1797 = _1785;
            float _1795 = mix(_1790, 0.0, _10(_1797));
            float _1806 = _1484 - (_1795 / 255.0);
            float _1801 = float(_10(_1806) > 0.0);
            _1485 *= _1801;
        }
        float _1813 = _1485 * _1699;
        uint _1817 = _1216._m6;
        uint _1821 = _1817;
        vec4 _1826 = _77(_1821) * _1813;
        vec4 _1820 = _22(_1826);
        _665._m11 = max(_665._m11, _1820.x);
        _665._m0 = mix(_665._m0, _1602, _1820.xxx);
        _665._m2 = mix(_665._m2, _1738.xyz, _1820.yyy);
        vec3 _1849 = _1676;
        vec3 _1859 = _1375.xyz + (_1849 * dot(_1375.xyz, _1849));
        _1375 = vec4(_1859.x, _1859.y, _1859.z, _1375.w);
        vec3 _1870 = _1381.xyz + (_1849 * dot(_1381.xyz, _1849));
        _1381 = vec4(_1870.x, _1870.y, _1870.z, _1381.w);
        _1486 = ((normalize(_1375.xyz) * _1486.x) + (normalize(_1381.xyz) * _1486.y)) + (_1849 * _1486.z);
        if ((_1436 & 256u) != 0u)
        {
            vec3 _1897 = mix(_1676, _1486, _1820.www);
            float _1903 = dot(_1897, _1676);
            _1486 = (_665._m6 * _1903) + ((_1897 - (_1676 * _1903)) * dot(_665._m6, _1676));
        }
        else
        {
            if ((_1436 & 64u) != 0u)
            {
                _1486 = mix(mix(_665._m6, _1676, vec3(_1813)), _1486, _1820.www);
            }
            else
            {
                _1486 = mix(_665._m6, _1486, _1820.www);
            }
        }
        _665._m6 = normalize(_1486);
        _665._m3 = mix(_665._m3, _1738.w, _1820.z);
    }
    vec3 _1957 = vec3(0.0);
    vec3 _1958 = vec3(_665._m34.x, _665._m34.y, _665._m34.z);
    vec3 _1966 = vec3(_665._m34.w, _665._m35.x, _665._m35.y);
    vec3 _1974 = vec3(_665._m35.z, _665._m35.w, _665._m36.x);
    vec3 _1982 = vec3(_665._m36.y, _665._m36.z, _665._m36.w);
    vec3 _1990 = ((_1958 - (_1966 * _665._m6.y)) + (_1974 * _665._m6.z)) - (_1982 * _665._m6.x);
    float _2013 = _938._m11.x * _686._m9.x;
    _1957 += max(_1990 * _10(_2013), vec3(0.0));
    float _2019;
    if (dot(_665._m10, vec3(1.0)) > 0.0)
    {
        _2019 = -_665._m3;
    }
    else
    {
        _2019 = _665._m3;
    }
    _665._m3 = _2019;
    _665._m18 = _1957;
    _665._m19 = _1957;
    uint _2040 = _1091;
    _2069 _2071;
    vec3 _2365;
    float _2456;
    float _2467;
    _2844 _2846;
    uint _2964;
    _2844 _2991;
    while (_2040 < _1092)
    {
        uint _2050 = _1191._m0[_2040];
        uint _2054 = _2050 & 4095u;
        uint _2057 = _2054;
        if (_2057 >= _2054)
        {
            _2040++;
        }
        int _2066 = 4;
        int _2067 = 4;
        int _2068 = 3;
        _2071._m0 = _2075._m0[(uint(_2066) * _2057) + 0u].xyz;
        float _2090 = _2075._m0[(uint(_2066) * _2057) + 0u].w;
        _2071._m1 = _27(_2090);
        _2071._m2 = _2075._m0[(uint(_2066) * _2057) + 1u];
        _2071._m3 = _2075._m0[(uint(_2066) * _2057) + 2u];
        _2071._m4 = _2114._m0[(uint(_2067) * _2057) + 0u];
        _2071._m5 = _2114._m0[(uint(_2067) * _2057) + 1u];
        _2071._m6 = _2114._m0[(uint(_2067) * _2057) + 2u];
        float _2144 = _2075._m0[(uint(_2066) * _2057) + 3u].x;
        _2071._m7.x = _27(_2144);
        float _2154 = _2075._m0[(uint(_2066) * _2057) + 3u].y;
        _2071._m7.y = _27(_2154);
        float _2164 = _2075._m0[(uint(_2066) * _2057) + 3u].z;
        _2071._m7.z = _27(_2164);
        float _2174 = _2075._m0[(uint(_2066) * _2057) + 3u].w;
        _2071._m7.w = _27(_2174);
        _2071._m8 = _2183._m0[(uint(_2068) * _2057) + 0u];
        _2071._m9 = _2183._m0[(uint(_2068) * _2057) + 1u];
        _2071._m10 = _2183._m0[(uint(_2068) * _2057) + 2u];
        float _2213 = _2114._m0[(uint(_2067) * _2057) + 3u].x;
        _2071._m11 = _27(_2213);
        float _2223 = _2114._m0[(uint(_2067) * _2057) + 3u].y;
        _2071._m12 = _27(_2223);
        _2071._m13 = _2114._m0[(uint(_2067) * _2057) + 3u].z;
        float _2241 = _2114._m0[(uint(_2067) * _2057) + 3u].w;
        _2071._m14 = _27(_2241);
        float _2246 = 0.0039215688593685626983642578125;
        vec4 _2247 = vec4(_665._m14, 1.0);
        float _2254 = 1.0 / dot(_2247, _2071._m6);
        vec3 _2260 = vec3(dot(_2247, _2071._m4) * _2254, dot(_2247, _2071._m5) * _2254, dot(_2247, _2071._m3));
        uint _2278 = _2071._m1;
        uint _2281 = _996;
        _2281 |= 64u;
        float _2285 = _2260.x;
        float _2288 = _2260.y;
        float _2291 = _2260.z;
        bool _2296 = _43(_2285, _2288, _2291) <= _2246;
        bool _2313;
        if (!_2296)
        {
            float _2300 = _2260.x;
            float _2303 = _2260.y;
            float _2306 = _2260.z;
            _2313 = _38(_2300, _2303, _2306) >= (1.0 - _2246);
        }
        else
        {
            _2313 = _2296;
        }
        bool _2321;
        if (!_2313)
        {
            _2321 = (_2278 & _2281) != 0u;
        }
        else
        {
            _2321 = _2313;
        }
        if (_2321)
        {
            continue;
        }
        if ((_2278 & 3u) == 2u)
        {
            vec2 _2340 = fract((_2260.xy * _686._m10.xy) + _686._m10.zw);
            _2260 = vec3(_2340.x, _2340.y, _2260.z);
        }
        vec3 _2343 = _2071._m0;
        float _2346 = 1.0;
        float _2347 = 1.0;
        vec3 _2348 = vec3(0.0, 0.0, 1.0);
        vec3 _2349 = vec3(0.0, 0.0, 1.0);
        uint _2350 = _2071._m1;
        vec3 _2353 = (_2260 * 2.0) - vec3(1.0);
        vec2 _2358 = _2260.xy;
        vec3 _2361 = _2071._m10.xyz;
        if ((_2350 & 3u) == 2u)
        {
            _2365 = _2361;
        }
        else
        {
            _2365 = normalize(_2343 - _665._m14);
        }
        _2348 = _2365;
        _2348 = _2348;
        float _2385 = dot(_665._m6, _2348);
        float _2380 = _10(_2385);
        bool _2389 = _2380 <= _2246;
        bool _2396;
        if (_2389)
        {
            _2396 = (_2350 & 48u) == 0u;
        }
        else
        {
            _2396 = _2389;
        }
        if (_2396)
        {
            continue;
        }
        uvec2 _2401 = _2071._m7.zw;
        vec4 _2400 = _90(_2401);
        float _2406 = TEXTURE_LOD(_2407, vec4((_2358 * _2400.xy) + _2400.zw, 0.0, 0.0).xy, vec4((_2358 * _2400.xy) + _2400.zw, 0.0, 0.0).w).x;
        float _2433 = _2406 * _2406;
        uint _2437 = _2350 & 3u;
        bool _2442 = _2437 == 1u;
        bool _2454;
        if (!_2442)
        {
            bool _2447 = _2437 == 0u;
            bool _2453;
            if (_2447)
            {
                _2453 = _2071._m8.z != 0.0;
            }
            else
            {
                _2453 = _2447;
            }
            _2454 = _2453;
        }
        else
        {
            _2454 = _2442;
        }
        bool _2440 = _2454;
        if (_2440)
        {
            float _2460 = _2071._m8.w;
            _2456 = _10(_2460);
        }
        else
        {
            _2456 = 0.5;
        }
        float _2455 = _2456;
        bool _2469 = _2437 == 0u;
        bool _2475;
        if (_2469)
        {
            _2475 = _2071._m8.z != 0.0;
        }
        else
        {
            _2475 = _2469;
        }
        if (_2475)
        {
            float _2483 = sqrt(dot(_2353, _2353));
            _2467 = min(0.9921875, _10(_2483));
        }
        else
        {
            _2467 = _2260.z;
        }
        float _2466 = _2467;
        uvec2 _2491 = _2071._m7.xy;
        vec4 _2490 = _90(_2491);
        vec2 _2496 = vec2(_2466, _2455);
        float _2500 = TEXTURE_LOD(_2407, vec4((_2496 * _2490.xy) + _2490.zw, 0.0, 0.0).xy, vec4((_2496 * _2490.xy) + _2490.zw, 0.0, 0.0).w).x;
        _2500 *= _2500;
        _2346 = _2500 * _2433;
        if ((_2350 & 48u) != 0u)
        {
            vec4 _2537 = _2071._m10;
            vec4 _2540 = _2071._m8;
            vec4 _2543 = _2071._m9;
            float _2546 = dot(_665._m14, _2537.xyz) + _2537.w;
            if (_2546 < 0.0)
            {
                continue;
            }
            float _2560 = length(_2537.xyz);
            float _2567 = _2546 * 50.0;
            float _2564 = _10(_2567);
            _2346 *= (_2564 * _2564);
            _2546 /= _2560;
            _2537 /= vec4(_2560);
            vec3 _2581 = reflect(-_665._m13, _665._m6);
            if (dot(_2581, _2537.xyz) > 0.0)
            {
                _2581 = reflect(_2581, _2537.xyz);
            }
            float _2599 = dot(_2581, _2537.xyz);
            float _2604 = _2546 / _2599;
            vec3 _2608 = _665._m14 - (_2581 * _2604);
            vec3 _2615 = _2608 - _2343;
            float _2619 = dot(_2615, _2540.xyz) / _2540.w;
            float _2627 = dot(_2615, _2543.xyz) / _2543.w;
            if ((_2350 & 48u) == 32u)
            {
                vec2 _2640 = vec2(_2619, _2627);
                float _2644 = 1.0 / max(1.0, length(vec2(_2619, _2627)));
                _2619 *= (_2644 * _2540.w);
                _2627 *= (_2644 * _2543.w);
            }
            else
            {
                float _2666 = abs(_2619);
                float _2668 = _2619;
                _2619 = (_10(_2666) * _69(_2668)) * _2540.w;
                float _2677 = abs(_2627);
                float _2679 = _2627;
                _2627 = (_10(_2677) * _69(_2679)) * _2543.w;
            }
            vec3 _2686 = (_2540.xyz * _2619) + (_2543.xyz * _2627);
            _2343 += _2686;
            _2348 = normalize(_2343 - _665._m14);
            _2348 = _2348;
        }
        else
        {
            uint _2706 = (_2071._m14 >> uint(16)) & 255u;
            if (_2706 == 0u)
            {
                vec4 _2715 = _2071._m9;
                if (dot(_2715.xyz, _665._m14) < (_2715.w - _2246))
                {
                    continue;
                }
            }
            else
            {
                if (_2706 == 1u)
                {
                    vec3 _2736 = _2071._m9.xyz;
                    float _2741 = _2071._m9.w;
                    uint _2745 = _27(_2741);
                    vec3 _2740 = (((_84(_2745) * 2.0) - vec3(1.0)) * _2736) + _2343;
                    vec3 _2754 = abs((_665._m14 - _2740) / _2736);
                    float _2762 = _2754.x;
                    float _2765 = _2754.y;
                    float _2768 = _2754.z;
                    if (_38(_2762, _2765, _2768) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_2346 <= (_2246 / 256.0))
        {
            continue;
        }
        float _2784 = 1.0;
        if ((_2278 & 4u) != 0u)
        {
            float _2791 = float(_2071._m14 & 255u) / 255.0;
            float _2797 = 0.00999999977648258209228515625;
            vec3 _2799 = _665._m14 + (_665._m6 * _2797);
            uint _2807 = 0u;
            if ((_2278 & 3u) == 0u)
            {
                vec3 _2813 = _2799 - _2071._m2.xyz;
                float _2819 = _2813.x;
                float _2822 = _2813.y;
                float _2825 = _2813.z;
                _2807 = _49(_2819, _2822, _2825);
            }
            else
            {
                if ((_2278 & 3u) == 2u)
                {
                    float _2835 = 0.0;
                    for (; _2807 < 3u; _2807++)
                    {
                        int _2843 = 5;
                        _2846._m0 = _2850._m0[(uint(_2843) * ((_2278 >> uint(22)) + _2807)) + 0u];
                        _2846._m1 = _2850._m0[(uint(_2843) * ((_2278 >> uint(22)) + _2807)) + 1u];
                        _2846._m2 = _2850._m0[(uint(_2843) * ((_2278 >> uint(22)) + _2807)) + 2u];
                        _2846._m3 = _2850._m0[(uint(_2843) * ((_2278 >> uint(22)) + _2807)) + 3u];
                        _2846._m4 = _2850._m0[(uint(_2843) * ((_2278 >> uint(22)) + _2807)) + 4u];
                        vec2 _2907 = vec2(dot(_2799, _2846._m0.xyz) + _2846._m0.w, dot(_2799, _2846._m1.xyz) + _2846._m1.w);
                        _2907 = abs((_2907 * 2.0) - vec2(1.0));
                        bool _2932 = _2907.x < 1.0;
                        bool _2938;
                        if (_2932)
                        {
                            _2938 = _2907.y < 1.0;
                        }
                        else
                        {
                            _2938 = _2932;
                        }
                        if (_2938)
                        {
                            _2835 = (1.0 - max(_2907.x, _2907.y)) * _686._m11.w;
                            break;
                        }
                    }
                    _2807 = min(2u, _2807);
                    uint _2955 = uint(_665._m16.x) ^ (uint(_665._m16.y) << uint(1));
                    if (_686._m12.w > 0.0)
                    {
                        _2964 = uint(_686._m13.x);
                    }
                    else
                    {
                        _2964 = 0u;
                    }
                    _2955 ^= _2964;
                    _2807 += uint(int(((float(_2955 & 3u) * 0.25) + 0.125) > _2835));
                }
            }
            int _2990 = 5;
            _2991._m0 = _2850._m0[(uint(_2990) * ((_2278 >> uint(22)) + _2807)) + 0u];
            _2991._m1 = _2850._m0[(uint(_2990) * ((_2278 >> uint(22)) + _2807)) + 1u];
            _2991._m2 = _2850._m0[(uint(_2990) * ((_2278 >> uint(22)) + _2807)) + 2u];
            _2991._m3 = _2850._m0[(uint(_2990) * ((_2278 >> uint(22)) + _2807)) + 3u];
            _2991._m4 = _2850._m0[(uint(_2990) * ((_2278 >> uint(22)) + _2807)) + 4u];
            vec4 _3047 = vec4((_2799.x * _2991._m0.x) + ((_2799.y * _2991._m0.y) + ((_2799.z * _2991._m0.z) + _2991._m0.w)), (_2799.x * _2991._m1.x) + ((_2799.y * _2991._m1.y) + ((_2799.z * _2991._m1.z) + _2991._m1.w)), (_2799.x * _2991._m2.x) + ((_2799.y * _2991._m2.y) + ((_2799.z * _2991._m2.z) + _2991._m2.w)), (_2799.x * _2991._m3.x) + ((_2799.y * _2991._m3.y) + ((_2799.z * _2991._m3.z) + _2991._m3.w)));
            vec3 _3134 = _3047.xyz / vec3(_3047.w);
            _3047 = vec4(_3134.x, _3134.y, _3134.z, _3047.w);
            bool _3142 = min(_3047.x, _3047.y) > 0.0;
            bool _3151;
            if (_3142)
            {
                _3151 = max(_3047.x, _3047.y) < 1.0;
            }
            else
            {
                _3151 = _3142;
            }
            if (_3151)
            {
                vec2 _3163 = (_3047.xy * _2991._m4.xy) + _2991._m4.zw;
                _3047 = vec4(_3163.x, _3163.y, _3047.z, _3047.w);
                if (false)
                {
                    _2784 = textureLod(_3171, vec3(_3047.xyz.xy, _3047.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3178 = (_3047.xy * _686._m14.xy) + vec2(0.5);
                    vec2 _3187 = floor(_3178);
                    vec2 _3190 = _3178 - _3187;
                    _3187 -= vec2(0.5);
                    vec2 _3197 = vec2(4.0) - (_3190 * 3.0);
                    vec2 _3203 = vec2(7.0);
                    vec2 _3206 = vec2(1.0) + (_3190 * 3.0);
                    vec2 _3211 = (_3187 + (((vec2(3.0) - (_3190 * 2.0)) / _3197) - vec2(2.0))) * _686._m14.zw;
                    vec2 _3226 = (_3187 + ((vec2(3.0) + _3190) / _3203)) * _686._m14.zw;
                    vec2 _3238 = (_3187 + ((_3190 / _3206) + vec2(2.0))) * _686._m14.zw;
                    vec3 _3262 = vec3(_3211.x, _3211.y, _3047.z);
                    _2784 = (_3197.x * _3197.y) * textureLod(_3171, vec3(_3262.xy, _3262.z), 0.0);
                    vec3 _3278 = vec3(_3226.x, _3211.y, _3047.z);
                    _2784 += ((_3203.x * _3197.y) * textureLod(_3171, vec3(_3278.xy, _3278.z), 0.0));
                    vec3 _3296 = vec3(_3238.x, _3211.y, _3047.z);
                    _2784 += ((_3206.x * _3197.y) * textureLod(_3171, vec3(_3296.xy, _3296.z), 0.0));
                    vec3 _3314 = vec3(_3211.x, _3226.y, _3047.z);
                    _2784 += ((_3197.x * _3203.y) * textureLod(_3171, vec3(_3314.xy, _3314.z), 0.0));
                    vec3 _3332 = vec3(_3226.x, _3226.y, _3047.z);
                    _2784 += ((_3203.x * _3203.y) * textureLod(_3171, vec3(_3332.xy, _3332.z), 0.0));
                    vec3 _3350 = vec3(_3238.x, _3226.y, _3047.z);
                    _2784 += ((_3206.x * _3203.y) * textureLod(_3171, vec3(_3350.xy, _3350.z), 0.0));
                    vec3 _3368 = vec3(_3211.x, _3238.y, _3047.z);
                    _2784 += ((_3197.x * _3206.y) * textureLod(_3171, vec3(_3368.xy, _3368.z), 0.0));
                    vec3 _3386 = vec3(_3226.x, _3238.y, _3047.z);
                    _2784 += ((_3203.x * _3206.y) * textureLod(_3171, vec3(_3386.xy, _3386.z), 0.0));
                    vec3 _3404 = vec3(_3238.x, _3238.y, _3047.z);
                    _2784 += ((_3206.x * _3206.y) * textureLod(_3171, vec3(_3404.xy, _3404.z), 0.0));
                    _2784 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _2784 = float((_2278 & 3u) == 2u);
            }
            float _3418 = float((_2278 >> uint(16)) & 63u) / 63.0;
            float _3432 = ((_2784 * _3418) + 1.0) - _3418;
            _2784 = _10(_3432);
        }
        uint _3435 = _2071._m12;
        vec3 _3434 = (_105(_3435) * _2784) * _2346;
        _2347 *= _2071._m13;
        vec3 _3447 = _3434;
        vec3 _3449 = _2348;
        float _3456 = dot(_665._m6, _3449);
        float _3451 = _10(_3456);
        vec3 _3462 = _665._m6;
        vec3 _3465 = _665._m13;
        vec3 _3468 = _2348;
        vec3 _3470 = _665._m2;
        float _3473 = abs(_665._m3);
        vec3 _3458 = _118(_3462, _3465, _3468, _3470, _3473);
        _665._m20 += (((_3458 * _2347) * _3447) * _3451);
        vec3 _3487 = mix(_3447, vec3(0.0), bvec3((_2278 & 256u) > 0u));
        _665._m19 += (_3487 * _3451);
    }
    _665._m19 = _665._m19;
    _665._m20 += _665._m10;
    float _3511 = 0.064999997615814208984375;
    float _3513 = 1.0 + _3511;
    bool _3516 = false;
    uint _3518;
    if (_686._m15.w > 0.00999999977648258209228515625)
    {
        _3518 = uint(_686._m15.x);
    }
    else
    {
        _3518 = 0u;
    }
    uint _3517 = _3518;
    _3539 _3541;
    for (uint _3529 = 0u; _3529 < _3517; _3529++)
    {
        int _3538 = 4;
        _3541._m0 = _3545._m0[(uint(_3538) * _3529) + 0u];
        _3541._m1 = _3545._m0[(uint(_3538) * _3529) + 1u];
        _3541._m2 = _3545._m0[(uint(_3538) * _3529) + 2u];
        float _3575 = _3545._m0[(uint(_3538) * _3529) + 3u].x;
        _3541._m3 = _27(_3575);
        float _3585 = _3545._m0[(uint(_3538) * _3529) + 3u].y;
        _3541._m4 = _27(_3585);
        float _3595 = _3545._m0[(uint(_3538) * _3529) + 3u].z;
        _3541._m5 = _27(_3595);
        vec4 _3600 = vec4(_665._m14, 1.0);
        vec3 _3607 = vec3(dot(_3600, _3541._m1), dot(_3600, _3541._m2), dot(_3600, _3541._m0));
        float _3621 = _3607.x;
        float _3624 = _3607.y;
        float _3627 = _3607.z;
        bool _3631 = _43(_3621, _3624, _3627) >= 0.0;
        bool _3640;
        if (_3631)
        {
            _3640 = max(_3607.x, _3607.y) < 1.0;
        }
        else
        {
            _3640 = _3631;
        }
        bool _3647;
        if (_3640)
        {
            _3647 = _3607.z < _3513;
        }
        else
        {
            _3647 = _3640;
        }
        if (_3647)
        {
            float _3650 = _3607.z;
            vec4 _3653 = vec4(_665._m14, 1.0);
            vec2 _3660 = vec2(0.0);
            _3660 = (((_3653.xy - _686._m16.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _3673 = 0.000244140625;
            float _3679 = abs(_665._m6.z) * 2.0;
            _3673 *= _10(_3679);
            vec3 _3683 = vec3(TEXTURE_LOD(_3684, vec4(_3660 + vec2(_3673), 0.0, 0.0).xy, vec4(_3660 + vec2(_3673), 0.0, 0.0).w).x, TEXTURE_LOD(_3684, vec4(_3660, 0.0, 0.0).xy, vec4(_3660, 0.0, 0.0).w).x, TEXTURE_LOD(_3684, vec4(_3660 - vec2(_3673), 0.0, 0.0).xy, vec4(_3660 - vec2(_3673), 0.0, 0.0).w).x);
            float _3747 = 2.0 - (2.0 * (length(_3653.xy - _686._m16.zw) / 16.0));
            _3683 *= _10(_3747);
            float _3754 = 1.0 - _3650;
            float _3751 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_3754));
            float _3766 = (_665._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _3757 = (_3683 * _3751) * _10(_3766);
            float _3775 = _3513 - _3650;
            float _3769 = (1.0 - _3751) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_3775));
            float _3790 = ((-_665._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _3779 = (_3683 * _3769) * _10(_3790);
            _3683 = _3757 + _3779;
            float _3801 = 1.02499997615814208984375 - _3650;
            float _3796 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_3801));
            float _3804 = _686._m15.w;
            _665._m19 = mix(_665._m19, (_665._m19 * _3683) + (_665._m19 * mix(1.0, 0.5, _3796)), vec3(_3804));
            break;
        }
    }
    _665._m19 *= _665._m0;
    _665._m21 = _665._m19 + _665._m20;
    vec3 _3838 = vec3(0.0);
    if (_938._m12.w > 0.0)
    {
        vec4 _3844 = vec4(0.0030000000260770320892333984375, 0.00999999977648258209228515625, 0.0500000007450580596923828125, 0.300000011920928955078125);
        vec2 _3849 = abs(vec2(1.0) / _686._m6.zw);
        vec2 _3855 = ((gl_FragCoord.xy * 1.5) * _686._m6.zw) * (_3849 / vec2(32.0));
        vec4 _3869 = TEXTURE_LOD(_3870, vec4((_3855 * _3844.xy) + (vec2(_686._m1.x * 0.75) * _3844.zw), 0.0, 0.0).xy, vec4((_3855 * _3844.xy) + (vec2(_686._m1.x * 0.75) * _3844.zw), 0.0, 0.0).w);
        float _3913 = (length(_691.xyz) - 10.0) * 2.0;
        float _3906 = 1.0 - _10(_3913);
        float _3916 = 1.0 - dot(_665._m6, normalize(-_691.xyz));
        float _3925 = 2.0;
        _3925 *= ((sin((_686._m1.x * 5.0) * 0.75) * 0.5) + 0.699999988079071044921875);
        _3925 *= _3925;
        _3925 *= _3916;
        _3916 *= _3916;
        float _3945 = (_3916 * _3916) * 9.9999997473787516355514526367188e-05;
        vec3 _3955 = _3869.xyz * _3869.xyz;
        _3869 = vec4(_3955.x, _3955.y, _3955.z, _3869.w);
        vec3 _3958 = _3869.xyz;
        float _3968 = (_3958.x * _3916) + _3945;
        vec3 _3961 = _938._m12.xyz * _10(_3968);
        float _3975 = _3958.x;
        vec3 _3974 = _938._m12.xyz * _10(_3975);
        vec3 _3983 = mix(_3961, _3974, vec3(0.0500000007450580596923828125));
        float _3993 = (0.5 * _3916) + _3945;
        vec3 _3988 = _938._m12.xyz * _10(_3993);
        _3983 /= _686._m17.xyz;
        vec3 _4004 = (_3983 * _938._m12.w) * 0.5;
        _3838 += (_4004 * _3906);
    }
    _665._m19 += _3838;
    vec3 _4026 = _665._m19 + _665._m20;
    _4021 = vec4(_4026.x, _4026.y, _4026.z, _4021.w);
    vec3 _4030 = _665._m6;
    bool _4033 = false;
    vec2 _4034 = _148(_4030, _4033);
    _4029 = vec4(_4034.x, _4034.y, _4029.z, _4029.w);
    float _4038 = _665._m2.x;
    float _4042 = _665._m2.y;
    float _4046 = _665._m2.z;
    float _4050 = _665._m3;
    _4037 = vec4(_72(_4038), _72(_4042), _72(_4046), _151(_4050));
    vec3 _4060 = _4021.xyz + _938._m13.xyz;
    _4021 = vec4(_4060.x, _4060.y, _4060.z, _4021.w);
}

